/*
 * cpar : affiche le format d'une format (contenu du tableau lmft)
 * TODO : choix du nom de la variable.
 */

#include <inrimage/image.h>
#include <stdio.h>

char version[] = "1.2";
char command[] = "[image [...]] [-n][-x][-i]";
char details[] = "Display the format of an image in C-style. Options are:\n"
  "  -n: use inrimage macros as index of the format array\n"
  "  -x: display the extended format\n" 
  "  -d: display as a variable declaration";

char *name[] = { "I_DIMX", "I_DIMY", "I_BSIZE", "I_TYPE",
		 "I_NDIMX", "I_NDIMY", "I_NDIMV", "I_NDIMZ", "I_EXP"};
char *type[] = { "PACKEE", "FIXE", "REELLE"};

void print_name( char *label, Fort_int *lfmt) {
  int i;
  for(i=0;i<3;i++)
    fprintf( stdout, "%s[%s] = %d;\n", label, name[i], lfmt[i]);
  fprintf( stdout, "%s[I_TYPE] = %s;\n", label, type[lfmt[I_TYPE]+1]);
  for(i=4;i<9;i++)
    fprintf( stdout, "%s[%s] = %d;\n", label, name[i], lfmt[i]);
}


int main( int argc, char **argv) {
  NF_fmt lfmt_s;
  Fort_int *lfmt = lfmt_s.lfmt;
  int i, n, x, d;
  char file[256];
  struct image *im;

  inr_init( argc, argv, version, command, details);
  n = igetopt0("-n"); 
  x = igetopt0("-x"); 
  d = igetopt0( "-d");
  
  infileopt( file);
  do {
    im = imagex_( file, "ex", " ", &lfmt_s);

    if( im) { 
      fprintf( stdout, "/* %s : */\n", file);
      
      /* Display the extended format */
      if( x) {
	/* As a variable declaration */
	if( d) {
	  fprintf( stdout, 
		   "NF_fmt lfmt_s = { %d, %d, %d, %d, %d, %d, %d, %d, %d,\n"
		   "                  %d, %d, %d, \n"
		   "                  %d, %g, %g };\n",
		   lfmt[0],lfmt[1],lfmt[2],lfmt[3],lfmt[4],lfmt[5],
		   lfmt[6],lfmt[7],lfmt[8],lfmt[9],
		   lfmt_s.offsets[0], lfmt_s.offsets[1], lfmt_s.offsets[2],
		   lfmt_s.maille, lfmt_s.bias, lfmt_s.scale);
	  
	} 
	else {  
	  /* As a variable affection */
	  if( n)
	    print_name( "lfmt_s.lfmt", lfmt);
	  else 
	    for( i = 0; i< 9; i ++)
	      fprintf( stdout, "lfmt_s.lfmt[%d] = %d;\n", i, lfmt[i]);
	  
	  for( i = 0; i< 3; i ++)
	    fprintf( stdout, "lfmt_s.offsets[%d] = %d;\n", i, lfmt_s.offsets[i]);
	  fprintf( stdout, "lfmt_s.maille = %d;\n", lfmt_s.maille);
	  fprintf( stdout, "lfmt_s.bias = %g;\n", lfmt_s.bias);
	  fprintf( stdout, "lfmt_s.scale = %g;\n", lfmt_s.scale);
	}
      } else {
	/* Display the short format */
	
	/* As a variable declaration */
	if( d) {
	  fprintf( stdout, "Fort_int lfmt[] = { %d, %d, %d, %d, %d, %d, %d, %d, %d};\n",
		   lfmt[0],lfmt[1],lfmt[2],lfmt[3],lfmt[4],lfmt[5],
		   lfmt[6],lfmt[7],lfmt[8],lfmt[9]);
	} 
	/* As a variable affectation */
	else if( n) 
	  print_name( "lfmt", lfmt);
	else
	  for( i = 0; i< 9; i ++)
	    fprintf( stdout, "lfmt[%d] = %d;\n", i, lfmt[i]);    	
      }      
      fermnf_( &im);
    }
  } while( infileopt(file));
  
  return 0;
}
