#include <stdio.h>
#include <stdlib.h>
#include <inrimage/image.h>
#include "fcmain.h"

#ifdef WITH_DZV
static char Ucmd[]=
"input-file output_file [-ichn -pos] [-ochn] [-cf] [-eps rr] [-x nn -y nn] [-s nn]";
static char Udetail[]=
"\t-ichn : input fichier de chaines produit par anac\n\
\t-pos : contours positifs seulement\n\
\t-ochn : output fichier de chaines type anac\n\
\t-cf => contours fermes (elimine les non fermes si input dzv)\n\
\t-eps rr : distance euclidienne max d'1 point a 1 segment (def 1.0)\n\
\t -x nn, -y nn : taille de l'image de depart\n\
\t -s nn : eliminer les contours de taille ou surf < nn\n";
#else
static char Ucmd[]=
"input-file output_file  [-cf] [-eps rr][-pos] [-s nn]";
static char Udetail[]=
"Approximation polygonale sur un fichier de contours\n\
\t-pos : contours positifs seulement\n\
\t-cf => contours fermes (elimine les non fermes si input dzv)\n\
\t-eps rr : distance euclidienne max d'1 point a 1 segment (def 1.0)\n\
\t -s nn : eliminer les contours de taille ou surf < nn\n";
#endif
static int iotype= 0;
static int pos_only= 0;
static int dimx= 0, dimy= 0, smin= 0;

f_c_main
{
	float eps=1.;
	int iopfr;
	char in[80],out[80];

	inr_init(ARGC,ARGV,"2.1",Ucmd,Udetail);

	iopfr = igetopt("-cf","",0,"",0,"",0);

	igetopt1("-s","%d",&smin);
	igetopt1("-eps","%f",&eps);
#ifdef WITH_DZV
	if(igetopt1("-x","%d",&dimx))
		if(!igetopt1("-y","%d",&dimy))
			iusage_(Ucmd,Udetail);
	if(igetopt0("-ichn")) {
		iotype = 1;
		pos_only = igetopt0("-pos");
	}
	if(igetopt0("-ochn"))
		iotype |= 0x100;
#else
	pos_only = igetopt0("-pos");
	iotype = 0x101;
#endif
	if ( !igetopt("","%s",in,"",0,"",0) )
		{
		fprintf(stderr,"%s:fichier de contours d'entree obligatoire\n",
								xargv[0]);
		exit(-1);
		}

	if ( !igetopt("","%s",out,"",0,"",0) )
		{
		fprintf(stderr,"%s:fichier de contours de sortie obligatoire\n",
								xargv[0]);
		exit(-1);
		}

	if ( tstopts() ) iusage_(Ucmd,Udetail);

	sapold(in,out,&eps,&iopfr,&iotype,&pos_only,dimx,dimy,&smin);
	return 0;

}
