#include <stdio.h>
#include <inrimage/image.h>

static char Ucmd[]= 
"[-bw | -c8| -q8 [-nc nb_cols][-nd]| -cv | -cz[|-c24] | -crgb ] [-a color_file] [-i3[rgb] | -hsv [-h hmax]] [image-in | - | image-R image-G image-B] [image-out]";
static char Udetail[]=
"\t-bw : sortie 8 bits Noir et Blanc (defaut)\n\
\t-c8 : sortie couleur 8 bits (3bits R, 3 V, 2 B)\n\
\t-q8 : sortie couleur 8 bits (quantification + dithering)\n\
\t  -nc nb couleurs souhaitees, -nd no dithering\n\
\t-cv : sortie couleur 24 bits (3 valeurs par pixel : NDIMV=3)\n\
\t-cz,-c24 : sortie couleur 24 bits sur image 3 plans\n\
\t-crgb : sortie couleur 24 bits sur 3 images (ordre donne par rgb)\n\
\t-hsv : entre HSV (NDIMV de 1  3), avec 0<= H <= 1 \n\
\t-h: valeur max pour H (o a hmax => 360 degres)\n\
\t-a : appliquer table du fichier color_file (DIMY= 1 or 3)\n\
\t-i3 : input en 3 fichiers (ordre par def. rgb)\n";

#define O_BW 0
#define O_C8 1
#define O_C24 2
#define O_C3V 3
#define O_Q8 5
#define O_Q8ND 6

static Fort_int flg_out;
float HSVmax= 0.;

struct image *nfi[3], *nfo[3], *nf_ct;
Fort_int lfmti[9]= {0,0,1,0,0,0,0,0,200};  /* images virg. fixe 1 octet */
Fort_int lfmto[9];
static Fort_int lfmt2[9];

static Fort_int ier;
extern int scnvcol();
extern koctet_;
#define DEF_MEM 300

static int set_file_order();
static char col_in[3]= {0,1,2}, col_out[3]= {0,1,2};
static char tc_ordre[32];

main(argc,argv)
int argc;
char **argv;
{
	char in[256], out[256], ctfile[256];
	int nzi, nzo;
	int nvi, nvo, dummy;
	int nbi, nbo, nstd, nodither;
	Fort_int tabv, ntabv, ntabf, tabf, nbcols;
	char *verif;
	register i;

	inr_init(argc,argv,"2.2",Ucmd,Udetail);

	nodither= 0;
	flg_out = O_BW;
	nzo = 1;
	nvo = 1;
	nbi = 1;
	nbo = 1;
	if(igetopt0("-bw"))
		flg_out = O_BW;
	else if(igetopt0("-c8"))
		flg_out = O_C8;
	else if(igetopt0("-q8")) {
		nbcols= 256;
		flg_out = O_Q8;
		if( igetopt1("-nc","%d",&dummy)) nbcols = dummy;
		nodither= igetopt0("-nd");
	} else if(igetopt0("-c24") || igetopt0("-cz")) {
		nzo = 3;
		flg_out = O_C24;
	} else if(igetopt0("-cv")) {
		nvo = 3;
		flg_out = O_C3V;
	}else if(igetopt0x("-c","%s",tc_ordre)) {
		if(set_file_order(tc_ordre,col_out))
			iusage_(Ucmd,Udetail);
		nzo = 1;
		nbo = 3;
		flg_out = O_C24;
	}
	if(igetopt0("-i3")) {
		nbi = 3;
	} else if(igetopt0x("-i3","%s",tc_ordre)) {
		if(set_file_order(tc_ordre,col_in))
			iusage_(Ucmd,Udetail);
		nbi = 3;
	} else if(igetopt0("-hsv")) {
		HSVmax= 1.;
		if(igetopt1("-h","%f",&HSVmax)) {
			if(HSVmax <= 0.)
				HSVmax = 1.;
		}
	}
	if(nodither && (flg_out == O_Q8)) flg_out = O_Q8ND;
			
	nf_ct = NULL;
	if(igetopt1("-a","%s",ctfile))
		nf_ct = image_(ctfile,"e","",lfmt2);
		
	if(tstoptm()) iusage_(Ucmd,Udetail);
	verif = "t";
	if(HSVmax) {
#if 0
		lfmti[I_BSIZE] = sizeof(float);
		lfmti[I_TYPE] = REELLE;
#else
		verif = "";
#endif
	}
	nstd=0;
	for(i=0;i<nbi;i++) {
		if ( !infileopt(in) ) { /* stdin par defaut */
			if(nstd)
				iusage_(Ucmd,Udetail);
			nstd = 1;
		}
		nfi[col_in[i]] = image_(in,"e",verif,lfmti);
		verif = "a";
	}
	verif = "t";
	nzi = lfmti[I_NDIMZ];
	nvi = lfmti[I_NDIMV];
	if(nzi != 1 && nzi != 3 && nvi != 3)
		imerror(9,"Pb de format avec %s : on doit NDIMZ=1 ou NDIMZ=3 ou NDIMV=3\n");
	for(i=0;i<9;i++)
		lfmto[i] = lfmti[i];
	if(HSVmax) {
		lfmto[I_BSIZE] = 1;
		lfmto[I_TYPE] = FIXE;
		lfmto[I_EXP] = 0;
	}
	if((flg_out != O_C3V) && (nvi != 3))
		nvo = nvi;
	if((flg_out != O_C24) && (nzi != 3))
		nzo = nzi;
	lfmto[I_NDIMZ] = nzo;
	lfmto[I_NDIMV] = nvo;
	lfmto[I_DIMY] = lfmto[I_NDIMY] * nzo;;
	lfmto[I_DIMX] = lfmto[I_NDIMX] * nvo;
	nstd = 0;
	for(i=0;i<nbo;i++) {
		if (!outfileopt(out)) { /* stdout par defaut */	
			if(nstd)
				iusage_(Ucmd,Udetail);
			nstd = 1;
		}
		nfo[col_out[i]] = image_(out,"s","a",lfmto);
	}
	if(nbi == 1) {
		nfi[2] = nfi[1] = nfi[0];
	}
	if(nbo == 1) {
		nfo[2] = nfo[1] = nfo[0];
	}
	if(tstopts()) iusage_(Ucmd,Udetail);
	if(! koctet_)
		koctet_ = DEF_MEM;
	tabf= 1;
	tabv = 1;
	if((flg_out == O_Q8) || (flg_out == O_Q8ND)){
		ntabv= 0;
		ntabf= 1; /* tableau bidon */
	} else {
		ntabv = 1;
		ntabf= 0;
	}
	exec_(&ier,&ntabf,&tabf,&ntabv,&tabv,scnvcol,nfi,nfo,&nf_ct,lfmti,lfmto,&flg_out,&HSVmax,&nbcols,&ier);
	return ier;
}

static int set_file_order(txt,tab)
unsigned char *txt, *tab;
{
	register i, c;
	tab[0] = 0xff;
	tab[1] = 0xff;
	tab[2] = 0xff;
	for(i=0;i<3;i++) {
		c = *txt++ | 0x20;
		switch (c) {
		case 'r':
			tab[i] = 0;
			break;
		case 'v':
		case 'g':
			tab[i] = 1;
			break;
		case 'b':
			tab[i] = 2;
			break;
		}
	}
	if(*txt != 0)
		return -1;
	if(tab[0] == 0xff || tab[1] == 0xff || tab[2] == 0xff)
		return -1;
	return 0;
}

