/* convertit un dump X (par xwd) en image inrimage 
*/

static char Ucmd[]= "[-noct | -xct] [input | -] [output]";
static char Udetail[]=
"\t-noct: ignore colormap\n\
\t-xct : apply colormap to pixels (else write in header)";

#include <inrimage/image.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/XWDFile.h>

#define NO_CT 0
#define X_CT 1
#define SET_CT 2

int fl_ct= SET_CT;

struct image *nf;
Fort_int lfmt[9]= {1,1,1,0,1,1,1,1,200};
int fd;
static XWDFileHeader hdr;
char *buffer= (char *)0;
char *buff2;

XWDColor *colors;
static int ncolors;

static char bufr[256], bufg[256], bufb[256];
static char *pcol[3]= {bufr,bufg,bufb};

static char Xcol_order[3];
static char Xcol_shft[3];
#define C_ROUGE 0
#define C_VERT 1
#define C_BLEU 2
static int fl_ct_eq;
static int depth;

#define high16(x) ((x & 0xf800) >> 8)
#define middle16(x) ((x & 0x07e0) >> 3)
#define low16(x) ((x & 0x1f) << 3)

static int prep_ct(), set_ct(), x_ctbw(), x_ctc();
static int prep_1col24(), prep_1col16(), prep_col_order(), sep_col24(), sep_col16();

extern char *i_malloc();
static int swaptest= 1;  /* check if swap needed : header and colors are MSBFirst */

main(argc,argv)
int argc;
char **argv;
{
	register n, i;
	register lct;
	char in[256], out[256];

	inr_init(argc,argv,"2.2",Ucmd,Udetail);

	if(igetopt0("-noct"))
		fl_ct = NO_CT;
	   else if(igetopt0("-xct"))
		fl_ct = X_CT;
	infileopt(in);
	outfileopt(out);
	if(tstopts()) iusage_(Ucmd,Udetail);

	if((in[0] == 0) || (in[1] == 0 && in[0] == '<')) {
		fd = 0;
	} else {
		if((fd = open(in,0)) <= 0)
			imerror(1,"open error on %s\n",in);
	}
	if((n = read_all(fd,&hdr,sizeof(hdr))) != sizeof(hdr))
		imerror(1,"header read pb : code %d\n",n);
	if(*(char *)&swaptest)
		swapint4(&hdr,sizeof(hdr)/ sizeof(int4));
	if (hdr.file_version != XWD_FILE_VERSION) 
		imerror(9,"XWD file format version mismatch\n");
	if(hdr.pixmap_format != ZPixmap)
		imerror(9,"XWD unexpected pixmap format : %d\n",hdr.pixmap_format);
	depth = hdr.pixmap_depth;
	lct = hdr.header_size - n;
	buffer = i_malloc(lct);
	if((n = read_all(fd,buffer,lct)) != lct)
		imerror(1,"header read pb : code %d\n",n);
	i_Free(&buffer);
	if(ncolors = hdr.ncolors) {
		lct = ncolors * sizeof(XWDColor);
		colors = (XWDColor *) i_malloc(lct);
		if((n = read_all(fd,colors,lct)) != lct)
			imerror(1,"header read pb : code %d\n",n);
		if(fl_ct != NO_CT) {
			if(*(char *)&swaptest) {
				for(i=0;i<ncolors;i++) {
					swapint4(&colors[i].pixel,1);
					swapshort(&colors[i].red,3);
				}
			}
			fl_ct_eq = prep_ct();
		}
	} else 	if(fl_ct != NO_CT) {
		fl_ct = NO_CT;
		fprintf(stderr,"Warning! No colormap on dump file!\n");
	}

	i_Free(&colors);
	lct = hdr.bytes_per_line * hdr.pixmap_height;
	DIMX = NDIMX = hdr.pixmap_width;
	DIMY = NDIMY = hdr.pixmap_height;
	buffer = i_malloc(lct);
	if((n = read_all(fd,buffer,lct)) != lct)
		imerror(1,"data read pb : code %d\n",n);
	switch(depth) {
	case 1 :
		if(DIMX != 8 * hdr.bytes_per_line) { /* extraction necessaire */
			c_trtblb(buffer,8 * hdr.bytes_per_line,1,buffer,DIMX,1,DIMX,DIMY,1);
		}
		TYPE = PACKEE;
		BSIZE = -1;
		nf = image_(out,"s","a",lfmt);
		set_ct();
		x_ctbw();
		c_ecr(nf,DIMY,buffer);
		break;
	case 8 :
		if(DIMX != hdr.bytes_per_line) { /* extraction necessaire */
			c_trtblb(buffer,hdr.bytes_per_line,1,buffer,DIMX,1,DIMX,DIMY,8);
		}
		TYPE = FIXE;
		BSIZE = 1;
		if(fl_ct_eq != 0 && (fl_ct == X_CT)) {
			NDIMZ = 3;
			DIMY = 3 * NDIMY;
			nf = image_(out,"s","a",lfmt);
			lct = DIMX * NDIMY;
			buff2 = i_malloc(lct);
			for(i=0;i<3;i++) {
				x_ctc(buffer,buff2,lct,i);
				c_ecr(nf,NDIMY,buff2);
			}
		} else {
			nf = image_(out,"s","a",lfmt);
			set_ct();
			x_ctbw();
			c_ecr(nf,DIMY,buffer);
		}
		break;
	case 16:
		TYPE = FIXE;
		BSIZE = 1;
		NDIMV = 3;
		DIMX = 3 * NDIMX;
		nf = image_(out,"s","a",lfmt);
		lct = NDIMX * NDIMY;
		buff2 = i_malloc(3*lct);
		set_ct();
		sep_col16(buffer,buff2,hdr.bytes_per_line,NDIMX,NDIMY);
		c_ecr(nf,NDIMY,buff2);
		break;
	  
	case 24:
		TYPE = FIXE;
		BSIZE = 1;
		NDIMZ = 3;
		DIMY = 3 * NDIMY;
		nf = image_(out,"s","a",lfmt);
		lct = DIMX * NDIMY;
		buff2 = i_malloc(lct);
		set_ct();
		for(i=0;i<3;i++) {
			sep_col24(buffer,buff2,lct,i);
			c_ecr(nf,NDIMY,buff2);
		}
		break;
	default:
		imerror(9,"unexpected bits per pixel : %d\n",depth);
	}
	fermnf_(&nf);
	return 0;

}
		
/* construit les 3 tables bufr, bufg, bufb
retourne 0 si les 3 sont identiques, 1 sinon */
static int prep_ct()
{
	register i, j;
	for(i=0;i<256;i++) {
		bufr[i] = bufg[i] = bufb[i] = 0;
	}
	if(depth <= 8) {
		for(i=0;i<ncolors;i++) {
			j = colors[i].pixel & 0xff;
			bufr[j] = colors[i].red >> 8;
			bufg[j] = colors[i].green >> 8;
			bufb[j] = colors[i].blue >> 8;
		}
	} else if(depth == 24) {  /* 24 bits */
		prep_col_order(depth);
		for(i=0;i<ncolors;i++) {
			j = colors[i].pixel;
			bufr[(j >> Xcol_shft[C_ROUGE]) & 0xff] = colors[i].red >> 8;
			bufg[(j >> Xcol_shft[C_VERT]) & 0xff] = colors[i].green >> 8;
			bufb[(j >> Xcol_shft[C_BLEU]) & 0xff] = colors[i].blue >> 8;
		}
	} else {  /* 16 bits */
	  if(Xcol_order[C_ROUGE] == 0) {
	    for(i=0;i<ncolors;i++) {
	      j = colors[i].pixel;
	      bufr[high16(j)] = colors[i].red >> 8;
	      bufg[middle16(j)] = colors[i].green >> 8;
	      bufb[low16(j)] = colors[i].blue >> 8;
	    }
	  } else {
	    for(i=0;i<ncolors;i++) {
	      j = colors[i].pixel;
	      bufr[low16(j)] = colors[i].blue >> 8;
	      bufg[middle16(j)] = colors[i].green >> 8;
	      bufb[high16(j)] = colors[i].red >> 8;
	    }
	  }
	}
	/* compare les 3 tables */
	for(i=0;i<ncolors;i++) {
		if(bufr[i] != bufg[i] || bufr[i] != bufb[i])
			return 1;
	}
	return 0;
}

static int set_ct()
{
	
	if(fl_ct == SET_CT)
		iwr_ctrgb(nf,0,256,bufr,bufg,bufb);
}

/* retourne l'indice de l'octet dans le mot correspondant au masque msk
(0xff ou 0xff00, ... )
*/
static int prep_1col24(numcol,msk,order)
register numcol;
register u_int4  msk;
int order;
{
	register i;
	for(i=0;i<sizeof(u_int4);i++) {
		if((msk & 0xff) == 0xff) break;
		msk >>= 8;
	}
	if(i >= 4) return -1;
	Xcol_shft[numcol] = 8 * i;
	if(order == MSBFirst)
		i = 3 -i;
	Xcol_order[numcol] = i;
	return i;
}

static unsigned short tabmsk16[] = {0xf800,0x7e0,0x1f};

static int prep_1col16(numcol,msk,order)
register numcol;
register u_int4  msk;
int order;
{
  register i;
  for(i=0;i<3;i++) {
    if((msk & tabmsk16[i]) == tabmsk16[i]) break;
  }
  if(i >= 3) return -1;
  return i;
}

/* prepare Xcol_order for 16 or 24 bits true color */
static int prep_col_order(depth)
int depth;
{
	register i;
	register order;
	order = hdr.byte_order;
	if(depth == 16) {
	  prep_1col16(C_ROUGE,hdr.red_mask,order);
	  prep_1col16(C_VERT,hdr.green_mask,order);
	  prep_1col16(C_BLEU,hdr.blue_mask,order);
	} else {  /* 24 bits */
	  prep_1col24(C_ROUGE,hdr.red_mask,order);
	  prep_1col24(C_VERT,hdr.green_mask,order);
	  prep_1col24(C_BLEU,hdr.blue_mask,order);
	}

	for(i=0;i<3;i++) {  /* en cas de pb */
		if(Xcol_order[i] > 3)
			Xcol_order[i] = 0;
	}
}
		
/* extrait la composante numcol de bufi dans bufo pour nb pixels
numcol=0, 1, 2 pour RGB
*/
static int sep_col24(bufi,bufo,nb,numcol)
register unsigned char *bufi, *bufo;
register nb, numcol;
{
	register char *pc;
	bufi += Xcol_order[numcol];
	if(fl_ct == X_CT) {
		pc = pcol[numcol];
		while(nb-- > 0) {
			*bufo++ = *(pc + *bufi);
			bufi += 4;
		}
		return 0;
	}
	while(nb-- > 0) {
		*bufo++ = *bufi;
		bufi += 4;
	}
	return 0;
}

/* separe les 3 composantes d'une image 16 bits
*/
static int sep_col16(bufi,bufo,bytes_per_line,dimx,dimy)
register unsigned short *bufi;
unsigned char *bufo;
int bytes_per_line,dimx,dimy;
{
  int x, nb;
  int incx;
  incx = bytes_per_line - (2 * dimx);
  if((incx != 0) && (incx != 2))
    imerror(9,"bad line padding for 16 bits mode\n");
  incx /= 2;
  if(fl_ct == X_CT) {
    if(Xcol_order[C_ROUGE] == 0) {
      while(dimy-- > 0) {
	nb = dimx;
	while(nb-- > 0) {
	  x = *bufi++;
	  *bufo++ = bufr[high16(x)];
	  *bufo++ = bufg[middle16(x)];
	  *bufo++ = bufb[low16(x)];
	}
	bufi += incx;
      }
      return 0;
    }
      while(dimy-- > 0) {
	nb = dimx;
	while(nb-- > 0) {
	  x = *bufi++;
	  *bufo++ = bufr[low16(x)];
	  *bufo++ = bufg[middle16(x)];
	  *bufo++ = bufb[high16(x)];
	}
	bufi += incx;
      }
    return 0;
  }
  if(Xcol_order[C_ROUGE] == 0) {
    while(dimy-- > 0) {
      nb = dimx;
      while(nb-- > 0) {
	x = *bufi++;
	*bufo++ = high16(x);
	*bufo++ = middle16(x);
	*bufo++ = low16(x);
      }
      bufi += incx;
    }
    return 0;
  }
  while(dimy-- > 0) {
    nb = dimx;
    while(nb-- > 0) {
      x = *bufi++;
      *bufo++ = low16(x);
      *bufo++ = middle16(x);
      *bufo++ = high16(x);
    }
    bufi += incx;
  }
  return 0;
}

static int x_ctbw()
{
	register nb;
	register u_int4 *pl;
	register unsigned char *data, *pcr;
	if(fl_ct != X_CT) return 0;
	if(depth == 1) {
		if(ncolors != 2) {
			fprintf(stderr,"Warning! nb of colors != 2 for 1 bit image\n");
			return -1;
		}
		if(bufr[0] == 0) return 0;  /* no need to invert bits */
		nb = ((DIMX * DIMY) + 31) / 32;
		pl = (u_int4 *) buffer;
		while(nb-- > 0)
			*pl++ ^= 0xffffffff;
		return 0;
	}
	/* 8 bits , 3 tables identiques */
	nb = DIMX * DIMY;
	data = (unsigned char *) buffer;
	pcr = (unsigned char *) bufr;
	while(nb-- > 0) {
		*data = *(pcr + *data);
		data++;
	}
	return 0;
}

#if 0
static char msks[3]= {0xe0,0x1c,0x3};
static char shfts[3]= {5,2,0};
static char tb1[8]= {0,0x24,0x49,0x6d,0x92,0xb6,0xdb,0xff};
static char yb2[4]= {0,0x55,0xaa,0xff};
#endif
static int x_ctc(bufi,bufo,nb,numcol)
register unsigned char *bufi, *bufo;
register nb, numcol;
{
	register char *pc;
	if(fl_ct != X_CT) return 0;
	pc = pcol[numcol];
	while(nb-- > 0) {
		*bufo++ = *(pc + *bufi++);
	}
	return 0;
}
