#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd1[]=
"image-in image1-out image2-out";
static char Ucmd2[]=
"image1-in image2-in image1-out image2-out";
static char Udet1[]=
"\tFFT de 'image-in' dans 'image1-out' (partie reelle) et 'image2-out' (partie imaginaire)";
static char Udet2[]=
"\tFFT complexe de ('image1-in','image2-in') dans ('image1-out','image2-out')";
static char Udet3[]=
"\tFFT inverse de ('image1-in','image2-in') dans ('image1-out','image2-out')";

extern debug_;
static struct multi_cmd cmds[] = {
	"rdf",Ucmd1,Udet1,	/*  1 */
	"ddf",Ucmd2,Udet2,	/*  2 */
	"idf",Ucmd2,Udet3,	/*  3 */
	0,0,0,
};

fcmain_()
{
	register struct multi_cmd *ppcmd;
	char inr[128],outr[128],ini[128],outi[128];
	Fort_int choix;
	register i1, i2;

	choix = inr_initm(0,0,"2.1",cmds);
	ppcmd = &cmds[choix];

	if ( debug_ ) fprintf(stderr,"fonction %s\n",ppcmd->name);


	switch ( choix ) {
		case 0 : /* rdf */ 
			infileopt(inr);
			i1 = outfileopt(outr);
			i2 = outfileopt(outi);
			if((i1 == 0) && (i2 == 0))
				imerror(9,"2 images de sortie obligatoires\n");
			break;

		case 1 :
		case 2 : /* ddf et idf */
			i1 = infileopt(inr);
			i2 = infileopt(ini);
			if((i1 == 0) && (i2 == 0))
				imerror(9,"2 images d'entree obligatoires\n");
			i1 = outfileopt(outr);
			i2 = outfileopt(outi);
			if((i1 == 0) && (i2 == 0))
				imerror(9,"2 images de sortie obligatoires\n");
			break;
		}

	

	if ( tstopts())
		iusage_(ppcmd->ucmd,ppcmd->udetail);

	choix++;
	sdft_(&choix,inr,outr,ini,outi);
	return 0;

}


