#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd1[]=
"image-in image1-out image2-out";
static char Ucmd2[]=
"image1-in image2-in image1-out image2-out";
static char Udet1[]=
"\tFFT (monodim.) de 'image-in' dans ('image1-out','image2-out')";
static char Udet2[]=
"\tFFT (monodim.) complexe de ('image1-in','image2-in') dans ('image1-out','image2-out')";
static char Udet3[]=
"\tFFT (monodim.) inverse de ('image1-in','image2-in') dans ('image1-out','image2-out')";
static char *Pcmd, *Pdetail;

extern debug_;
static struct multi_cmd cmds[] = {
	"rmo",Ucmd1,Udet1,	/*  1 */
	"dmo",Ucmd2,Udet2,	/*  2 */
	"imo",Ucmd2,Udet3,	/*  3 */
	0,0,0,
};

fcmain_()
{
	register struct multi_cmd *ppcmd;
	char inr[128],outr[128],ini[128],outi[128];
	Fort_int choix;
	register i1, i2;

	/* determination de la fonction demandee */
	choix = inr_initm(0,0,"2.1",cmds);
	ppcmd = &cmds[choix];

	if ( debug_ ) fprintf(stderr,"fonction %s\n",ppcmd->name);


	switch ( choix ) {
		case 0 : /* rmo */ 
			fileopt(inr,"i");
			i1 = fileopt(outr,"o");
			i2 = fileopt(outi,"o");
			if((i1 == 0) && (i2 == 0))
				imerror(9,"2 images de sortie obligatoires\n");
			break;

		case 1 : case 2 : /* dmo et imo */
			i1 = fileopt(inr,"o");
			i2 = fileopt(ini,"o");
			if((i1 == 0) && (i2 == 0))
				imerror(9,"2 images d'entree obligatoires\n");
			i1 = fileopt(outr,"o");
			i2 = fileopt(outi,"o");
			if((i1 == 0) && (i2 == 0))
				imerror(9,"2 images de sortie obligatoires\n");
			break;
		}

	

	if ( tstopts())
		iusage_(ppcmd->ucmd,ppcmd->udetail);

	choix++;
	sfftli_(&choix,inr,ini,outr,outi);
	return 0;

}


