#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>

extern debug_,koctet_;

static char version[]= "2.2";
static char Ucmd[]=
"input-contour-file [image-out] [-af offset[,coef] | -fv fill_values | [-ff|-invff] src-image| [-ixoff n][-iyoff n]] [-add] [-xoff n] [-yoff n][-izo n][-nz n][-ivo] [-nv] [-pos | -neg] [-s min[,max]] [-e env] [-l cont-list]";
static char Udetail[]= 
"\tinput-file: fichier de contours produit par anac\n\
\t-af : auto-fill avec (offset + ((coef * num_cont) % (255 - offset))), par ex 0,1\n\
\t-fv : liste (<= NDIMV) de valeurs de remplissage (n1/n2,... def 255, -1 => auto-fill)\n\
\t-ff : image a utiliser pour le remplissage des contours positifs\n\
\t-invff : image a utiliser pour le remplissage des contours negatifs\n\
\t-ixoff, iyoff : offsets dans image source\n\
\t-add: ajouter a l'image resultat\n\
\t-pos : contours positifs seulement\n\
\t-neg : contours negatifs seulement\n\
\t-e env : contour d'enveloppe numero env ( ext. si -e 0, int. si env<0)\n\
\t -xoff, -yoff :offsets dans l'image resultat (>=0 ou <0)\n\
\t\txoff en nb de vecteurs-pixels, yoff dans 1 plan si -izo ou -nz\n\
\t-izo : numro du plan  remplir (1.. NDIMZ)\n\
\t-nz : rpter opration dans n plans\n\
t-ivo : numro de la 1re composante vectorielle  remplir (1.. NDIMV)\n\
\t-nv : rpter opration sur n composantes\n\
\t -l : liste de numeros de contours, dans l'ordre croissant (1,3,5-10) \n\
\t -s min,max : ne garder que  les contours de surface comprise entre min et max\n";

static int iotype= 0;
static Fort_int isens= 0, flg_fv= 0;  // -1 = -af, 0 = -fv, 1 = -ff, 2= _invff
static Fort_int xoff= 0, yoff= 0, ismmx[2], num_env= 0, afillval[2]= {0,1};

Fort_int flg_add= 0, ixoff= 0, iyoff= 0;
Fort_int nbz= 1, izo= 0, ivo= 0, nbv= 1;
main(argc,argv)
int argc;
char *argv[];
{
	char out[128],cont[128], fill_im[128], list_cont[256];
	char buf[64], fvbuf[256];
	char *pfv;
	int dum1,dum2;
	strcpy(fvbuf,"255");
	inr_init(argc,argv,version,Ucmd,Udetail);

	ismmx[0] = 0;
	ismmx[1] = 0x7fffffff;
	if(igetopt("-s","",0,"%s",buf,"",0)) {
		sscanf(buf,"%d,%d",&dum1,&dum2);
		ismmx[0]= dum1; ismmx[1]= dum2;
		if((ismmx[0] > ismmx[1]) || (ismmx[0] < 0))
			iusage_(Ucmd,Udetail);
	}
	fill_im[0] = 0;
	igetopt1("-xoff","%d",&xoff);
	igetopt1("-yoff","%d",&yoff);
	if(igetopt("-af","",0,"%s",buf,"",0)) {
		sscanf(buf,"%d,%d",&dum1,&dum2);
		afillval[0] = dum1; afillval[1] = dum2;
		if((afillval[0] < 0) || (afillval[1] < 0) ||
		   (afillval[0] >= 255) || (afillval[1] >= 256)) {
			fprintf(stderr," valeurs hors limites pour -af\n");
			iusage_(Ucmd,Udetail);
		}
		if(afillval[1] == 0)
			afillval[1] = 1;
		flg_fv = -1;  /* mark auto-fill */
		
	} else if(! igetopt1("-fv","%s",fvbuf)) {
		if(igetopt1("-ff","%s",fill_im)) {
		  flg_fv = 1;
		} else if(igetopt1("-invff","%s",fill_im)) {
		  flg_fv = 2;
		}
		if(flg_fv > 0) {
		  if((fill_im[0] == '-') && (fill_im[1] == 0))
		    fill_im[0] = '<';
		  if(! igetopt1("-ixoff","%d",&ixoff)) ixoff = xoff;
		  if(! igetopt1("-iyoff","%d",&iyoff)) iyoff = yoff;
		}
	}
	if(igetopt1("-izo","%d",&izo))
		nbz = 1;
	if(igetopt1("-nz","%d",&nbz)) {
		if(izo <= 0)
			izo = 1;
	}
	if(igetopt1("-ivo","%d",&ivo))
		nbv = 1;
	if(igetopt1("-nv","%d",&nbv)) {
		if(ivo <= 0)
			ivo = 1;
	}

	isens = 0;
	if(igetopt("-pos","",0,"",0,"",0))
		isens = 1;
	else if(igetopt("-neg","",0,"",0,"",0))
		isens = -1;
	flg_add = igetopt("-add","",0,"",0,"",0);
	if ( !igetopt("-l","",0,"%s",list_cont,"",0))
		list_cont[0] = 0;
	if(igetopt("-e","",0,"%d",&dum1,"",0)) {
	        num_env = dum1;
		if(num_env < 0) num_env = -1;
	} else
		num_env = -2;
	if ( !igetopt("","%s",cont,"",0,"",0)) {
		fprintf(stderr,"fichier de contours d'entree obligatoire\n");
		iusage_(Ucmd,Udetail);
	}
	fileopt(out,"o");
	if ( gtstopts(0,1,0) ) iusage_(Ucmd,Udetail);
	sfillc_(out,cont,fill_im,&flg_fv,fvbuf,afillval,list_cont,&isens,&num_env,&ixoff,&iyoff,&xoff,&yoff,&izo,&nbz,&ivo,&nbv,ismmx,&flg_add);
	return 0;
}
