/*kfmed_
**************************************************************************
*									 *
* Ce programme est le lanceur de l'executable "filtre median"
* Il recupere les  arguments :						 *
* - x (idim) dimension en X du filtre  (par defaut = 3)	 *
* - y (kdim) dimension en Y du filtre  (par defaut = 3)	 *
* - inname   nom de l'image d'entree (eventuellement un pipe) dont les   *
*            doivent etre comprises entre 0 et 1.
* - outname  nom de l'image de sortie (eventuellement un pipe)		 *
*									 *
*   Puis il appelle sfmed.f qui definira ouvrira les images et lancera  
	le filtre *
*									 *
**************************************************************************
*/

#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd[]=
"[-x nn] [-y nn] [image-in] [image-out]";
static char Udetail[]=
"\tconvolution de 'image-in' (defaut stdin) par filtre median\n\
\t -x, -y : taille du filtre (3x3 par defaut)";
 


main(argc,argv)
int argc;
char *argv[];
{
	char inname[128],outname[128];
	Fort_int kdim = 3, idim= 3;

	inr_init(argc,argv,"2.1",Ucmd,Udetail);
	igetopt("-x","",0,"%d",&idim,"",0);
	igetopt("-y","",0,"%d",&kdim,"",0);
	if(kdim == 0) kdim = 1;
	if(idim == 0) idim = 1;

	fileopt(inname,"i");
	fileopt(outname,"o");
	if ( tstopts() )
		iusage_(Ucmd,Udetail);


	sfmed_(inname,outname,&idim,&kdim);
	return 0;
}
