#include <inrimage/image.h>
#include <stdio.h>

#include "fcmain.h"

static char Ucmd[]=
"[-h | -hn | -hc |-re][-g] [image-in] [image-out]";
static char Udetail[]=
"\tcalcule histogramme ou fonct. de repartition de 'image-in'\n\
\tresultat dans 'image-out'\n\
\t-h : histogramme simple (nb de points/classe, defaut)\n\
\t-hn : histogramme normalise (proprtion de points/classe)\n\
\t-hc : histogramme couleur normalise (cube couleur 4x4x4 pour rgb)\n\
\t -re : fonction de repartition normalise (proportion de pts de valeur <= classe)\n\
\t-g : calcul global sur toute l'image, sinon par composante et plan";


f_c_main
{
	char inname[128],outname[128];
	Fort_int icd = 0; /* histogramme par defaut */
	Fort_int isep= 3; /* separation des composantes V et Z */

	inr_init(ARGC,ARGV,"2.1",Ucmd,Udetail);

	if ( igetopt0("-re"))
		icd = 1 ;	/* fonction de repartition */
	else if( igetopt0("-h"))
		icd = 0 ;	/* histogramme simple : nb pts / classe*/
	else if( igetopt0("-hn"))
		icd = -1 ;	/* histogramme normalise : proportion de points/ classe */
	else if( igetopt0("-hc"))
		icd = -2 ;	/* histogramme couleur normalise */
	if(icd >= -1) {
		if ( igetopt0("-g"))
			isep = 0;	/* ne pas separer les composantes */
	} else isep = 0;
	fileopt(inname,"i");
	fileopt(outname,"o");
	if ( tstopts())
		iusage_(Ucmd,Udetail);

	shisto_(inname,outname,&icd,&isep);
	return 0;
}

