#include <stdio.h>
#include <inrimage/error.h>
#include <inrimage/image.h>

char in[256], out[256];
static char Ucmd[]= 
"[-iz num_plan][-z nb_plans]  [-wr out-file | -wr+ out-file][input-images... | -]\n";
static char Udetail[]= 
"enleve l'en-tete des images,\n\
   ecrit les donnees sur stdout ou dans out-file\n\
\t-wr+ : on ecrit a la fin du fichier\n\
\t-iz, -z : pour selectionner certains plans\n";

static struct nf_fmt gfmt;
extern struct image *c_ouvimf();

unsigned char *pic;


#define DEF_SIZE 400

extern int debug_, koctet_;
int mem_size= 0;

FILE *fp;
extern int errno;
int iz0= 1, nz0= 0;
int iz= 1, nz= 0;
static int flg_wr;
char *cmd;
main(argc,argv)
int argc;
char **argv;
{
	struct image *nf;
	register next;
	int ier;
	inr_init(argc,argv,"2.1",Ucmd,Udetail);
	cmd = argv[0];

	flg_wr = 0;
	if(igetopt1("-wr","%s",out))
		flg_wr = 1;
	else if(igetopt1("-wr+","%s",out))
		flg_wr = 2;
	igetopt1("-iz","%d",&iz0);
	igetopt1("-z","%d",&nz0);
	if(tstoptm())
		iusage_(Ucmd,Udetail);
	if(!flg_wr) {
		fp = stdout;
	} else {
		if(flg_wr > 1)
			fp = fopen(out,"a");  /* append */
		else
			fp = fopen(out,"w");  /* new file */
		if(fp == NULL)
			imerror(1,"out file %s, open err %d\n",out,errno);
	}
	if(koctet_ <= 0) koctet_ = DEF_SIZE;
	mem_size = koctet_ * 1024;
	fileopt(in,"i");
	next = 1;
	silent_err();
	while (next) {
		c_erreur(ier);
		if(ier != 0) goto suite;
		if ( (nf = c_ouvimf( in,&gfmt,1) ) == (struct image *)0 ) {
			fprintf(stderr,"%s:probleme avec %s\n",argv[0],in);
			goto suite;
		}
		inrcat_im(nf);
		fermnf_(&nf);
	suite: next = xfileopt(in,"i",0);
	}
	fclose(fp);
	return 0;
}

inrcat_im(nf)
register struct image *nf;
{
	register i, n;
	register iy, iy0;
	int lglig, nblig, ntot;
	Fort_int ibs;
	iz = iz0 - 1;
	nz = nz0;

	if(iz < 0) iz = 0;
	else if(iz >= gfmt.NDIMZ) iz = gfmt.NDIMZ - 1;
	if(nz <= 0) nz = gfmt.NDIMZ - iz;
	else if(nz > (gfmt.NDIMZ -iz)) nz = gfmt.NDIMZ - iz;
	i = ligbit_(gfmt.lfmt,&ibs);
	lglig = ( i + 7)/ 8;
	nblig = mem_size / lglig;
	if(nblig > gfmt.NDIMY)
		nblig = gfmt.NDIMY;
	n = nblig * lglig;
	pic = (unsigned char *)i_malloc(n);
	c_lptset(nf,iz * gfmt.NDIMY +1);
	ntot = nz * gfmt.NDIMY;
	
	while(ntot > 0) {
		if(nblig > ntot) {
			nblig = ntot;
			n = nblig * lglig;
		}
		ntot -= nblig;
		c_xlect(nf,nblig,pic,1);
		if(fwrite(pic,1,n,fp) <= 0)
			imerror(9,"write ppm error\n");
	}
	fflush(fp);
	return 0;
}

