#include <inrimage/image.h>
#include <stdio.h>

#include "fcmain.h"

static char Ucmdg[]=
"[image-in] [-ixi nn] [-iyi nn] [-izi nn][-ivi nn] [image-out] [-ixo nn] [-iyo nn] [-izo nn][-ivo nn] [-idx nn] [-idy nn] [-idz nn][-idv nn][-tr|[-rgi in_range][-rgo out_range]][options-de-dim.]";
static char Udetailg[]=
"     Melange de 2 images avec test sur les valeurs de pixels\n\
\t -ixi, -iyi, -izi. -ivi: origine dans 'image-in'\n\
\t   ixi : 1..NDIMX, iyi : 1..NDIMY, izi : 1..NDIMZ, ivi : 1..NDIMV\n\
\t -ixo, -iyo, -izo, -ivo : origine dans 'image-out' (1 a NDIMX)\n\
\t -idx, -idy, -idz, -idv : taille de la fenetre a melanger (idx de 1 a NDIMX)\n\
\t -tr : transparence image-in : on copie les pixels >0\n\
\t-rgi : intervalle de valeurs des pixels a copier dans image-in\n\
\t-rgo : intervalle de valeurs des pixels modifiables dans image-out\n\
\t intervalles de la forme  \"pix1,pix2\",  pixi = v1/.../vn pour n composantes\n\
\t [] pour indiquer bornes comprises ou non (-tr == -rgi ]0)\n\
\t     intervalle precede de ~ pour selection hors intervalle\n\
\tex: -rgi 1,255 -rgo \",255[\"  ou -rgi \"~10,20\"";

static char Ucmd0[]=
"[image-in] [-ixi nn] [-iyi nn] [-izi nn] [image-out] [-ixo nn] [-iyo nn] [-izo nn] [-idx nn] [-idy nn] [-idz nn][options-de-dim.]";
static char Udetail0[]=
"     Melande de 2 images (inadapte aux image vectorielles : utiliser melg)\n\
\t -ixi, -iyi, -izi: origine dans 'image-in' (1 a NDIMX*NDIMV)\n\
\t -ixo, -iyo, -izo : origine dans 'image-out' (1 a NDIMX*NDIMV)\n\
\t -idx, -idy, -idz : taille de la fenetre a melanger (idx de 1 a NDIMX*NDIMV)";

static struct multi_cmd cmds[] = {
  "mel",Ucmd0,Udetail0,	/*  0 */
  "melg",Ucmdg,Udetailg,	/*  1 */
  0,0,0,
};

static void get_inr_coord();
static char *ic_opts[]= { "-ixi","-iyi","-izi","-ivi"};
static char *oc_opts[]= { "-ixo","-iyo","-izo","-ivo"};
static char *win_opts[]= { "-idx","-idy","-idz","-idv"};
static char ivals[128], ovals[128];
static Fort_int in_pt[4], out_pt[4], win[4];

main(argc,argv)
int argc;char *argv[];
{
	char inname[128],outname[128];
	Fort_int ixi = 1 , iyi = 1 , ixo = 1 , iyo = 1 , idx = 0 , idy = 0;
	Fort_int izi= 1, izo= 1, idz= 0;
	Fort_int choix, mtype;
	int nbopt= 3;
	struct multi_cmd *ppcmd;
	choix = inr_initm(argc,argv,"2.3",cmds);
	ppcmd = &cmds[choix];
	mtype = 0;
	infileopt(inname);
	outfileopt(outname);
	in_pt[3] = 1;
	out_pt[3] = 1;
	win[3] = 0;
	if(choix) nbopt= 4;
	get_inr_coord(nbopt,ic_opts,in_pt);  /* coord 1e pt image in */
	get_inr_coord(nbopt,oc_opts,out_pt);  /* coord 1e pt image out */
	get_inr_coord(nbopt,win_opts,win); /* taille fenetre */

	if(choix) {
	  mtype = 0x10000;
	  if(igetopt0("-tr")) {
	    mtype |= 1;
	    strcat(ivals,"]0");
	  } else {
	    if(igetopt1("-rgi","%s",ivals)) mtype |= 1;
	    if(igetopt1("-rgo","%s",ovals)) mtype |= 0x100;
	  }
	}
	if(gtstopts(0,1,0) > 0)
		iusage_(ppcmd->ucmd,ppcmd->udetail);
	smelan_(inname,outname,in_pt,out_pt,win,&mtype,ivals,ovals);
	return 0;

}


static void get_inr_coord(n,opts,res)
int n;
char **opts;
Fort_int *res;
{
  int dummy;
  register i;
  for(i=0;i<n;i++) {
    if(! igetopt1(*opts++,"%d",&dummy)) *res = 0;
    else *res = dummy;
    res++;
  }
}
