#include <inrimage/inrfile.h>
#include <inrimage/error.h>
#include <inrimage/contour.h>

#include <stdio.h>
#include <stdlib.h>
#if defined(HAVE_SYS_TYPES_H) && defined(HAVE_UNISTD_H)
#include <sys/types.h>
#include <unistd.h>
#else
extern off_t lseek();
#endif

extern debug_,koctet_;
static char Ucmd[]=
"[-wr output-ascii-file] [-a | -h | -c] [-x] [-y] [-z] [-v] [-x0] [-y0] [-z0] [-f] [-r] [-p] [-o] [-b] [-e] [-imbi] [-imsc] [-F] [-hdr] [-m] [image ... image]";

static char Udetail[]=
"\tliste sur stdout le format des images,\n\
\t avec l'historique si '-h', les commentaires si '-c', toutes les \n\
\t informations ascii si '-a'.\n\
\t Si d'autres options sont presentes, on liste sur stdout les valeurs\n\
\t qui leur correspondent.\n\
\t -wr: fichier de sortie (defaut stdout, -wr stderr => sortie stderr)";

FILE *outf;

struct image *c_ouvimf();
static struct image *nf;
static struct nf_fmt gfmt;
static char *tabcod[]= {"-a","-h","-c"};
static tst_taille();
static int rd_opt1();
static int prt_opts();

extern FILE *asciifileopt();

#define P_FMT 1
#define P_VERS 2
#define P_HIST 4
#define P_ASCII 8
#define P_DIV 0x10
#define P_COMM 0x20

main(int argc,char **argv)
{
	char nom[128];
	int iopt;
	int all = 1;
	int first;
	int next;
	int i;
	int ier;

	inr_init(argc,argv,"2.2",Ucmd,Udetail);

	iopt = 0;
	fileopt(nom,"i");

	next= 1;
	first = 1;
	silent_err();
	iopt = 3;
	if((i = itoggleopt("-choix1",tabcod,3)) >= 0) {
	  // iopt |= (i == 0) ? 8 : 4;
	  switch( i) {
	  case 0: iopt = P_ASCII; break;
	  case 1: iopt = P_HIST; break;
	  case 2: iopt = P_COMM; break;	    
	  }
	}
	if((outf = asciifileopt("-wr",1)) == NULL)
		outf = stdout;
	if((all = rd_opt1()) != 0) {
		if(tstopts())
			iusage_(Ucmd,Udetail);
	} else {
		if(tstoptm())
			iusage_(Ucmd,Udetail);
	}
	while (next) {
		c_erreur(ier);
		if(ier != 0) goto suite;
		if ( (nf = c_ouvimf( nom,&gfmt,1) ) == (struct image *)0 ) {
		        struct fc_cont *fct;
			fct = c_iouvct( nom, 0, "r");
			if( fct != NULL) {
			  Fort_int a,b;
			  c_irctgp( fct, &a, &b, &a, &a, &a);
			  fprintf(stderr,"%s est un fichier de contours et decrit %d contour%s.\n",
				 nom, b, b>1 ? "s":"");
			  c_fermct( fct);
			} else
			  fprintf(stderr,"%s:probleme avec %s\n",argv[0],nom);
			goto suite;
		}
		if(first) {
			first = 0;
			if(all) {
				prt_opts(nf,&gfmt,all);
				exit(0);
			}
		}
		tst_taille(nf);
		c_prtnf(nf,iopt,outf);
		/*		if (desc.flag & COMMENT) printf("%s",desc.comment);
				if (desc.flag & MMM)
				printf("minimum=%g maximum=%g moyenne=%g\n",
				desc.minimum,desc.maximum,desc.moyenne);
				*/
		fermnf_(&nf);
	suite: next = xfileopt(nom,"i",0);
	}
	return first;
}


static tst_taille(struct image *nf)
{
	int desc;
	off_t taille;
#ifdef OLDOLD
	desc = 256;
#else
	desc = nf->desc_size;
#endif
	taille = lseek(nf->fd,(off_t)0,2);

	if ( taille != -1 ) {
		if (nf->DIMY * nf->hors_tout + desc > taille )
			fprintf(stderr,
				"%s:attention taille incorrecte (%d au lieu de %d)\n",
				nf->nom,taille,(nf->DIMY*nf->hors_tout) +desc);
	}
}

#define OP_X 1
#define OP_Y 2
#define OP_Z 4
#define OP_V 8
#define OP_TYP 0x10
#define OP_BS 0x20
#define OP_EXP 0x40
#define OP_M 0x80
#define OP_X0 0x100
#define OP_Y0 0x200
#define OP_Z0 0x400
#define OP_BI 0x800
#define OP_SC 0x1000
#define OP_F 0x2000
#define OP_HDR 0x4000

static int rd_opt1()
{
	int code= 0;
	if ( igetopt("-F","",0,"",0,"",0) ) {
		code |= OP_F;
	}
	if ( igetopt("-hdr","",0,"",0,"",0) ) {
		code |= OP_HDR;
	}
	if ( igetopt("-x","",0,"",0,"",0) ) {
		code |= OP_X;
	}
	
	if ( igetopt("-y","",0,"",0,"",0) ) {
		code |= OP_Y;
	}
	
	if ( igetopt("-v","",0,"",0,"",0) ) {
		code |= OP_Z;
	}
	
	if ( igetopt("-z","",0,"",0,"",0) ) {
		code |= OP_V;
	}
	if ( igetopt("-x0","",0,"",0,"",0) ) {
		code |= OP_X0;
	}
	if ( igetopt("-y0","",0,"",0,"",0) ) {
		code |= OP_Y0;
	}
	if ( igetopt("-z0","",0,"",0,"",0) ) {
		code |= OP_Z0;
	}
	if ( igetopt("-m","",0,"",0,"",0) ) {
		code |= OP_M;
	}
	
	if ( igetopt("-b","",0,"",0,"",0) ||
	    igetopt("-o","",0,"",0,"",0) ) {
		code |= OP_BS;
	}
	
	if ( igetopt("-f","",0,"",0,"",0) ||
	    igetopt("-r","",0,"",0,"",0) ||
	    igetopt("-p","",0,"",0,"",0) ) {
		code |= OP_TYP;
	}
	
	if ( igetopt("-e","",0,"",0,"",0) ) {
		code |= OP_EXP;
	}
	if ( igetopt("-imbi","",0,"",0,"",0) ) {
		code |= OP_BI;
	}
	if ( igetopt("-imsc","",0,"",0,"",0) ) {
		code |= OP_SC;
	}
	
	return code;
}

static int prt_opts(struct image *nf,struct nf_fmt *pgfmt,int code)
{
	if(code & OP_F) {
		fprintf(outf," -F=%s",version_name(nf->i_version));
	}
	if(code & OP_HDR) {
		fprintf(outf," -hdr=%d",nf->desc_size / DESC);
	}
	if(code & OP_X) {
		fprintf(outf," -x %d",pgfmt->NDIMX);
	}
	
	if(code & OP_Y) {
		fprintf(outf," -y %d",pgfmt->NDIMY);
	}
	
	if(code & OP_Z) {
		fprintf(outf," -v %d",pgfmt->NDIMV);
	}
	
	if(code & OP_V) {
		fprintf(outf," -z %d",pgfmt->NDIMZ);
	}
	if(code & OP_X0) {
		fprintf(outf," -x0 %d",pgfmt->X_OFFSET);
	}
	if(code & OP_Y0) {
		fprintf(outf," -y0 %d",pgfmt->Y_OFFSET);
	}
	if(code & OP_Z0) {
		fprintf(outf," -z0 %d",pgfmt->Z_OFFSET);
	}
	if(code & OP_M) {
		if(pgfmt->maille == I_HEXAG)
			fprintf(outf," -m=h");
		else
			fprintf(outf," -m=r");
	}
	
	if(code & OP_BS) {
		if ( pgfmt->BSIZE > 0 ) fprintf(outf," -o %d",pgfmt->BSIZE);
		else 		    fprintf(outf," -b %d",-pgfmt->BSIZE);
	}
	
	if(code & OP_TYP) {
		switch ( pgfmt->TYPE ) {
		case REELLE :
			fprintf(outf," -r");
			break;
		case FIXE :
			fprintf(outf," -f");
			break;
		case PACKEE :
			fprintf(outf," -p");
			break;
		}
	}
	
	if(code & OP_EXP && (pgfmt->TYPE != REELLE)) {
		fprintf(outf," -e %d",pgfmt->EXP-200);
	}
	if(code & OP_BI) {
		fprintf(outf," -imbi %f",pgfmt->bias);
	}
	if(code & OP_SC) {
		fprintf(outf," -imsc %f",pgfmt->scale);
	}
	
	return 0;
}
