#include <inrimage/image.h>
#include <stdio.h>

static char Ucmd[]=
"{-sx | -sy | -da | -db | -ta | -tb | -tc} [image-in] [image-out]";
static char Udetail[]=
"\t -sx : symetrie / ligne mediane\n\
\t -sy : symetrie / colonne mediane\n\
\t -da : symetrie / 1ere diagonale\n\
\t -db : symetrie / 2e diagonale\n\
\t -ta : rotation 90 deg. autour du centre\n\
\t -tb : rotation 180 deg. autour du centre\n\
\t -tc : rotation 270 deg. autour du centre";

static char Ucmd0[]= "-sx [image-in] [image-out]";
static char Ucmd1[]= "-sy [image-in] [image-out]";
static char Ucmd2[]= "-da [image-in] [image-out]";
static char Ucmd3[]= "-db [image-in] [image-out]";
static char Ucmd4[]= "-ta [image-in] [image-out]";
static char Ucmd5[]= "-tb [image-in] [image-out]";
static char Ucmd6[]= "-tc [image-in] [image-out]";

static struct multi_cmd cmds[] = {
	"-sx",Ucmd0,Udetail,	/*  1 */
	"-sy",Ucmd1,Udetail,	/*  2 */
	"-da",Ucmd2,Udetail,	/*  3 */
	"-db",Ucmd3,Udetail,	/*  4 */
	"-ta",Ucmd4,Udetail,	/*  5 */
	"-tb",Ucmd5,Udetail,	/*  6 */
	"-tc",Ucmd6,Udetail,	/*  7 */
	"",Ucmd,Udetail,	/*  default */
	0,0,0,
};

extern debug_;


fcmain_()

{
	char inname[80],outname[80];
	Fort_int choix = 1 ;

	choix = inr_initm(0,0,"2.1",cmds);
	if(choix < 0) {
		fprintf(stderr,"Il faut l'une des options -sx -sy -da -db -ta -tb -tc\n");
		iusage_(Ucmd,Udetail);
	}
	if(!igetopt(cmds[choix].name,"",0,"",0,"",0))
		iusage_(Ucmd,Udetail);
	choix++;
	if(debug_) {
		switch (choix) {
		case 1:
			fprintf(stderr,"symetrie/x\n");
			break;
		case 2:
			fprintf(stderr,"symetrie/y\n");
			break;
		case 3:
			fprintf(stderr,"symetrie/1ere diagonale\n");
			break;
		case 4:
			fprintf(stderr,"symetrie/2eme diagonale\n");
			break;
		case 5:
			fprintf(stderr,"rotation de 90 degres\n");
			break;
		case 6:
			fprintf(stderr,"rotation de 180 degres\n");
			break;
		case 7:
			fprintf(stderr,"rotation de 270 degres\n");
			break;
		}
	}

	fileopt(inname,"i");
	fileopt(outname,"o");
	if(tstopts())
		iusage_(Ucmd,Udetail);

	strans_(inname,outname,&choix);
	return 0;

}


