#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <stdio.h>

#include "fcmain.h"

static char version[]= "2.3";
static char Ucmd[]=
"[-k] [-D] [contour-file [-xv[=v1,v2] | -tek[P]] [ -pos | -neg] [-cf] [-s min[,max]][-p x,y] [-e env] [-l cont-list]]";
static char Udetail[]=
"\t-xv[=v1,v2] : sortie sur stdout au format de xvisdraw (v1,v2 = val trace pos et neg, -1=> num cont.)\n\
\t-tek[P] : sortie format tektro, apres effacement si -tekP\n\
\t-pos : contours positifs seulement\n\
\t-neg : contours negatifs seulement\n\
\t-cf => contours fermes \n\
\t-e env : contour d'enveloppe numero env (( ext. si -e 0, int. si env<0)\n\
\t -l : liste de numeros de contours, dans l'ordre croissant (1,3,5-10) \n\
\t -s min,max : ne garder que  les contours de surface comprise entre min et max\n\
\t -p x,y : ne garder que  les contours contenant le point x,y\n";

static Fort_int flg_vis= 0, isens = 0, flg_closed= 0, ismmx[2], point[2], num_env=0;
static Fort_int xv_val[2]= {255,0};
static Fort_int numax, nbct, xydim[2];
struct fc_cont *open_ct();
static Fort_int list_cont[256];

extern int vischn_();

f_c_main
{
	struct fc_cont *ct_in;
	char buf[64]; 
	char filename[512];
	char tkbuf[128];
	Fort_int ier;
	Fort_int zero= 0, n, ndimv;
	int dum1, dum2;

	inr_init(ARGC,ARGV,version,Ucmd,Udetail);
	if(!tstopts()) { /* mode interactif */
		kviscn_();
		return 0;
	}
	if(igetopt("-tek","",0,"",0,"",0))
		flg_vis = 1;
	else if(igetopt("-tekP","",0,"",0,"",0)) {
		flg_vis = 5;
	} else if(igetopt("-xv","",0,"",0,"",0))
		flg_vis = 6;
	else if(igetopt("-xv=","%s",buf,"",0,"",0)) {
		flg_vis = 2;
		sscanf(buf,"%d,%d",&dum1,&dum2);
		xv_val[0] = dum1; xv_val[1] = dum2; 
	}
	isens = 0;
	if(igetopt("-pos","",0,"",0,"",0))
		isens = 1;
	else if(igetopt("-neg","",0,"",0,"",0))
		isens = -1;
	flg_closed = igetopt("-cf","",0,"",0,"",0);
	ismmx[0] = 0;
	ismmx[1] = 0x7fffffff;
	if(igetopt("-s","",0,"%s",buf,"",0)) {
		sscanf(buf,"%d,%d",&dum1,&dum2);
		ismmx[0] = dum1; ismmx[1] = dum2;
		if((ismmx[0] > ismmx[1]) || (ismmx[0] < 0))
			iusage_(Ucmd,Udetail);
	}
	point[0]= -1;
	point[1] = -1;
	if(igetopt("-p","",0,"%s",buf,"",0)) {
		sscanf(buf,"%d,%d",&dum1,&dum2);
		point[0] = dum1; point[1] = dum2;
		if((point[0] < 0) || (point[1] < 0))
			iusage_(Ucmd,Udetail);
	}
	if ( !igetopt("-l","",0,"%s",list_cont,"",0))
		list_cont[0] = 0;
	if(igetopt("-e","",0,"%d",&dum1,"",0)) {
	         num_env = dum1;
		if(num_env < 0) num_env = -1;
	} else
		num_env = -2;
	if(!igetopt("","%s",filename,"",0,"",0))
		iusage_(Ucmd,Udetail);
	if(tstopts())
		iusage_(Ucmd,Udetail);
	ct_in = open_ct(filename,xydim,&numax,&nbct);
	if(flg_vis & 1)
		c_t4init(128,0,tkbuf);
	n = 1;
	ndimv = 1;

	exec_(&ier,&zero,&zero,&n,&ndimv,vischn_,&ct_in,&numax,&flg_vis,&flg_closed,&isens,&num_env,ismmx,point,xv_val,list_cont,xydim,&ier);
	if(flg_vis & 1) {
		t4end_();
		fertek_();
	}
	return 0;
}

struct fc_cont *open_ct(nom,xydim,pnumax,pnbct)
char *nom;
Fort_int *xydim, *pnumax, *pnbct;
{
	Fort_int ixy0[2], idimxy[2]; 
	Fort_int npmax, nblocs, iftyp;
	struct fc_cont *ct_in;
	ct_in = c_iouvct(nom,0,"r");
	c_irctgp(ct_in,pnumax,pnbct,&npmax,&nblocs,&iftyp);
	fprintf(stderr,"%ld contours (max %ld)\n",*pnbct,*pnumax);
	if(!c_irctdm(ct_in,ixy0,idimxy)) {
		fprintf(stderr,"\n-ix %d -iy %d -dx %d -dy %d\n",ixy0[0],ixy0[1],idimxy[0],idimxy[1]);
		*xydim = ixy0[0] - 1 + idimxy[0];
		*(xydim+1) = ixy0[1] - 1 + idimxy[1];
	} else {
		*xydim = 4096;
		*(xydim+1)= 4096;
	}
	return ct_in;
}
