/*  SAPOLD
	SUBROUTINE SAPOLD(in,out,EPS,iopfr,iotype,pos)
	sapold_(in,out,eps,iotype,iopfr,pos)
   approximation polygonale de contours fermes ou non (iopfr = 1 ou 0)
iotype : contient 1 si input au format anac, + 0x100 si output format anac
Si input DZV et iopfr >0 on elimine les contours non fermes
si input chaines et pos > 0 : on ne garde que les contours positifs
*/
#include <inrimage/image.h>
#ifdef WITH_DZV
#include <dzv.h>
#endif
#include <stdio.h>

extern int *c_iouvct();

extern errno;
extern debug_;
#define NOTDZVIN 1
#define NOTDZVOUT 0x100
#ifdef WITH_DZV
static int init_dzv_in(), init_dzv_out();
extern int c_apoldzv();
#else  /* emulates DZV */
# define init_dzv_in(name,n_elt,dimx,dimy) 0
# define init_dzv_out(name,n_elt,dimx,dimy,idzv) 0
# define cl_fic(x)
extern int c_apold();
#endif
static Fort_int zero = 0;
static int dimx= 0, dimy= 0;
sapold(in,out,eps,iopfr,iotype,pos,idimx,idimy,smin)
unsigned char *in, *out;
int *iopfr, *iotype, *pos;
float *eps;
int idimx, idimy, *smin;
{
	int *ct_in, *ct_out;
	int in_dzv, out_dzv;
	Fort_int n;
	int nbcont, parmax, nmx;
	Fort_int ier;
	int idzv;
	Fort_int idimv[2];
	dimx = idimx;
	dimy = idimy;
	if(*iotype & NOTDZVIN) {
		idzv = 0;
		ct_in = c_iouvct(in,0,"r");
		c_irctgp(ct_in,&nmx,&nbcont,&parmax,&n,&n);
		if(parmax >= 64)
			imerror(9,"trop de parametres par contour\n");
	} else {
		idzv = 1;
		in_dzv = init_dzv_in(in,&nmx,&dimx,&dimy);
		ct_in = &in_dzv;
	}
	if(*iotype & NOTDZVOUT) {
		ct_out = c_iouvct(out,1,"w");
	} else {
		out_dzv = init_dzv_out(out,nmx,&dimx,&dimy,idzv);
		ct_out = &out_dzv;
	}
	n = 2;
	idimv[0] = 1;
	idimv[1] = 1;
#ifdef WITH_DZV
	exec_(&ier,&zero,&zero,&n,idimv,c_apoldzv,ct_in,ct_out,&nmx,eps,iopfr,iotype,pos,smin,&ier);
#else
	exec_(&ier,&zero,&zero,&n,idimv,c_apold,ct_in,ct_out,&nmx,eps,iopfr,iotype,pos,smin,&ier);
#endif
	imperr_(&ier);
	if(*iotype & NOTDZVIN) {
		c_fermct(ct_in);
	} else {
		cl_fic(in_dzv);
	}
	if(*iotype & NOTDZVOUT) {
		c_fermct(ct_out);
	} else {
		cl_fic(out_dzv);
	}
}

#ifdef WITH_DZV
static DZV *dzv_fic, *dzv_elt, *dzv_mai;
extern DZV *cr_dzv();
static int init_dzv_in(name,n_elt,dimx,dimy)
char *name;
int *n_elt, *dimx, *dimy;
{
	register fd;
	char *f_type;
	char COMM[80];
	int *taillz , nb_zone , ta_mai, ta_jo , ta_mo ;
	char *typage;
	char *TYP;
	float *moye;
	if((fd = op_fic_base(name,&f_type,n_elt,&dzv_fic,&dzv_elt,&dzv_mai)) < 0)
		imerror(1,"open err %d on %s\n",errno,name);
	re_fic(fd,COMM, dimx, dimy );
/*	ra_fic(fd,1,0); */
	if(debug_)
		fprintf(stderr,"fichier type %s, dimx= %d, dimy=%d\n",f_type,*dimx,*dimy);
	/* Definition du fichier sur disque auquel on s'attend */
	re_dzv(dzv_elt,&nb_zone,&taillz,&typage) ;
	ta_jo = taillz[1] ;
	ta_mo = taillz[4] ;
	if ( nb_zone != 4 && ta_jo != 5 && ta_mo != 2 )
		imerror(9," La definition de dzv_elt n'est pas celle du fichier lu \n") ;
	re_dzv(dzv_mai,&nb_zone,&taillz,&typage) ;
	ta_mai = taillz[1] ;
	if (nb_zone != 1 && ta_mai != 3  )
		imerror(9," La definition de dzv_mai n'est pas celle du fichier lu \n") ;
	if(debug_) {
		fprintf(stderr," Nbre de segments du fichier %d (attention a la validite)\n",n_elt) ;
		fprintf(stderr," Commentaires : %s ",COMM) ;
	}
	return fd;
}
#define MA 7   /* on ne peut creer des maillons a plus de 7 elements */
#define BA 2   /* nombre de valeur flottante de l'entete */
#define JO 5   /* nombre short par famille */
/* si idzv = 0, on remplace moyenne variance par enveloppe surface */
static int init_dzv_out(name,n_elt,dimx,dimy,idzv)
char *name;
int n_elt, *dimx, *dimy;
int idzv;
{
	int ta;
	register fd;
	ta = 3;  /* taille maillons */
	dzv_fic = cr_dzv(3,20,"char","approx polyg",1,"int","dimx",1,"int","dimy");
		de_bug("dzv_fic mal passe") ;
	if(idzv == 0)
		dzv_elt = cr_dzv(4,JO,"short","jonct tete",JO,"short","jonct queue",1,"short","fermeture",BA,"int","enveloppe surface") ;
	else
		dzv_elt = cr_dzv(4,JO,"short","jonct tete",JO,"short","jonct queue",1,"short","fermeture",BA,"float","moyenne variance") ;
	de_bug("dzv_elt mal passe") ;
	dzv_mai = cr_dzv(1,ta,"short","x y nul") ;
	de_bug("dzv_mai mal passe") ;

	fd = cr_fic_base(name,"chaines",n_elt,dzv_fic,dzv_elt,dzv_mai);
	de_bug("creation mal passee") ;

	wr_fic(fd, "chainage avec apold" ,dimx,dimy );
	de_bug("wr_fic :  mal passee") ;
	return fd;
}
#endif
