/* SEXTIM
   subroutine sextim(in,out,first_pt,pas_echan,fl_noct,flag_extend)
   extraction d'une partie d'une image de type quelconque
	a partir du point first_pt (ix,iy,iz,iv)
    pas_echan : pas d'echantillonnage en x y z v (uniquement si flag_extend != 0)
   flag_extend= 0 => ix de 1 a DIMX, iv ignore
   flag_extend= 1 => ix de 1 a NDIMX, iv pris en compte, et utilisation de pas_echan
*/
#include <stdlib.h>
#include <inrimage/image.h>
#include <inrimage/inrfile.h>

extern int extimg_(), extimgv_();
extern int IM_nbmin_hdr;

sextim_(in,out,first_pt,pas_echan,fl_noct,flag_extend)
char *in, *out;
register Fort_int *first_pt, *pas_echan, *fl_noct, *flag_extend;
{
	Fort_int lfmt[9], lfmto[9];
	struct image *nfi, *nfo;
	Fort_int ntabv, ier;
	Fort_int zero= 0;
	Fort_int un= 1;
	Fort_int nixi;
	char *verif;
	int use_subvect= 0;
	nfi = image_(in,"e","",lfmt);
	c_mvmots(lfmt,lfmto,9);
	if(!*fl_noct) {  /* keep hdr size */
		IM_nbmin_hdr = nfi->desc_size / FILE_HEADER_LEN;
	}
	verif= "t";
	if(*flag_extend && ifsize_(out) <= 0) {
	  lfmto[I_NDIMX] = 1 + (lfmt[I_NDIMX] - *first_pt)/ *pas_echan;
	  lfmto[I_NDIMY] = 1 + (lfmt[I_NDIMY] - *(first_pt+1)) / *(pas_echan+1);
	  lfmto[I_NDIMZ] = 1 + (lfmt[I_NDIMZ] - *(first_pt+2)) /  *(pas_echan+2);
	  lfmto[I_NDIMV] = 1 + (lfmt[I_NDIMV] - *(first_pt+3)) /  *(pas_echan+3);
	  if(lfmto[I_NDIMX] < 0) lfmto[I_NDIMX] = 1;
	  if(lfmto[I_NDIMY] < 0) lfmto[I_NDIMY] = 1;
	  if(lfmto[I_NDIMZ] < 0) lfmto[I_NDIMZ] = 1;
	  if(lfmto[I_NDIMV] < 0) lfmto[I_NDIMV] = 1;
	  opt_modfmt((struct nf_fmt*) lfmto,2);
	  verif= "a";
	}
	nfo = image_(out,"s",verif,lfmto);
	if(*flag_extend) {
	  if((lfmto[I_NDIMV] != lfmt[I_NDIMV]) || (*(first_pt+3) != 1)
	     || (*pas_echan > 1) || (*(pas_echan+1) > 1)
	     || (*(pas_echan+2) > 1) || (*(pas_echan+3) > 1))
	    use_subvect= 1;
	}
	if(! *fl_noct)
		icop_ct(nfi,nfo);
	if(*first_pt <= 0) *first_pt = 1;
	if(*(first_pt+1) <= 0) *(first_pt+1) = 1;
	if(*(first_pt+2) <= 0) *(first_pt+2) = 1;
	if(*(first_pt+3) <= 0) *(first_pt+3) = 1;
	if(*flag_extend) {
	  if(! use_subvect)
	    *first_pt = 1 + ((*first_pt - 1) * lfmt[I_NDIMV]);
	} else if((lfmt[I_NDIMV] != 1) || (lfmto[I_NDIMV] != 1)) {
	    fprintf(stderr,"ATTENTION! Ce programme n'est pas adapte aux images vectorielles: utilisez extg\n");
	}
	ntabv = 1;
	if(use_subvect)
	  exec_(&ier,&zero,&zero,&un,&ntabv,extimgv_,&nfi,&nfo,first_pt,pas_echan,&ier);
	else
	  exec_(&ier,&zero,&zero,&un,&ntabv,extimg_,&nfi,&nfo,first_pt,first_pt+1,first_pt+2,&ier);
	imperr_(&ier);
	if( ier ) exit( ier);
	fermnf_(&nfi);
	fermnf_(&nfo);
}
