/*  
	sfillc_(out,cont,fill_im,flg_fill,fvbuf,afillval,list_cont,isens,num_env,xoff,yoff,izo,nbz,ismmx,flg_add)
	construit une image en remplissant les contours
   flg_fill (mode remplissage) : -1 -> selon num cont, 0 -> constante, 1/2 -> avec image (contours pos / neg)
  isens : 1, -1 ou 0 = contours pos, neg ou les 2
  num_env : num enveloppe (>= 0), -1 = tout sauf 0, -2 = pas de test
  ismmx[2] : surf min et max
  si izo > 0 : c'est l'indice du 1er plan, et nbz est le nb de plan
  	ou on repete le meme remplissage
  si ivo > 0 : c'est l'indice de la 1e composante vect, et nbv est le nb 
  de composantes a remplir
*/
#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>
#include <inrimage/contour.h>

extern int fillcont();
extern struct fc_cont *c_iouvct();

extern char *index();

static struct image *nf, *nf_fill;

static Fort_int lfmt[9], lfmti[9];
extern errno;
extern debug_;
static Fort_int zero = 0;
sfillc_(out,cont,fill_im,flg_fill,fvbuf,afillval,list_cont,isens,num_env,ixoff,iyoff,xoff,yoff,pizo,pnbz,pivo,pnbv,ismmx,flg_add)
unsigned char *cont, *out, *fill_im, *list_cont, *fvbuf;
Fort_int *isens, *num_env;
Fort_int *ixoff, *iyoff, *xoff, *yoff, *ismmx, *flg_fill, *afillval, *flg_add;
Fort_int *pnbz, *pizo, *pnbv, *pivo;
{
	struct fc_cont *ct_in;
	Fort_int n, nmax, nbcont, parmax, idimv;
	int nmx, i, val;
	Fort_int ier;
	int *fill_vals;
	char *bufim, *bufim2, *pc;
	char icom[128];
	register iy, iyi, ny, nyi;
	Fort_int nbz, izo, nbv, ivo;
	char *verif;
	nbz = *pnbz;
	izo = *pizo;
	nbv = *pnbv;
	ivo = *pivo;
	ct_in = c_iouvct(cont,0,"r");
	c_irctcm(ct_in,icom);
	if(debug_)
		fprintf(stderr,"opened %s : %s\n",cont,icom);
	c_irctgp(ct_in,&nmx,&nbcont,&parmax,&n,&n);
	if(parmax >= 64)
		imerror(9,"trop de parametres par contour\n");
	
	BSIZE = 1;
	TYPE = FIXE;
	EXP = 200;
	nf = image_(out,"s","t",lfmt);
	memcpy(lfmti,lfmt,sizeof(lfmt));
	if(*fill_im != 0) {
		nf_fill = image_(fill_im,"e","t",lfmti);
		if((lfmti[I_NDIMV] != NDIMV) || (lfmti[I_NDIMZ] != NDIMZ))
			imerror(7,"mauvais parametre NDIMV ou NDIMZ pour %s\n",fill_im);
	} else
		verif = "t";
	if(izo > NDIMZ)
		izo = NDIMZ;
	if(izo) {
		if(nbz > (NDIMZ - izo + 1))
			nbz = NDIMZ - izo + 1;
	}
	if(izo > 0) {
		iy = (izo - 1) * NDIMY + 1;
		ny = NDIMY * nbz;
		iyi = (izo - 1) * lfmti[I_NDIMY] + 1;
		nyi = lfmti[I_NDIMY] * nbz;
	} else {
		ny = DIMY;
		iy = 1;
		nyi = lfmti[I_DIMY];
		iyi = 1;
	}
	if(ivo > NDIMV)
		ivo = NDIMV;
	if(ivo) {
		if(nbv > (NDIMV - ivo + 1))
			nbv = NDIMV - ivo + 1;
	} else {
		ivo = 1;
		nbv = NDIMV;
	}
	bufim = (char *)i_calloc(DIMX * ny, sizeof(char));
	if(*flg_add) {
		c_lptset(nf,iy);
		c_lect(nf,ny,bufim);
		c_lptset(nf,iy);
	} else if(izo) {
		c_lptset(nf,iy);
	}
	if(*fill_im != 0) {
/*		nf_fill = image_(fill_im,"e","a",lfmt); */
		bufim2 = (char *)i_calloc(lfmti[I_DIMX] * nyi, sizeof(char));
		c_lptset(nf_fill,iyi);
		c_lect(nf_fill,nyi,bufim2);
		fermnf_(&nf_fill);
	} else {
		bufim2 = (char *)0;
		if(*flg_fill == 0) {
			fill_vals = (int *)i_malloc(nbv * sizeof(int));
			decode_pixel((char *)fvbuf,fill_vals,nbv,0,"/",'/');
		}
	}
	n = 1;
	idimv = 1;
	nmax = (Fort_int)nmx;
	exec_(&ier,&zero,&zero,&n,&idimv,fillcont,bufim,&bufim2,&ct_in,&nf,lfmti,lfmt,&nmax,ixoff,iyoff,xoff,yoff,&nbz,&ivo,&nbv,isens,num_env,ismmx,flg_fill,fill_vals,afillval,list_cont,&ier);
	imperr_(&ier);
	c_fermct(ct_in);
}

