/*
	SUBROUTINE SMELAN(in,out,inpt,outpt,win,mtype,ivals,ovals)
  MELANGE UNE PARTIE D'UNE IMAGE DANS UNE AUTRE, A UN ENDROIT QQUE
  IMAGES DE TYPE QUELCONQUE
  inpt = coord x,x,z 1e pt in
  outpt = coord x,x,z 1e pt out
  win = taille fenetre (x,y,z,v)  (v force a NDIMV)
  mtype : 0 = ancienne version (x de 1 a DIMX)
         & 0x10000 new version, mtype & 0x1f1f == 0 : cas normal, >0 : avec transparence 
		(test sur ivals si &0xff et/ou ovals si  &ff00
		&1 = existe borne inf, &2 = ex. b. sup., & 4/8 = borne (inf/sup)
		comprise), &0x10 = inverser le test (hors intervalle)
  ivals, ovals chaines de car. decrivant un intervalle, bornes comprises par def
  de valeurs a conerver dans in et a remplacer dans out (1 val / composante)
  Ex: 1/2,255  ]0,255]
  */
#include <inrimage/image.h>

#define MEL_NEW 0x10000
#define MSK_IN MSK_ITVL
#define MSK_OUT (MSK_IN << 8)
#define MEL_MSK (MSK_IN | MSK_OUT)

extern Fort_int ispipe_(), isempty_();
extern void raz_(), melang_(), cpimag_();

static Fort_int un= 1, zero= 0;

smelan_(in,out,in_pt,out_pt,win,mtype,ivals,ovals)
char *in, *out, *ivals, *ovals;
Fort_int *in_pt, *out_pt, *win;
Fort_int *mtype;
{
  struct nf_fmt lfmti, lfmto;
  struct image *nfi, *nfo, *nfto;
  register i;
  int nmx, sfto, fl_pipe, is_float, ndimv;
  Fort_int ntab, ndi, ier, ntype;
  int *in_msk, *out_msk;
  nfi = image_(in,"e"," ",&lfmti);
  lfmto.lfmt[I_TYPE] = lfmti.lfmt[I_TYPE];
  lfmto.lfmt[I_BSIZE] = lfmti.lfmt[I_BSIZE];
  lfmto.lfmt[I_EXP] = lfmti.lfmt[I_EXP];
  nfo = image_(out,"s","t",&lfmto);
  for(i=0;i<4;i++) {
    if(in_pt[i] <= 0) in_pt[i] = 1;
  }
  for(i=0;i<4;i++) {
    if(out_pt[i] <= 0) out_pt[i] = 1;
  }
  ntype = *mtype & MEL_NEW ? MEL_NEW : 0;
  if(! ntype) {
    if(lfmto.lfmt[I_NDIMV] != lfmti.lfmt[I_NDIMV])
      imerror(7,"Les 2 images doivent avoir meme NDIMV\n");
    if(lfmto.lfmt[I_NDIMV] != 1 || lfmti.lfmt[I_NDIMV] != 1)
      fprintf(stderr,"ATTENTION! Ce programme n'est pas adapte aux images vectorielles: utilisez melg\n");
  }
  i = (ntype & MEL_NEW) ? I_NDIMX : I_DIMX;
  nmx = lfmto.lfmt[i] - out_pt[0] + 1;
  if (nmx > (lfmti.lfmt[i] - in_pt[0] + 1)) nmx = lfmti.lfmt[i] - in_pt[0] + 1;
  if(nmx <= 0) imerror(9,"Origines en x incorrectes\n");
  if(win[0] <= 0) {
    win[0] = nmx;
  } else if(win[0] > nmx) imerror(6,"ndimx de la fenetre trop grand (max %d)\n",nmx);

  nmx = lfmto.lfmt[I_NDIMY] - out_pt[1] + 1;
  if (nmx > (lfmti.lfmt[I_NDIMY] - in_pt[1] + 1)) nmx = lfmti.lfmt[I_NDIMY] - in_pt[1] + 1;
  if(nmx <= 0) imerror(9,"Origines en z incorrectes\n");
  if(win[1] <= 0) {
    win[1] = nmx;
  } else if(win[1] > nmx) imerror(6,"ndimy de la fenetre trop grand (max %d)\n",nmx);


  nmx = lfmto.lfmt[I_NDIMZ] - out_pt[2] + 1;
  if (nmx > (lfmti.lfmt[I_NDIMZ]) - in_pt[2] + 1) nmx = lfmti.lfmt[I_NDIMZ] - in_pt[2] + 1;
  if(nmx <= 0) imerror(9,"Origines en y incorrectes\n");
  if(win[2] <= 0) {
    win[2] = nmx;
  } else if(win[2] > nmx) imerror(6,"ndimz de la fenetre trop grand (max %d)\n",nmx);

  nmx = lfmto.lfmt[I_NDIMV] - out_pt[3] + 1;
  if (nmx > (lfmti.lfmt[I_NDIMV]) - in_pt[3] + 1) nmx = lfmti.lfmt[I_NDIMV] - in_pt[3] + 1;
  if(nmx <= 0) imerror(9,"Origines en v incorrectes\n");
  if(win[3] <= 0) {
    win[3] = nmx;
  } else if(win[3] > nmx) imerror(6,"ndimv de la fenetre trop grand (max %d)\n",nmx);
  ndimv = win[3];

  ntab = 1;
  if(fl_pipe = ispipe_(&nfo)) {  /* sortie dans un pipe : il faut une image temp */
    nfto = image_("/tmp/melXXXXXX","t","a",&lfmto);
    ndi=1;
    exec_(&ier,&zero,&zero,&un,&ndi,raz_,&nfto,&sfto,&lfmto,&ier);
    c_lptset(nfto,1);
  } else {
    nfto=nfo;
    if(iempty_(&nfo)) {
      ndi=1;
      exec_(&ier,&zero,&zero,&un,&ndi,raz_,&nfo,&sfto,&lfmto,&ier);
      c_lptset(nfo,1);
    }
  }
  if(ntype & MEL_NEW && *mtype & MEL_MSK) {
    if((lfmti.lfmt[I_TYPE] == REELLE) || (lfmti.lfmt[I_BSIZE] > 1)
       || (lfmti.lfmt[I_BSIZE] < -8)) {
      is_float = 1;
      in_msk = (int *)i_malloc(2 * ndimv * sizeof(float));
      out_msk = (int *)i_malloc(2 * ndimv * sizeof(float));
      if(*mtype & MSK_IN) {
	ntype |= fpix_interval(ivals,(float *)in_msk,ndimv);
      }
      if(*mtype & MSK_OUT) {
	ntype |= (fpix_interval(ovals,(float *)out_msk,ndimv) << 8);
      }
    } else {
      is_float = 0;
      in_msk = (int *)i_malloc(2 * ndimv * sizeof(int));
      out_msk = (int *)i_malloc(2 * ndimv * sizeof(int));
      if(*mtype & MSK_IN) {
	ntype |= ipix_interval(ivals,in_msk,ndimv);
      }
      if(*mtype & MSK_OUT) {
	ntype |= (ipix_interval(ovals,out_msk,ndimv) << 8);
      }
    }
  }
  exec_(&ier,&zero,&zero,&un,&ntab,melang_,&nfi,&nfto,in_pt,out_pt,win,&ntype,in_msk,out_msk,&ier);
  if(fl_pipe) { /* sortie pipe */
    ndi= 1;
    exec_(&ier,&zero,&zero,&un,&ndi,cpimag_,&nfto,&nfo,&ier);
    rmnf_(&nfto);
  }
  imperr_(&ier);
  fpanic_();
}



