#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

static void fin_seg_noir(), seg_acheval();

/*
   c_anaseg(lseg1,lseg2,ilig,connect)
   analyse une ligne de segments et met a jour la table anac_iseg
   (lseg1 pts ligne prec., lseg2 ligne courante)
  ilig =  num ligne courante
  connect: definit la connexite (0=point commun , non 0= coin commun suff

 STRUCTURES :
 descripteurs :
     struct cont_desc
       num: numero >0 ou <0 selon sens direct ou retro
       numext: numero(sans signe)contour entourant (0 si n'ex. pas)
      p_bloc, d_bloc: indices (>=1) de strucy chn 1er et dernier bloc de la liste
      surf : surface avec signe des contours
    struct  iseg: 2 elements par segment (1e et 2e pt)
       x :   coordonnees du pt
       idesc : indice (>=1) de struct cont_desc du contour associe 
		 les blocs sont ranges a partir de la fin (le &e est anac_desc-1)
   table des pts de contour ou chaines (anac_chn)
   une chaine est composee d'un nb pair de blocs chaines (ip0: indice de struct chn)
   ip0  1e et der. bloc= indice dans bloc
    inext der. bloc= nb pnts au lieu de 0
   pts : coordonnes x,y ou 0
*/

static int j, k, ilig1, idesc, jmax, jmin, iconn;
static int x0k, x1k, x0j, x1j;

void c_anaseg(lseg1,lseg2,ilig,connect)
int lseg1,lseg2,ilig,connect;
{
	int iext;
	int is, j1, n1, n0, i;
	iconn = connect ?  1 : 0;
	/* indices : k ligne preec, j ligne cour. */
	ilig1 = ilig - 1;
	k = 1;
	jmin = lseg1 + 1;
	jmax = lseg1 + lseg2;
	j = jmin;
	while(1) {
		if(j >= jmax) { 
			if(k >= lseg1) return;
			/* fin ligne : on traite les seg. restant de la prec */
			/* disparition segment noir */ /* goto 5*/
			fin_seg_noir(k); /* LAB 5*/
/* 			k += 2; incr dans fin_seg_noir */
			continue;
		}
		if(k >= lseg1) { 
			/* LAB 110*/
			iext = 0;
			/*  GOTO 15*/
			/* LAB 15*/
			is=1;
			/* LAB 16 */
			c_newchn(&idesc,iext,is);
			(anac_iseg+j-1)->idesc = idesc;
			(anac_iseg+j)->idesc = idesc;
			/* LAB 45 */
			c_adtchn(anac_iseg+j-1,ilig);
			c_adtchn(anac_iseg+j,ilig);
			j += 2;
			continue;
		}
		x0j = (anac_iseg+j-1)->x;
		x1j= (anac_iseg+j)->x;
		x0k = (anac_iseg+k-1)->x;
		x1k = (anac_iseg+k)->x;
		if(x0j >= x0k) {
			if((x0j -iconn) > x1k) {
				/* LAB 5 */
				fin_seg_noir(k); /* LAB 5*/
				continue;
			}
			/* LAB 20 */
			/* 1e pt int a 1 segment */
			if((anac_iseg+j-1)->idesc == 0)  /* rien a gauche */
				(anac_iseg+j-1)->idesc = (anac_iseg+k-1)->idesc;
			/* GOTO 50 */
			seg_acheval(ilig);
			continue;
		}
		/* LAB 10 */
		/* cas 1er pnt exterieur a 1 segment i-1 */
		if((x1j+iconn) >= x0k) {
			/* LAB 60*/
			(anac_iseg+j-1)->idesc = (anac_iseg+k-1)->idesc;
			/* GOTO 50*/
			seg_acheval(ilig);
			continue;
		}
		n1 = (anac_iseg+k-1)->idesc;
		iext = (anac_desc-n1)->numext;
		if(k <= 2) {
			if((anac_desc-n1)->num < 0)
				imerror(9,"anaseg: pb de sens de contour\n");
			/* GOTO 15 */
		} else {
			n0 = (anac_iseg+k-2)->idesc;
			i = (anac_desc-n1)->num;
			if(n0 == n1) {
				/* LAB 12 */
				if(i < 0) iext = -i;
				else iext = (anac_desc-n1)->numext;
				/* GOTO 15*/
			} else if(i < 0) iext = -i;
		}
		/* LAB 15 */
		is = 1;
		/* LAB 16 */
		c_newchn(&idesc,iext,is);
		(anac_iseg+j-1)->idesc = idesc;
		(anac_iseg+j)->idesc = idesc;
		/* LAB 45 */
		c_adtchn(anac_iseg+j-1,ilig);
		c_adtchn(anac_iseg+j,ilig);
		j += 2;
		continue;
	}
}
/* LAB 34*/
void fin_seg_noir(n)
int n;
{
	if((anac_iseg+n-1)->idesc == (anac_iseg+n)->idesc) {
		/* LAB 37 */
		/* chaine terminee */
		c_finchn(anac_desc - (anac_iseg+k)->idesc,jmax);
	} else {
		c_unichn(anac_iseg,jmax,n,n+1,ilig1);
	}
	k += 2;
}

/* LAB 50 */
/* retourne incr de k */
void seg_acheval(ilig)
int ilig;
{
	int n1, n0, is;
	int j1, iext;
	while(1) {
		if(x1j <= x1k) {/* GOTO 70*/
			/* LAB 70 */
			if(((j+2) >= jmax) || (((anac_iseg+j+1)->x-iconn) > x1k)) {				/* LAB 80 */
				/* 2e extr entre 2 seg */
				(anac_iseg+j)->idesc = (anac_iseg+k)->idesc;
				c_adtchn(anac_iseg+j-1,ilig);
				c_adtchn(anac_iseg+j,ilig);
				j += 2;
				k += 2;
				return ;
			}
			/* nouvelle chaine sens retro */
				n1 = (anac_iseg+k)->idesc;
			j1 = j + 2;
			is = -1;
			n0 = (anac_iseg+k-1)->idesc;
			iext = (anac_desc-n1)->num;
			if(iext <= 0) {
				if((n0 == n1) || ((anac_desc-n0)->num < 0)) {
					/* LAB 73*/
					iext = (anac_desc-n0)->numext;
					/* GOTO 16 */
				} else {
					iext = (anac_desc-n0)->num;
					/* GOTO 16 */
				}
				
			} 
			/* GOTO 16*/
			/* LAB 16 */
			c_newchn(&idesc,iext,is);
			(anac_iseg+j1-1)->idesc = idesc;
			(anac_iseg+j)->idesc = idesc;
			/* LAB 45 */
			c_adtchn(anac_iseg+j-1,ilig);
			c_adtchn(anac_iseg+j,ilig);
			j += 2;
			return ;
		/* 2e extr ext au segm i-1 */
		}
		if((k+3) < jmin) {
			/* LAB 55 */
			if((x1j+iconn) >= (anac_iseg+k+1)->x) {
				fin_seg_noir(k+1);
				/* LAB 151 */
				x0k = (anac_iseg+k-1)->x;
				x1k = (anac_iseg+k)->x;
				continue;
			}  /* else GOTO 80 */
		} 
		/* LAB 80 */
		/* 2e extr entre 2 seg */
		(anac_iseg+j)->idesc = (anac_iseg+k)->idesc;
		c_adtchn(anac_iseg+j-1,ilig);
		c_adtchn(anac_iseg+j,ilig);
		j += 2;
		k += 2;
		return ;
	}
}

