/*  
	fillcont(A,ndim,bufim,bufim2,ct_in,nf,lfmt,nmx,ixoff,iyoff,xoff,yoff,nbz,ivo,nbv,isens,num_env,ismmx,flg_fill,fill_vals)
 remplit des contours dans l'image nf a partir des contours ct_in
 A tableau de travail de ndim int (donnees pour chaque cont.)
 bufim : buffer pour contenir l'image
 bufim2 : char ** , non nul si remplissage a partir d'une image
 flg_fill : 0 => remplissage avec fill_vals
	-1 => on remplit (neg et pos) avec numero de contour selon la formule
	 (offset + ((coef * num_cont) % (255 - offset)))
	 avec offset=afillval[0], coef=afillval[1]
	 1 => remplissage avec image : avec 2e image (bufim2) pour contours >0
	      avec image originale si contour <0
	2 => avec image, mais on inverse les rles des contours pos et neg
 fill_vals : valeur de remplissage pour chaque composante des vect.
  nmx est le numero maximum de contour
  isens : 1, -1 ou 0 = contours pos, neg ou les 2
  num_env : num enveloppe (>= 0), -1 = tout sauf 0, -2 = pas de test
  ismmx[2] : surf min et max
  xoff : offset en pixels dans image resultat
  yoff : offset sur les lignes
  ixoff, iyoff : offset dans image source eventuelle
  nbz : nb de plans de repetition si > 0
  ivo : indice 1e composante, nbv= nb de composantes
Si NDIMV > 1 : on remplit toutes les composantes
*/

#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>
#include <inrimage/contour.h>

extern char *i_malloc();

extern errno;
extern debug_;
#define NOTDZVIN 1
#define NOTDZVOUT 0x100

static Fort_int ipar[2]= {0}, sens= 0;

static int get_chn_anac();

fillcont(a,ndim,bufim,pbufim2,ct_in,nf,lfmti,lfmt,nmx,ixoff,iyoff,xoff,yoff,pnbz,pivo,pnbv,isens,num_env,ismmx,flg_fill,fill_vals,afillval,list_cont)
short *a;
char *bufim, **pbufim2;
struct fc_cont **ct_in;
struct image **nf;
Fort_int *ndim;
Fort_int *nmx, *isens, *num_env, *ismmx;
Fort_int *flg_fill, *afillval, *ixoff, *iyoff, *xoff, *yoff, *pnbz, *pivo, *pnbv;
Fort_int lfmt[], lfmti[];
int *fill_vals;
char *list_cont;
{
	struct ct_select ct_sel;
	register i, ny, nyi;
	char *pcnt_marks;
	char *bufim2;
	char *bufim0 = NULL; // copie de l'image originale por ff et contours <0
	int val, *pval;
	int n, num, ndm;
	int coef, offset, fillsens;
	int nbz, ivo, nbv;
	int incxi,incyi;
	nbz = *pnbz;
	nbv = *pnbv;
	ivo = *pivo - 1;
	offset = *afillval;
	coef = *(afillval+1);
	bufim2 = *pbufim2;
	ndm = *ndim * (sizeof (t_aligned)/ sizeof (int4));
	ct_sel.cnt_marks= (char *)0;
	parse_ctselec(list_cont,(int)*nmx,&ct_sel);
	pcnt_marks = ct_sel.cnt_marks;
	incxi = *ixoff - *xoff;
	incyi = *iyoff - *yoff;
	if(bufim2 != NULL) {
	  n = lfmt[I_DIMX]*lfmt[I_DIMY];
	  bufim0 = (char *)i_malloc(n);
	  memcpy(bufim0,bufim,n);
	}
	for(i=0;i<*nmx;i++) {
		if(!*(pcnt_marks + i))
			continue;
		n = get_chn_anac(*ct_in,i+1,&num,a,ndm,(int)*isens,(int)*num_env,(int)ismmx[0],(int)ismmx[1]);
		fillsens = (*flg_fill > 1) ? - sens : sens;
		if(n < 0)
			imerror(8,"pas assez de place pour les contours\n");
		else if(n == 0)
			continue;
		/* PROCESS contour */
		pval = fill_vals;
		if(sens < 0) {
			val = 0;
			pval = &val;
		}
		if(*flg_fill == -1) {
			register mod;
			if(offset == 0) {
				val = coef == 1 ? i + 1 : ((coef * (i+1)) % 255);
			} else {
				if((mod = (255 - offset) & 0xff) <= 0)
					mod = 1;
				val = offset + ((coef * (i+1)) % mod);
			}
			pval = &val;
		}
		if(debug_)
			fprintf(stderr,"draw contour %d with %d\n",num,val);
		ny = nbz ? NDIMY : DIMY;
		nyi = nbz ? lfmti[I_NDIMY] : lfmti[I_DIMY];
		do_fillc(a,n,bufim,bufim0,bufim2,fillsens,lfmti[I_NDIMX],DIMX,NDIMX,NDIMV,nbv,ny,nyi,incxi,incyi,(int)*xoff,(int)*yoff,pval, nbz,ivo);
	}
	ny = nbz ? (NDIMY * nbz) : DIMY;
	c_ecr(*nf,ny,bufim);
	if(c_lptget(*nf) <= DIMY) {
		c_lptset(*nf,DIMY);
		bzero(bufim,DIMX);
		c_ecr(*nf,1,bufim);
	}
	if(bufim0 != NULL) i_Free(&bufim0);
}

/* i = num demande, renvoie numero dans num (= i) 
retour= nb points
*/
static int get_chn_anac(ct_in,i,num,a,ndim,isens,num_env,smin,smax)
struct fc_cont *ct_in;
int i;
int *num;
int ndim;
short *a;
register isens, num_env;
register smin, smax;
{
	Fort_int n;
	register s;
	Fort_int env, np;
	if((n = c_irctpa(ct_in,i,&sens,&env,&n,ipar,1,&np)) == 0) return n;
	*num = i;
	if(debug_)
		fprintf(stderr,"contour %d (%d), lgr= %d, S= %d\n",i,env,n,ipar[0]);
	if(isens && (sens != isens)) return 0;
	if(num_env == -1) {
		if(env <= 0)
			return 0;
	} else if((num_env >= 0) && (num_env != env))
			return 0;
	s = ipar[0] < 0 ? -ipar[0] : ipar[0];
	if(s < smin || s > smax) return 0;
	n = c_ircttb(ct_in,i,a,ndim);
	return n;
}

struct cntx {
	short inext;  /* indice du pt de contour suivant dans mm ligne image */
	short ix;  /* coord x du point */
};

/*
  fillsens : si bufim2 != NULL, indique pour quel type de contours
(>0 ou <0) on utilise l'image bufim2 pour le remplissage
 */
do_fillc(a,n,bufim,bufim0,bufim2,fillsens,ndimxi,dimx,ndimx,ndimv,nv,ny,nyi,icxi,icyi,ix,iy,pval,nbz,ivo)
short *a;
int n;
char *bufim, *bufim0, *bufim2;
int  dimx, ndimx, ndimxi, ndimv, nv, ny, nyi;
int fillsens, ix, iy, icxi, icyi;
int *pval;
int nbz, ivo;
{
  struct cntx *pcnt;
  short *plig, *pp;
  struct cntx *pcnt0;
  short *plig0;
  int x, y, i, j, dx, k;
  int x1, y1;
  int  dimy, incbuf, incbuf1;
  int flg_ff, dimxi;
  unsigned char val;
	flg_ff = (bufim2 == NULL) ? 0 : 1;
	if(! flg_ff)
	  val = (unsigned char)*pval;
	dimxi = ndimxi * ndimv;
	if(nbz > 0) {
		dimy = ny * nbz;
		incbuf = ny * dimx;
		incbuf1 = ny * dimxi;
	} else {
		dimy = ny;
		incbuf = 0;
		incbuf1 = 0;
	}
	/* plig[i] = -1 ou indice dans pcnt du pt le plus a gouche de la ligne i */
	plig = plig0 = (short *)i_malloc(ny * sizeof(short));
	/* 1 entree par point du contour : coord x + indice du pt suivant de la ligne */
	pcnt = pcnt0 = (struct cntx *)i_malloc(n * sizeof(struct cntx ));
	for(i=0;i<ny;i++)
		*plig++ = -1;
	plig = plig0;
	for(i=0;i<n;i++) {
		x = *a++ -1 + ix;
		if(x < 0 || x >= ndimx)
			imerror(9,"x coord (%d) out of image \n",x);
		(pcnt + i)->ix = x;
		(pcnt + i)->inext = -1;
		y = *a++ -1 + iy;
		if(y < 0 || y >= ny)
			imerror(9,"y coord (%d) out of image \n",y);
		if((j = *(plig + y)) < 0) {
			*(plig + y) = i;
		} else {
			pp = plig + y;
			while(1) {
				if(x < (pcnt + j)->ix) {
					*pp = i;
					(pcnt + i)->inext = j;
					break;
				}
				pp = &(pcnt + j)->inext;
				if((j = *pp) < 0) {
					*pp = i;
					break;
				}
			}
		}
	}
	if(nbz <= 0)
		nbz= 1;
	while(nbz-- > 0) {
	/* fillup the image */
	    for(y=0;y<ny;y++) {
	      char *pc0, *pc, *pc0i, *pci, *pc0s, *pcs;
		if((j = *(plig + y)) < 0)
			continue;
		if(flg_ff) {
			if((y1 = y + icyi) < 0) continue;
			if(y1 >= nyi) break;
		}
		pc0 = bufim + (y * dimx) + ivo;
		pc0i = bufim2 + (y1 * dimxi) + ivo;
		pc0s = bufim0 + (y * dimx) + ivo;
		while(1) {
			i = (pcnt + j)->ix;
			if(icxi) {
				x1 = i + icxi;
				if(x1 < 0) {
					i -= x1;
					x1 = 0;
				}
			} else
				x1 = i;
			if(sens < 0)
				i++;
			if(ndimv > 1) {
				dx = i * ndimv;
				pc = pc0 + dx;
				pci = pc0i + (x1 * ndimv);
				pcs = pc0s + dx;
			} else {
				pc = pc0 + i;
				pci = pc0i + x1;
				pcs = pc0s + i;
			}
			if((j = (pcnt+j)->inext) < 0)
				imerror(9,"mauvais nb de points dans ligne %d\n",y+1);
			i = (pcnt + j)->ix - i;
			if(i < 0) continue;
			if(sens >= 0) 
				i++;
			if((i + x1) >= ndimxi) i = ndimxi - x1;
			if(ndimv == nv) {
			  if(flg_ff) {
			    i *= nv;
			    if(fillsens >= 0) {
			      while(i-- > 0)
				*pc++ = *pci++;
			    } else {
			      while(i-- > 0)
				*pc++ = *pcs++;
			    }
			  } else if(sens < 0) {
			    i *= nv;
			    while(i-- > 0)
			      *pc++ = val;
			  } else {
			    while(i-- > 0) {
			      for(k=0;k<nv;k++)
				*pc++ = *(pval+k);
			    }
			  }
			} else {
				dx = ndimv - nv;
				if(flg_ff) {
				  if (fillsens >= 0) {
				    while(i-- > 0) {
				      for(k=0;k<nv;k++)
					*pc++ = *pci++;
				      pc += dx;
				      pci += dx;
				    }
				  } else {
				    while(i-- > 0) {
				      for(k=0;k<nv;k++)
					*pc++ = *pcs++;
				      pc += dx;
				      pcs += dx;
				    }
				  }
				} else if(sens < 0) {
					while(i-- > 0) {
						for(k=0;k<nv;k++)
							*pc++ = val;
						pc += dx;
					}
				} else {
					while(i-- > 0) {
						for(k=0;k<nv;k++)
							*pc++ = *(pval+k);
						pc += dx;
					}
				}
			}
			if((j = (pcnt+j)->inext) < 0)
				break;
		}
	    }
	    bufim += incbuf;
	    if(bufim2) {
	      bufim2 += incbuf1;
	      bufim0 += incbuf;
	    }
    }
	i_Free(&plig0);
	i_Free(&pcnt0);
}

