#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>


/*
   reunion de 2 contours
   iseg1, iseg2 = indices (>= 1) de struct iseg dans pseg des 2 pts de reunion
   iy = num de ligne
*/

void c_unichn(pseg,lseg,iseg1,iseg2,iy)
int iseg1, iseg2, lseg;
int iy;
struct iseg *pseg;
{
	struct iseg *pseg1, *pseg2, *ps;
	struct cont_desc *pdesc1, *pdesc2, *pdesc;
	int idesc1, idesc2, iext1, iext2;
	int flg_1avant, flg_ordre, is;
	int i, num, nu2, nu;
	int ixy1, ixy2, ix1, iy1, ideb1, ifin1, ideb2, ifin2;
	int id1, id2, ip2, lgr, lgr2, isurf, isrp;
	struct chn *pchn1, *pchn2;

	pseg1 = pseg + iseg1 -1;
	pseg2 = pseg + iseg2 -1;
	pdesc1 = anac_desc - pseg1->idesc;
	pdesc2 = anac_desc - pseg2->idesc;
	/* verif preliminaires , determination de l'ordre */
	ixy1 = (pseg1->x << 16) | (iy & 0xffff);
	ixy2 = (pseg2->x << 16) | (iy & 0xffff);
	pchn1 = anac_chn + pdesc1->p_bloc - 1;
	i = 2 * pchn1->ip0;
	ideb1 = (pchn1->pts[i] << 16) | pchn1->pts[i+1];
	pchn1 = anac_chn + pdesc2->p_bloc - 1;
	i = 2 * pchn1->ip0;
	ideb2 = (pchn1->pts[i] << 16) | pchn1->pts[i+1];
	pchn1 = anac_chn + pdesc1->d_bloc - 1;
	i = 2 * (pchn1->ip0 -2);
	ifin1 = (pchn1->pts[i] << 16) | pchn1->pts[i+1];
	pchn1 = anac_chn + pdesc2->d_bloc - 1;
	i = 2 * (pchn1->ip0 -2);
	ifin2 = (pchn1->pts[i] << 16) | pchn1->pts[i+1];
	/* determination de l'ordre des contours */
	flg_1avant = 1;
	if(ideb1 == ifin1) {
		if(ideb2 != ifin2) {
			if(ifin2 == ixy2) flg_1avant = 0;
			else if((ifin1 != ixy1) || (ideb2 != ixy2))
				imerror(9,"unichn: contours incoherents\n");
		} else if(ideb1 > ideb2)
			flg_1avant = 0;
	} else {
		if(ideb1 == ixy1) {
			if(ifin2 == ixy2) flg_1avant = 0;
			else if((ifin1 != ixy1) || (ideb2 != ixy2))
				imerror(9,"unichn: contours incoherents\n");
		} else if((ifin1 != ixy1) || (ideb2 != ixy2))
			imerror(9,"unichn: contours incoherents\n");
	}
	/* on veut garder le descripteur de + petit indice */
	if(pseg1->idesc > pseg2->idesc) {
		idesc2 = pseg1->idesc;
		idesc1 = pseg2->idesc;
		pdesc = pdesc1;
		pdesc1 = pdesc2;
		pdesc2 = pdesc;
		flg_1avant ^= 1;
	} else {
		idesc1 = pseg1->idesc;
		idesc2 = pseg2->idesc;
	}
	if((num = pdesc1->num) < 0) {
		num = -num;
		is = -1;
	} else
		is = 1;
	iext2 = pdesc1->numext;
	iext1 = num;
	flg_ordre = -is;
	nu2 = pdesc2->num;
	if(nu2 < 0) nu2 = -nu2;
	nu = nu2;
	if(nu2 < num) {  /* on garde le + petit numero de contour */
		pdesc1->num = is * nu2;
		iext1 = nu2;
		nu = num;
	}
	if((is * pdesc2->num) >= 0) {
		if(pdesc2->numext != iext2)
			imerror(9,"unichn: err de num enveloppe\n");
		iext2 = pdesc1->num * is;
		flg_ordre = is;
	}
	set_bitmap(nu,0);  /* liberer num 2e contour */
	if(flg_1avant) { /* cont 1 avant 2 */
		id1 = pdesc1->d_bloc;
		id2 = pdesc2->d_bloc;
		ip2 = pdesc2->p_bloc;
		pdesc1->d_bloc = id2;
	} else { /* cont 2 avant 1 */
		id1 = pdesc2->d_bloc;
		id2 = pdesc1->d_bloc;
		ip2 = pdesc1->p_bloc;
		pdesc1->p_bloc = pdesc2->p_bloc;
	}
	pchn1 = anac_chn + id1 -1;
	pchn2 = anac_chn + id2 -1;
	lgr = pchn1->inext;
	lgr2 = pchn2->inext;
	if(! (lgr & 1) || ! (lgr2 & 1)) isrp = 0;
	else isrp = 1;
	lgr2 += lgr;
	pchn2->inext = lgr2;  /* new lgr */
	pchn1->inext = ip2;  /* raccordement des 2 listes */
	/* addition des surfaces */
	pchn1 = anac_chn + pdesc1->p_bloc -1;
	i = 2 * pchn1->ip0;
	ix1 = pchn1->pts[i];
	iy1 = pchn1->pts[i+1];
	i = 2 * (pchn2->ip0 - 2);
	if((pchn2->pts[i+1] != iy1) && isrp)
		imerror(9,"unichn: contour incoherent\n");
	isrp += (pchn2->pts[i] - ix1) * isrp;
	isurf = isrp + pdesc1->surf + pdesc2->surf;
	pdesc1->surf = isurf;
	/* mise a jour du tableau des descripteurs */
	ps = pseg;
	for(i=0;i<lseg;i++) {
		if(ps->idesc == idesc2)
			ps->idesc = idesc1;
		ps++;
	}
	/* nettoyage table descr */
	c_comprs(idesc2,pseg,lseg);
	/* mise a jour des num env. dans table descr */
	 i = (anac_info.ix0_desc - anac_info.ix_cont_desc) / sizeof(struct cont_desc);
	pdesc = anac_desc;
	while(i-- > 0) {
		pdesc--;
		if(pdesc->numext == num) {
			pdesc->numext = iext1;
			continue;
		}
		if(pdesc->numext != nu2) continue;
		pdesc->numext = iext2;
		if((pdesc->num * flg_ordre) > 0)
			imerror(9,"unichn: incogerence de sens de contour\n");
		if(iext2) continue;
		if(pdesc->p_bloc && pdesc->d_bloc) continue;
		c_sorchn(pdesc,lseg);
		pdesc++;
	}
}
