#include <stdio.h>
#include <inrimage/image.h>
#include <inrimage/contour.h>
#include <inrimage/anac.h>

extern int debug_;

/*
  vischn_(buf,ndim,ct_in,numax,flg_vis,flg_closed,isens,num_env,ismmx,point,xv_val,list_cont,xydim)
  buf : buffer de taille *ndim * sizeof(t_aligned)
  ct_in : fichier contours (struct fc_cont)
  numax : numero contour max (>= 1)
  flg_vis : 1= tek, 5=tek+erase , 2= xvisdraw, 6= xvisdraw sans forcer couleur
  flg_closed : 1 => contours fermes (on repete 1e point)
  isens : 1, -1 ou 0 = contours pos, neg ou les 2
  num_env : num enveloppe (>= 0), -1 = tout sauf 0, -2 = pas de test
  ismmx[2] : surf min et max
  point[2] : selectionner contour contenant le point x,y
  	pas de test usr x si point[0] == 0, pas de test y si point[1] == 0
  xv_val[2] : pour trace xvisdraw des cont. pos et neg
  list_cont : liste des contours selectionnes (1,3,6-8,10....)
  xydim: dim X Y de l'image
  */


vischn_(buf0,ndim,ct_in,numax,flg_vis,flg_closed,isens,num_env,ismmx,point,xv_val,list_cont,xydim)
char *buf0, *list_cont;
Fort_int *ndim, *numax, *flg_vis, *flg_closed;
Fort_int *isens, *num_env, *ismmx, *point, *xv_val, *xydim;
struct fc_cont **ct_in;
{
	struct ct_select ct_sel;
	Fort_int sens, env, lgr, nbp;
	int4 tbpar[2];
	char *buf;
	struct chn *pchn;
	int surf, v, ndm;
	int fl_vis;
	int npmax= 2;
	char *ps;
	register int i, n;
	Fort_int dmax, un=1;
	ct_sel.cnt_marks = (char *) 0;
	parse_ctselec(list_cont,(int)*numax,&ct_sel);
	ps = ct_sel.cnt_marks;
	ndm = *ndim * (sizeof(t_aligned) * sizeof(int4)) - 2 * sizeof(short);
	buf = buf0 + 2 * sizeof(short);
	for(i=0;i< 2*sizeof(short);i++)
		*(buf0+i) = 0;
	pchn = (struct chn *)buf0;
	dmax = (int)*xydim < *(xydim+1) ? *(xydim+1) : *xydim;
	fl_vis = *flg_vis & 3;
	if(*flg_vis == 5)
		t4effa_();
	for(i=ct_sel.cnt_min;i<=ct_sel.cnt_max;i++) {
		if(!*(ps+i)) continue;
		n = i+1;
		if(c_ircttb(*ct_in,n,buf,ndm) <= 0)
			continue;
		c_irctpa(*ct_in,n,&sens,&env,&lgr,tbpar,npmax,&nbp);
		if(*isens && (sens != *isens))
			continue;
		if(*num_env == -1) {
			if(env <= 0)
				continue;
		} else if((*num_env >= 0) && (*num_env != env))
			continue;
		surf = tbpar[0] < 0 ? -(int)tbpar[0] : (int)tbpar[0];
		if((surf < *ismmx) || (surf > *(ismmx+1)))
			continue;
		if(!chk_point(point,buf,lgr,(int)xydim[1])) 
			continue;
		if(sens < 0)
			n = -n;
		if(debug_)
			fprintf(stderr,"contour %6d (%5ld), L= %6ld, S= %7d\n",n,env,lgr,tbpar[0]);
		if(!fl_vis)
			printf("contour %6d (%5ld), L= %6ld, S= %7d\n",n,env,lgr,tbpar[0]);
		if(fl_vis == 1) {
		  pchn->ip0 = 1;
		  c_ecchtk(pchn,1,sens,*flg_closed,lgr,dmax);
		}
		if(fl_vis == 2) {
			register short *psd;
			register int j;
			printf("contour %6d (%5ld), L= %6ld, S= %7d\n",n,env,lgr,tbpar[0]);
			v = sens < 0 ? *(xv_val +1) : *xv_val;
			/* if val < 0 : tracer avec val= num contour */
			if(v < 0)
				v = n < 0 ? -n : n;
			if(! (*flg_vis & 4))
			  printf("C %d\n",v & 0xff);
			psd = (short *)buf;
			for(j=0;j<lgr;j++) {
				printf("%d %d\n",(int)*psd,(int)*(psd+1));
				psd += 2;
			}
			if(*flg_closed) {
				psd = (short *)buf;
				printf("%d %d\n",(int)*psd,(int)*(psd+1));
			}
		}
	}
}

static int xcompar(n1,n2)
register short *n1, *n2;
{
	return (*n1 - *n2);
}

chk_point(point,buf,lgr,ndimy)
Fort_int *point;
register short *buf;
register int lgr, ndimy;
{
	register int xp, yp;
	register int x, y, i, j;
	register short *ptab, *ptab0;
	xp = *point;
	yp = *(point+1);
	if((xp <= 0) && (yp <= 0))
		return 1;
	if(xp <= 0) { /* pas de test en xp */
		buf++;
		while(lgr-- > 0) {
			if(*buf == yp)
				return 1;
			buf += 2;
		}
		return 0;
	}
	if(yp <= 0) { /* test en x seul */
		while(lgr-- > 0) {
			if(*buf == xp)
				return 1;
			buf += 2;
		}
		return 0;
	}
	/* tester xp ET yp */
	xp--;
	yp--;
	if(yp < 0 || yp >= ndimy)
		return 0;
	ptab = ptab0 = (short *)i_malloc(lgr * sizeof(short ));
	j = 0;
	for(i=0;i<lgr;i++, buf += 2) {
		y = *(buf + 1) - 1;
		if(y != yp) continue;
		x = *buf -1;
		*ptab++ = x;
		j++;
	}
	if( j & 1) {  /* nb impair de points !! */
		fprintf(stderr,"Attention! nb impair de points sur une ligne\n");
		return 0;
	}
	qsort(ptab0,j,sizeof(short),xcompar);
	ptab = ptab0;
	for(i=0;i<j;i += 2, ptab += 2) {
		if(xp < *ptab)
			continue;
		if(xp <= *(ptab + 1)) return 1;
	}
	return 0;
}
