/*
 READI
	SUBROUTINE READI(A,NDIM,NF,IXYZ,IDXYZ,FILE,IFORM,XTOUT,XINTER)
	readi_(a,ndim,nf,ixyz,idxyz,file,iform,xtout,xinter)
  entree ascii de la fenetre de taille IDXYZ(1),IDXYZ(2),IDXYZ(3) en X,Y,Z
   et de 1er point IXYZ(1),IXYZ(2),IXYZ(3), de l'image NF
 donnees lue sur file FILE (stdin si FILE == 0) si xinter == 0, sur tty sinon,
  tableau de trvail A de taille ndim int
  IFORM : format d'impression d'une valeur par printf
  xtout = 0 si on n'ecrit pas toute l'image.
*/
#include <inrimage/image.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

static char * ifmt1;
extern char *i_malloc();

readi_(a,ndim,nf,ixyz,idxyz,file,iform,xtout,xinter)
register char *a;
Fort_int *ndim, *xtout, *xinter;
struct image **nf;
Fort_int *ixyz, *idxyz;
FILE *file;
char *iform;
{
	Fort_int lfmt[9];
	int ixi, iyi, izi;
	int ntot, nlig, isig;
	register i, n, ibs;
	register nlg;
	int y0, y00, ibits, ityp;
	Fort_int icodi[2];
	int nlmax;
	int np, y, z;
	char *tmp;
	if(iform == 0 || *iform == 0)
		imerror(9,"printi: format non defini\n");
	if(file == NULL)
		file = stdin;
	c_getgfm(*nf,lfmt,0);
	ixi = ixyz[0] -1;
	iyi = ixyz[1] -1;
	izi = ixyz[2] -1;
	if(NDIMZ == 1)
		izi = 0;
	if(((ixi + idxyz[0]) > DIMX) ||
	   ((iyi + idxyz[1]) > NDIMY) ||
	   ((izi + idxyz[2]) > NDIMZ))
		imerror(9,"printi : parametres de fenetre incorrects\n");

	ntot = *ndim * sizeof(t_aligned);
	if((ityp = formtype(iform)) < 0)
		imerror(9,"printi: format incorrect\n");
	if(BSIZE > 0)
		ibs = BSIZE;
	else
		ibs = (7 - BSIZE) / 8;
	ibits = TYPE >= 0 ? 8 * ibs : -BSIZE;
	nlig = ntot / (DIMX * ibs);
	if(nlig <= 0)
		imerror(8,"printi: pas assez de memoire (utilisez option -k)\n");
	i = strlen(iform) + 2;
	ifmt1 = (char *)i_malloc(i);
	i = compil_format(iform,ifmt1);
	ntot = idxyz[1] * idxyz[2];
	if((idxyz[1] == NDIMY) && (*xinter != 1)) {
		nlmax =  ntot;
		np = 1;
	} else {
		np = idxyz[2];
		nlmax =  idxyz[1];
	}
	if(nlig > nlmax)
		nlig = nlmax;
	if(ityp > 0) {  /* flottant */
		if(sizeof(float) != 4)
			imerror(9,"PB!pb! sizeof float != 4\n");
		icodi[0] = sizeof(float);
		icodi[1] = 1;
	} else {
		icodi[0] = ibs;
		icodi[1] = TYPE == REELLE ? REELLE : FIXE;
	}
	tmp = (char *)i_malloc(nlig * idxyz[0] * ibs);
	y0 = iyi + (izi * NDIMY) + 1;
	if(NDIMZ <= 1)
		izi = -1;
	isig = EXP < 0 ? 1 : 0;
	z = izi + 1;
	while(np-- > 0) {
		nlg = nlmax;
		y00 = y0;
		y0 += NDIMY;
		y = iyi + 1;
		while (nlg > 0) {
			if(nlig > nlg)
				nlig = nlg;
			n = nlig * idxyz[0];
			nlg -= nlig;
			c_lptset(*nf,y00);
			if(*xtout == 0) {
				c_lect(*nf,nlig,a);
				c_lptset(*nf,y00);
			}
			if(*xinter == 1) {
#ifndef NONINTERACTIF
				inter_read(tmp,idxyz[0],nlig,y,z);
				c_cnvtbg(tmp,tmp,n,icodi,&lfmt[2],EXP,EXP);
				y += nlig;
				if(z > 0) z++;
#else
				imerror(9,"readi_ : interactive mode not supported\n");
#endif
			} else if(ityp > 0) { /* read float */
				rreadtb(tmp,n,file,ifmt1);
				c_cnvtbg(tmp,tmp,n,icodi,&lfmt[2],EXP,EXP);
			} else {
				ireadtb(tmp,n,file,ifmt1,ibs,isig);
				c_cnvtbg(tmp,tmp,n,icodi,&lfmt[2],EXP,EXP);
			}
			c_trtblb(tmp,idxyz[0],1,a,DIMX,ixi+1,idxyz[0],nlig,ibits);
			c_ecr(*nf,nlig,a);

			y00 += nlig;
		}
	}
}

#ifndef NONINTERACTIF
inter_read(buf,dimx,nbl,y,z)
register float *buf;
register dimx, nbl, y, z;
{
	char msg[128];
	while(nbl-- > 0) {
		if(z > 0)
			sprintf(msg,"ligne %d plan %d : ecrire %d termes ",y,z,dimx);
		else
			sprintf(msg,"ligne %d : ecrire %d termes\n",y,dimx);
		c_outstr(0,msg);
		c_realch(0,"",1,dimx,buf);
		buf += dimx;
		y++;
	}
}
#endif
