#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>
#include "bmp.h"

extern errno;
extern debug_;
extern struct extimage *openimext();

static int bmp_writ1(pnf,buf,n)
struct extimage **pnf;
register char *buf;
register n;
{
	register i;
	if(n <= 0)
		return 0;

	if((i = fwrite(buf,1,n,(*pnf)->file)) != n) {
		fermbmp(pnf);
		imerror(1,"write err %d\n",errno);
	}

	return i;
}

static int wrcmap(ppnf)
struct extimage **ppnf;
{
	struct extimage *pnf;
	char tmp[4*256];
	register numcols, n, i, j, k;
	register struct bmp_info *pb;
	pnf = *ppnf;
	pb = (struct bmp_info *)pnf->x_params;
	if((numcols = pnf->numcols) == 256) {
		k = 0;
		for(i=0;i<256;i++) {
			tmp[k++] = pnf->bbuf[i];
			tmp[k++] = pnf->gbuf[i];
			tmp[k++] = pnf->rbuf[i];
			tmp[k++] = 0;
		}
		bmp_writ1(ppnf,tmp,1024);
		return 0;
	}
	/* ramener le nb de couleurs a 2 ou 16 */
	if(numcols == 2) {
		n = 255;
	} else if(numcols == 16) {
		n = 16;
	} else bmp_err(ppnf,9,"bad nb of colors (%d)\n",numcols);
	j = 0;i = 0;
	for(k=0;k<numcols;k++) {
		tmp[i++] = pnf->bbuf[j];
		tmp[i++] = pnf->gbuf[j];
		tmp[i++] = pnf->rbuf[j];
		tmp[i++] = 0;
		j += n;
	}
	n = 4 * numcols;
	bmp_writ1(ppnf,tmp,n);

}

struct extimage *createbmp(name,pic,width,height,nbits,rle,numcols,r,g,b)
char *name, *pic;
char *r, *g, *b;
int width, height, nbits, numcols;
int rle;
{
	unsigned char tmp[64];
	FILE *f;
	register x, n, i;
	register unsigned char *pc;
	register struct bmp_info *pb;
	struct extimage *nfext;
	if(nbits != 1 && nbits != 4 && nbits != 8 && nbits != 24)
		bmp_err(&nfext,9,"incorrect bit number for BMP file %s\n",name);
	
	nfext = openimext(name,1);
	if(!name || ((*name == '>') && (*(name + 1) == 0))) {
		f = stdout;
	} else {
		if(!(f = fopen(name,"w+")))
			bmp_err(&nfext,2,"create err %d on %s\n",errno,name);
	}
	nfext->file = f;
	pb = (struct bmp_info *)i_calloc(1,sizeof(struct bmp_info));
	nfext->x_params = (void *)pb;
	for(i=14;i<(14 + INFO_SIZE);i++)
		tmp[i] = 0;
	n = 0;
	pb->nbits = nbits;
	if(nbits == 24) {
		nfext->ndimv = 3;
		nfext->nbits = 8;
		nfext->numcols = 0;
	} else {
		nfext->ndimv = 1;
		nfext->nbits = nbits;
		if(numcols > 256) numcols = 256;
		if(nbits < 8) {
			nfext->numcols = (1 << nbits);
		} else {
			nfext->numcols = 256;
		}
			
	}
	for(i=0;i<numcols;i++) {
		nfext->rbuf[i] = r[i];
		nfext->gbuf[i] = g[i];
		nfext->bbuf[i] = b[i];
	}
	nfext->ndimx = width;
	nfext->ndimy = height;
	nfext->ndimz = 1;
	pb->inrline = ((nfext->ndimx * nfext->nbits * nfext->ndimv) + 7) / 8;
	nfext->size = pb->inrline * nfext->ndimy;
	pb->lgline = 4 * (((nfext->ndimx * nfext->nbits * nfext->ndimv) + 31) / 32);
	pb->bmp_size = pb->lgline * nfext->ndimy;
	pb->info_size = INFO_SIZE;
	pb->width = width;
	pb->height = height;
	pb->nbits = nbits;
	if(rle) {
		if(nbits != 8)
			bmp_err(&nfext,9,"RLE compression only for 8 bits images\n");
		pb->comp_type = COMP_RLE8;
	}
	pb->off_data = 14 + INFO_SIZE + (nfext->numcols * 4);
	strcpy(tmp,"BM");
	pc = &tmp[2];
	x = pb->fsize;
	put_int(x,pc);
	x = 0;
	put_int(x,pc);
	x = pb->off_data;
	put_int(x,pc);
	x = pb->info_size;
	put_int(x,pc);
	
	x = nfext->ndimx;
	put_int(x,pc);
	x = nfext->ndimy;
	put_int(x,pc);
	x = 1;
	put_short(x,pc);
	x = pb->nbits;
	put_short(x,pc);

	x = pb->comp_type;
	put_int(x,pc);
	x = pb->bmp_size;
	put_int(x,pc);  /* image size */
	x = (int)((75 * 100) / 2.54); /* pixels/ metre*/
	put_int(x,pc);
	put_int(x,pc);
	x = nfext->numcols;
	put_int(x,pc);
	put_int(x,pc);  /* ncol_imp */
	pb->cur_pos = 14 + pb->info_size;
	bmp_writ1(&nfext,tmp,pb->cur_pos);
	if(nfext->ndimv != 3)
		wrcmap(&nfext);
	/* alloc data buffers */
	nfext->data = (unsigned char *)pic;
	nfext->cindex = (unsigned char *)i_malloc(pb->lgline);
	return nfext;
}


/* write data */
writebmp(ppnf)
struct extimage **ppnf;
{
	register struct extimage *pnf;
	register struct bmp_info *pb;
	register unsigned char *buf, *tbuf, *pc, *p2;
	register n, i, v;
	pnf = *ppnf;
	pb = (struct bmp_info *)pnf->x_params;
/*	if(pnf->nbits == 1) { */
	if( pb->comp_type) {
		if(pb->comp_type == COMP_RLE8)
			return writebmprle8(ppnf);
		bmp_err(pnf,9,"bmp compression not yet available\n");
	}
	n = pnf->ndimy;
	buf = pnf->data + pnf->size;
	tbuf = pnf->cindex;
	if(pb->inrline == pb->lgline) {
		while (n-- > 0) {
			buf -= pb->inrline;
			if(pnf->ndimv == 3) {
				pc = buf;
				i = pnf->ndimx;
				while(i-- > 0) {
					v = *pc;
					*pc = *(pc+2);
					pc += 2;
					*pc++ = v;
				}
			}
			bmp_writ1(ppnf,buf,pb->lgline);
		}
		return 0;
	}
	
	while (n-- > 0) {
		buf -= pb->inrline;
		if(pnf->ndimv == 3) {
			p2 = tbuf;
			pc = buf;
			i = pnf->ndimx;
			while(i-- > 0) {
				*(p2+2) = *pc++;
				*(p2+1) = *pc++;
				*p2 = *pc++;
				p2 += 3;
			}
		} else {
			memcpy(tbuf,buf,pb->inrline);
		}
		bmp_writ1(ppnf,tbuf,pb->lgline);
		
	}
	return 0;
}

/* write data 8 bits avec compression rle */
writebmprle8(ppnf)
struct extimage **ppnf;
{
	register struct extimage *pnf;
	register struct bmp_info *pb;
	register unsigned char *buf, *tbuf, *pc, *p2;
	register n, i, v;
	pnf = *ppnf;
	pb = (struct bmp_info *)pnf->x_params;
	n = pnf->ndimy;
	buf = pnf->data + pnf->size;
	tbuf = pnf->cindex;
	while (n-- > 0) {
		buf -= pb->inrline;
		bmp_writ1(ppnf,buf,pb->lgline);
	}
	return 0;
}

