#define TEST 1
#include <stdio.h>
#include <inrimage/image.h>
#include "imext.h"

extern errno;
extern debug_;

extern struct extimage *openimext();

static int wrcmap (pnf)
register struct extimage **pnf;
{
	char tmp[3*256];
	register numcols, n, i;
	numcols = (*pnf)->numcols;
	if(debug_)
		fprintf(stderr,"write GIF colormap (%d colors)\n",numcols);
	n = 0;
	for(i=0;i<numcols;i++) {
		tmp[n++] = (*pnf)->rbuf[i];
		tmp[n++] = (*pnf)->gbuf[i];
		tmp[n++] = (*pnf)->bbuf[i];
	}
	gif_write(pnf,tmp,3 * numcols);

}

/* true_color != 0  => quantization
   true_color < 0  => quantization sans tester si on peut l'eviter
*/
struct extimage *creategif(name,buf,dimx,dimy,nbanim,true_color,nodither,numcols,comment,r,g,b)
char *name, *buf;
int dimx, dimy, true_color,numcols, nodither, nbanim;
char *comment;
unsigned char *r, *g, *b;
{
	unsigned char tmp[16];
	register i, n, flag, c;
	register nbits;
	int screenw, screenh;
	int newnbcols;
	struct extimage *nfgif;
	register unsigned char *outbuf;
	nfgif = openimext(name,1);

	nfgif->ndimx = dimx;
	nfgif->ndimy = dimy;
	nfgif->ndimz = nbanim ? nbanim : 1;
	nfgif->size = dimx * dimy;
	nfgif->interlace = 0;
	nbits = 8;
	if(comment && *comment) 
		nfgif->flag = 1;
	if(nfgif->flag)
		gif_write(&nfgif,"GIF89a",6);
	else
		gif_write(&nfgif,"GIF87a",6);
	nfgif->data = buf;
	if(true_color) {
		flag = nodither ? 1 : 0;
		if(true_color < 0)
			flag |= 2;
/*		quantize(&nfgif,nodither); */
		outbuf = (unsigned char *)i_malloc(nfgif->size * nfgif->ndimz);
		quantize(nfgif->data,outbuf,nfgif->ndimx,nfgif->ndimy,numcols,&newnbcols,
			 flag,nfgif->rbuf,nfgif->gbuf,nfgif->bbuf);
		i_Free((char **)&nfgif->data);
		nfgif->data = outbuf;
	} else {
		newnbcols = numcols;
		for(i=0;i<numcols;i++) {
			nfgif->rbuf[i] = r[i];
			nfgif->gbuf[i] = g[i];
			nfgif->bbuf[i] = b[i];
		}
	}
	numcols = newnbcols;
	tmp[0] = dimx & 0xff;
	tmp[1] = dimx >> 8;
	tmp[2] = dimy & 0xff;
	tmp[3] = dimy >> 8;
	if(numcols) {
		if(numcols > 256)
			numcols = 256;
		i = 256;
		nbits = 8;
		while (i) {
			if( i = numcols)
				break;
			if(i < numcols) {
			  nbits++;
			  break;
			}
			i >>= 1;
			nbits--;
		}
		if(!i)
			imext_err(&nfgif,9,"creategif: bad number of colors\n");
		tmp[4] = 0xf0 | (nbits - 1);
	} else
		tmp[4] = 0;
	tmp[5] = 0;
	tmp[6] = 0;
	nfgif->nbits = nbits;
	nfgif->numcols = 1 << nbits;
	if(debug_)
		fprintf(stderr,"create gif file %s, dimx %d, dimy %d, %d bits/pixel,%d colors\n",
			name,nfgif->ndimx,nfgif->ndimy,nbits,numcols);
	/* en -tete global : sreen widht and height + colormap */
	gif_write(&nfgif,tmp,7);
	wrcmap(&nfgif);

#ifndef TEST
	/* write comments and extents */
	if(comment && *comment) {
		tmp[0] = '!';
		tmp[1] = 0xfe;
		gif_write(&nfgif,tmp,2);
		i = strlen(comment);
		n = 255;
		while(i) {
			if(n > i)
				n = i;
			putc(n,(FILE *)nfgif->file);
			gif_write(&nfgif,comment,n);
			i -= n;
		}
		putc(0,(FILE *)nfgif->file);
	}
#endif
	return nfgif;
}

writegif(pnf,graphic_ext,delay,nbloop)
struct extimage **pnf;
int graphic_ext, delay, nbloop;
{
	char tmp[12];
	char *pc0;
	struct extimage *nfgif;
	register k, n, nbanim;
	int ntot, i;
	int disposal;
	nfgif = *pnf;
	if(! (nbanim = nfgif->ndimz)) nbanim= 1;
	pc0 = nfgif->data;
	ntot = 0;
	if(nbanim > 1) {
		disposal = 2;
		if(debug_) 
			fprintf(stderr,"Write gif animation : %d loops, delay %d\n",nbloop,delay);
	} else {
		delay = 0;
		disposal = 0;
	}
	for(i=0;i<nbanim;i++) {
		if((graphic_ext >= 0) || delay) {
			tmp[0] = '!';
			tmp[1] = 0xf9;
			tmp[2] = 4;
			tmp[3] = (graphic_ext < 0 ? 0 : 1) | (disposal << 2) & 0xff;
			tmp[4] = (unsigned char)delay;
			tmp[5] = delay >> 8;
			tmp[6] = graphic_ext < 0 ? 0 : graphic_ext;
			tmp[7] = 0;
			gif_write(&nfgif,tmp,8);
		}
		if(nbanim > 1) {  /* graph ext animation */
			if (nbloop >= 0) { /* !!! */	
				tmp[0] = '!';
				tmp[1] = 0xff;
				tmp[2] = 11;
				gif_write(&nfgif,tmp,3);
				gif_write(&nfgif,"NETSCAPE2.0",11);
				k = 0;
				tmp[k++] = 0x03;
				tmp[k++] = 0x01 ;
				tmp[k++] = nbloop & 0xff;
				tmp[k++] = nbloop >> 8;
				tmp[k++] = 0;
				gif_write(&nfgif,tmp,k);
			}
		}
		tmp[0] = ',';  /* image separator */
		tmp[1] = 0;
		tmp[2] = 0;
		tmp[3] = 0;
		tmp[4] = 0;
		tmp[5] = nfgif->ndimx & 0xff;
		tmp[6] = nfgif->ndimx >> 8;
		tmp[7] = nfgif->ndimy & 0xff;
		tmp[8] = nfgif->ndimy >> 8;
		tmp[9] = 0;   /* use global colormap */
		gif_write(pnf,tmp,10);
		n = nfgif->nbits;
		if(n < 2) n = 2;
		putc(n,(FILE *)nfgif->file);
		ntot += LZWEncode(pnf);
/*		tmp[0] = 0;
		tmp[1] = ';';
		gif_write(pnf,tmp,2); */
		nfgif->data += nfgif->size;
		putc(0,(FILE *)nfgif->file);
	}
	putc(';',(FILE *)nfgif->file);
	nfgif->data = pc0;
	return ntot;
}

int gif_write(pnf,buf,n)
struct extimage **pnf;
register char *buf;
register n;
{
	register i;
	if(n <= 0)
		return 0;
	if((i = fwrite(buf,1,n,(*pnf)->file)) < 0) {
		imext_err(pnf,1,"write err %d\n",errno);
	}
	if(i != n)
		imext_err(pnf,9,"GIF Truncated write (%d -> %d)\n",n,i);
	return i;
}

