#include <stdio.h>
#include <inrimage/image.h>

char in[256], out[256], tcn[256];
static char Ucmdp[]= 
"[-ct colortb_file_in][-C][-iz num_plan][-z nb_plans] [input-image | -] [out-file]\n";
static char Ucmdb[]= 
"[-iz num_plan][-z nb_plans] [input-image | -] [out-file]\n";
static char Udetailp[]= 
"  Conversion inrimage en PPM\n\
\t-ct : utiliser le fichier donne comme table couleurs au lieu de l'en-tete image\n\
\t-iz, -z : permettent de ne convertir que certains plans (utile pour MPEG)\n\
\t-C: image source en vraie couleur (si NDIMV==3 ou NDIMZ==3)";
static char Udetailg[]= 
"  Conversion inrimage en PGM (image vraie ou fausse couleur transformee en niveaux de gris)\n\
\t-ct : utiliser le fichier donne comme table couleurs au lieu de l'en-tete image\n\
\t-iz, -z : permettent de ne convertir que certains plans\n\
\t-C: image source en vraie couleur (si NDIMV==3 ou NDIMZ==3)";
static char Udetailb[]= 
"  Conversion inrimage 1 ou 8 bits en PBM\n\
\t-iz, -z : permettent de ne convertir que certains plans";

static struct multi_cmd cmds[] = {
  "inr2ppm",Ucmdp,Udetailp,   /*0*/
  "inr2pgm",Ucmdp,Udetailg,   /*1*/
  "inr2pbm",Ucmdb,Udetailb,   /*2*/
  0,0,0,
};

  
static Fort_int lfmt[9]= {0,0,1,0,0,0,1,1,200};
struct image *nf, *nft;
int pWIDE, pHIGH;

unsigned char r[256],g[256],b[256];
unsigned char *pcol[]= {r,g,b};

unsigned char *pic, *pic2;
unsigned char *picg, *picb;

#define DEF_SIZE 400

extern int debug_, koctet_;
int mem_size= 0;

int true_color;
static int i0, numcols;
Fort_int lfmt1[9]= {256,3,1,0,256,3,1,1,200};
int flgct;
FILE *fp;
extern int errno;
int iz= 1, nz= 0;
#define C_PPM 0
#define C_PGM 1
#define C_PBM 2
static char codes[3] = {'6','5','4'};

static void inv_pix(buf,nblig,dimx)
char *buf;
int nblig;
int dimx;
{
  int n, n1, msk, i, j;
  n = dimx / 8;
  n1 = dimx % 8;
  msk = (0xff00 >> n1) & 0xff;
  for(i=0;i<nblig;i++) {
    for(j=0;j<n;j++) {
      *buf ^= 0xff;
      buf++;
    }
    if(n1) {
      *buf ^= msk;
      buf++;
    }
  }
}

static void inr8_to_pbm(buf,nblig,dimx)
unsigned char *buf;
int nblig;
int dimx;
{
  int n, n1, msk, i, j, k;
  int c, v;
  unsigned char *po;
  n = dimx / 8;
  n1 = dimx % 8;
  po = buf;
  for(i=0;i<nblig;i++) {
    for(j=0;j<n;j++) {
      v = 0;
      msk = 0x80;
      k = 8;
      while(k-- > 0) {
	c = *buf++;
	if(c <= 0x80) v |= msk;
	msk >>= 1;
      }
      *po++ = v;
    }
    if(n1) {
      v = 0;
      msk = 0x80;
      k = n1;
      while(k--) {
	c = *buf++;
	if(c <= 0x80) v |= msk;
	msk >>= 1;
      }
      *po++ = v;
    }
  }
}

char *cmd;
main(argc,argv)
int argc;
char **argv;
{
  register i, n;
  register iy, iy0;
  int ntc;
  int lglig, lglig1, nblig, ntot;
  char comment[256];
  int prog_type;
  struct multi_cmd *ppcmd;

  prog_type = inr_initm(argc,argv,"2.2",cmds);
  ppcmd = &cmds[prog_type];

  cmd = argv[0];
  flgct = 0;
  true_color = 0;

  fileopt(in,"i");
  fileopt(out,"o");
  igetopt1("-iz","%d",&iz);
  igetopt1("-z","%d",&nz);
  if(prog_type != C_PBM) {
    flgct = igetopt1("-ct","%s",tcn);
    true_color = igetopt0("-C");
  }
  if(tstopts())
    iusage_(ppcmd->ucmd,ppcmd->udetail);
  nf = image_(in,"e","",lfmt);
  if((prog_type == C_PBM) && (BSIZE != -1 || TYPE != PACKEE) && (BSIZE != 1))
    imerror(9,"L'image doit etre codee sur 1 ou 8 bits\n");
  if((out[0] == '>') && (out[1] == 0)) {
    fp = stdout;
  } else {
    if((fp = fopen(out,"w+")) == NULL)
      imerror(1,"out file %s, open err %d\n",out,errno);
  }
  if(NDIMV != 3 && NDIMZ != 3)
    true_color = 0;
  iz--;
  if(iz < 0) iz = 0;
  else if(iz >= NDIMZ) iz = NDIMZ - 1;
  if(nz <= 0) nz = NDIMZ - iz;
  else if(nz > (NDIMZ -iz)) nz = NDIMZ - iz;
  pHIGH = nz * NDIMY;
  if(true_color) {
    if(NDIMV == 3) {
      pWIDE = NDIMX;
    } else {
      true_color = 2;
      pWIDE = DIMX;
      pHIGH = NDIMY;
      nz= 1;iz= 0;
    }
  } else {
    pWIDE = DIMX;
  }
  if(flgct) {
    nft = image_(tcn,"s","a",lfmt1);
    c_lect(nft,1,r);
    c_lect(nft,1,g);
    c_lect(nft,1,b);
    ntc = 3;
    fermnf_(&nft);
    numcols = 256;
#if 0
    r[255] = r[0] ^ 255;
    g[255] = g[0] ^ 255;
    b[255] = b[0] ^ 255;
#endif
  } else {
    ntc = ird_ctrgb(nf,&i0,&numcols,r,g,b,256);
  }
  if(koctet_ <= 0) koctet_ = DEF_SIZE;
  mem_size = koctet_ * 1024;
  if(true_color == 2) mem_size /= 3;
  /*	n = NDIMY * DIMX; */
  if(prog_type == C_PBM) {
    lglig1 = (DIMX + 7) / 8;
    lglig = (BSIZE < 0) ? lglig1 : DIMX;
  } else {
    i = BSIZE > 0 ? BSIZE : ((-BSIZE + 7) / 8);
    lglig = DIMX * i;
    lglig1 = lglig;
  }
  nblig = mem_size / lglig;
  if(nblig > NDIMY)
    nblig = NDIMY;
  pic = (unsigned char *)i_malloc(nblig * lglig);
  if(ntc == 3 && !true_color)
    true_color = 3;  /* conversion necessaire */
  if(true_color != 1)
    pic2 = (unsigned char *)i_malloc(3 * DIMX );
#if 0
  if(true_color) {
    if(true_color > 1)
      pic2 = (unsigned char *)i_malloc(n * i);
  } else {

  }
#endif
  fprintf(fp, "P%c\n",codes[prog_type]);
  fprintf(fp, "%d %d\n", pWIDE, pHIGH);
  if(prog_type != C_PBM)
    fprintf(fp, "255\n");

  if(true_color == 2) { /* couleur sur 3 plans */
    ntot = NDIMY;
    iy0 = 1;
    picg = (unsigned char *)i_malloc(nblig * lglig);
    picb = (unsigned char *)i_malloc(nblig * lglig);
    while(ntot > 0) {
      if(nblig > ntot)
	nblig = ntot;
      ntot -= nblig;
      n = lglig * nblig;
      iy = iy0;
      iy0 += nblig;
      c_lptset(nf,iy);
      c_lect(nf,nblig,pic);
      c_cnvvis(pic,pic,nblig,lfmt,0,0,0,1);
      iy += NDIMY;
      c_lptset(nf,iy);
      c_lect(nf,nblig,picg);
      c_cnvvis(picg,picg,nblig,lfmt,0,0,0,1);
      iy += NDIMY;
      c_lptset(nf,iy);
      c_lect(nf,nblig,picb);
      c_cnvvis(picb,picb,nblig,lfmt,0,0,0,1);
      if(prog_type == C_PGM) {
	c24_to_bw(pic,picg,picb,pic,n,pcol);
	if(fwrite(pic,1,pWIDE,fp) <= 0) 
	  imerror(9,"write pgm error %d\n",errno);
      } else {
	if(write_zcolppm(fp, pic, picg, picb, pWIDE, nblig,ntc) != 0)
	  imerror(9,"write ppm error %d\n",errno);
      }
    }

    fflush(fp);
    fermnf_(&nf);
    fclose(fp);
    return 0;
  }
  c_lptset(nf,iz * NDIMY +1);
  ntot = nz * NDIMY;
  while(ntot > 0) {
    if(nblig > ntot)
      nblig = ntot;
    n = lglig1 * nblig;
    ntot -= nblig;
    if(prog_type == C_PBM) {
      c_xlect(nf,nblig,pic,0);
      if(BSIZE < 0) { /* image 1 bit */
	inv_pix(pic,nblig,DIMX);   /* il faut inverser : 1= noir en pbm */
      } else { /* 8bits : conversion + inversion */
	inr8_to_pbm(pic,nblig,DIMX);
      }
      if(fwrite(pic,1,n,fp) <= 0) 
	  imerror(9,"write pbm error %d\n",errno);
      continue;
    }
    c_lect(nf,nblig,pic);
    c_cnvvis(pic,pic,nblig,lfmt,0,0,0,1);
    if(prog_type == C_PPM) {
      if(true_color == 1) { /* vect RGB / pixel */
	if(write_vcolppm(fp, pic, pWIDE, nblig,ntc) != 0)
	  imerror(9,"write ppm error\n");
      } else {
	if(write_monoppm(fp, pic, pWIDE, nblig,ntc) != 0)
	  imerror(9,"write ppm error\n");
      }
      continue;
    }
    /* type PGM */
    if(true_color == 1) { /* vect RGB / pixel */
      cvec_to_bw(pic,pic,pWIDE*nblig,pcol);
    } else {
      c8_to_bw(pic,pic,n,pcol);
    }
    if(fwrite(pic,1,n,fp) <= 0) 
      imerror(9,"write pgm error %d\n",errno);
  }
  fflush(fp);
  fermnf_(&nf);
  fclose(fp);
  return 0;
}


write_monoppm(fp,buf, width, height,ntc)
register width, height, ntc;
FILE *fp;
register unsigned char *buf;
{
	register x, y;
	register unsigned char *p2;

	for(y=0;y<height;y++) {
		p2 = pic2;
		if(ntc) {
			for(x=0;x<width;x++) {
				*p2++ = r[(int)*buf];
				*p2++ = g[(int)*buf];
				*p2++ = b[(int)*buf++];
			}
		} else {
			for(x=0;x<width;x++) {
				*p2++ = *buf;
				*p2++ = *buf;
				*p2++ = *buf++;
			}
		}
		if(fwrite(pic2,3,width,fp) <= 0) return -1;
	}
	return 0;
}

write_vcolppm(fp,buf, width, height,ntc)
register width, height, ntc;
FILE *fp;
register unsigned char *buf;
{
	register x, y;
	register unsigned char *p2, *p0;

	for(y=0;y<height;y++) {
		p0 = buf;
		if(ntc) {
			p2 = buf;
			for(x=0;x<width;x++) {
				*p2++ = r[(int)*buf++];
				*p2++ = g[(int)*buf++];
				*p2++ = b[(int)*buf++];
			}
		} else {
			buf += 3 * width;
		}
		if(fwrite(p0,3,width,fp) <= 0) return -1;
	}
	return 0;
}

/* convert z color buffer to ppm */
write_zcolppm(fp,bufr, bufg, bufb, width, height,ntc)
register width, height, ntc;
FILE *fp;
register unsigned char *bufr, *bufg, *bufb;
{
	register x, y;
	register unsigned char *p2, *p0;
	for(y=0;y<height;y++) {
		p2 = pic2;
		if(ntc) {
			for(x=0;x<width;x++) {
				*p2++ = r[(int)*bufr++];
				*p2++ = g[(int)*bufg++];
				*p2++ = b[(int)*bufb++];
			}
		} else {
			for(x=0;x<width;x++) {
				*p2++ = *bufr++;
				*p2++ = *bufg++;
				*p2++ = *bufb++;
			}
		}
		if(fwrite(pic2,3,width,fp) <= 0) return -1;
	}
	return 0;
}
