#include <stdio.h>
#include <inrimage/image.h>
#include "sunras.h"


static char version[]= "2.1";

static char Ucmd[]= 
"[-ct colortb_file_out] [input-file | -] [out-image]\n";
static char Udetail[]= 
"  Converts sun raster image to inrimage\n\
\t-ct : write cmap in specified file instead of image header";
static Fort_int lfmt[9]= {0,0,1,0,0,0,1,1,200};
struct image *nf, *nft;

extern int IM_nbmin_hdr;

char in[256], out[256], tcn[256];

extern int debug_;

Fort_int lfmt1[9]= {256,3,1,0,256,3,1,1,200};
int flgc;
struct extimage *nfext;
extern struct extimage *opensunras();

char *cmd;
main(argc,argv)
int argc;
char **argv;
{
	register i;
	inr_init(argc,argv,version,Ucmd,Udetail);
	cmd = argv[0];
	flgc = igetopt("-ct","",0,"%s",tcn,"",0);
	fileopt(in,"i");
	fileopt(out,"o");
	if(tstopts())
		iusage_(Ucmd,Udetail);
	nfext = opensunras(in);
	if(nfext->nbits > 8) {
		BSIZE = (nfext->nbits + 7) / 8;
	}
	NDIMX = nfext->ndimx;
	NDIMV = nfext->ndimv;
	DIMX = NDIMX * NDIMY;
	DIMY = NDIMY = nfext->ndimy;
	if(nfext->nbits < 8) {
		TYPE = PACKEE;
		BSIZE = -nfext->nbits;
	} else {
		TYPE = FIXE;
		BSIZE = nfext->nbits / 8;
	}
	if(!flgc) {  /* set correct size of header */
		IM_nbmin_hdr = 8;
	}
	nf = image_(out,"s","a",lfmt);
	if(flgc) {
		nft = image_(tcn,"s","a",lfmt1);
		c_ecr(nft,1,nfext->rbuf);
		c_ecr(nft,1,nfext->gbuf);
		c_ecr(nft,1,nfext->bbuf);
		fermnf_(&nft);
	} else {
		iwr_ctrgb(nf,0,nfext->numcols,nfext->rbuf,nfext->gbuf,nfext->bbuf);
	}
	readsunras(&nfext);
	c_xecr(nf,NDIMY,nfext->data,1);
	fermnf_(&nf);
	fermimext(&nfext);
	return 0;
}

