#include <stdio.h>
#include <inrimage/image.h>

#define MAXCOL 256

static char tabr[MAXCOL], tabg[MAXCOL], tabb[MAXCOL];
static char outtab[3*MAXCOL];
static char compr[MAXCOL], compg[MAXCOL], compb[MAXCOL];

static char *pcol[3] = {tabr,tabg,tabb};
static char *pcomp[3] = {compr,compg,compb};

#define O_BW 0
#define O_C8 1
#define O_C24 2
#define O_IMAGE O_C24
#define O_VOLUME O_BW

static int un= 1;
#define ALIGN4(x) ((x + 3) & ~3)

extern int errno;
extern int debug_;
/* si *nf_ct != NULL, on compose les t.c. avec le fichier nf_ct */

static char out_hdr[8];  /* for outputfile header */

/* pnzi : NDIMZ d'entree, lfmt = format d'entree
nfi tableaux de 3 nf
si 1 seule image les 3 elements du tableau nf sont egaux
*/
sim2avs(buffer,ndims,nfi,fd_out,nf_ct,pnzi,lfmt,pflg_out)
char *buffer;
int *ndims;
struct image **nfi, **nf_ct;
int *pnzi;
long lfmt[9];
int *fd_out;
int *pflg_out;
{
	int nbtab1, nbtab2, nbtab;
	int i0, nbcol;
	int flg_in, flg_out;
	int nzi;
	int nbi;
	int iy, iy0;
	register n, i, nbl;
	register char **pc;
	int nblig;
	int nmax;
	register char *bufr, *bufo;
	nbi = nfi[0] == nfi[1] ? 1 : 3;
		
	if(nbi == 1) {
		nbtab1 = ird_ctrgb(*nfi,&i0,&nbcol,tabr,tabg,tabb,MAXCOL);
	} else {
		ird_ctrgb(nfi[0],&i0,&nbcol,tabr,NULL,NULL,MAXCOL);
		ird_ctrgb(nfi[0],&i0,&nbcol,NULL,tabg,NULL,MAXCOL);
		ird_ctrgb(nfi[0],&i0,&nbcol,NULL,NULL,tabb,MAXCOL);
		nbtab1 = icmp_ct(tabr,tabg,tabb,MAXCOL);
	}
	nbtab = nbtab1;
	if(*nf_ct != NULL) { /* il y a 2e table couleur */
		nbtab2 = ird_ctfile(*nf_ct,&i0,&nbcol,compr,compg,compb,MAXCOL);
		nbtab = nbtab2 > nbtab1 ? nbtab2 : nbtab1;
		/* compose 2 tables */
		apply_1ct(tabr,tabr,MAXCOL,compr);
		apply_1ct(tabg,tabg,MAXCOL,compg);
		apply_1ct(tabb,tabb,MAXCOL,compb);
	}
	nzi = *pnzi;
	flg_out = *pflg_out;
	if((nzi > 1 || nbi > 1) && (flg_out == O_IMAGE))
		flg_in = O_C24;
	else {
		if(nbtab <= 1)
			flg_in = O_BW;
		else
			flg_in = O_C8;
	}
	n = *ndims * sizeof(long);
	nmax = DIMY;
	/* determination du nb de buffers */
	if(flg_out == O_IMAGE) {
		n = (n - sizeof(long)) / 5;
		nmax = NDIMY;
	}
	nblig = n / DIMX;
	if(nblig <= 0)
		imerror(8,"scnvcol: pas assez de memoire\n");
	if(nblig > nmax)
		nblig = nmax;
	pc = nbtab >= 1 ? pcol : NULL;
	iy = 1;
	if(debug_) {
		fprintf(stderr,"scnvcol : flg_in=%d, flg_out=%d, nbtab %d, nblig %d\n",
			flg_in, flg_out,nbtab,nblig);
	}
	if(nbi == 3)
		nzi = 3;
	if(flg_out == O_VOLUME) {
		if(DIMX >= 256 || NDIMY >= 256 || NDIMZ >= 256)
			imerror(9,"image trop grande : AVS volume limite a 256x256x256\n");
		out_hdr[0] = DIMX;
		out_hdr[1] = NDIMY;
		out_hdr[2] = NDIMZ;
		mywrite(*fd_out,out_hdr,3);
		while (nmax > 0) {
			if(nblig > nmax)
				nblig = nmax;
			nmax -= nblig;
			n = nblig * DIMX;
			c_lect(nfi[0],nblig,buffer);
			switch(flg_in) {
			case O_BW:
				if(nbtab >= 1)
					apply_1ct(buffer,buffer,n,*pc);
				break;
			case O_C8:
			        c8_to_bw((char*)buffer,(char*)buffer,n,(unsigned char **)pc);
				break;
			default:
				imerror(9,"sim2avs: unexpected switch case %d %d\n",flg_in,flg_out);
				break;
			}
			mywrite(*fd_out,buffer,n);
		}
		return 1 /* makes c99 happy */;
	}
	/* sortie image */
	out_hdr[0] = DIMX;
	out_hdr[1] = DIMX >> 8;
	out_hdr[2] = DIMX >> 16;
	out_hdr[3] = DIMX >> 24;
	out_hdr[4] = DIMY;
	out_hdr[5] = DIMY >> 8;
	out_hdr[6] = DIMY >> 16;
	out_hdr[7] = DIMY >> 24;
	mywrite(*fd_out,out_hdr,8);
	n = nblig * DIMX;
	bufo = buffer + ALIGN4(n);
	bufr = bufo + 3;
	for(i=0;i<n;i++)
		*bufr++ = 0;
	iy0 = 1;
	while (nmax > 0) {
		if(nblig > nmax)
			nblig = nmax;
		nmax -= nblig;
		n = nblig * DIMX;
		bufr = bufo + 2;
		iy = iy0;
		iy0 += nblig;
		for(i=0;i<3;i++) {
			c_lptset(nfi[i],iy);
			c_lect(nfi[i],nblig,buffer);
			if(nzi > 1)
				iy += NDIMY;
			switch (flg_in) {
			case O_BW:
			case O_C8:
				bwc8_to_iavs(buffer,bufr,n,pc,i);
				break;
			case O_C24:
				break;
			default:
				imerror(9,"sim2avs: unexpected switch case %d %d\n",flg_in,flg_out);
			}
			bufr--;
		}
		mywrite(*fd_out,bufo,n * 4);
	}
}


mywrite(fd,buf,n)
register n, fd;
char *buf;
{
	register i;
	if((i = write(fd,buf,n)) != n) {
		if(i < 0)
			imerror(1,"write error %d on AVS file\n",errno);
		else
			imerror(1,"bad write count (%d, %d) on AVS file\n",n,i);
	}
}

bwc8_to_iavs(bufi,bufo,n,pcol,ic)
register char *bufi, *bufo, **pcol;
register n, ic;
{
	register char *pc;
	if(pcol == NULL) {
		while(n-- > 0) {
			*bufo = *bufi++;
			bufo += 4;
		}
		return 0;
	}
	pc = pcol[ic];
	while(n-- > 0) {
		*bufo = *(pc + *bufi++);
		bufo += 4;
	}
	return 0;
}
