/**
 * (c) 2007 Dominique Brziat
 */
#include <inrimage/gvis.h>
#include "structs.h"
#include "labels.h"

GdkColor gdkcolors[] = {
  { 0, 0, 0, 65535},
  { 0, 0, 65535, 0},
  { 0, 0, 65535, 65535},
  { 0, 65535, 0, 0},
  { 0, 65535, 0, 65535},
  { 0, 65535, 65535, 0},
  { 0, 65535, 65535, 65535},
  { 0, 0, 0, 0}};

void par_str( char *str, struct inrgvis *data, int ix, int iy) {
  int in = 1;
  
  if( ix > 0 && ix <= data->NDIMX)
    sprintf( str, "-ix %d", (ix-1) % data->NDIMX + 1);
  else {
    sprintf( str, "-ix <out>");
    in = 0;
  }
  if( iy > 0 && iy <= data->NDIMY)
    sprintf( str, "%s  -iy %d", str, (iy-1) % data->NDIMY + 1);
  else {
    sprintf( str, "%s  -iy <out>", str);
    in = 0;
  }  
  if( data->display != DISP_RGB && data->NDIMV > 1) 
    sprintf( str, "%s  -iv %d", str, data->iv);  
  if( data->NDIMZ > 1) sprintf( str, "%s  -iz %d", str, data->iz);  
  /* valeur du pixel */
  if( in) {
    int index = data->DIMX * data->NDIMY * (data->iz-1);
    switch( data->display) {
    case DISP_RGB:
      index += data->DIMX * (iy-1) + 3 *(ix-1);
      sprintf( str, "%s  -pix %d %d %d", str, data->buf[ index], 
	       data->buf[index+1], data->buf[index+2]);
      break;
    case DISP_RGBA:
      index += data->DIMX * (iy-1) + 4 *(ix-1);
      sprintf( str, "%s  -pix %d %d %d %d", str, data->buf[ index], 
	       data->buf[index+1], data->buf[index+2], data->buf[index+3]);
      break;
    default:
      index += data->DIMX * (iy-1) + data->NDIMX *(data->iv-1) + ix - 1;
      sprintf( str, "%s  -pix %d", str, data->buf[ index] ); 
    }
  }  
}
