C* EGHIST
	SUBROUTINE EGHIST(NIVEAU,NOVHIS,TABNIV,NTABF,A,NTABV,NFI,ISFI,
     *NFO,ISFO,IFMT,IAS,NDIS,RALPHA)
C
C   EFFECTUE UNE EGALISATION D'HISTOGRAMME SUR UNE IMAGE DE
C   BYTESIZE 1.
C   POSSIBILITES D'AVOIR L'HISTOGRAMME SEUL,
C                L'EGALISATION D'HISTOGRAMME SIMPLE
C                L'EGALISATION AVEC MOENNAGE SUR UN VOISINAGE
C                DE RAYON NDIS(PIXELS) AUTOUR DU POINT
C                (PERMET DE RAJOUTER DES NIVEAUX ARTIFICIELS)
C                D'OBTENIR LES HISTOGRAMMES SUR TEK:
C
C  MOENNAGE
C          A PARTIR DU TABLEAU ORIGINAL DANS A
C          ON CREE A LA SUITE UN TABLEAU AGGRANDI
C          BORDE PAR NDIS LIGNES ET COLONNES DE CHAQUE COTE.
C
C
C      * ********
C        *      *
C      N *      *
C      L *      *
C      I *      *
C      G *  A   *
C      1 *      *
C      * *      *
C *********      *********
C *       N              *
C *NDIS--*D------*NDIS---*
C *       I              *
C *       S              *
C *       ********       *
C *       *NDIMX *       *
C *     N *      *       *
C *     L *      *       *
C *     I *  A   *       *
C *     G *      *       *
C *     1 *      *       *
C *      ********        *
C *       N              *
C *       D              *
C *       I              *
C *       S              *
C ************************
C
C     A:TABLEAU GENERAL
C     NDIMX:TAILLE EN X DE L'IMAGE
C     NDIS : RAYON EN PIXELS DU VOISINAGE
C     NBLIG:NOMBRE DE LIGNES IMAGE A UTILISER POUR LE TABLEAU
C           AGGRANDI
C     NLIG1:NOMBRE DE LIGNES EFFECTIVES MOYENNEES
C     KT1  :NOMBRE DE LIGNES A DUPLIQUER EN DESSOUS
C     KT2  :NOMBRE DE LIGNES A DUPLIQUER AU DESSUS
C     NIVEAU ,NOVHIS,TABNIV UTILISES POUR MODIF.HISTOGRAMME
C     NBLIG+KT1+KT2=NLIG1+2*NDIS
C     SI RALPHA=1,OU SI NDIS=0,EGALISATION CLASSIQUE
C  IAS=1 SI TRACE TEKTRO
C
	 DIMENSION NTABF(3),NTABV(1),IFMT(4),NIVEAU(1)
	 DIMENSION A(1),TABNIV(1),NOVHIS(1)
         integer*4 tekbuf(64)
	IF(IAS.NE.1) goto 100
        call t4init(256,0,tekbuf)
        call t4effa
 100    IF(NDIS.LE.0) RALPHA=0
	 NDIMX=IFMT(1)
	 NDIMY=IFMT(2)
	 IF(IFMT(3).NE.1)CALL ERMESF(15)
	 DO 1 I=1,256
  1    NIVEAU(I)=0
	 N1=NDIMX+2*NDIS
	 NLIG=(4*NTABV(1)-N1*2*NDIS)/(N1+NDIMX)
	 IF(NLIG.LE.0)CALL ERMESF(8)
	 NPFAIR=1
	NDEBU=0
	 NLIG1=0
 20    NPFAIR=NPFAIR+NLIG1
	 IF(NPFAIR-NDIMY)16,16,1000
 16    NPLIG=NLIG+NPFAIR-1
	 NDLIG=NPFAIR-NDIS
	 NHLIG=NPLIG+NDIS
	 IF(NDLIG)3,3,4
 4     CALL LPTSET(NFI,NDLIG)
	 KT2=0
	 IF(NHLIG-NDIMY)5,5,6
 5     NBLIG=NLIG+2*NDIS
	 NLIG1=NLIG
	 KT1=0
	 GO TO 9
 6     NBLIG=NDIMY+1-NDLIG
	 IF(NPLIG-NDIMY)7,7,8
 7     NLIG1=NLIG
	 KT1=NHLIG-NDIMY
	 GO TO 9
 8     NLIG1=NDIMY-NPFAIR+1
	 KT1=NDIS
	 GO TO 9
 3     KT2=1-NDLIG
	 CALL LPTSET(NFI,1)
	 IF(NHLIG-NDIMY)10,10,11
 10    NBLIG=NHLIG
	 NLIG1=NLIG
	 KT1=0
	 GO TO 9
 11    NBLIG=NDIMY
	 IF(NPLIG-NDIMY)7,7,8
 9     NBA=NBLIG*NDIMX
	 N=NLIG1*(N1+NDIMX)+(2*NDIS*N1)
	 CALL LECT(NFI,NBLIG,A)
	IF(NDEBU.EQ.0)GO TO 34
	ND=NDIS-KT2
	NDIMA=NDIMX+2*NDIS
	NAG=NDIMX*NLIG1+(NDIMX+2*NDIS)*NLIG1+NDIS+1
	CALL TRTBL(A,NDIMA,NAG,A,NDIMX,1,NDIMX,ND,1)
  34   CALL AUGMTA(A,KT1,KT2,NDIS,NBLIG,NDIMX,N)
	NDEBU=1
	 CALL LPTSET(NFI,NPFAIR)
	 CALL LECT(NFI,NLIG1,A)
	 CALL MODIMA(A,NDIS,NLIG1,NDIMX,RALPHA,NIVEAU)
	 CALL LPTSET(NFO,NPFAIR)
	 CALL ECR(NFO,NLIG1,A)
	 GO TO 20
1000   DO 17 I=1,256
 17    TABNIV(I)=NIVEAU(I)
	 IF(IAS.NE.1)GO TO 32
	 CALL PLOT(TABNIV,16,256,0,1.,256.,IER)
	 CALL OUTSTR(0,'HISTOGRAMME DE DEPART $')
25     I=IASK(0,'CONTINUE (O/N)? $')
	 IF(I.NE.1)GO TO 25
C ***     TRANSFORMATION D'HISTOGRAMME
C
32     ANB=255./(NDIMX*NDIMY)
	 ANIV=TABNIV(1)*ANB+1
	 TABNIV(1)=ANIV
	 DO 2 I=2,256
	 ANIV=ANIV+ANB*TABNIV(I)
 2     TABNIV(I)=ANIV
	 IF(IAS.NE.1)GO TO 33
	 CALL PLOT(TABNIV,16,256,0,1.,256.,IER)
	 CALL OUTSTR(0,'TABLEAU DE MODIFICATION D HISTOGRAMME $')
 26    CALL OUTSTR(0,'TAPER C RETURN CHARIOT POUR CONTINUER $')
	 I=LTCARA(BLUF)
	 IF(I.NE.67)GO TO 26
  33   DO 27 I=1,256
	 NOVHIS(I)=NIVEAU(I)
 27    NIVEAU(I)=TABNIV(I)
C ***     CONSTRUCTION DE L'IMAGE MODIFIEE
C
	 NLIG=4*NTABV(1)/NDIMX
	 NFIN=0
	 NPLIG=1
 12     IF(NLIG-NDIMY+NPLIG-1)14,14,15
 14     CALL LPTSET(NFO,NPLIG)
	 CALL LECT(NFO,NLIG,A)
	 NLI=NDIMX*NLIG
	 CALL MODHIS(A,NLI,NIVEAU)
	 CALL LPTSET(NFO,NPLIG)
	 CALL ECR(NFO,NLIG,A)
	 NPLIG=NPLIG+NLIG
	    IF(NFIN)12,12,28
 15    NLIG=NDIMY-NPLIG+1
	 NFIN=1
	 GO TO 14
 28    DO 30 I=1,256
	 NIVEAU(I)=NOVHIS(I)
 30    NOVHIS(I)=0
	 IF(IAS.NE.1)GO TO 13
	 DO 31 I=1,256
	 NIV=TABNIV(I)
 31    NOVHIS(NIV)=NOVHIS(NIV)+NIVEAU(I)
	 DO 29 I=1,256
 29    TABNIV(I)=NOVHIS(I)
	 CALL PLOT(TABNIV,16,256,0,1.,256.,IER)
	 CALL OUTSTR(0,'HISTOGRAMME FINAL $')
 13       CALL LPTSET(NFO,1)
	    CALL LPTSET(NFI,1)
	    RETURN
	    END
