/* MELAN
	SUBROUTINE MELANG(A,NDIM,NFI,NFO,inpt,outpt,win,mtype,inmsk,outmsk)
	melang_(a,ndim,nfi,nfo,in_pt,out_pt,win,mtype,in_msk,out_msk)
   melange une partie de l'image d'entree nfi a l'image nfo
   in_pt est le debut de la fenetre d'entree, de taille win
   elle est ecrite sur nfo a partir du point out_pt
  a de ndim mots, est le tableau de travail
  in_pt, out_pt, win : tableau de 4 Fort_int pour x,y,z,v 
  (v ignore pour pt, doit etre egal a NDIMV dans win)
  mtype : 0 = ancienne version (x de 1 a DIMX)
         & 0x100 new version, mtype & 0xff == 0 : cas normal, >0 : avec transparence 
		(test sur ivals si &0xf et/ou ovals si  &f0
		&1 = existe borne inf, &2 = ex. b. sup., & 4/8 = borne (inf/sup)
		comprise)
  in_msk, out_msk : tableaux de 2*NDIMV valeurs definissant des intervalles,
  de valeurs de pixels : 
  si mtype & 0xf, on me copie que les pixels de valeurs comprises dans in_msk
  si mtype & 0xf0 : on ne peut modifier que les pixels de image-out dont les valeurs
  sont comprises dans out_msk
  
*/
#include <inrimage/image.h>
#define M_IX 0
#define M_IY 1
#define M_IZ 2
#define M_IV 3
#define CONV_PACK 1
#define CONV_FLOAT 2

extern debug_;

#define MEL_NEW 0x10000
#define MEL_VECT 0x20000
#define MSK_IN MSK_ITVL
#define MSK_OUT (MSK_IN << 8)
#define MEL_MSK (MSK_IN | MSK_OUT)

melang_(a,ndim,nfi,nfo,in_pt,out_pt,win,mtype,in_msk,out_msk)
CHAR *a;
Fort_int *ndim;
struct image **nfi, **nfo;
Fort_int *in_pt, *out_pt, *win;
Fort_int *mtype, *in_msk, *out_msk;
{
	Fort_int lfmti[9], lfmto[9], ltmp[9];
	int ibs, nl, mtyp, nb_cop;
	register nb, i2;
	register iop;
	int ilo;
	int nblig;
	int ayi, ayo;
	int nbitsi, nbitso, lgligx;
	int jxi, jxo, jdimx;
	register i, need_conv;
	int tmpi[4];
	mtyp = *mtype & MEL_NEW ? *mtype & (MEL_MSK | MEL_NEW) : 0;
	c_getgfm(*nfi,(struct nf_fmt *)lfmti,0);
	c_getgfm(*nfo,(struct nf_fmt *)lfmto,0);
	if(lfmti[I_TYPE] != lfmto[I_TYPE] || lfmti[I_BSIZE] != lfmto[I_BSIZE])
		imerror(6,"codage des images incompatible\n");
	if(*win <= 0 || *(win+1) <= 0 || *(win+2) <= 0) return 1 /* makes c99 happy */; 
	tmpi[M_IX] = mtyp & MEL_NEW ? I_NDIMX : I_DIMX;
	tmpi[M_IY] = I_NDIMY;tmpi[M_IZ] = I_NDIMZ;
	tmpi[M_IV] = I_NDIMV;
	if((lfmti[I_NDIMV] != lfmto[I_NDIMV]) || (lfmti[I_NDIMV] != win[M_IV])) {
	  if(! mtyp) imerror(7,"le ndimv sont incompatibles\n");
	  mtyp |= MEL_VECT;
	}
	  
	for(i=0;i<4;i++) {
	  i2 = tmpi[i];
	  if((*(win+i) > (lfmti[i2] - *(in_pt+i) + 1)) || 
	     (*(win+i) > (lfmto[i2] - *(out_pt+i) + 1)))
	
	    imerror(7,"taille fenetre incompatible avec taille des images\n");
	}
	ltmp[I_BSIZE] = lfmti[I_BSIZE];
	ltmp[I_TYPE] = lfmti[I_TYPE];
	need_conv = 0;
	if(mtyp & (MEL_MSK | MEL_VECT)) {
	  if(lfmti[I_TYPE] == REELLE) {
	    need_conv = CONV_FLOAT;
	  } else if((lfmti[I_TYPE] == FIXE) && (lfmti[I_BSIZE] > 1 || lfmti[I_BSIZE] < -8)) {
	    need_conv = CONV_FLOAT;
	    ltmp[I_TYPE] = REELLE;
	    ltmp[I_BSIZE] = sizeof(float);
	  } else if(lfmti[I_TYPE] == PACKEE) {
	    ltmp[I_TYPE] = FIXE;
	    if(lfmti[I_BSIZE] < -8) {
	      ltmp[I_TYPE] = REELLE;
	      ltmp[I_BSIZE] = sizeof(float);
	      need_conv = CONV_FLOAT;
	    } else need_conv = CONV_PACK;
	  }
	}
	ltmp[I_DIMX] = lfmti[I_DIMX];
	nbitsi = ligbit_(ltmp,&ibs);
	ltmp[I_DIMX] = lfmto[I_DIMX];
	nbitso = ligbit_(ltmp,&ibs);
	lgligx = *(win+M_IX) * ibs;
	if(mtyp & MEL_NEW) lgligx *= lfmti[I_NDIMV];
	if((lgligx == nbitso) && (win[M_IV] == lfmto[I_NDIMV]) && !(mtyp & MEL_MSK)) { 
	  /* la fenetre a la taille de l'image de sortie : pas besoin de lire image-out*/
		nblig = (32 * *ndim) / nbitsi;
		if(nblig > *(win+M_IY))
			nblig = *(win+M_IY);
		if(nblig <= 0)
			imerror(8,"memoire insuffisante, augmentez -k\n");
		iop = 0;
		i2 = 0;
	} else {
		iop = 1;
		nblig = (32 * *ndim) / (nbitsi + nbitso);
		if(nblig > *(win+M_IY)) nblig = *(win+M_IY);
		while(1) {
			if(nblig <= 0)
				imerror(8,"memoire insuffisante, augmentez -k\n");
			if((nblig * nbitsi + 31)/32 + (nblig * nbitso + 31)/32 <= *ndim)
				break;
			nblig--;
		}
		i2 = 4 * ((nblig * nbitsi + 31) / 32);
	}
	ayi = *(in_pt+M_IY)  + (*(in_pt+M_IZ) - 1) * lfmti[I_NDIMY];
	ayo = *(out_pt+M_IY)  + (*(out_pt+M_IZ) - 1) * lfmto[I_NDIMY];
	if(mtyp & MEL_NEW) {
	  jxi = 1 + ((*(in_pt+M_IX) - 1) * lfmti[I_NDIMV]);
	  jxo = 1 + ((*(out_pt+M_IX) - 1) * lfmto[I_NDIMV]);
	  jdimx = *(win+M_IX) * lfmti[I_NDIMV];
	} else {
	  jxi = *(in_pt+M_IX);
	  jxo = *(out_pt+M_IX);
	  jdimx = *(win+M_IX);
	}
	nb_cop= 0;
	for(i=0;i<*(win+M_IZ);i++) {
		c_lptset(*nfi,ayi);
		ayi += lfmti[I_NDIMY];
		ilo = ayo;
		ayo += lfmto[I_NDIMY];
		nb = *(win+M_IY);
		nl = nblig;
		while(nb > 0) {
			if(nl > nb) nl = nb;
			if(need_conv == CONV_FLOAT)
			  c_lecflt(*nfi,nl,a);
			else {
			  c_lect(*nfi,nl,a);
			  if(need_conv == CONV_PACK)
			     c_unpkbt(a,a,nl * lfmti[I_DIMX],-lfmti[I_BSIZE]);
			}
			if(iop) {
				c_lptset(*nfo,ilo);
				if(need_conv == CONV_FLOAT)
				  c_lecflt(*nfo,nl,a+i2);
				else {
				  c_lect(*nfo,nl,a+i2);
				  if(need_conv == CONV_PACK)
				    c_unpkbt(a+i2,a+i2,nl * lfmto[I_DIMX],-lfmti[I_BSIZE]);
				}
			}
			if(mtyp & (MEL_MSK | MEL_VECT)) {
			  if(need_conv == CONV_FLOAT)
			    nb_cop += float_merge(a,lfmti,a+i2,lfmto,win,in_pt,out_pt,nl,mtyp,in_msk,out_msk);
			  else
			    nb_cop += int_merge(a,lfmti,a+i2,lfmto,win,in_pt,out_pt,nl,mtyp,in_msk,out_msk);
			} else {
			  c_trtblb(a,(int)lfmti[I_DIMX],jxi,a+i2,(int)lfmto[I_DIMX],jxo,jdimx,nl,ibs);
			}
			c_lptset(*nfo,ilo);
			if(need_conv == CONV_FLOAT)
			  c_ecrflt(*nfo,nl,a+i2);
			else {
			  if(need_conv == CONV_PACK)
			    c_pckbt(a+i2,a+i2,nl * lfmto[I_DIMX],-lfmto[I_BSIZE]);
			  c_ecr(*nfo,nl,a+i2);
			}
			ilo += nl;
			nb -= nl;
		}
	}
        if(debug_) printf("melang_: %d pixels copied\n",nb_cop);
}

float_merge(in,lfmti,out,lfmto,win,in_pt,out_pt,nl,mtyp,in_msk,out_msk)
float *in, *out, *in_msk, *out_msk;
Fort_int *in_pt, *out_pt, *win;
Fort_int *lfmti, *lfmto;
int nl, mtyp;
{
  int incxi, incxo, jdimx, ndimv;
  register i, j, fl_cop;
  register float *pi, *po;
  int nb_cop= 0;
  int ityp, otyp;
  ityp = mtyp & MSK_IN;
  otyp = (mtyp & MSK_OUT) >> 8;
  jdimx = win[M_IX];
  ndimv = win[M_IV];
  incxi = lfmti[I_NDIMV] - ndimv;
  incxo = lfmto[I_NDIMV] - ndimv;
  if(debug_) {
    printf("Float Merge, 0x%x\n",mtyp);
    if(ityp) {
      printf("in_msk: ");
      for(i=0;i<2*ndimv;i++)
	printf("%g ",*(in_msk+i));
      printf("\n");
    }
    if(otyp) {
      printf("out_msk: ");
      for(i=0;i<2*ndimv;i++)
	printf("%g ",*(out_msk+i));
      printf("\n");
    }
  }
  in += ((in_pt[M_IX]-1) * lfmti[I_NDIMV]) + in_pt[M_IV] - 1;
  out += ((out_pt[M_IX]-1) * lfmto[I_NDIMV]) + out_pt[M_IV] - 1;
  while(nl-- > 0) {
    pi = in;
    po = out;
    for(j=0;j<jdimx;j++) {
      fl_cop = ndimv;
      if(ityp) {
	for(i=0;i<ndimv;i++) {
	  if((*(pi+i) < *(in_msk+i)) || (*(pi+i) > *(in_msk+i+ndimv))) {
	    fl_cop--;
	  }
	}
	if(ityp & ITVL_NEGATE) fl_cop = fl_cop ? 0 : 1;
      }
      if(fl_cop && otyp) {
	fl_cop = ndimv;
	for(i=0;i<ndimv;i++) {
	  if((*(po+i) < *(out_msk+i)) || (*(po+i) > *(out_msk+i+ndimv))) {
	    fl_cop--;
	  }
	}
	if(otyp & ITVL_NEGATE) fl_cop = fl_cop ? 0 : 1;
      }
      if(fl_cop) {
	nb_cop++;
	for(i=0;i<ndimv;i++)
	  *po++ = *pi++;
      } else {
	pi += ndimv;
	po += ndimv;
      }
      pi += incxi;
      po += incxo;
    }
    in += lfmti[I_DIMX];
    out += lfmto[I_DIMX];
  }
  return nb_cop;
}


int_merge(in,lfmti,out,lfmto,win,in_pt,out_pt,nl,mtyp,in_msk,out_msk)
CHAR *in, *out;
int *in_msk, *out_msk;
Fort_int *in_pt, *out_pt, *win;
Fort_int *lfmti, *lfmto;
int nl, mtyp;
{
  int incxi, incxo, jdimx, ndimv, fl_sign;
  register i, j, fl_cop;
  register CHAR *pi, *po;
  register char *spi, *spo;
  int nb_cop= 0;
  int ityp, otyp;
  ityp = mtyp & MSK_IN;
  otyp = (mtyp & MSK_OUT) >> 8;
  ndimv = win[3];
  fl_sign = lfmti[I_EXP] < 0 ? 1 : 0;
  jdimx = win[M_IX];
  ndimv = win[M_IV];
  incxi = lfmti[I_NDIMV] - ndimv;
  incxo = lfmto[I_NDIMV] - ndimv;
  if(debug_) {
    printf("Int Merge, 0x%x, sign %d\n",mtyp,fl_sign);
    if(ityp) {
      printf("in_msk: ");
      for(i=0;i<2*ndimv;i++)
	printf("%d ",*(in_msk+i));
      printf("\n");
    }
    if(otyp) {
      printf("out_msk: ");
      for(i=0;i<2*ndimv;i++)
	printf("%d ",*(out_msk+i));
      printf("\n");
    }
  }
  in += ((in_pt[M_IX]-1) * lfmti[I_NDIMV]) + in_pt[M_IV] - 1;
  out += ((out_pt[M_IX]-1) * lfmto[I_NDIMV]) + out_pt[M_IV] - 1;
  while(nl-- > 0) {
    if(fl_sign) {
      spi = (char *)in;
      spo = (char *)out;
      for(j=0;j<jdimx;j++) {
	fl_cop = 1;
	if(ityp) {
	  for(i=0;i<ndimv;i++) {
	    if(((int)*(spi+i) < *(in_msk+i)) || ((int)*(spi+i) > *(in_msk+i+ndimv))) {
	      fl_cop = 0;
	      break;
	    }
	  }
	  if(ityp & ITVL_NEGATE) fl_cop ^= 1;
	}
	if(fl_cop && otyp) {
	    for(i=0;i<ndimv;i++) {
	      if(((int)*(spo+i) < *(out_msk+i)) || ((int)*(spo+i) > *(out_msk+i+ndimv))) {
		fl_cop = 0;
		break;
	      }
	    }
	    if(otyp & ITVL_NEGATE) fl_cop = fl_cop ? 0 : 1;
	}
	if(fl_cop) {
	  nb_cop++;
	  for(i=0;i<ndimv;i++)
	    *spo++ = *spi++;
	} else {
	  spi += ndimv;
	  spo += ndimv;
	}
	spi += incxi;
	spo += incxo;
      }
    } else {
      pi = in;
      po = out;
      for(j=0;j<jdimx;j++) {
	fl_cop = ndimv;
	if(ityp) {
	  for(i=0;i<ndimv;i++) {
	    if(((int)*(pi+i) < *(in_msk+i)) || ((int)*(pi+i) > *(in_msk+i+ndimv))) {
	      fl_cop--;
	    }
	  }
	  if(ityp & ITVL_NEGATE)  fl_cop = fl_cop ? 0 : 1;
	}
	if(fl_cop) {
	  if(otyp) {
	    fl_cop = ndimv;
	    for(i=0;i<ndimv;i++) {
	      if(((int)*(po+i) < *(out_msk+i)) || ((int)*(po+i) > *(out_msk+i+ndimv))) {
		fl_cop--;
	      }
	    }
	    if(otyp & ITVL_NEGATE) fl_cop ^= 1;
	  }
	}
	if(fl_cop) {
	  nb_cop++;
	  for(i=0;i<ndimv;i++)
	    *po++ = *pi++;
	} else {
	  pi += ndimv;
	  po += ndimv;
	}
	pi += incxi;
	po += incxo;
      }
    }
    in += lfmti[I_DIMX];
    out += lfmto[I_DIMX];
  }
  return nb_cop;
}
