/* normalisation d'une image
   normim_(buf,dim,nfi,nfo,nft)
   normalise l'image NFI, resultat dans NFO
   si *NFO != *NFT, NFT est une image temporaire de copie
   BUF : tableau DIM float pour les calculs
 */

#include <stdio.h>
#include <inrimage/image.h>

extern Fort_int ispipe_();

normim_(buf,dim,nfi,nfo,nft)

float *buf;
Fort_int *dim;
struct image **nfi,**nfo,**nft;
{
	Fort_int lfmt[9];
	Fort_int nrow,lnrow,nb_lignes,nb_pixels;
	register i, flg_cop;
	register float *fin_buf,*p,r_max,r_min,scale,temp;
	int opipe;
	int init = 1;


	cpyfmg_(nfi,lfmt);
	/* copie sur fichier temporaire si pipe ou image non reelle */
	if(*nfi != *nft)
		flg_cop = 1;
	else	flg_cop = 0;
	TYPE = REELLE;
	BSIZE = sizeof(float);

	setup_(dim,lfmt,&nrow,&lnrow,&nb_pixels);
	nb_lignes = nrow; /* sauvegarde */
	if(nrow == DIMY) flg_cop = -1;	/* tout tient en memoire */

	/* determination des extrema et copie simultanee sur nft */
	opipe = ispipe_(nfo);

	i  = DIMY;
	while(i > 0) {
		if (nrow > i) nrow = i;
		i -= nrow;

		lecflt_(nfi,&nrow,buf);
		if(flg_cop > 0 && (opipe || i > 0))
			c_ecr(*nft,nrow,buf); /* copie temporaire */

		if ( init ) { /* c'est la premiere ligne */
			r_max = *buf;
			r_min = *buf;
			init = 0;

		}

		fin_buf = buf + nrow * DIMX ;
		p = buf;

		while ( p < fin_buf ) {
			temp = *p++;
			if ( r_max < temp ) r_max = temp ;
			else if ( r_min > temp ) r_min = temp ;
		}

	}

	scale = r_max - r_min;
	if(scale == 0.)
		imerror(9,"image constante. Ne peut etre normalisee!\n");
	/* normalisation a partir de nft */
	/* on ne relit pas dernier buffer et commnece par la fin si
	   output n'est pas 1 pipe */
	if(opipe) {
		nrow = nb_lignes;
		for(i=1;i<=DIMY;i += nrow) {

			c_lptset(*nft,i);
			if(nrow > (DIMY - i + 1))
				nrow = DIMY -i + 1;
			if(flg_cop >= 0) lecflt_(nft,&nrow,buf);
		
			fin_buf = buf + nrow * DIMX ;
			p = buf;

			while ( p < fin_buf ) {
				*p = (*p - r_min) / scale;
				p++;
			}

			ecrflt_(nfo,&nrow,buf);
		}
		return 1 /* makes c99 happy */; 
	}
	i = DIMY - nrow + 1;
	init = 1;
	while(i > 0) {
		if((flg_cop >= 0) && !init) {
			c_lptset(*nft,i);
			lecflt_(nft,&nrow,buf);
		}
		init = 0;
		fin_buf = buf + nrow * DIMX ;
		p = buf;

		while ( p < fin_buf ) {
			*p = (*p - r_min) / scale;
			p++;
		}

		c_lptset(*nfo,i);
		ecrflt_(nfo,&nrow,buf);
		nrow = nb_lignes;
		i -= nrow;
	}
}
