/* conversion d'un tableau de float (float*8 pour cnvfl8) dans le type local 
   subroutine cnvflt(buf,n,typin)
   c_cnvflt(buf,n,typ_in) int4 *buf, n, typ_in;
   subroutine cnvfl8(buf,n,typin)
   c_cnvfl8(buf,n,typ_in) int4 *buf, n, typ_in;
   n = nb de valeurs a convertir dans buf
   typ_in : type des donnees (selon flt_type.h)
   retourne :
   	-1 si conversion impossible
	nb d'overflow sinon
*/
#include <stdio.h>
#include <stdlib.h>
#include <inrimage/flt_type.h>
#include <inrimage/image.h>

#define M_S 0x80000000
#define M_EXP2 0x7f800000
#define M_EXPD2 0x7ff00000
#define M_EXP16 0x7f000000
#define M_MANT2 0x7fffff
#define M_MANTD2 0xfffff
#define M_MANT16 0xffffff
#define FORCE_BIT 0x800000
#define EXP2_SHFT 23
#define EXPD2_SHFT 20
#define EXP16_SHFT 24
#define EXP2_BASE 127
#define EXPD2_BASE 1023
#define EXP16_BASE 64

extern Local_Float;
cnvflt_(buf,n,typ)
register float *buf;
register Fort_int *n;
Fort_int *typ;
{
	register int fltyp, nb;
	nb = (int)*n;
	fltyp = (int)*typ;
	return c_cnvflt(buf,nb,fltyp);
}

c_cnvflt(buf,nb,fltyp)
register float *buf;
register fltyp, nb;
{
	if(Local_Float == FL_UNDEF) get_fltyp();
	return cnv_float2((int4 *)buf,nb,fltyp,Local_Float);
}

cnvfl8_(buf,n,typ)
register float *buf;
register Fort_int *n;
Fort_int *typ;
{
	register int fltyp, nb;
	nb = (int)*n;
	fltyp = (int)*typ;
	return c_cnvfl8(buf,nb,fltyp);
}

c_cnvfl8(buf,nb,fltyp)
register float *buf;
register fltyp, nb;
{
	if(Local_Float == FL_UNDEF) get_fltyp();
	return cnv_float2_8((int4 *)buf,nb,fltyp,Local_Float);
}


cnv_float2(buf,nb,typ_in,typ_out)
register int4 *buf, nb;
register typ_in, typ_out;
{
int4 nbov;
register char *s1, *s2;
	if(typ_in == typ_out) return 0;
	s1 = get_flname(typ_in);
	s2 = get_flname(typ_out);
	if(typ_out != FL_SUN && typ_out != FL_GOULD && typ_out != FL_PE && typ_out != FL_DEC && typ_out != FL_KSR1) {
errc:		fprintf(stderr,"Desole : on ne convertit pas %s en %s !\n",s1,s2);
		return -1;
	}
	nbov = 0;
	switch(typ_in) {
	case FL_PE :
		if(typ_out == FL_SUN)
			cpe_sun(buf,nb);
		else if(typ_out == FL_GOULD)
			cpe_gould(buf,nb);
		else
			goto errc;
		break;
	case FL_SUN:
		if(typ_out == FL_GOULD)
			csun_gould(buf,nb);
		else if(typ_out == FL_DEC) {
			csun_dec(buf,nb,1);
		} else {
			goto errc;
		}
		break;
	case FL_GOULD:
		if(typ_out == FL_SUN)
			nbov = cgould_sun(buf,nb);
		else if(typ_out == FL_DEC)
			nbov = cgould_dec(buf,nb);
		else
			cgould_pe(buf,nb);
		break;
	case FL_KSR1:
		if(typ_out == FL_SUN)
			break;
		else if(typ_out == FL_DEC)
			nbov = cksr1_dec(buf,nb);
		else goto errc;
		break;
	case FL_VAX:
		if(typ_out == FL_SUN)
			cvax_sun(buf,nb);
		else if(typ_out == FL_GOULD)
			cvax_gould(buf,nb);
		else goto errc;
		break;
	case FL_DEC:
		if(typ_out == FL_SUN)
			csun_dec(buf,nb,1);
		else if(typ_out == FL_GOULD)
			cdec_gould(buf,nb);
		else
			goto errc;
		break;
	default:
		goto errc;
	}
	return nbov;
}

cnv_float2_8(buf,nb,typ_in,typ_out)
register int4 *buf, nb;
register typ_in, typ_out;
{
int4 nbov;
register char *s1, *s2;
	if(typ_in == typ_out) return 0;
	s1 = get_flname(typ_in);
	s2 = get_flname(typ_out);
/*	if(typ_out != FL_SUN && typ_out != FL_GOULD && typ_out != FL_PE && typ_out != FL_DEC && typ_out != FL_KSR1) { */
	if(typ_out != FL_SUN && typ_out != FL_DEC && typ_out != FL_KSR1) {
errc:		fprintf(stderr,"Desole : on ne convertit pas %s 64 bits en %s !\n",s1,s2);
		return -1;
	}
	nbov = 0;
	switch(typ_in) {
	case FL_SUN:
		if(typ_out == FL_DEC) {
			csun_dec(buf, nb,2);
		} else if(typ_out == FL_KSR1) {
			break;
		} else {
			goto errc;
		}
		break;
	case FL_KSR1:
		if(typ_out == FL_SUN)
			break;
		else if(typ_out == FL_DEC)
			nbov = cksr1_dec(buf,nb);
		else goto errc;
		break;
	case FL_DEC:
		if(typ_out == FL_SUN)
			csun_dec(buf,nb,2);
		else if(typ_out == FL_KSR1) {
			cdec_ksr1(buf,nb);
		} else
			goto errc;
		break;
	default:
		goto errc;
	}
	return nbov;
}

/* ****************************************
   programmes de conversion de cpu a cpu :
   chacun retourne le nb d'overflows
   */

/* pe->gould : il suffit de traiter les nb < 0 : on supp bit de signe 
et on prend l'oppose */
cpe_gould(buf,n)
register int4 *buf, n;
{
	register int4 v;
	while(n > 0) {
		if((v = *buf) < 0)
			*buf = -(v & 0x7fffffff);
		buf++;
		n--;
	}
	return 0;
}

/* gould->pe : il suffit de traiter les nb < 0 : on prend l'oppose et
 on rajoute le bit de signe */
cgould_pe(buf,n)
register int4 *buf, n;
{
	register int4 v;
	while(n > 0) {
		if((v = *buf) < 0)
			*buf = -v | M_S;
		buf++;
		n--;
	}
	return 0;
}

/* conversion flottant de format ieee sun a format gould
  format ieee :
	b0 = signe mantisse
	b1-b8 = exposant binaire : 1-255 representant 2**(exp-127)
	b9-b31 = mantisse normalisee sans son 1e bit (qui est tjs 1)
  format gould : (base 16)
	b0 = signe 
	b1-b7 = exposant base 16 0-127 pour -64 a +63
	b8-b31 = mantisse normalisee en base 16 : le 1er chiffre 
	pour les nb <0 on prend simplement l'oppose de la val. abs. 

*/

csun_gould(tab,nb)
register int4 *tab;
register nb;
{
	register shft;
	register e2, m, e16;
	register s;
	while(nb > 0) {
		nb--;
		if((m = *tab) == 0) {
			tab++;
			continue;
		}
		s = m;
		e2 = ((m & M_EXP2) >> EXP2_SHFT) - EXP2_BASE +1;
		m = (m & M_MANT2) | FORCE_BIT;
		if(e2 > 0) {
			e16 = (e2 + 3) >> 2;	/* puiss de 16 superieure */
			if((shft = (e16 << 2) - e2) > 0)	/* il faut decaler a droite la mant. */
				m >>= shft;
			e16 += EXP16_BASE;
		} else {
			e2 = -e2;
			e16 = e2 >> 2;
			if((shft = e2 & 0x3) > 0)
				m >>= shft;
			e16 = EXP16_BASE - e16;
		}
		m |= e16 << EXP16_SHFT;
		if(s < 0) m = -m;
		*tab++ = m;
		
	}
	return 0;
}

/* conversion flottant vax -> sun :
 rearrange les octets du vax : permute les octets 2 a 2  sur des int4! */
#define swpf(x,y) { x = y;\
y = ((x & 0xff00ff00) >> 8) | ((x & 0xff00ff) << 8); }
cvax_sun(tab,nb)
register u_int4 *tab;
register u_int4 nb;
{
	register u_int4 vx;
	while(nb-- > 0) {
		swpf(vx,*tab)
		tab++;
	}
	return 0;
}

char x16_2[]= { 0,0, 1,1, 2,2,2,2, 3,3,3,3,3,3,3,3};
static long nbovf;
cgould_sun(tab,nb)
register int4 *tab;
register nb;
{
register shft;
register e2, m, e16;
register s;
	nbovf= 0;
	while(nb > 0) {
		nb--;
		if((m = *tab) == 0) {
			tab++;
			continue;
		}
		if((s = m & M_S) < 0) m = -m;
		e16 = ((m & M_EXP16) >> EXP16_SHFT) - EXP16_BASE -1;
		m &= M_MANT16;
		shft = x16_2[m >> 20];
		if(e16 > 0) {
			e2 = (e16 << 2 ) + shft;
			if(e2 > 128) {
				nbovf++;
				e2 = 128;
			}
			e2 += EXP2_BASE;
		} else {
			e16 = -e16;
			e2 = (e16 << 2) -shft;
			if(e2 > 127) {
				nbovf++;
				e2 = 127;
			}
			e2 = EXP2_BASE - e2;
		}
		m <<= 3 - shft;
		m &= M_MANT2;
		*tab++ = m | (e2 << EXP2_SHFT) | s;
	}
	return nbovf;
}

cpe_sun(tab,nb)
register int4 *tab;
register nb;
{
register shft;
register e2, m, e16;
register s;
	nbovf= 0;
	while(nb-- > 0) {
		if((m = *tab) == 0) {
			tab++;
			continue;
		}
		s = m & M_S;
		e16 = ((m & M_EXP16) >> EXP16_SHFT) - EXP16_BASE -1;
		m &= M_MANT16;
		shft = x16_2[m >> 20];
		if(e16 > 0) {
			e2 = (e16 << 2 ) + shft;
			if(e2 > 128) {
				nbovf++;
				e2 = 128;
			}
			e2 += EXP2_BASE;
		} else {
			e16 = -e16;
			e2 = (e16 << 2) -shft;
			if(e2 > 127) {
				nbovf++;
				e2 = 127;
			}
			e2 = EXP2_BASE - e2;
		}
		m <<= 3 - shft;
		m &= M_MANT2;
		*tab++ = m | (e2 << EXP2_SHFT) | s;
	}
	return nbovf;
}


/* conversion sun <-> dec simple (nw=1) ou double (nw=2) */
csun_dec(buf,nb,nw)
register int4 *buf;
register nb;
int nw;
{
  if(nw == 2) swapint8(buf,nb);
  else swapint4(buf,nb);
	return 0;
}

/* conversions dec (mips <--> gould : on swap les bytes et on fait comme sun */
cdec_gould(buf,nb)
register int4 *buf;
register nb;
{
	swapint4(buf,nb);
	return csun_gould(buf,nb);
}
cgould_dec(buf,nb)
register int4 *buf;
register nb;
{
	register nbovf;
	swapint4(buf,nb);
	nbovf = cgould_sun(buf,nb);
	return nbovf;
}

cksr1_dec(buf,nb)
register int4 *buf;
register nb;
{
	swapint4(buf,2 * nb);
	nbovf = 0;
	return 0;
}
cdec_ksr1(buf,nb)
register int4 *buf;
register nb;
{
	swapint4(buf,2 * nb);
	nbovf = 0;
	return 0;
}

#define swp2(x,y) { x = y; y = ((x >> 8) & 0xff) | (x << 8); }
#define swp4(x,y) { x = y;\
y = (x << 24) | ((x & 0xff00) << 8) | ((x >> 8) & 0xff00) | ((x >> 24) & 0xff);}
swapint4(buf,nb)
register u_int4 *buf;
register nb;
{
	register u_int4 rl;
	while(nb-- > 0) {
		swp4(rl,*buf);
		buf++;
	}
}

/* swap sur 8 octets, nb = nb de doubles */
swapint8(buf,nb)
register u_int4 *buf;
register nb;
{
  register u_int4 r1, r2, v;
  while(nb-- > 0) {
    r1 = *(buf+1);
    r2 = *buf;
    swp4(v,r1);
    *buf++ = r1;
    swp4(v,r2);
    *buf++ = r2;
  }
}

swapshort(buf,nb)
register unsigned short *buf;
register nb;
{
	register unsigned short r2;
	while(nb-- > 0) {
		swp2(r2,*buf);
		buf++;
	}
}

cvax_gould(tab,n)
     int4 *tab;
     int n;
{
sorry();
}
sorry()
{
	fprintf(stderr,"Desole! Conversion non implementee\n");
	exit(1);
}
