/* EXCHTB
   c_exchtb(ibs,a,b,ia,ib,ipa,ipb,lgr)
	SUBROUTINE EXCHTB(IBS,A,B,IA,IB,IPA,IPB,LGR)

 echange les LGR points de byte size IBS entre
les tableaux A et B en partant des points IA et IB
et avec un pas IPA et IPB (en nb de points)
*/

#include <inrimage/image.h>

exchtb_(ibs,a,b,ia,ib,ipa,ipb,lgr)
Fort_int *ibs, *ia, *ib, *ipa, *ipb, *lgr;
int4 *a, *b;
{
	c_exchtb((int)*ibs,a,b,(int)*ia -1,(int)*ib -1,(int)*ipa,(int)*ipb,(int)*lgr);
}

c_exchtb(ibs,a,b,ia,ib,ipa,ipb,lgr)
register ibs, ipa, ipb, lgr;
register ia, ib;
register int4 *a, *b;
{
	register tmp, i;
	register char *p1, *p2;
	if((ibs <= 0) || ((ibs > 4) && (ibs != 8)))
		imerror(9,"c_exchtb: parametre ibs incorrect\n");
	if(ibs >= 4) {
		a += ia;
		b += ib;
		while (lgr-- > 0) {
			tmp = *a;
			*a = *b;
			*b = tmp;
			a += ipa;
			b += ipb;
		}
		return 1 /* makes c99 happy */; 
	}
	p1 = (char *)a;
	p2 = (char *)b;
	if(ibs == 1) {
		p1 += ia;
		p2 += ib;
		while (lgr-- > 0) {
			tmp = *p1;
			*p1 = *p2;
			*p2 = tmp;
			p1 += ipa;
			p2 += ipb;
		}
		return 1 /* makes c99 happy */; 
	}
	ipa = (ipa -1) * ibs;
	ipb = (ipb -1) * ibs;
	p1 += (ia *ibs);
	p2 += (ib * ibs);
	while (lgr-- > 0) {
		for(i=0;i<ibs;i++) {
			tmp = *p1;
			*p1++ = *p2;
			*p2++ = tmp;
			p1 += ipa;
			p2 += ipb;
		}
	}
}
