/*
  subroutine fmtset(nf,lfmt)
  subroutine gfmset(nf,gfmt)
  gfmset_(nf,gfmt)
  struct image **nf; struct nf_fmt *gfmt;
 procedures de remise a jour du format d'une image
a partir du tableau lfmt ou de la structure nf_fmt gfmt.
Si une option "-F=" valide a ete donnee, on change le type de header
NB: le header n'est ecrit sur le fichier que lors de "fermnf" ou de la 1e ecriture
*/

#include <stdio.h>
#include <inrimage/inrfile.h>
extern debug_;

static struct nf_fmt gfmt0 = {0};

fmtset_(anf,lfmt)
struct image **anf;
Fort_int lfmt[];
{
	register i;
	for(i=0;i<9;i++)
		gfmt0.lfmt[i] = lfmt[i];
	gfmset_(anf,&gfmt0);
}

gfmset_(anf,gfmt)
struct image **anf;
struct nf_fmt *gfmt;
{
	register struct image *nf;
	register n, trunc;
	int vers, hfree;
	register char **plines;
	register char *p;
	nf = *anf;
	if (debug_) fprintf(stderr,"%s fmtset:%s\n",xargv[0],nf->nom);

	if(gfmt->TYPE == REELLE) {
		if(gfmt->EXP > 0 && chk_ftyp(gfmt->EXP) > 0)
			nf->float_typ = gfmt->EXP;
	}
	put_gfmt(nf,gfmt,1);
	if((n = get_vers_opt()) > 0) {
		if(n == IV_OLD) n = IV_INR3;
		if(n == nf->i_version) n = 0;
	}
	if(n == IV_INR3 && nf->desc_size != DESC) {
		fprintf(stderr,"Attention! %s: taille header incompatible avec format demande\n",nf->nom);
		return 0;
	}
	if(n == 0) {
		while(1) {
			if((vers = fmt_desc(nf)) == 0) break;
			if(nf->i_version == IV_INR4)
				if(hist_del(nf,0) >= 0) continue;
			imerror(9,"Attention! impossible de modifier le header de %s\n",
				nf->nom);
		}
		return 0;
	}
	/* changement de header */
	if(nf->desc_size % FILE_HEADER_LEN) {
		fprintf(stderr,"Attention! %s : taille header incompatible avec format demande\n",nf->nom);
		return 0;
	}
	vers = nf->i_version;
	nf->i_version = n;
	plines = nf->hdr_lines;
	n = nf->hdr_nlines;
	if(nf->hdr_data != (char *) 0) {
		free(nf->hdr_data);
	}
	nf->hdr_data = (char *) 0;
	nf->hdr_lines = (char **) 0;
	nf->hdr_nlines = 0;
	nf->first_hist = nf->last_hist = -1;
	nf->hnum1 = nf->hnum2 = 0;
	init_hdr(nf,nf->desc_size);
	if(vers == IV_INR4) {
		plines++;
		n--;
	}
	n -= 2;
	while(n-- > 0) {
		if((hfree = ifreehdr(nf)) <= 0) break;
		p = *plines++;
		if(*p == '\n' || *p == 0) continue;
		trunc = 1;
		if(*p != '#') {
			trunc = 0;
			if(tst_hdrkey(p) >= 0) continue;
		} else {
			/* ne pas tronquer n'importe comment si history */
			if(chk_hist("",p) + 8 > hfree) continue;
		}
		add_hinfo(nf,"",0,p,lgrline(p),trunc);
	}
	/* on reconstruit tou proprement */
	free(nf->hdr_lines);
	nf->hdr_lines = (char **) 0;
	nf->hdrl_size = 0;
	nf->hdr_nlines = 0;
	bld_hdrlg(nf);
	return 0;
}

