/* programmes de determination de type de flottant */
#include <inrimage/flt_type.h>
#include <inrimage/image.h>

static char undef[]= "undef";
int Local_Float= FL_UNDEF;
char *Local_Flname= undef;
int Local_Msbfirst= -1;

static float local_moins1= -1.;
static union {
	int i_local;
	float f_local;
} fx;
static struct fltcnv fl_tb[]= {
	0xbef00000, 1, FLT_32 | FLT_64, FL_GOULD, "gould",	/* on complemente la valeur abs. si nb < 0 */
	0xbf800000, 1, FLT_32 | FLT_64, FL_SUN, "sun",	/* nb <0 : on met le 1er bit a 1 */
	0xbff00000, 1, FLT_64, FL_KSR1, "ksr1",	/* nb <0 : on met le 1er bit a 1 */
	0xbf800000, 0, FLT_32 | FLT_64, FL_DEC, "decm",	/* decstation  . vu 0x000080bf sur gould ou sun */
	0xc080, 0, FLT_32 | FLT_64, FL_VAX, "vax",	/* decstation  . vu 0x000080bf sur gould ou sun */
	0xc1100000, 1, FLT_32 | FLT_64, FL_PE, "pe",
	0x0000bf80, 0, FLT_32 , FL_HACKERS, "hackers",
	0, 0, 0, FL_UNDEF, undef
	};

/* si Local_Float est <= 0 appelle get_fltyp
renvoie Local_Float
version fortran locflt(type)
*/
Fort_int locflt_(type)
Fort_int *type;
{
	return (*type = (Fort_int)fl_type());
}

int fl_type()
{
	if(Local_Float <= 0) get_fltyp();
	return Local_Float;
}

/* renvoie le type de la machine courante, et le met dans la variable globale
   Local_Float
Cas particulier de Decstation : type FL_SUN avec LSB first
   */
int get_fltyp()
{
	register struct fltcnv *fl;
	register int fi;
	register short fltp;
	fx.f_local = local_moins1;
	fi = fx.i_local;
	fl = fl_tb;
	if(Local_Msbfirst < 0)
		Local_Msbfirst = ismsbfirst();
	while((fltp = fl->fl_typ) != FL_UNDEF) {
		if((fi == fl->v_moins1) && (fl->fl_msbfirst == Local_Msbfirst)) {
			Local_Flname = fl->fl_name;
			return (Local_Float = fltp);
		}
		fl++;
	}
	Local_Flname = undef;
	return (Local_Float = FL_UNDEF);
}

/* returns a pointer to the struct. for type ftyp  : NULL if not found */
static struct fltcnv *find_fltyp(ftyp)
register ftyp;
{
register struct fltcnv *fl;
register short fltp;
	fl = fl_tb;
	while((fltp = fl->fl_typ) != FL_UNDEF) {
		if(ftyp == fltp)
			return fl;
		fl++;
	}
	return (struct fltcnv *)0;
}

/* renvoie FL_UNDEF si fltyp n'est pas un type flottant connu, ftyp sinon */
chk_ftyp(fltyp)
register fltyp;
{
#if 0
	if(fltyp != FL_PE && fltyp != FL_SUN && fltyp != FL_DEC &&
	   fltyp != FL_GOULD)
		fltyp = FL_UNDEF;
	return fltyp;
#else
	register struct fltcnv *fl;
	if((fl = find_fltyp(fltyp)) == (struct fltcnv *)0)
		return FL_UNDEF;
	return fltyp;
#endif
}

/* renvoie le nom du flottant de type ftyp */
char *get_flname(ftyp)
register short ftyp;
{
	register struct fltcnv *fl;
	if((fl = find_fltyp(ftyp)) == (struct fltcnv *)0)
		return undef;
	return fl->fl_name;
}

/* renvoie le type de flottant en fonction du nom donne */
chk_flname(fname)
register char *fname;
{
	register struct fltcnv *fl;
	register short fltp;
	fl = fl_tb;
	while((fltp = fl->fl_typ) != FL_UNDEF) {
		if(strcmp(fname,fl->fl_name) == 0) return fltp;
		fl++;
	}
	return FL_UNDEF;
}


/* returns 1 if MSB first on this cpu */
int Ismsb_val= 0x1000000;

int ismsbfirst()
{
	return (ISMSBFIRST);
}

/* return 1 if Msb first on cpu of type fl_typ, -1 if unknown */
int chk_msbfirst(fltyp)
register fltyp;
{
	register struct fltcnv *fl;
	if((fl = find_fltyp(fltyp)) == (struct fltcnv *)0)
		return -1;
	return (int)fl->fl_msbfirst;
}
