/* programmes d'ecriture de history */
/*   auto_history(nf)
	iwrhis_(anf,string)
	c_iwrhis(nf,string)
	hist_del(nf,num)
	hist_size(nf,nbl)
*/
#include <inrimage/inrlocal.h>
#include <inrimage/inrfile.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

extern struct hdr_keys hdr_keys[];

/* automatic history */
auto_history(nf)
register struct image *nf;
{
	register char *p, *out;
	register n, i;
	char buf[256];
	if(nf->hdr_stat & HST_HISTSET) return 0;
	out = buf;
	n = 255;
	for(i=0;i<xargc;i++) {
		if((p = xargv[i]) != (char *)0) {
			while(*p != 0) {
				if(n-- <= 0) break;
				*out++ = *p++;
			}
			if(n <= 0) break;
			*out++ = ' ';
			n--;
		}
	}
	*out = 0;
	return c_iwrhis(nf,buf);
}

/* add string ended by '\0' or '\n' as a history item
(a special header will be prepended to string)
return -1 if error, 0 if already set, else history num
*/

iwrhis_(anf,string)
struct image **anf;
register char *string;
{
	return c_iwrhis(*anf,string);
}
c_iwrhis(nf,string)
register struct image *nf;
register char *string;
{
	register char *p;
	register n, maxhist;
	char buf[sizeof(S_HISTORY)+10];
	register length;
	if(nf == (struct image *) 0) return -1;
	if(nf->hdr_stat & HST_HISTSET) return 0;
	if((maxhist = get_hist()) <= 0) return -1;
	init_hdrkeys();
	length = lgrline(string);
	n = move_line(hdr_keys[IS_HISTORY].key,buf,sizeof(S_HISTORY));
	if((unsigned short)nf->hnum2 >= 0x7fff) {  /* debordement de numero */
		nf->hnum2 -= nf->hnum1;
		nf->hnum1 = 0;
	}
	sprintf(&buf[n],"<%d> ",nf->hnum2 +1);
	n = nf->hnum1 > 0 ? nf->hnum2 - nf->hnum1 + 1 : 0;
/*	p = hdr_keys[IS_HISTORY].key;*/
	if(n >= maxhist) {
		hist_del(nf,0);
	}
	while((n = add_hinfo(nf,buf,strlen(buf),string,length,0)) < 0) {
		if(hist_del(nf,0) < 0) return -1;  /* get space */
		if(nf->hnum2 == 0) {
			if((n = add_hinfo(nf,buf,strlen(buf),string,length,1)) < 0)
				return -1;
			break;
		}
	}
	nf->hnum2++;
	nf->last_hist = n;
	if(nf->hnum1 <= 0) {
		nf->hnum1 = nf->hnum2;
		nf->first_hist = -1;
	}
	if(nf->first_hist < 0)
		nf->first_hist = nf->last_hist;
	nf->hdr_stat |= HST_HISTSET | HST_TOWRITE;
	return nf->hnum2;
}

/* delete hitory record number num 
if num <= 1st : del 1st
if num >= last : del last
returns -1 if error
else : effective num
*/

hist_del(nf,num)
register struct image *nf;
register num;
{
	register nl, nl0;
	register char *p;
	register flag, kl;
	init_hdrkeys();
	if(nf->hnum2 <= 0) return -1;
	kl = hdr_keys[IS_HISTORY].key_length;	flag = -1;
	if(num <= nf->hnum1) {
		flag = 0;
		nl = nf->first_hist;
		num = nf->hnum1;
	} else if(num >= nf->hnum2) {
		flag = 1;
		nl = nf->last_hist;
		num = nf->hnum2;
	}
	if(flag < 0) {  /* ligne intermediaire */
		nl = nf->first_hist;
		while(1) {
			if((nl = next_key(nf,hdr_keys[IS_HISTORY].key,nl+1)) < 0)
				return -1;
			p = nf->hdr_lines[nl] + kl;
			if(*p != '<') return -1;
			if(num == atoi(p+1)) break;
		}
	}
	del_hline(nf,nl);
	if(flag < 0) {
		nf->last_hist--;
		return num;
	}
	if(nf->last_hist == nf->first_hist) {  /* no history left */
		nf->hnum1 = -1;
		nf->hnum2 = 0;
		nf->first_hist = nf->last_hist = -1;
		return num;
	}
	if(flag == 0) {  /* 1st hist deleted */
		nf->last_hist--;
		nf->first_hist = next_key(nf,hdr_keys[IS_HISTORY].key,nf->first_hist);
		nf->hnum1 = atoi(nf->hdr_lines[nf->first_hist] + kl + 1);
		return num;
	}
	/* last hist deleted */
	nl0 = nf->first_hist;
	while(1) {
		if((nl = next_key(nf,hdr_keys[IS_HISTORY].key,nl0+1)) < 0)
			break;
		nl0 = nl;
	}
	nf->last_hist = nl0;
	p = nf->hdr_lines[nl0] + kl + 1;
	nf->hnum2 = atoi(p);
	return num;
}

/* renvoie la taille totale des lignes de history
met dans nbl le nb de lignes
*/
int hist_size(nf,nbl)
register struct image *nf;
register int *nbl;
{
	register nl;
	register lgr;
	init_hdrkeys();
	*nbl = 0;
	if(nf->hnum2 <= 0) return 0;
	nl = nf->first_hist;
	lgr = 0;
	while((nl = next_key(nf,hdr_keys[IS_HISTORY].key,nl)) >= 0) {
		lgr += lgrline(nf->hdr_lines[nl]) +1;  /* +1 for \n */
		*nbl++;
		nl++;
	}
	return lgr;
}

