#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <inrimage/image.h>
#include <inrimage/inrlocal.h>

/* un mecanisme different pour les args Fortran de DEC, Evidemment!!!! */
extern int f77argc;
extern char **f77argv;
extern int for__l_argc;
extern char **for__a_argv;
extern int __xargc;
extern char **__xargv;

#ifdef INR_KHOROS
extern int khoros_mode;
#endif

static int xigetopt();

/* igetopt0(opt)
   retourne 1 si option trouve, 0 sinon */
int igetopt0(opt)
char *opt;
{
	return xigetopt(1,opt,"",0,"",0,"",0);
}

/* igetopt0x(opt,fopt,varopt)
   cherche option avec argument accolle'.
   retourne 1 si option trouve, 0 sinon */
int igetopt0x(opt,fopt,varopt)
char *opt, *fopt;
void *varopt;
{
	if((*opt != '-') || (*(opt+1) == 0))
		imerror(9,"igetopt0x invalifd first arg\n");
	return xigetopt(1,opt,fopt,varopt,"",0,"",0);
}

/* igetopt1(opt,f1,v1)
   cherche option a 1 arg.
   retourne 1 si option trouve, 0 sinon */
int igetopt1(opt,f1,v1)
char *opt, *f1;
void *v1;
{
	if((*opt != '-') || (*(opt+1) == 0))
		imerror(9,"igetopt1 invalifd first arg\n");
	return xigetopt(1,opt,"",0,f1,v1,"",0);
}

/* igetopt2(opt,f1,v1,f2,v2)
   cherche option a 2 arg.
   retourne 1 si option trouve, 0 sinon */
int igetopt2(opt,f1,v1,f2,v2)
char *opt, *f1, *f2;
void *v1, *v2;
{
	if((*opt != '-') || (*(opt+1) == 0))
		imerror(9,"igetopt2 invalifd first arg\n");
	return xigetopt(1,opt,"",0,f1,v1,f2,v2);
}

/* igetopt2v(opt,f1,v1,f2,v2)
   cherche option a 1 ou 2 arg.
   retourne 0 si non trouve, 1 ou 2 si 1 ou 2 args trouves 
*/
int igetopt2v(opt,f1,v1,f2,v2)
char *opt, *f1, *f2;
void *v1, *v2;
{
	if((*opt != '-') || (*(opt+1) == 0))
		imerror(9,"igetopt2 invalifd first arg\n");
	return xigetopt(0,opt,"",0,f1,v1,f2,v2);
}

/* igetopt */
/* procedure de decodage de la chaine d'options 

   on passe en argument 

	l'adresse de la string representant l'option cherchee ( si '\0'
					toute string convient )
	le format de cette string ( si ce format est '\0' on ne decode pas
					l'option )
	la variable de reception de l'option ( utilisee si format != '\0' )
	le format de l'option liee 1 ( meme principe )
	la variable receptrice
	le format de l'option liee 2 ( meme principe )
	la variable receptrice
Notes: 
    1. si l'option commence par '-' et que le format n'est pas nul,
   on acceptera une option commencant par "opt" et se terminant par qque chose
   qui correspond a fopt.
   2. si le format est gal  "%s" ou utilisera strcpy au lieu de sscanf
     pour ne pas tronquer sur les espaces
 Exemple:
       igetopt("-x","%s",string,"",0,"",0);
   reconnaitra -xyy (mettra "yy" dans string) mais pas -x

Modifs pour Khoros.  En mode khoros :
1.  les options isolees (-x sans arg)
    admettent un argument logique (0/1) dont la valeur est retournee
    Ex : -D  devient equ a -D 1
    c-a-d si *f1 == 0, on cherche si arg suivant vaut 0 ou 1
2. pour les options a 2 args, ces 2 args sont rassemblees en une seule chaine de car.
3. pour les options dont l'argument est accolle : on separe option et arg
  */
extern debug_;

int inr_xargc= 0;
char **inr_xargv= (char **) 0;

igetopt(opt,fopt,varopt,f1,v1,f2,v2)

char *opt;	/* option cherchee */
char *fopt;	/* format de l'option */
void *varopt;	/* pointeur sur la variable receptrice 
		    de type char pour satisfaire tous les cas */
char *f1;	/* format de l'option liee 1 */
void *v1;	/* pointeur sur la variable liee 1 */
char *f2;	/* format de l'option liee 2 */
void *v2;	/* pointeur sur la variable liee 2 */

{
	return xigetopt(1,opt,fopt,varopt,f1,v1,f2,v2);
}

static int inr_scanopt(char *p,char *fmt, void *opt)
{
  if(strcmp(fmt,"%s") == 0) {
    strcpy((char *)opt,p);
    return 1;
  } else
    return sscanf(p,fmt,opt);
}

static int xigetopt(fatal,opt,fopt,varopt,f1,v1,f2,v2)
register fatal;  /* errors are fatal */
char *opt;	/* option cherchee */
char *fopt;	/* format de l'option */
void *varopt;	/* pointeur sur la variable receptrice 
		    de type char pour satisfaire tous les cas */
char *f1;	/* format de l'option liee 1 */
void *v1;	/* pointeur sur la variable liee 1 */
char *f2;	/* format de l'option liee 2 */
void *v2;	/* pointeur sur la variable liee 2 */

{

	register i, n;
	register stat;
	register char *p;
	char tmp[128];
	if(inr_xargc == 0) {  /* 1ere fois : copier les arguments */
		inr_setopts();
	}
	for (i=1 ; i<inr_xargc ; ++i) { /* on scanne tous les arg */
		
		/* les arguments deja utilises == pointeur nul */
		
		if ((p = inr_xargv[i]) == (char *)0)
			continue;  /* skip to next valig arg. */
		
		/* si option == '\0' toute chaine convient 
		   sauf celles debutant par "-" ou un chiffre */
		
		n = strlen(opt);
		if ( n == 0 ) {
			if((*p == '-'&& strcmp("-",p)!=0) || isdigit(*p))
				continue;   /* non matching arg. */
			if (*fopt != '\0') inr_scanopt(p,fopt,varopt);
		} else if(*opt == '-' && *fopt != '\0') {
			if(khoros_mode) {   
				/* on simule le cas fopt=="" et f1 != "" */

				if(strcmp(opt,p) != 0)
					continue;
				if(*f1 != 0)
					imerror(9,"igetopt: pb with KHOROS mode\n");
				f1 = fopt;
				v1 = varopt;
			} else {
				if(strncmp(opt,p,n) != 0)
					continue;
				if(inr_scanopt(p+n,fopt,varopt) != 1)
					continue;
			}
		} else {
			if(strcmp(opt,p) != 0)
				continue;
			if (*fopt != '\0') inr_scanopt(p,fopt,varopt);
		}
		
		if(*f1 == 0) {  /* pas d'arguments */
			inr_xargv[i] = (char *)0 ; /* on invalide l'argument */
#ifdef INR_KHOROS
			if(!khoros_mode) 
				return 1;
			/* khoros_mode: chercher 0 ou 1 */
			if( ++i >= inr_xargc) return 0;  /* not found */
			if(inr_xargv[i] == (char *)0) return 0;  /* not found */
			n = -1;
			if(strcmp(inr_xargv[i],"1") == 0)
				n = 1;
			else if(strcmp(inr_xargv[i],"0") == 0)
				n = 0;
			if(n >= 0) {
				inr_xargv[i] = (char *)0; /* on invalide */
				return n;
			} else
				return 1;
#else /* NOT INR_KHOROS */
			return 1;

#endif /* INR_KHOROS */
		}
		inr_xargv[i] = (char *)0 ; /* on invalide l'argument */
		/* *f1 != '\0'  option a 1 ou 2 arg */
		if( ++i >= inr_xargc)  { /* missing arg */
			if(fatal)
				imerror(9,"missing arg for option %s\n",opt);
			return 0;
		}
		if(inr_xargv[i] == (char *)0) { /* missing arg */
			if(fatal)
				imerror(9,"missing arg for option %s\n",opt);
			return 0;
		}
		if(*f2 == 0) { /* found */
			stat = inr_scanopt(inr_xargv[i],f1,v1);
			if(stat != 1) { /* bad arg */
				if(fatal) {
					inr_xargv[i] = (char *)0; /* on invalide l'argument */
					imerror(9,"arg type incorrect for option %s\n",opt);
				}
				return 0;
			}
			inr_xargv[i] = (char *)0; /* on invalide l'argument */
			return 1;
		}
#ifdef INR_KHOROS
		if(khoros_mode) {
			if((strlen(f1) + strlen(f2)) > 127)
				imerror(9,"igetopt: formats d'options trop longs");
			strcpy(tmp,f1);
			strcat(tmp,f2);
			stat = sscanf(inr_xargv[i],tmp,v1,v2);
			inr_xargv[i] = (char *)0; /* on invalide l'argument */
			if(stat != 2)
				imerror(9,"arg type incorrect for option %s\n",opt);
			return 1;
		}
#endif /* INR_KHOROS */
		/* not in khoros mode , 2 arguments*/
		stat = inr_scanopt(inr_xargv[i],f1,v1);
		if(stat != 1) { /* 1e arg invalide ? */
			if(fatal) {
				inr_xargv[i] = (char *)0; /* on invalide l'argument */
				imerror(9,"1st arg type incorrect for option %s\n",opt);
			}
			return 0;
		}
		inr_xargv[i] = (char *)0; /* on invalide l'argument */
		/* option a 2 arguments */
		if(++i >=  inr_xargc)  { /* 2nd arg not found */
			if(fatal)
				imerror(9,"missing 2nd arg for option %s\n",opt);
			return 1;  /* got 1 arg */
		}
		if(inr_xargv[i] == (char *) 0) {
			if(fatal)
				imerror(9,"missing 2nd arg for option %s\n",opt);
			return 1;  /* got 1 arg */
		}
		stat = inr_scanopt(inr_xargv[i],f2,v2);
		if(stat != 1) {
			if(fatal) {
				inr_xargv[i] = (char *) 0; /* on invalide  l'argument */
				imerror(9,"2nd arg type incorrect for option %s\n",opt);
			}
			return 1;  /* got 1 valid arg */
		}
		inr_xargv[i] = (char *) 0; /* on invalide  l'argument */
		return(2);	/* on a trouve les 2 options */
		
	} /* fin de boucle sur les arguments */
	
	return(0);	/* on n'a pas trouve l'option */
	
}

inr_setopts()
{
	register int nbarg, i;
	register char **pargv;
	if(inr_xargc != 0) 
		return 1 /* makes c99 happy */; 
	/* 1ere fois : copier les arguments */
	nbarg = (int)xargc;
	pargv = xargv;
#if (defined mips || defined __alpha)
	if(nbarg <= 0) {
		xargc = nbarg = f77argc;
		xargv = pargv = f77argv;
	}
	if(nbarg <= 0) {
		xargc = nbarg = for__l_argc;
		xargv = pargv = for__a_argv;
	}
#endif
	if(nbarg <= 0) {
		xargc = nbarg = __xargc;
		xargv = pargv = __xargv;
	}
	if(nbarg <= 0)
		imerror(9,"igetopt : option list not initialized (use inr_init or initopts)\n");
	if((inr_xargv = (char **)malloc(nbarg * sizeof(char *))) == (char **)0)
		imerror(8,"pas assez de memoire pour copier les arguments\n");
	inr_xargc = nbarg;
	for(i=0;i<nbarg;i++)
		inr_xargv[i] = pargv[i];
}


int iverifopt(opt)
register char *opt;
{
	register i;
	if(inr_xargc == 0) {  /* 1ere fois : copier les arguments */
		inr_setopts();
	}
	for (i=1 ; i<inr_xargc ; ++i) { /* on scanne tous les arg */
		if(inr_xargv[i] != NULL) {
			if(strcmp(inr_xargv[i],opt) == 0)
				return 1;
		}
	}
	return 0;
}


/* retourne -1 ou le numero de l'option dans la table 
opt = option a utiliser en mode khoros 
erreur si plusieurs options trouvees
*/
int itoggleopt(opt,table0,n)
char **table0;
register char *opt;
register n;
{
	register char **table;
	register i, j, k, lg;
	char tmp[256];
	table = table0;
#ifdef INR_KHOROS
	if(khoros_mode) {
		if(!xigetopt(1,opt,"",0,"%s",tmp,"",0))
			return -1;
		for(i=0;i<n;i++) {
			if(strcmp(*table++,tmp) == 0)
				return i;
		}
		return -1;
	}
#endif
	j = -1;
	for(i=0;i<n;i++) {
		if(xigetopt(1,*table++,"",0,"",0,"",0)) {
			if(j >= 0) {
				table = table0;
				lg = 256;
				tmp[0] = 0;
				for(i=0;i<n;i++) {
					k = strlen(*table);
					if(lg < k) break;
					lg -= k - 1;
					strcat(tmp,*table++);
					strcat(tmp," ");
				}
				imerror(9,"only one option within '%s'\n",tmp);
			}
			j = i;
		}
	}
	return j;
}
