/* lecture / ecriture info T.C. dans hdr */
/*
  iwr_ctbw(nf,i0,nb,buf)
  iwr_ctrgb(nf,i0,nb,bufr,bufg,bufb)
  ird_ctrgb(nf,i0,nb,bufr,bufg,bufb,maxcol)
  idel_ct(nf)
  icmp_ct(tabr,tabg,tabb,maxcol)
  icop_ct(nfi,nfo)
*/

/* TCTYPE=STD
COLTB[R][G][B]=L(0,0-255,255) (x0,y0-x1,y1)  : table[s] lineaire[s]
COLTB[R][G][B]=A(i0-i1)......  pour pixels de i0 a i1 (inclus)

	int iwr_ctbw(nf,i0,nb,buf)
	  ecrit dans le header de NF la meme T.C. pour rgb
	  (NB donnees utiles dans BUF, I0= indice (dans buf) de debut table : >=0)
	  retourne 1

	int iwr_ctrgb(nf,i0,nb,bufr,bufg,bufb)
	struct image *nf;int i0, nb;char * bufr, bufg, bufb;
	  ecrit dans le header de NF les T.C. rgb
	  (NB donnees utiles dans BUFR pour R, bufg pour G, bufb pour B, 
	  I0= indice (dans buf?) de debut table)
	  Le programme determine si les tables sont lineaires et lesquelles
	  sont identiques
	  retourne le nb de tables differentes  : 1 si 3 tables identiques, 2 si 2 tables identiques, 3 sinon

	int ird_ctrgb(nf,i0,nb,bufr,bufg,bufb,maxcol)
	struct image *nf;int *i0, *nb;char * bufr, bufg, bufb;
	   renvoie dans BUFR, BUFG, BUFB, de taille maxcol,
	   les tables couleurs de NF
	   renvoie dans I0 l'indice de debut, et dans NB la longueur
	   Les elements des tableaux entre 0 et i0-1 et entre i0+nb et 255
	   sont mis a 0.
	   Certains pointeurs BUFR, BUFG, BUFB peuvent etre nuls :
	     dans ce cas on ne charge pas les tables correspondantes
	   Si 1 ou 2 tables manquent sur le fichier, les tableaux correspondants
	   sont charges avec une table lineaire croissante.
	   retourne le nb de tables differentes  : 0 si pas de T.C., 1 si toutes identiques, 2 si seulement 2 tables differentes, 3 sinon

	int idel_ct(nf)
	   supprime les T.C. de NF
	   
	int icmp_ct(tabr,tabg,tabb,maxcol)
	    compare 3 tables couleur de taille maxcol
	    renvoie le nb de tables differentes :
	    0 a nb_tables, ou nb_tables = nb de pointeurs non nuls
	    (0 si 3 ptr nuls)

	int icop_ct(nfi,nfo)
		copie les tables couleur de l'imnage nfi sur l'image nfo
		retourne le nb de tables differentes
		(0 si pas de tables sur nfi)
*/
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <inrimage/image.h>

extern char *index();

static char key1[12];
static char key2[12];
static char key3[12];
static char key0[]= "COLTB";
#define MAXCOL 256

static char data1[2*MAXCOL+16];
static char data2[2*MAXCOL+16];
static char data3[2*MAXCOL+16];

/* compare 2 tableaux : retourne 0 si identiques , 1 si diff,
   -1 si l'un des ptr est NULL*/
static int cmptb(p1,p2,n)
register unsigned char *p1, *p2;
register n;
{
	if((p1 == NULL) || (p2 == NULL))
		return -1;
	if(p1 == p2)
		return 0;
	while(n-- > 0)
		if(*p1++ != *p2++) return 1;
	return 0;
}

static int cpct(p1,p2,nb)
register unsigned char *p1, *p2;
register nb;
{
	while(nb-- > 0)
		*p2++ = *p1++;
	return 0;
}

static int islin(pc,n)
register unsigned char *pc;
register n;
{
	register v1, v2;
	register ist;
	register float d, v;
	v1 = *pc;
	v2 = *(pc + n -1);
	if(n <= 1) return 0;
	d = (float)(v2 - v1) / (float) (n -1);
	if(v1 <= v2) {  /* croissant */
		ist = 1;
	} else {
		ist = -1;
	}
	pc++; n -= 2;
	v = (float) v1;
	while(n-- > 0) {
		v += d;
		if((int) (v + .5) != *pc++) return 0;
	}
	return ist;
}

static char hxtab[]= "0123456789ABCDEF";

/* buf = ptr vers partie utile de la table */
static int mk_ct1(data,buf,i0,n,lin)
register char *data;
register unsigned char *buf;
register i0, n;
int lin;
{
	register i, v;
	i = i0 + n -1;
	if(lin) { /* table lineaire */
		sprintf(data,"L(%d,%d-%d,%d)\n",i0,*buf,i,*(buf + n -1));
		return strlen(data);
	}
	/* table complete */
	sprintf(data,"A(%d-%d)",i0,i);
	i = strlen(data);
	while (n-- > 0) {
		v = *buf++;
		*(data + i++) = hxtab[v >> 4];
		*(data + i++) = hxtab[v & 0xf];
	}
	*(data + i++) = '\n';
	*(data + i) = 0;
	return i;
}

/* remplit buf, de taille maxcol entre i0 et i0+nb-1,
met des 0 entre 0 et i0-1 et entre i0+nb et 255
retourne -1 si pb, 1 si table lin. 0 sinon
*/
static int decod_ct1(data,bufo,i0,nb,maxcol)
register char *data;
unsigned char *bufo;
register int *i0, *nb;
register maxcol;
{
	register unsigned char *buf;
	register n, c;
	int v1, v2, i1;
	int lin;
	register float d, v;
	c = *data++;
	if(c == 'L') {
		lin = 1;
	} else if (c == 'A') { /* type array */
		lin = 0;
	} else return -1;
	if(lin) { /* table lineaire */
		if(sscanf(data,"(%d,%d-%d,%d)\n",i0,&v1,&i1,&v2) != 4)
			return -1;
		if((*i0 >= maxcol) || (i1 >= maxcol) || (i1 < *i0))
			return -1;
		n = i1 - *i0;
		*nb = n + 1;
		buf = bufo + *i0;
		*(buf + n) = v2;
		*buf++ = v1;
		if(n > 1) {
			d = (float)(v2 - v1) / (float) n;
			v = (float) v1;
			n--;
			while(n-- > 0) {
				v += d;
				*buf++ = (int)(v + .5);
			}
		}
		v1 = 1;
	} else {
		/* table complete */
		if(sscanf(data,"(%d-%d)",i0,&i1) != 2)
			return -1;
		if((*i0 >= maxcol) || (i1 >= maxcol) || (i1 < *i0))
			return -1;
		buf = bufo + *i0;
		n = i1 - *i0 + 1;
		*nb = n;
		data = (char *)index(data,')');
		if(data == (char *)0) return -1;
		data++;
		while(n-- > 0) {
			c = *data++;
			if(isdigit(c)) {
				c -= '0';
			} else {
				if(!isxdigit(c)) return -1;
				c = (c | 0x20) - 'a' + 10;
			}
			*buf = c << 4;
			c = *data++;
			if(isdigit(c)) {
				c -= '0';
			} else {
				if(!isxdigit(c)) return -1;
				c = (c | 0x20) - 'a' + 10;
			}
			*buf++ |= c;
		}
		v1 = 0;
	}
	if(*i0 > 0) {
		buf = bufo;
		for(n=0;n<*i0;n++)
			*buf++ = 0;
	}
	if(i1 < (maxcol -1)) {
		buf = bufo + i1 + 1;
		for(n=i1+1;n<maxcol;n++)
			*buf++ = 0;
	}
	return v1;
}

/* cree table couleur de taille maxcol , lineaire entre i0 et i0+nb-1, nulle ailleurs. 
Ne fait rien si buf == NULL */
static void mk_ctlin(buf,i0,nb,maxcol)
register char *buf;
register i0, nb;
register maxcol;
{
	register i;
	if(buf == NULL) return;
	for(i=0;i<i0;i++)
		*buf++ = 0;
	for(i=0;i<nb;i++)
		*buf++ = i0++;
	for(i=i0;i<maxcol;i++)
		*buf++ = 0;
}

int iwr_ctbw(nf,i0,nb,buf)
register struct image *nf;
int i0, nb;
char *buf;
{
	register n, n1, lgr;
	int nbl;
	if(nb <= 0) return 1;
	if((i0 < 0) || ((i0 + nb) > MAXCOL))
		imerror(9,"iwr_ctbw : depassement de taille de table couleur\n");
	sprintf(key1,"%sRGB=",key0);
	lgr = strlen(key1);
	buf += i0;
	lgr += mk_ct1(data1,buf,i0,nb,islin(buf,nb));
	idel_ct(nf);
	n = ifreehdr(nf);
	n1 = hist_size(nf,&nbl);
	if((n + n1) < lgr)
		imerror(8,"pas assez de place dans le header pour %d octets\n",lgr);
	while(n < lgr) {  /* supp history records if necessary */
		if(hist_del(nf,0) < 0)
			imerror(8,"pas assez de place dans le header pour %d octets\n",lgr);
		n = ifreehdr(nf);
	}
	if((n = iputhline(nf,key1,data1)) < 0)
		imerror(9,"unable to write key %s in header\n",key1);
	return 1;
}

/* 	  retourne le nb de tables differentes  : 1 si 3 tables identiques, 2 si 2 tables identiques, 3 sinon
*/
int iwr_ctrgb(nf,i0,nb,bufr,bufg,bufb)
register struct image *nf;
int i0, nb;
register char *bufr, *bufg, *bufb;
{
	register n, n1;
	register lgr, lg0;
	int nbl;
	char cmp[3];  /* cmp rg, rb gb */
	short tblin[3];  /* 1 si lin croiss., -1 si decr, 0 sinon */
	if(nb <= 0) return 1;
	if((i0 < 0) || ((i0 + nb) > MAXCOL))
		imerror(9,"iwr_ctrgb : depassement de taille de table couleur\n");
	bufr += i0;
	bufg += i0;
	bufb += i0;
	cmp[0] = cmptb(bufr,bufg,nb);
	cmp[1] = cmptb(bufr,bufb,nb);
	cmp[2] = cmptb(bufg,bufb,nb);
	/* table rouge */
	tblin[0] = islin(bufr,nb);
	if(cmp[0] == 0)
		tblin[1] = tblin[0];
	else
		tblin[1] = islin(bufg,nb);
	if(cmp[1] == 0) {
		tblin[2] = tblin[0];
	} else if(cmp[2] == 0) {
		tblin[2] = tblin[1];
	} else
		tblin[2] = islin(bufb,nb);
	lg0 = strlen(key0);
	/* table rouge */
	strcpy(key1,key0);
	n = lg0;
	key1[n++] = 'R';
	if(cmp[0] == 0)
		key1[n++] = 'G';
	if(cmp[1] == 0)
		key1[n++] = 'B';
	key1[n++] = '=';
	key1[n] = 0;
	lgr = n;
	lgr += mk_ct1(data1,bufr,i0,nb,tblin[0]);
	/* table G si necessaire */
	if(cmp[0]) {
		strcpy(key2,key0);
		n = lg0;
		key2[n++] = 'G';
		if(cmp[2] == 0)
			key2[n++] = 'B';
		key2[n++] = '=';
		key2[n] = 0;
		lgr += n;
		lgr += mk_ct1(data2,bufg,i0,nb,tblin[1]);
	}
	if(cmp[1] && cmp[2]) {
		strcpy(key3,key0);
		n = lg0;
		key3[n++] = 'B';
		key3[n++] = '=';
		key3[n] = 0;
		lgr += n;
		lgr += mk_ct1(data3,bufb,i0,nb,tblin[2]);
	}
	idel_ct(nf);
	n = ifreehdr(nf);
	n1 = hist_size(nf,&nbl);
	if((n + n1) < lgr)
		imerror(8,"pas assez de place dans le header pour %d octets\n",lgr);
	while(n < lgr) {  /* supp history records if necessary */
		if(hist_del(nf,0) < 0)
			imerror(8,"pas assez de place dans le header pour %d octets\n",lgr);
		n = ifreehdr(nf);
	}
	if((n = iputhline(nf,key1,data1)) < 0)
		imerror(9,"unable to write key %s in header\n",key1);
	n1 = 1;
	if(cmp[0]) {  /* R and G differ */
		if((n = iputhline(nf,key2,data2)) < 0)
			imerror(9,"unable to write key %s in header\n",key2);
		n1++;
	}
	if(cmp[1] && cmp[2]) {
		if((n = iputhline(nf,key3,data3)) < 0)
			imerror(9,"unable to write key %s in header\n",key3);
		n1++;
	}
	return n1;
}

/* bits  pour les couleurs */
#define M_R 1
#define M_G 2
#define M_B 4
/* retourne 0 si pas de tables, 1 si 3 identiques, 2 si 2 identiques, 3 sinon 
si pas de tables, on remplit quand meme les buffers ainsi que i0 (0) et nb (maxcol)
*/
int ird_ctrgb(nf,i0,nb,bufr,bufg,bufb,maxcol)
register struct image *nf;
int *i0, *nb;
char *bufr, *bufg, *bufb;
int maxcol;
{
	int size;
	register num, n;
	register i;
	register char *pc, *ptc;
	int cmp[3];
	int nbtb;
	char rgb, rgb1, rgb_wanted;
	char data[2*MAXCOL+16];
	num = 0;
	n = 0;
	rgb1 = 0;
	rgb_wanted = 0;
	nbtb = 0;
	if(bufr != NULL) {
		nbtb++;
		rgb_wanted |= M_R;
	}
	if(bufg != NULL) {
		nbtb++;
		rgb_wanted |= M_G;
	}
	if(bufb != NULL) {
		nbtb++;
		rgb_wanted |= M_B;
	}
	if(nbtb == 0) return -1;
	while (num >= 0) {
		if((num = igethline(nf,key0,num,data,2*MAXCOL+16,&size)) < 0) break;
		cmp[0] = cmp[1] = cmp[2] = 1;
		rgb = 0;
		pc = (char *)index(data,'=');
		if(pc == (char *) 0) continue;
		i = (unsigned long)pc - (unsigned long) data;
		if(i == 0 || i > 3) continue;
		pc = data;
		while (i-- > 0) {
			switch (*pc++) {
			case 'R':
				if(rgb_wanted & M_R) {
					rgb |= M_R;rgb1 |= M_R;
				}
				break;
			case 'G':
				if(rgb_wanted & M_G) {
					rgb |= M_G;rgb1 |= M_G;
				}
				break;
			case 'B':
				if(rgb_wanted & M_B) {
					rgb |= M_B;rgb1 |= M_B;
				}
				break;
			default: imerror(9,"bad COLTB arg in file\n");
			}
		}
		if(rgb == 0) continue;
		if((rgb & 3) == 3)
			cmp[0] = 0;
		if((rgb & 5) == 5)
			cmp[1] = 0;
		if((rgb & 6) == 6)
			cmp[2] = 0;
		if(rgb & 1)
			ptc = bufr;
		else if(rgb & 2)
			ptc = bufg;
		else ptc = bufb;
		if(decod_ct1(pc +1,ptc,i0,nb,maxcol) < 0)
			imerror(9,"bad COLTB key in file\n");
		/* copy table if necessary */
		if(cmp[0] == 0)
			cpct(bufr,bufg,maxcol);
		if(cmp[1] == 0)
			cpct(bufr,bufb,maxcol);
		else if (cmp[2] == 0)
			cpct(bufg,bufb,maxcol);
		n++;
	}
	if(n <= 0) {
		*i0 = 0;
		*nb = maxcol;
	}
	if(!(rgb1 & M_R))
		mk_ctlin(bufr,*i0,*nb,maxcol);
	if(!(rgb1 & M_G))
		mk_ctlin(bufg,*i0,*nb,maxcol);
	if(!(rgb1 & M_B))
		mk_ctlin(bufb,*i0,*nb,maxcol);
	if(n <= 0) return 0;
	return icmp_ct(bufr,bufg,bufb,maxcol);
}
int idel_ct(nf)
register struct image *nf;
{
	int size;
	register num, n;
	register lg0, i, j;
	register char *pc;
	char key[16], data[2*MAXCOL+16];
	lg0 = strlen(key0);
	num = 0;
	n = 0;
	while (num >= 0) {
		strcpy(key,key0);
		if((num = igethline(nf,key,num,data,2*MAXCOL+16,&size)) < 0) break;
		n++;
		pc = (char *)index(data,'=');
		if(pc == (char *) 0) continue;
		i = (unsigned long)pc - (unsigned long) data;
		if(i == 0 || i > 3) continue;
		pc = data;
		j = lg0;
		while(i > 0) {
			if(*pc != 'R' && *pc != 'G' && *pc != 'B')
				break;
			key[j++] = *pc++;
			i--;
		}
		if(i > 0) continue;
		key[j++] = '=';
		key[j] = 0;
		num = idelhline(nf,key,num -1);
	}
	return n;
}


icmp_ct(tabr,tabg,tabb,maxcol)
register char *tabr, *tabg, *tabb;
register maxcol;
{
	int cmp[3];
	register nz;
	nz = 3;
	if(tabr == NULL) nz--;
	if(tabg == NULL) nz--;
	if(tabb == NULL) nz--;
	if(!nz) return 0;
	if(nz == 1) return 1;
	cmp[0] = cmptb(tabr,tabg,maxcol);
	cmp[1] = cmptb(tabr,tabb,maxcol);
	cmp[2] = cmptb(tabg,tabb,maxcol);
	if(cmp[0] == 0) { /* R == G */
		nz--;
		if(cmp[1] == 0) /* R == B */
			nz--;
	} else {
		if(cmp[1] == 0)
			nz--;
		if(cmp[2] == 0)
			nz--;
	}
	return nz;
}

int icop_ct(nfi,nfo)
register struct image *nfi, *nfo;
{
	int i0, nb;
	register n;
	char bufr[MAXCOL],bufg[MAXCOL],bufb[MAXCOL];
	if((n = ird_ctrgb(nfi,&i0,&nb,bufr,bufg,bufb,MAXCOL)) <= 0)
		return 0;
	return iwr_ctrgb(nfo,i0,nb,bufr,bufg,bufb);
}
