/* programmes pour obtenir les parametres internes de INRIMAGE
version de sortie,
taille header,
mecanisme 'history'
*/
/* strategies : on regarde d'abord ENV, puis Inrimage4.ctrl, puis def complies
*
IM_inr_home : homedir inrimage. on verifie si existe dir
   ENV(INR_HOME), 
   nom donne dans le fichier Inrimage4.conf par defaut
   {INR_DEF_HOME}-version, {INR_DEF_HOME}
   {INR_DEF_HOME2}-version, {INR_DEF_HOME2}
ctrl-file : dans
   ".", $HOME/.inrimage/
   inr_home/etc/, INR_CTRL_XDIR
inr_extfile : dans
   ENV(INR_EXTFILE), ".", $HOME/.inrimage/,inr_home/etc/ 
*/
/* fonctions a usgae de programmation :
   get_inr_home();
   set_hdr_min(n);
*/


#include <inrimage/image.h>
#include <inrimage/inrlocal.h>
#include <unistd.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

extern int khoros_mode;
extern char Inrimage_version[];
extern koctet_;

/* les variables definies dans le fichier Inrimage4.conf ou par environnement */
int IM_nbmin_hdr= 0;  /* nb min de blocs du header demandes par le programme 
			 remis a 0 apres utilisation
		       */

static int defopts_in= -1;  /* options par defaut non etablies */
int IM_out_version= -1;   /* version des images a creer : -1 si non definie
			 IV_VLOG si visilog, IV_INR3 si inrimage V3,
			 sinon inrimage version 4.
			 Si == -1, on met la valeur donnee par la vriable
			 d'environnement IMAGE_OUT (VISILOG, INR3)
*/
int IM_nb_hdr4blk= -1;  /* nb de blocs de header pour les images V-4 qu'on cree */
int IM_nb_hdr3blk= -1;  /* nb de blocs de header pour les images V-3 qu'on cree */
int IM_nb_hdrVblk= -1;  /* nb de blocs de header pour les images Visilog qu'on cree */
int IM_history= -1;   /* nb de messages de history */
int IM_vers_opt= -1;  /* num version si option "-F=" trouvee, 0 si cherchee et non trouvee */
char *IM_extfile=  (char *)0;   /* ->  get_inr_extfile */
char *IM_inr_home=  (char *)0;   /* get_inr_home */

char *getenv();
#define N_VLOG 1
#define N_INR3 2
#define N_INR4 4
#define N_MASK (N_VLOG | N_INR4 | N_INR3)

#define MAXV '7'

static char forbidden= 0;   /* versions interdites */
static char no_vers[IV_MAX+1]= {0};
static int def_vers= DEF_VERS;
static int def_hdr4blk= DEF_HDR4BLK;
static int def_hdr3blk= DEF_HDR3BLK;
static int def_maxhdrblk= DEF_MAXHDRBLK;
static int def_history= DEF_HISTORY;
static char *def_inr_extfile = (char *)0;
static char *def_inr_home = (char *)0;
static char *user_home_inr= (char *)0;
static char *user_home_dir= (char *) 0;
static int user_home_defined = 0;   
static int inr_home_defined= 0;     /* 1 quand on a defini IM_inr_home */
static int inr_extfile_defined= 0;  /* 1 quand on a defini IM_extfile */
static int get_defopts(), is_dir();

struct im_version {
	int v_type;
	char *v_nom;
}; 
static struct im_version im_version[]= {
	IV_OLD, NOM_OLD,
	IV_INR3, NOM_INR3,
	IV_INR4, NOM_INR4,
	IV_VLOG, NOM_VLOG,
	0, 0
	};
static int khim_version[]= {IV_INR4,IV_INR3,IV_VLOG};

char *inr_mymalloc(n,txt)
register n;
char *txt;
{
	register char *pc;
	if((pc = (char *)malloc(n)) == (char *)0) {
		imerror(8,"%s inrimage internal malloc err %d\n",txt,errno);
	}
	return pc;
}

char *inr_myrealloc(ptr,n,txt)
register n;
char *txt;
void *ptr;
{
	register char *pc;
	if((pc = (char *)realloc(ptr,n)) == (char *)0) {
		imerror(8,"%s inrimage internal realloc err %d\n",txt,errno);
	}
	return pc;
}

char *inr_mycalloc(size,n,txt)
register n, size;
char *txt;
{
	register char *pc;
	if((pc = (char *)calloc(size,n)) == (char *)0) {
		imerror(8,"%s inrimage internal calloc err %d\n",txt,errno);
	}
	return pc;
}

inr_myfree(pc)
register char *pc;
{
	if(! pc) return 1 /* makes c99 happy */; 
	free(pc);
}

/* fabrique une chaine (malloc) par concatenation de n chaine
tab = liste des pointeurs (chaine vide si &e nul, les nuls sont ignores)
ltab = table des longueurs (recalculees si 0)
*/
static char *mk_name(tab,ltab,n)
register char **tab;
register int *ltab;
register n;
{
	char *pc;
	register lg, i, k, l;
	if((n <= 0) || (*tab == (char *)0)) return (char *)0;
	lg = 0;
	for(i = 0;i<n;i++) {
		if(! (k = *(ltab+i))) {
			if(! *(tab+i)) continue;
			k = strlen(*(tab+i));
			*(ltab+i) = k;
		}
		lg += k;
	}
	lg++;
	pc = inr_mymalloc(lg,"inropts.c :");
	k = 0;
	for(i = 0;i<n;i++) {
		if(! (l = *ltab++)) {
			tab++;
			continue;
		}
		strcpy(pc+k,*tab++);
		k += l;
	}
	return pc;
}

/* retourne la home dir user */
//static 
char * get_user_home()
{
	register char *ph;
	char *tab[3];
	int ltab[3];
	if(user_home_defined) return user_home_inr;
	user_home_defined = 1;
	if(ph = getenv("HOME")) {
		user_home_dir = ph;
		tab[0] = ph;
		tab[1] = "/";
		tab[2] = USER_INR;
		ltab[0] = strlen(ph);
		ltab[1] = 1;
		ltab[2] = sizeof(USER_INR) - 1;
		ph = mk_name(tab,ltab,3);
		if(is_dir(ph))
			return (user_home_inr = ph);
		inr_myfree(ph);
	}
	return (user_home_inr = (char *)0);
}

/* retourne 1 si name est un directory */
static int is_dir(name)
char *name;
{
	struct stat fstat;
	if(stat(name,&fstat)) return 0;
	if(S_ISDIR(fstat.st_mode)) return 1;
	return 0;
}

/*
determine la homedir inrimage en verifiant si le repertoire existe effectivement: 
d'abord la variable d'environnement ENV_INR_HOME, 
puis la constante INR_DEF_HOME, puis INR_DEF_HOME2 (dfinies dans include/inrimage/inrlocal.h)
*/
char *get_inr_home()
{
	register flg;
	char *ph;
	char *tmp_tab[5];
	int tmp_ltab[5];
	if(inr_home_defined) return IM_inr_home;
	inr_home_defined = 1;
	while(1) {
		tmp_tab[0] = getenv(ENV_INR_HOME);
		tmp_ltab[0] = 0;
		if(ph = mk_name(tmp_tab,tmp_ltab,1))
			if(is_dir(ph)) break;
		inr_myfree(ph);
		get_defopts(1);
		if(ph = def_inr_home) break;
		tmp_tab[0] = INR_DEF_HOME;
		tmp_ltab[0] = sizeof(INR_DEF_HOME) - 1;
		tmp_tab[1] = "-";
		tmp_ltab[1] = 1;
		tmp_tab[2] = Inrimage_version;
		tmp_ltab [2] = 0;
		if(ph = mk_name(tmp_tab,tmp_ltab,3))
			if(is_dir(ph)) break;
		inr_myfree(ph);
		if(ph = mk_name(tmp_tab,tmp_ltab,1))
			if(is_dir(ph)) break;
		inr_myfree(ph);
		tmp_tab[0] = INR_DEF_HOME2;
		tmp_ltab[0] = sizeof(INR_DEF_HOME2) - 1;
		if(ph = mk_name(tmp_tab,tmp_ltab,3))
			if(is_dir(ph)) break;
		inr_myfree(ph);
		if(ph = mk_name(tmp_tab,tmp_ltab,1))
			if(is_dir(ph)) break;
		inr_myfree(ph);
		return (IM_inr_home = def_inr_home);
	}
	return (IM_inr_home = ph);
}

/* initialise koctet_ avec la taille mem par defaut : fichier de config ou env */
get_defkoctet ()
{
  char *pc;
  if (koctet_ > 0) return 1 /* makes c99 happy */; 
  get_defopts(0);
  //  if(koctet_ <= 0) {
  if(pc = getenv(INR_DEFK))
    koctet_ = atoi(pc);
    //  }
  if(koctet_ <= 0)
    koctet_ = DEF_KBMEM;
}

/* retourne le type par defaut des images de sortie */
get_version()
{
	register char *p;
	register i;
	if(IM_out_version >= 0) return IM_out_version;
	get_defopts(0);
	if(IM_out_version >= 0) return IM_out_version;
	if(get_vers_opt() > 0) {
		i = IM_vers_opt;
	} else {
		if((p = getenv(ENV_VERS)) == 0)
			return (IM_out_version = def_vers);
		if((i = chk_version(p)) <= 0)
			return (IM_out_version = def_vers);
	}

	if(i == IV_OLD) i = IV_INR3;
	if(no_vers[i]) i = def_vers;
	return (IM_out_version = i);
}

/* retourne le numero de version correspondant au numero num
en mode khoros (num contient 0, 1, ou 2)
 */
int khchk_version(num)
register num;
{
	register struct im_version *pv;
	if((num < 0) || (num >= sizeof(khim_version)))
		return -1;
	return khim_version[num];
}

/* retourne le numero de version correspondant au nom */
int chk_version(nom)
register char *nom;
{
	register struct im_version *pv;
	pv = im_version;
	while(pv->v_type > 0) {
		if(strcmp(pv->v_nom,nom) == 0) return pv->v_type;
		pv++;
	}
	return -1;
}

/* cherche l'option de version */
get_vers_opt()
{
	char buff[32];
	int val;
	if(IM_vers_opt >= 0) return IM_vers_opt;
#ifdef INR_KHOROS
	if(khoros_mode) {
		if(!igetopt("-F=","",0,"%d",&val,"",0)) return (IM_vers_opt = 0);
		return (IM_vers_opt = khchk_version(val));
	}
#endif
	if(!igetopt("-F=","%s",buff,"",0,"",0)) return (IM_vers_opt = 0);
	return (IM_vers_opt = chk_version(buff));
}

/* cherche l'option de taille de header Inrimage */
static get_hdr_opt()
{
	int nb;
	if(!igetopt("-hdr=","%d",&nb,"",0,"",0)) return -1;
	return nb;
}
	
/* retourne un pointeur sur le nom de version 0 si err*/
char *version_name(version)
register version;
{
	register struct im_version *pv;
	pv = im_version;
	while(pv->v_type > 0) {
		if(pv->v_type == version) return pv->v_nom;
		pv++;
	}
	return (char *) 0;
}

static int chk_hdr(n)
register n;
{
	if(n < IM_nbmin_hdr) {
		n = IM_nbmin_hdr;
		IM_nbmin_hdr = 0;
	}
	return n;
}
/* defini la taille min de l'n-tete en nb blocs */
set_hdr_min(nblk)
register nblk;
{
	if(nblk <= 0) return 1 /* makes c99 happy */; 
	IM_nbmin_hdr = nblk;
}

/* donne le nb de blocs de header inrimage version 4 */
static get_hdrblk()
{
	register char *p;
	register n3, n4, nV;
	if((n3 = get_hdr_opt()) >= 0)  {
		if(n3 > def_maxhdrblk) n3 = def_maxhdrblk;
		IM_nb_hdrVblk = IM_nb_hdr3blk = IM_nb_hdr4blk = n3;
		if(n3 == 0) { /* 0 == defaut pour V-3 et V-4 */
			IM_nb_hdr3blk = def_hdr3blk;
			IM_nb_hdr4blk = def_hdr4blk;
		}
		return 0;
	}
	if((p = getenv(ENV_HDR)) == 0) {
		nV = n3 = def_hdr3blk;
		n4 = def_hdr4blk;
	} else {
		nV = n4 = n3 = atoi(p);
		if(n3 <= 0) {
			n4 = def_hdr4blk;
			n3 = def_hdr3blk;
			if(n3 < 0)
				nV = def_hdr3blk;
		}
		if(n3 > def_maxhdrblk) {
			n3 = def_maxhdrblk;
			nV = def_maxhdrblk;
		}
		if(n4 > def_maxhdrblk) n4 = def_maxhdrblk;
	}
	IM_nb_hdr4blk = n4;
	IM_nb_hdr3blk = n3;
	IM_nb_hdrVblk = nV;
	return 0;
}

/* donne le nb de blocs de header inrimage Visilog */
get_hdrVblk()
{
	if(IM_nb_hdrVblk >= 0) return chk_hdr(IM_nb_hdrVblk);
	get_defopts(0);
	if(IM_nb_hdrVblk >= 0) return chk_hdr(IM_nb_hdrVblk);
	get_hdrblk();
	return chk_hdr(IM_nb_hdrVblk);
}
/* donne le nb de blocs de header inrimage version 3 */
get_hdr3blk()
{
	if(IM_nb_hdr3blk > 0) return chk_hdr(IM_nb_hdr3blk);
	get_defopts(0);
	if(IM_nb_hdr3blk > 0) return chk_hdr(IM_nb_hdr3blk);
	get_hdrblk();
	return chk_hdr(IM_nb_hdr3blk);
}

/* donne le nb de blocs de header inrimage version 4 */
get_hdr4blk()
{
	if(IM_nb_hdr4blk > 0) return chk_hdr(IM_nb_hdr4blk);
	get_defopts(0);
	if(IM_nb_hdr4blk > 0) return chk_hdr(IM_nb_hdr4blk);
	get_hdrblk();
	return chk_hdr(IM_nb_hdr4blk);
}

get_hist()
{
	register char *p;
	register n;
	if(IM_history > 0) return IM_history;
	get_defopts(0);
	if(IM_history > 0) return IM_history;
	if((p = getenv(ENV_HIST)) == 0) return (IM_history = def_history);
	n = atoi(p);
	if(n < 0) n = 0;
	return (IM_history = n);
}

/* determine l'emplacement du fichier inr_extfile */
char *get_inr_extfile()
{
	char *px;
	register i;
	char *tmp_tab[5];
	int tmp_ltab[5];
	struct stat fstat;
	if(inr_extfile_defined) return IM_extfile;
	for(i=0;i<4;i++) {
		tmp_tab[i] = (char *)0;
		tmp_ltab[i] = 0;
	}
	tmp_tab[4] = INR_EXTFILENAME;
	tmp_ltab[4] = sizeof(INR_EXTFILENAME) - 1;
	inr_extfile_defined = 1;
	while(1) {
		/* la variable d'env peut servir a supprimer les extensions */
		if(tmp_tab[0] = getenv(ENV_INR_EXTFILE)) { 
			if(px = mk_name(tmp_tab,tmp_ltab,1))
				if(! stat(px,&fstat)) break;
			inr_myfree(px);
			return (IM_extfile = NULL);
		}
		tmp_tab[0] = ".";tmp_ltab[0] = 1;
		tmp_tab[1] = "/";tmp_ltab[1] = 1;
		if(px = mk_name(tmp_tab,tmp_ltab,5))
			if(! stat(px,&fstat)) break;
		inr_myfree(px);
		tmp_tab[0] = get_user_home();
		tmp_ltab[0] = 0;
		if(px = mk_name(tmp_tab,tmp_ltab,5))
			if(! stat(px,&fstat)) break;
		inr_myfree(px);
		tmp_ltab[0] = 0;
		tmp_tab[0] = get_inr_home();
		tmp_tab[3] = "/";
		tmp_ltab[3] = 1;
		tmp_tab[2] = INR_CONFDIR;
		tmp_ltab[2] = sizeof(INR_CONFDIR) -1;
		if(px = mk_name(tmp_tab,tmp_ltab,5))
			if(! stat(px,&fstat)) break;
		inr_myfree(px);
		get_defopts(0);
		return (IM_extfile = def_inr_extfile);
	}
	return (IM_extfile = px);
}

/* la 1ere ligne du fichier donne les options generales inrimage,
selon la structure inropts.
Chaque parametre est initialise lors de sa 1ere utilisation : 
la valeur peut etre imposee par le fichier, ou laissee libre.
Si la valeur est "libre", le parametre est initialise
par une variable d'environnement; si une telle variable n'existe pas,
la valeur par defaut est donnee par le fichier.
(en l'absence de fichier, la valeur par defaut est definie dans inropts.c
*/
static struct inropts {
	char v_type;  /* liste des versions interdites '0'=libre
	     +1= no Visilog , +4=non Inrimage4 +2=no Inr3, '7'= forcer version*/
	char version; /* default version : V= VISILOG, 3=old inrimage, 4=new (header ascii) */
	char space1;   /* separateur */
	char hd4_type;  /* type de la taille du header version 4 : 0=libre, 1=impose */
	char nb_hdr4blk[3]; /* nb de blocs de header */
	char space2;   /* separateur */
	char hd3_type;  /* type de la taille du header version 3 : 0=libre, 1=impose */
	char nb_hdr3blk[3]; /* nb de blocs de header */
	char space3;   /* separateur */
	char max_hdrblk[3];  /* nb max de blocs header */
	char space4;   /* separateur */
	char hist_type;  /* history : -= interdit 0=libre += impose */
	char history[3]; /* max nb of history lines */
	char newl;	/* pour le \n final */
	char eol;	/* pour le 0 final */
} bufopt= {0};
#define LGOPTS sizeof(bufopt)
#define LG_RDOP 512
static FILE *try_open(name)
char *name;
{
	FILE *fp;
	if(! name) return NULL;
	if(! (fp =  fopen(name,"r")))
		inr_myfree(name);
	return fp;
}

/* cree une string pour name et range son adresse dans pdest
interprete le ~ initial
*/
static void store_name(name,pdest)
char *name;
char **pdest;
{
	register char *pc, *pc2;
	register n, n2;
	n2 = 0;
	while((*name == ' ') || (*name == '\t')) name++;
	if(pc2 = index(name,' ')) *pc2 = 0;
	if(pc2 = index(name,'\n')) *pc2 = 0;
	if((*name == '~') && (*(name+1) == '/')) {
		name += 2;
		get_user_home();
		if(user_home_dir) n2 = strlen(user_home_dir);
		n2++;
	}
	n = strlen(name);
	pc = inr_mymalloc(n + n2 + 1,"inropts.c :");
	*pdest = pc;
	if(n2) {
		strcpy(pc,user_home_dir);
		pc += n2 - 1;
		*pc++ = '/';
	}
	strcpy(pc,name);
	pc += n;
	*pc = 0;
}

/* pour eviter un warning de compil et un bug d'exec avec fgets 
 * sur systeme avec gcc4 et versions rcentes de glibc (typiquement ubuntu)
 * Il faut une dclaration en static et pas en local dans la fonction
 */
static char *pbufopt = (char *)&bufopt;

/* flg =1 si appel de get_inr_home */
static get_defopts(flg)
register flg;
{
	register n, lg, i;
	FILE *fp;
	char *tmp_tab[5];
	int tmp_ltab[5];
	char tmpbuf[LG_RDOP];
	register char *pc, *pc2;
	Fort_int ier;
	if(defopts_in > 0) return 0;
	defopts_in = 1;
	for(i=0;i<4;i++) {
		tmp_tab[i] = (char *)0;
		tmp_ltab[i] = 0;
	}
	tmp_tab[4] = INR_CTRL_FILE;
	tmp_ltab[4] = sizeof(INR_CTRL_FILE) - 1;
	
	while(1) {
		tmp_tab[0] = ".";tmp_ltab[0] = 1;
		tmp_tab[1] = "/";tmp_ltab[1] = 1;
		if(pc = mk_name(tmp_tab,tmp_ltab,5))
			if(fp = try_open(pc)) break;
		tmp_tab[0] = get_user_home();
		tmp_ltab[0] = 0;
		if(pc = mk_name(tmp_tab,tmp_ltab,5))
			if(fp = try_open(pc)) break;
		tmp_ltab[0] = sizeof(INR_CTRL_XDIR) -1;
		tmp_tab[0] = INR_CTRL_XDIR;
		tmp_tab[2] = tmp_tab[3] = NULL;
		tmp_ltab[2] = tmp_ltab[3] = 0;
		if(pc = mk_name(tmp_tab,tmp_ltab,5))
			if(fp = try_open(pc)) break;
		if( flg) {
			defopts_in = 0;
			return 1;
		}
		tmp_ltab[0] = 0;
		tmp_tab[0] = get_inr_home();
		tmp_tab[3] = "/";
		tmp_ltab[3] = 1;
		tmp_tab[2] = INR_CONFDIR;
		tmp_ltab[2] = sizeof(INR_CONFDIR) -1;
		if(pc = mk_name(tmp_tab,tmp_ltab,5))
			if(fp = try_open(pc)) break;
		return 1;
	}
	inr_myfree( pc);
	fgets(pbufopt,LGOPTS,fp);
	bufopt.eol = 0;
	n = strlen((char *)&bufopt);
	tmpbuf[LG_RDOP-1] = 0;
	while(fgets(tmpbuf,LG_RDOP-1,fp)) {
		if(tmpbuf[0] == '#') break;
		if(strncmp(tmpbuf,"EXTFILE=",8) == 0) {
			store_name(&tmpbuf[8],&def_inr_extfile);
			continue;
		} else if(strncmp(tmpbuf,"HOME=",5) == 0) {
			store_name(&tmpbuf[5],&def_inr_home);
			continue;
		} else if(strncmp(tmpbuf,"KBMEM=",6) == 0) {
		  if(koctet_ <= 0) koctet_ = atoi(&tmpbuf[6]);
			continue;
		} else break;
	}
	fclose(fp);
	if(n != LGOPTS-1) return 1;
	if(bufopt.v_type < '0' || bufopt.v_type > MAXV) return 1;
	switch(bufopt.version) {
	case 'V':
		def_vers = IV_VLOG;
		break;
	case '3':
		def_vers = IV_INR3;
		break;
	case '4':
	default:
		def_vers = IV_INR4;
	}
	if((forbidden = n = bufopt.v_type & N_MASK) == N_MASK)
		IM_out_version = def_vers;
	no_vers[IV_INR3] = n & N_INR3;
	no_vers[IV_INR4] = n & N_INR4;
	no_vers[IV_VLOG] = n & N_VLOG;
	n = c_idonne(bufopt.nb_hdr4blk,0,2,&ier);
	if(ier == 0) def_hdr4blk= n;
	n = c_idonne(bufopt.max_hdrblk,0,2,&ier);
	if(ier == 0) def_maxhdrblk= n;
	if(def_hdr4blk > def_maxhdrblk) def_hdr4blk = def_maxhdrblk;
	if(bufopt.hd4_type == '1')
		IM_nb_hdr4blk = def_hdr4blk;
	n = c_idonne(bufopt.history,0,2,&ier);
	if(ier == 0) def_history = n;
	switch(bufopt.hist_type) {
	case '+':
		IM_history = def_history;
		break;
	case '0':
		break;
	case '-':
	default:
		IM_history = def_history = 0;
	}
	return 0;
}
