#include <inrimage/image.h>
/*#include "iprotos.h"*/
#include <inrimage/inrfile.h>
#include <sys/wait.h>

/* int is_inrimage(name,opt)
teste si le fichier name est une image Inrimage
opt = 0 : test strict
opt = 1 : accepte les images compressees
opt > 1 : accepte tout ce que inr_tstext accepte
Le debut du fichier est lu
retour :
  0 si fichier n'existe pas ou n'est pas du bon type
  2 a 4 (type image, mais IV_OLD n'est pas teste')  vraie image
  type + 0x100 : vraie image compressee
  0x200 : autre fichier (lisible par un filtre)
*/
int is_inrimage(name,opt)
register char *name;
register opt;
{
	int status;
	register n, flg, code;
	register fd;
	register struct descripteur *pi;
	register struct vlg_desc *pv;
	char hdr[FILE_HEADER_LEN];
	flg = 0;
	if(opt > 0) {
		flg = inr_tstext(name);
		if(flg > 1 && opt == 1) {
			flg = -1;  /* type non accepte */
		}
	}
	if(!flg < 0) return 0;
	if(flg > 1) return IV_OTHERIM;
	if(flg == 1) {
		flg = IV_COMPRESSED;
		fd = inr_startsubproc(name,1);
	} else {
		fd = open(name,0);
	}
	if(fd < 0) return 0;
	if(read_all(fd,hdr,VDESC) != VDESC) {
		close(fd);
		if(flg)
#ifdef sun5
			waitpid(0,&status,WNOHANG);
#else

			wait3(&status,WNOHANG,NULL);
#endif
		return 0;
	}
	pv = (struct vlg_desc *) hdr;
	pi = (struct descripteur *) hdr;
	n = DESC - VDESC;
	if(pv->i_magic == V_SWMAGIC || pv->i_magic == V_MAGIC) {
		code = flg | IV_VLOG;
	} else if(read_all(fd,&hdr[VDESC],n) != n) {
		code = 0;
	} else {
		if(pi->im_magic == IM3_SWMAGIC || pi->im_magic == IM3_MAGIC) {
			code = IV_INR3 | flg;
		} else if(strncmp(MAGIC_HEADER,hdr,sizeof(MAGIC_HEADER) -1) == 0) {
			code = IV_INR4 | flg;
		} else {
			code = 0;
		}
	}
	close(fd);
	if(flg)
#ifdef sun5
		waitpid(0,&status,WNOHANG);
#else
		wait3(&status,WNOHANG,NULL);
#endif
	return code;
}
