/* procedure de lecture d'1 caractere 
   la lecture se fait en mode CBREAK

   si l'entree n'est pas une tty on echo le caractere sur stderr */


#include <stdio.h>
#include <stdlib.h>
#ifdef TERMIOS
#include <termios.h>
#include <unistd.h>
#else
#include <sgtty.h>
#endif
#include <inrimage/image.h>

ltcara_(icar)
Fort_int *icar; 	/* caractere lu */


{

	int ISATTY;
#ifdef TERMIOS
	struct termios tty;
	tcflag_t olflag;
	char vmin, vtime;
#else
	struct sgttyb tty;
#endif

	ISATTY = isatty(0); /* determine si stdin est une tty */

#ifndef NONINTERACTIF
	if ( ISATTY )  {/* si stdin est une tty --> mode CBREAK */
#ifdef TERMIOS
		tcgetattr(0,&tty);
		olflag = tty.c_lflag;
		vmin= tty.c_cc[VMIN];
		vtime= tty.c_cc[VTIME];
		tty.c_lflag &= ~ICANON;
		tty.c_cc[VMIN] = 1;
		tty.c_cc[VTIME] = 0;
		tcsetattr(0,TCSANOW,&tty);
#else
		gtty(0,&tty);
		tty.sg_flags |= CBREAK;
		stty(0,&tty);
#endif
	}
#endif

again:	if ( ISATTY) fputs("_\b",stderr); /* prompt pour les tty */

	if ( (*icar = getchar()) != EOF ) { /* pour les non tty */
		if ( ISATTY != 1 ) putc(*icar,stderr); /* echo */
	
#ifndef NONINTERACTIF
		if ( ISATTY ) {
#ifdef TERMIOS
			tty.c_lflag = olflag;
			tty.c_cc[VTIME] = vtime;
			tty.c_cc[VMIN] = vmin;
			tcsetattr(0,TCSANOW,&tty);
#else
			/* ligne en mode !CBREAK */
			tty.sg_flags ^= CBREAK;
			stty(0,&tty);
#endif
		}
#endif
		return(*icar);
	} else { /* fin de fichier sur stdin */
		fprintf(stderr,"%s EOF sur stdin\n",xargv[0]);
		if ( ISATTY ) goto again ; /* on peut dialoguer */
		else exit(-1); /* que faire d'autre ? */
	}
	return -1;
}

