/*LTCHAI
  FUNCTION LTCHAI_(ITAB,NMX,NCHR,BRK,NBRK,IBRKCH)
  int c_ltchai(itab,nmx,brk,nbrk,ibrkch)
 procedure de lecture d'une chaine de caracteres 
   ITAB buffer de nmx char pour le resultat
   nb effectif renvoye en valeur de c_ltchai ou dans nchr
   brk : string des nbrk break char.
   on renvoie dans le 1er char de ibrkch, le break rencontre

   la lecture se fait en mode CBREAK
 ***************************************
modif 6/8/86 :
  en entree tty  les caracteres d'edition sont ceux de la tty
   le caractere '^k' fait un abort (ermesf(-1))
**********************************
   si l'entree n'est pas une tty on echo les caracteres sur stderr */


#include <stdio.h>
#include <stdlib.h>
#ifdef TERMIOS
#include <termios.h>
#include <unistd.h>
#else
#include <sgtty.h>
#endif
#include <signal.h>
#include <inrimage/image.h>
#include <inrimage/dialog.h>

extern struct dialg dialg_;

extern int inr_stdin_used, khoros_mode;

#ifdef TERMIOS
static struct termios tty;
static tcflag_t olflag;
static char vmin, vtime;
#define RESET_TTY {tty.c_lflag = olflag;tty.c_cc[VTIME] = vtime;\
tty.c_cc[VMIN] = vmin;tcsetattr(0,TCSANOW,&tty);}

#else
static struct sgttyb tty;
static int oflags;
static int localmod, noctrl= LCTLECH;
#define RESET_TTY {tty.sg_flags = oflags;stty(0,&tty);ioctl(0,TIOCLSET,&localmod);}
#endif
static void (*sigst)();

ltchai_(itab,nmx,nchr,brk,nbrk,ibrkch)

char *itab;	/* recepteur */
Fort_int *nmx;	/* nb max de caracteres attendus */
Fort_int *nchr;	/* nb de caracteres lus */
char *brk;	/* table des caracteres de fin de chaine */
Fort_int *nbrk;	/* nb de caracteres de fin */
char *ibrkch;	/* caractere de fin de la chaine */

{
	*nchr = (Fort_int)c_ltchai(itab,(int)*nmx,brk,(int)*nbrk,ibrkch);
}

c_ltchai(itab,nmx,brk,nbrk,ibrkch)

char itab[];	/* recepteur */
register nmx;	/* nb max de caracteres attendus */
char brk[];	/* table des caracteres de fin de chaine */
register nbrk;	/* nb de caracteres de fin */
char *ibrkch;	/* caractere de fin de la chaine */

{
	register char c_kill, c_erase;
	register i,j;
	char bsp;
	Fort_int i1= -1;
	int c;
	register ISATTY;
	int lchint();
	if(inr_stdin_used)
		imerror(9,"interactive mode disabled : stdin already in use\n");
	if(khoros_mode)
		imerror(9,"interactive mode disabled in KHOROS mode\n");
	c_kill = c_erase = 0;
	bsp= '\b';
	ISATTY = isatty(0); /* determine si stdin est une tty */

	if ( ISATTY ) {/* si stdin est une tty --> mode CBREAK */
	  sigst = signal(SIGINT,lchint);
#ifdef TERMIOS
		tcgetattr(0,&tty);
		olflag = tty.c_lflag;
		c_erase = tty.c_cc[VERASE];
		c_kill = tty.c_cc[VKILL];
		vmin= tty.c_cc[VMIN];
		vtime= tty.c_cc[VTIME];
		tty.c_lflag &= ~ICANON;
		tty.c_cc[VMIN] = 1;
		tty.c_cc[VTIME] = 0;
		tcsetattr(0,TCSANOW,&tty);
#else
		gtty(0,&tty);
		oflags = tty.sg_flags;
		c_kill = tty.sg_kill;
		c_erase = tty.sg_erase;
		tty.sg_flags |= CBREAK;
		stty(0,&tty);
		ioctl(0,TIOCLGET,&localmod);   /* pas d'echo des controles */
		ioctl(0,TIOCLBIC,&noctrl);   /* pas d'echo des controles */
		/*!!! ioctl(0,TIOCFLUSH,NULL); /* flush de l'input */
#endif
	}

again:	for ( i=0 ; i <= nmx ; i++ ) { /* on lit jusqu'a nmx caracteres */
		if ( ISATTY )  fputs("_\b",stderr); /* prompt pour les tty */

		if ( (c = getchar()) != EOF ) { /* pour les non tty */
			if ( ISATTY != 1 ) putc(c,stderr); /* echo */
			
			if (c == '\n') c = '\r'; /* newline = retour chariot */

			for ( j=0 ; j < nbrk ; ++j )/* car de terminaison ? */
				if ( c == brk[j] ) {
					dialg_.nbchr = i;
					*ibrkch = c; dialg_.icrbrk = c;
					dialg_.numbrk = j+1;
					if ( ISATTY ) {
						/* ligne en mode initial */
						RESET_TTY;
						signal(SIGINT,sigst);
					}
					return i;
				} else ;

			if ( c == c_erase ) { /* backspace */
				if(ISATTY) {
#ifdef ECHO_CTRL_CHARS
					if(c < 0x20 || c == 0x7f) { /* ctrl char */
						putc('\b',stderr);
						putc('\b',stderr);
					}
#endif
					if( i > 0)
#if 0
						putc('\b',stderr);
#else
					write(2,&bsp,1);
#endif
				}
				i = ( i-2 < 0 ? -1 : i-2 );
			} else if ( c == c_kill ) { /* kill */
				i = -1;
				if(ISATTY) putc('\n',stderr);
			} else if(c == ('k' & 0x1f)) {	/* ^k = abort */
				if(ISATTY) {
					RESET_TTY;
				}
				ermesf_(&i1);
				exit(-1);
			} else if ( i < nmx ) itab[i] = c; /* rangement du car */
			else {
				fprintf(stderr,"%s ltchai:trop de caracteres\n",xargv[0]);
				if ( ISATTY ) goto again ; /* on peut dialoguer */
				else exit(-1); /* que faire d'autre ? */
			}

		} else  {/* fin de fichier sur stdin */
			fprintf(stderr,"%s ltchai:EOF sur stdin\n",xargv[0]);
			if ( ISATTY ) goto again ; /* on peut dialoguer */
			else exit(-1); /* que faire d'autre ? */
		}
	}
	return i;
}


/* recuperation du del et du break */
int lchint(i1,i2,i3)
{
	RESET_TTY;
	if((unsigned int)sigst > 10) {
		signal(SIGINT,sigst);
		(*sigst)(i1,i2,i3);
	}
	exit(-1);
}
