/* mvmots
	subroutine mvmots(a,b,n)
	c_mvmots(a,b,n)
		int *a, *b, n;
  transfere n mots de a dans b en commencant par debut
  ou fin selon les positions relatives
*/

#include <stdio.h>
#include <inrimage/image.h>


mvmots_(in,out,nmots)
Fort_int *in,*out;
Fort_int *nmots;
{
	c_mvmots(in,out,(int)*nmots);
}

c_mvmots(in,out,nmots)
register Fort_int *in,*out;
register nmots;
{

	register Fort_int *r_in, *r_out, *last_out;

	if ( in == out ) return 1 /* makes c99 happy */;  /* rien a faire */

	if (in < out ) 
		{	/* on commence par la fin */

		r_in = in + nmots - 1;
		r_out = out + nmots - 1;

		last_out = out - 1;

		while ( r_out > last_out )
			{
			*(r_out--) = *(r_in--);
			}
		}
	else
		{	/* on commence par le debut */

		r_in = in ;
		r_out = out ;

		last_out = out + nmots;

		while ( r_out < last_out )
			{
			*(r_out++) = *(r_in++) ;
			}
		}
}

/* copy int */
c_mvints(in,out,nmots)
register int *in,*out;
register nmots;
{

	register int *r_in, *r_out, *last_out;

	if ( in == out ) return 1 /* makes c99 happy */;  /* rien a faire */

	if (in < out ) 
		{	/* on commence par la fin */

		r_in = in + nmots - 1;
		r_out = out + nmots - 1;

		last_out = out - 1;

		while ( r_out > last_out )
			{
			*(r_out--) = *(r_in--);
			}
		}
	else
		{	/* on commence par le debut */

		r_in = in ;
		r_out = out ;

		last_out = out + nmots;

		while ( r_out < last_out )
			{
			*(r_out++) = *(r_in++) ;
			}
		}
}

