/* ecriture des informations relatives a une image sur stdout ou stderr
   subroutine prtnf(nf,option,out)
   int c_prtnf(nf,opt,out)
   struct image *nf;
   int option;
   FILE *out;
stdout si *out == 1, stderr si ==2, fichier sinon
option : un choix par bit 
   0x1 = format habituel
   0x2 = nom, Version et type cpu
   0x4 = history seul
   0x8 = contenu ascii du header
   0x10 = info complementaire du nf (un peu n'importe quoi)
*/

#include <stdio.h>
#include <string.h>
#include <inrimage/inrfile.h>

#define P_FMT 1
#define P_VERS 2
#define P_HIST 4
#define P_ASCII 8
#define P_DIV 0x10
#define P_COMM 0x20
#define P_MASK 0x3f
#define BMAX 1024
static char xbuf[BMAX];
static int msize;

extern struct hdr_keys hdr_keys[];
extern char *version_name();

prtnf_(anf,aopt,fd)
struct image **anf;
Fort_int *aopt;
FILE **fd;
{
	return c_prtnf(*anf,(int)*aopt,(FILE *)*fd);
}

c_prtnf(nf,opt,fd)
register struct image *nf;
register opt;
FILE *fd;
{
	register char *p;
	register n;
	FILE *std;
	if(fd == (FILE *)2)
		std = stderr;
	else if(fd == (FILE *)1)
		std = stdout;
	else std = fd;
	if(!(opt & P_MASK)) return 1;
	if(opt & P_VERS) {
		fprintf(std,"%-16s",nf->nom);
		if((p = version_name(nf->i_version)) != (char *) 0)
			fprintf(std," -F=%s\t",p);
#if 0
		if((n = nf->desc_size / FILE_HEADER_LEN)) 
#else
		n = nf->desc_size / FILE_HEADER_LEN;
#endif
			fprintf(std," -hdr=%d\t",n);
	}
	if(opt & P_FMT) {
		fprintf(std,"-x %d\t",nf->NDIMX);
		fprintf(std,"-y %d\t",nf->NDIMY);
		if(nf->NDIMZ > 1)
			fprintf(std,"-z %d\t",nf->NDIMZ);
		if(nf->NDIMV > 1)
			fprintf(std,"-v %d\t",nf->NDIMV);
		if(nf->X_OFFSET != 0)
			fprintf(std,"-x0 %d\t",nf->X_OFFSET);
		if(nf->Y_OFFSET != 0)
			fprintf(std,"-y0 %d\t",nf->Y_OFFSET);
		if(nf->Z_OFFSET != 0)
			fprintf(std,"-z0 %d\t",nf->Z_OFFSET);
		fprintf(std,"%s",(nf->TYPE == 1 ? "-r" :
				    (nf->TYPE == -1 ? "-p" : 
				     "-f")));
		if(nf->TYPE == REELLE && opt & P_VERS && nf->float_typ != 0)
			fprintf(std,"%s",get_flname(nf->float_typ));
		fprintf(std,"\t%s %d",( nf->BSIZE < 0 ? "-b" : "-o"),abs(nf->BSIZE));
		if((nf->TYPE != REELLE) && nf->swap_needed) {
			if(nf->swap_needed > 0)
				fprintf(std,"(swap)");
			else
				fprintf(std,"(??)");
		}
		if(nf->TYPE != REELLE) {
			if(nf->EXP < 0)
				fprintf(std,"\t-s");
			if( abs(nf->EXP)-200 != 0 && abs(nf->EXP) != 0 )
				fprintf(std,"\t-e %d",abs(nf->EXP)-200);
			if(nf->scale != 0)
				fprintf(std,"\t-imsc %f",nf->scale);
			if(nf->bias != 0)
				fprintf(std,"\t-imbi %f",nf->bias);
		}
		if(nf->maille == I_HEXAG)
			fprintf(std,"\t-m=h");
	}
	if(opt & (P_VERS | P_FMT))
		fprintf(std,"\n");
	if(opt & P_DIV) {
		fprintf(std,"\t%d bits/ligne (%d octets),",
			nf->bits_lig,nf->hors_tout);
		fprintf(std," header de %d (%d lignes ascii)\n",nf->desc_size,
			nf->hdr_nlines-2);
	}
	init_hdrkeys();
	if(opt & P_ASCII) {
		n = 0;	
		while((n = igethline(nf,"",n,xbuf,BMAX,&msize)) >= 0)
			fprintf(std,"\t%d\t%s\n",n-1,xbuf);
		fprintf(std,"\tfree space = %d\n",ifreehdr(nf));

	} else if (opt & P_HIST) {
		n = 0;	
		p = hdr_keys[IS_HISTORY].key;
		while((n = igethline(nf,p,n,xbuf,BMAX,&msize)) >= 0)
			fprintf(std,"\t%s\n",xbuf);
	} else if (opt & P_COMM) {
		n = 0;	
		p = hdr_keys[IS_HISTORY].key + 1;
		while((n = igethline(nf,"#",n,xbuf,BMAX,&msize)) >= 0) {
		  if( strstr( xbuf, p) == xbuf) continue;
		  fprintf(std,"\t%s\n",xbuf);
		}
	}
	return 0;
}
