#include <stdio.h>
#include <inrimage/image.h>

/*
   rgb8tohsv(n,Hbuf,Sbuf,Vbuf,inchsv,Hmax,rbuf,gbuf,bbuf,incrgb)
*/

#define CNVF(x) ((float)x / 255.)
/*
   int rgb8tohsv(n,Hbuf,Sbuf,Vbuf,inchsv,Hmax,rbuf,gbuf,bbuf,incrgb)
   convertit les n donne'es rbg 8 bits en hsv (flottants)
   inchsv : increment dans les buffer HSV (cas d'images vectorielles)
   Hmax : valeur limite pour H,  (normalement 1 ou 360)
   incrgb : increment dans les buffer RGB (cas d'images vectorielles)
   retour : & 1 = Hbuf non defini, &2 => S = 1, &4 => V= 1
*/

rgb8tohsv(n,Hbuf,Sbuf,Vbuf,inchsv,Hmax,rbuf,gbuf,bbuf,incrgb)
register n, inchsv, incrgb;
register float *Hbuf, *Sbuf, *Vbuf, Hmax;
register unsigned char *rbuf, *gbuf, *bbuf;
{
  register i;
  register float xfr, xfg, xfb;
  register float fr, fg, fb;
  register float coef;
  register float vmin, vmax, vdelta;
  int ret = 0;
  coef =  Hmax / 6.;
  ret = 7;
  while(n-- > 0) {
    fr = CNVF(*rbuf);
    fg = CNVF(*gbuf);
    fb = CNVF(*bbuf);
    rbuf += incrgb;
    gbuf += incrgb;
    bbuf += incrgb;
    if(fr > fg) {
      if(fr > fb) vmax = fr;
      else vmax = fb;
      if(fg < fb) vmin = fg;
      else vmin = fb;
    } else {
      if(fg > fb) vmax = fg;
      else vmax = fb;
      if(fr < fb) vmin = fr;
      else vmin = fb;
    }
    vdelta = vmax - vmin;
    *Vbuf = vmax;
    if((*Sbuf = vmax ? vdelta / vmax : 0.)) {
      xfr = (vmax - fr) / vdelta;
      xfg = (vmax - fg) / vdelta;
      xfb = (vmax - fb) / vdelta;
      *Hbuf = ((fr == vmax) ? (xfb - xfg) : ((fg == vmax) ? (2 + xfr - xfb) : 4 + xfg - xfr)) * coef;
      ret &= 6;
      
    } else {
      *Hbuf = -1.;
    }
    if((ret & 2) && (*Sbuf != 1.)) ret &= 5;
    if((ret & 4) && (*Vbuf != 1.)) ret &= 3;
    Vbuf += inchsv;
    Sbuf += inchsv;
    Hbuf += inchsv;
  }
  return ret;
}
