/* traitement des headers visilog */

#include <stdio.h>
#include <inrimage/inrfile.h>
#include <inrimage/flt_type.h>
extern char *realloc();
extern char **hdrl_alloc();

static vread_hdr(nf)
register struct image *nf;
{
	register char *file_header;
	register n;
	register len;
	if( nf->desc_size <= DESC) return 0;
/*	if((nf->desc_size % DESC) != 0) return 1;  c'est autorise!! */
	file_header = nf->hdr_data;
	file_header = (char *) realloc(file_header,nf->desc_size*sizeof(char));
	n = nf->desc_size - DESC;
	if ( file_header == NULL ) {
		perror("realloc");
		fprintf(stderr,"Could'nt realloc %d chars\n",nf->desc_size);
		return(1);
	}
	if ( (len = read_all(nf->fd,file_header+DESC,n)) < 0) { 
		perror("read");
		return(-1);
	}
	nf->hdr_data = file_header;
	nf->byte_pnt += len;
	if(n != len)
		return -1;
	return 0;
	
}


vdesc_fmt(nf)
register struct image *nf;
{
	register struct vlg_desc *pv;
	register n, fl;
	if((n = vread_hdr(nf)) != 0) return n;
	pv = (struct vlg_desc *) nf->hdr_data;
	nf->NDIMX = nf->DIMX = pv->i_dimx;
	nf->NDIMY = pv->i_dimy;
	nf->NDIMZ = pv->i_dimz;
	nf->NDIMV = 1;
	nf->DIMY = nf->NDIMY * nf->NDIMZ;
	nf->maille = pv->i_maille;
	nf->X_OFFSET = pv->i_orix -1;
	nf->Y_OFFSET = pv->i_oriy -1;
	nf->Z_OFFSET = pv->i_oriz -1;
	nf->EXP = 200;
	n = pv->i_bstoc;
	fl = n & I_PACKED;
	n &= ~I_PACKED;
	if(pv->vlg_float <= 0)
		nf->float_typ = FL_SUN;
	else
		nf->float_typ = pv->vlg_float;
	nf->data_msbfirst = chk_msbfirst(nf->float_typ);
	if(fl) {
		nf->BSIZE = -n;
		nf->TYPE = PACKEE;
		nf->bits_lig = nf->DIMX * n;
	} else if((fl =  pv->i_code) == I_FLOAT) {
		nf->BSIZE = 4;
		nf->TYPE = REELLE;
		if(nf->float_typ != fl_type())
			nf->flt_conv = 1;
		nf->bits_lig = nf->DIMX * n;
		nf->EXP = nf->float_typ;
	} else {
		nf->TYPE = FIXE;
		if(n & 7) {
			nf->BSIZE = -n;
			n = 8 * ((n + 7) / 8);
		} else {
			nf->BSIZE = n / 8;
		}
		nf->bits_lig = nf->DIMX * n;
		if(fl == I_CHR) {
			nf->EXP = -200;  /* char signe */
			if(nf->BSIZE != 1) return 1;
		}
	}
	/* check if swap needed on fix type : not packed and coded on 2 or 4 bytes */
	if((nf->TYPE != REELLE) && (nf->TYPE != PACKEE) && (n > 8)) { 
		if(nf->data_msbfirst < 0)
			nf->swap_needed = -1;
		else if(nf->data_msbfirst != ismsbfirst())
			nf->swap_needed = (n <= 16) ? 1 : ((n > 24) ? 2 : -1);
	}
	nf->hors_tout = (nf->bits_lig + 7) / 8;
	return bld_hdrlv(nf);
}

bld_hdrlv(nf)
register struct image *nf;
{
	register struct vlg_desc *pv;
	register n, i;
	register char *pc;
	pv = (struct vlg_desc *) nf->hdr_data;
	pc = (char *)pv + VDESC;
	if((n = bld_hdrl(nf,pc)) != 0) return n;
	n = 0;
	i = nf->hdr_nlines -1;
	pc = nf->hdr_lines[i];
	if(*pc != 0 && *pc != '\n')
		n = 1;
	if(nf->hdr_nlines >= nf->hdrl_size-n)
		if(hdrl_alloc(nf) == 0) return 1;
	if(n)
		nf->hdr_lines[nf->hdr_nlines++] = nf->hdr_data + nf->desc_size;
	nf->hdr_lines[nf->hdr_nlines++] = nf->hdr_data + nf->desc_size;
	return 0;
}

/* generation descripteur visilog */
fmt_vdesc(nf)
register struct image *nf;
{
	register struct vlg_desc *pv;
	register n, fl;
	pv = (struct vlg_desc *) nf->hdr_data;
	pv->i_magic = V_MAGIC;
	pv->i_dimx = nf->DIMX ;
	pv->i_dimy = nf->NDIMY ;
	pv->i_dimz = nf->NDIMZ ;
	pv->i_maille = nf->maille;
	pv->i_orix = nf->X_OFFSET +1;
	pv->i_oriy = nf->Y_OFFSET +1;
	pv->i_oriz = nf->Z_OFFSET +1;
	pv->hdr_sys = VDESC;
	pv->hdr_usr = nf->desc_size <= VDESC ? 0 : nf->desc_size - VDESC;
	pv->hdr_data = pv->hdr_sys + pv->hdr_usr;
	if(nf->hdr_lines == (char **) 0) {  /* c'est une creation de header */
		if(hdrl_alloc(nf) != 0) {
			nf->hdr_lines[0] = (char *)pv + VDESC;
			nf->hdr_lines[1] = nf->hdr_data + nf->desc_size;
			nf->hdr_nlines = 2;
		}
	}
	/* set float type (i.e. cpu type) */
	if(nf->float_typ == 0) {
		nf->float_typ = fl_type();
		nf->data_msbfirst = ismsbfirst();
	}
	pv->vlg_float = nf->float_typ;

	if(nf->TYPE == REELLE) {
		pv->i_code = I_FLOAT;
		pv->i_bstoc = 8 * nf->BSIZE;
		nf->bits_lig = pv->i_bstoc * nf->DIMX;
		nf->hors_tout = (nf->bits_lig + 7) / 8;
		nf->flt_conv = 0;  /* on devrait peut-etre dire 1 si pas FL_SUN ?? */
		return 0;
	}
	fl = 0;
	if((n = nf->BSIZE) < 0) {
		n = -n;
		if(nf->TYPE == FIXE)
			n = 8 * ((n + 7) / 8);
		else
			fl = I_PACKED;
	} else
		n *= 8;
	nf->bits_lig = n * nf->DIMX;
	nf->hors_tout = (nf->bits_lig + 7) / 8;
	fl |= n;
	pv->i_bstoc = fl;
	if(n <= 8) {
		if(nf->EXP < 0)
			pv->i_code = I_CHR;
		else
			pv->i_code = I_CHRU;
		if(n == 1) pv->i_code = I_BINP;
	} else if(n <= 16) {
		pv->i_code = I_SHORT;
	} else
		pv->i_code = I_LONG;
	/* swap file header to put MSB first */
	if(!nf->data_msbfirst)
		swapvdesc(pv);
	return 0;
} /* end visilog part */
