#include <stdio.h>

int flg_pts= 0;
int flg_line;
int flg_dble, xcol= 255;
int flg_ed, flg_eff, flg_sync, flg_cp;
#define NBMAX 512
int tbx[NBMAX], tby[NBMAX];
int oldtbx[NBMAX], oldtby[NBMAX];
int nbpts, oldnbpts;
char filename[256];
int nbfiles;
FILE *ifile;
int tempo= 2;
int z0= 1;

struct ops {
	int (*init)();
	int (*end)();
	int (*setcol)();
	int (*setz)();
	int (*line)();
	int (*point)();
	int (*rect)();
	int (*polyline)();
};

struct ops *ptops;

extern int xved_init(), xved_end(), xved_setcol(), xved_setz(), xved_line();
extern int xved_point(), xved_rect(), xved_polyline();
extern int xvdraw_init(), xvdraw_end(), xvdraw_setcol(), xvdraw_setz(), xvdraw_line();
extern int xvdraw_point(), xvdraw_rect(), xvdraw_polyline();
int no_op();

struct ops op_ed= {
	xved_init, xved_end, xved_setcol, xved_setz, xved_line, xved_point,
	xved_rect, xved_polyline};
struct ops op_draw= {
	xvdraw_init, xvdraw_end, xvdraw_setcol, xvdraw_setz, xvdraw_line, xvdraw_point,
	no_op, xvdraw_polyline};

main(argc,argv)
int argc;
char **argv;
{
	register ist, first, i;
	register char **pf;
	initopts(argc,argv);
	kdopts_();
	flg_pts = igetopt("-p","",0,"",0,"",0);
	flg_line = igetopt("-l","",0,"",0,"",0);
	igetopt("-c","",0,"%d",&xcol,"",0);
	igetopt("-z","",0,"%d",&z0,"",0);
	z0--;
	if(z0 < 0)
		z0 = 0;
	flg_dble = igetopt("-d","",0,"",0,"",0);
	flg_ed = igetopt("-ed","",0,"",0,"",0);
	flg_eff = igetopt("-e","",0,"",0,"",0);
	flg_cp = igetopt("-E","",0,"",0,"",0);
	flg_sync = igetopt("-s","",0,"",0,"",0);
	nbfiles = 0;
	nbfiles = igetopt("","%s",filename,"",0,"",0);
	if(!nbfiles)
		ifile = stdin;
	ptops = flg_ed ? &op_ed : &op_draw;
	ptops->init(flg_cp);
	ptops->setcol(xcol);
	ptops->setz(z0);
	first = 1;
	while(1) {
		if(nbfiles < 0) {
			ptops->end();
			return 1 /* makes c99 happy */; 
		}
		if(nbfiles) {
			ifile = fopen(filename,"r");
			if(!igetopt("","%s",filename,"",0,"",0))
				nbfiles = -1;
		}
		ist = readdata();
		if(nbfiles != 0)
			fclose(ifile);
		if(ist || (ist == 0 && nbfiles != 0)) {
			if(flg_dble && !first) {
				if(xcol >= 0)
					ptops->setcol(0);
				redraw();
			} else 
				first = 0;
			ptops->init(flg_cp);
			ptops->setcol(xcol);
			ptops->setz(z0);
		}
		draw1(0);
		if(ist == 0 && !nbfiles)
			break;
		for(i=0;i<tempo;i++)
			savetb();
	}
	if(flg_dble) {
		if(xcol >= 0)
			ptops->setcol(0);
		draw1(1);
	}
	ptops->end();
}

readdata()
{
	float v1, v2;
	char buf[80];
	register i, n;
	i = 0;
	while (fgets(buf,80,ifile) != 0) {
		if((n = sscanf(buf,"%f %f",&v1,&v2)) != 2) {
			if(n >= 0) {
				nbpts = i;
				return 1;
			}
			continue;
		}
		if(v1 < 0. || v2 < 0.) {
			fprintf(stderr,"negative value ignored\n");
			continue;
		}
		tbx[i] = (int)(v1 + .5);
		tby[i] = (int)(v2 + .5);
		i++;
		if(i >= NBMAX)
			imerror(8,"depassement taille buffer\n");
	}
	nbpts = i;
	return 0;
}


draw1(flg2)
register flg2;  /* 1 si redraw */
{
	register i;
	if(flg_eff) {
		printf("##!paste()\n");
	}
	if(flg_pts) {
		for(i=0;i<nbpts;i++)
			ptops->point(tbx[i],tby[i]);
	} else if(flg_line) {
		ptops->point(tbx[0],tby[0]);
		for(i=1;i<nbpts;i++)
			ptops->line(tbx[i],tby[i]);
	} else {
		ptops->polyline(tbx,tby,nbpts);
	}
	if(flg_cp && !flg2) {
		printf("##!draw(s 1 1 %d -1 -1 1)\n",z0);
	}
	if(flg_sync)
		xvis_sync();
}
redraw()
{
	ptops->polyline(oldtbx,oldtby,oldnbpts);
}
savetb()
{
	register i;
	for(i=0;i<nbpts;i++) {
		oldtbx[i] = tbx[i];
		oldtby[i] = tby[i];
	}
	oldnbpts = nbpts;
}

int no_op()
{
}
