/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <inrimage/image.h>
#include "xvis.h"
#include "xvglobl.h"

#define evreturn(n) {evt_retcode = n; return 1 /* makes c99 happy */; }

extern int evt_retcode;

/* les help messages */
char **p_msg;
char **old_msg= NULL;
char *message= NULL;


extern char *m_help[], *m_nom[], *m_exit[], *m_edit[], *m_loop[], *m_zloop[], *m_step[], *m_same[], *m_param[], *m_next[], *m_prev[], *m_shell[], *m_imag[];


set_msg(msg)
char **msg;
{
	p_msg = msg;
	if(old_msg != p_msg) {
		prp_msg();
		prt_msg();
		old_msg = p_msg;
	}
}

prp_msg()
{
	register char **msg;
	register char *pm, *pc;
	msg = p_msg;
	pm = message;
	while((pc = *msg++) != NULL) {
		while(*pc != 0) {
			*pm++ = *pc++;
		}
		*pm++ = '\n';
	}
	*pm++ = 0;
}

ev_noop()
{
	evreturn( NOOP);
}

b_exit()
{
	clear_edit();
	xtermine();
	xvsh_kill();
	exit(0);
	evreturn( QUIT);
}

b_cmap()
{
	pop_cmap();
	evreturn(NOOP);
}

b_same()
{
	do_exit(B_SAME);
	if(!(file_type & PIPE)) {
		ptim = &tabim[numim-1];
		trt_image();
	} else {
		b_next();
	}
	evreturn( SAME);
}

b_upleft()
{
	struct screenpt scr;
	im2sc_coord(&cur_ima_pt,&scr);
	scroll_image(scr.x,scr.y);
	xv_scr_orig(&cur_scr_top);
	sc2im_coord(&cur_scr_top,&cur_ima_top);
	sc2im_coord(&cur_scr_top,&cur_ima);
}

b_center()
{
	struct screenpt scr;
	im2sc_coord(&cur_ima_pt,&scr);
	center_display(scr.x,scr.y);
}

/* centre display image sur point de coord ecran x, y */
center_display(x,y)
register x,y;
{
	struct screenpt scrs;
	xv_scr_size(&scrs);
	x -= (scrs.x / 2);
	y -= (scrs.y / 2);
	scroll_image(x,y);

}

b_nextz()
{
#if 1
	register z;
	struct screenpt scr;
	struct imagept ima;
	xv_scr_orig(&scr);
	sc2im_coord(&scr,&ima);
	z = ima.z + zpas;
	if(z >= (iz0 + im_nz * zpas))
		z = iz0;
	ima.z = z;
	ima.zy = 0;
	im2sc_coord(&ima,&scr);
	scroll_image(scr.x,scr.y);
#else
	put_nextz(0);
#endif
}
b_prevz()
{
#if 1
	register z;
	struct screenpt scr;
	struct imagept ima;
	xv_scr_orig(&scr);
	sc2im_coord(&scr,&ima);
	z = ima.z - zpas;
	if(z < 0)
	z = (iz0 + im_nz * zpas) - 1;
	ima.z = z;
	ima.zy = 0;
	im2sc_coord(&ima,&scr);
	scroll_image(scr.x,scr.y);
#else
	put_prevz(0);
#endif
}

b_nextv()
{
  int v;
  struct screenpt scr;
  struct imagept ima;
  xv_scr_orig(&scr);
  sc2im_coord(&scr,&ima);
  v = ima.v + 1;
  if(v >= (im_nbv + iv0))
    v = iv0;
  ima.v = v;
  ima.vx = 0;
  im2sc_coord(&ima,&scr);
  scroll_image(scr.x,scr.y);
}
b_prevv()
{
  int v;
  struct screenpt scr;
  struct imagept ima;
  xv_scr_orig(&scr);
  sc2im_coord(&scr,&ima);
  v = ima.v - 1;
  if(v < 0)
    v = iv0 + im_nbv - 1;
  ima.v = v;
  ima.vx = 0;
  im2sc_coord(&ima,&scr);
  scroll_image(scr.x,scr.y);
}

b_next()
{
	if(file_type & PIPE) {
		numim++;
	} else {
		do_exit(B_NEXT);
		numim += im_opfiles;
		if(numim > nbim) {
			if(flg_rv_loop && sens_loop >= 0) { /* auto reverse */
				numim -= im_opfiles;
				sens_loop = -1;
			} else {
				numim = 1;
				ptim = tabim;
			}
		} else {
			ptim = &tabim[numim-1];
		}
	}
	trt_image();
	evreturn( NEXT);
}

b_prev()
{
	register n;
	do_exit(B_PREV);
	if(file_type & PIPE) {
		numim++;
		n =  NEXT;
	} else {
		if(numim <= im_opfiles) {
			if(flg_rv_loop && sens_loop < 0) { /* auto reverse */
				sens_loop = 1;
			} else 
				numim = nbim - im_opfiles + 1;
		} else {
			numim -= im_opfiles;
		}
		ptim = &tabim[numim-1];
		n = PREV;
	}
	trt_image();
	evreturn( n);
}


/* common routine to modify points :
but = 1, 2, 3 pout bouton 1,2 ou 3 
+0x100 si Shift en plus : mode remplissage rectangle pour bouton 2
Bouton 1 : marque point en noir, bouton 3 : marque point en blanc
Bouton 2 : trace ligne vers dernier point, dans la meme couleur
   avec Shift : trace un rectangle plein
*/
cmn_edit_pt(x,y,Bouton,affiche)
register x, y;
int Bouton, affiche;
{
	struct screenpt scr, scr2;
	struct imagept ima, ima2, *p2;
	register but;
	register flg;
	register v;
	but = Bouton & 7;
	scr.x = x;
	scr.y = y;
	sc2im_v_coord(&scr,&ima);  /* convert from screen to image coord */
	p2 = (struct imagept *)0;
	if((curs_options & CURS_OP_ED) && (curs_type & CURS_ORIENT)) {
		scr2.x = x + curs_offset.x;
		scr2.y = y + curs_offset.y;
		if((scr2.x < im_w) && (scr2.y < im_h)) {
			sc2im_v_coord(&scr2,&ima2);
			p2 = &ima2;
		}
	}
	if(affiche)
		affiche_coord(&ima,p2);
/*	printf("edit: x= %d, y=%d but= %d\n",x,y,but); */
	if(but < 1) but = 1;
	if(but > 3) but = 3;
	if(but == 2) {
		flg = 1;
		if(edit.lastbutton == 0) {
			xvbell();
			return 1 /* makes c99 happy */; 
		}
		but = edit.lastbutton;
		if(edit.oldima.z != ima.z) {
			fprintf(stderr,"ATTENTION! changement de plan interdit!\n");
			xvbell();
			return 1 /* makes c99 happy */; 
		}
		if(Bouton & 0x100)
			flg = 2;
	} else {
		edit.lastbutton = but;
		flg = 0;
	}
	draw_edit(flg,but,&edit.oldima,&ima);
	if(p2) {
		if(!flg || (ed_lastbutton2 && (ed_oldima2.z == ima2.z)))
			draw_edit(flg,but,&ed_oldima2,p2);
		ed_lastbutton2 = but;
	} else
		ed_lastbutton2 = 0;
	if(flg_pr_edit)
		pr_edit_action(flg,but,&ima,p2);
	evreturn(NOOP);
}

draw_edit(flg,but,oldima,ima)
register flg, but;
register struct imagept *oldima, *ima;
{
	if(flg == 0)
		set_ed_pt(ima,but);
	else if(flg == 1)
		set_line(oldima,ima);
	else
		set_ed_rect(oldima,ima);
	oldima->x = ima->x;
	oldima->y = ima->y;
	oldima->zy = ima->zy;
	oldima->vx = ima->vx;
	oldima->z = ima->z;
	oldima->v = ima->v;
}


b_edit()
{
	if(b_list[B_EDIT]->b_inv > 0) { /* deja actif : desactiver */
		clear_edit();
	} else {
		b_list[B_EDIT]->b_inv = 1;
		init_edit();
		xv_start_edit();  /* set event handler */
		wrbutton(B_EDIT);
	}
	evreturn(NOOP);
}


/* ouverture fenetre shell */
b_shell()
{
	xvsh_create();
	evreturn( NOOP);
}

b_help()
{
	show_msg();
	evreturn( NOOP);

}

/* set new params of visualisation */
xvset_params(s)
register char *s;
{
	int i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11;
	register n;
	register nmx;
	if(s == NULL)
		return 1 /* makes c99 happy */; 
	if(scrdepth == 1) {
		nmx = 10;
		n = sscanf(s,"%d %d %d %d %d %d %d %d %d %d",&i1,&i2,&i3,&i4,&i5,&i6,&i7,&i8,&i9,&i10);
	} else {
		n = sscanf(s,"%d %d %d %d %d %d %d",&i3,&i4,&i5,&i6,&i7,&i8,&i9,&i10,&i11);
		nmx = 9;
		if(n >= nmx--)
			if(new_nb_hz != i11) {
				new_nb_hz = i11;
				new_params = 1;
			}
	}
	if(n >= nmx--)
		if(new_vis_exp != i10) {
			new_vis_exp = i10;
			new_params = 1;
		}
	if(n >= nmx--)
		if(zloop_int != i9) {
			zloop_int = i9;
		}
	if(n >= nmx--)
		if(new_nb_vcomp != i8) {
			new_nb_vcomp = i8;
			new_params = 1;
		}
	if(n >= nmx--)
		if(new_deb_vcomp != i7) {
			new_deb_vcomp = i7;
			new_params = 1;
		}
	if(n >= nmx--)
		if(new_nb_plan != i6) {
			new_nb_plan = i6;
			new_params = 1;
		}
	if(n >= nmx--)
		if(new_deb_plan != i5) {
			new_deb_plan = i5;
			new_params = 1;
		}
	if(n >= nmx--)
		if(new_zpas != i4) {
			new_zpas = i4;
			new_params = 1;
		}
	if(n >= nmx--)
		if(new_opt_pas != i3) {
			new_opt_pas = i3;
			new_params = 1;
		}
	if(scrdepth == 1) {
		if(n >= 2)
			if(new_g_size != i2) {
				new_g_size = i2;
				new_params = 1;
			}
		if(n >= 1)
			if(new_fl_peano != i1) {
				if(i1 < 0) i1 = 0;
				else if(i1 > 1) i1 = 1;
				new_fl_peano = i1;
				new_params = 1;
			}
	}

}


/* Appele par selection du menu images avec ptr = adresse dans tabim */
image_menu(num)
register num;
{
	
/*	numim = 1 + ((int)ptr - (int)tabim) / sizeof (char *); */
	numim = num;
	b_same();
}
