/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include "xvis.h"
#include <inrimage/image.h>
#include "xvglobl.h"
#include "xvxglobl.h"


static int setedval();

static int last_ed_col= -1;  /* last color val */
static int last_ed_z= -1;  /* last z val */

static Fort_int lfmtrdp[9];
unsigned char *get_im_line();

/* desactive le mode edit :
vide les buffers et nettoie la structure edit ,
*/
clear_edit()
{
	flush_edit();
	if(edit.active) {
		i_Free((char **)&edit.pmodif);
		i_Free((char **)&edit.data);
		edit.active = 0;
		fermnf_(&edit.wnf);
		if(b_list[B_EDIT]->b_inv > 0) {
			b_list[B_EDIT]->b_inv = 0;
			wrbutton(B_EDIT);
			xv_end_edit(); /* reset event handler */
		}
	}
}

/* desactive le mode read pixel from file
vide les buffers et nettoie la structure edit ,
*/
clear_rdpix()
{
	register i, n;
	if((n = ed_rdpix.active)) {
		i_Free((char **)&ed_rdpix.data);
		i_Free((char **)&ed_rdpix.pmodif);
		ed_rdpix.active = 0;
		for(i=0;i<n;i++)
			fermnf_(&rd_nf[i]);
	}
}
flush_rdpix()
{
}


/* entree en mode edit: appele par b_edit()  : initialise la table edit 
appelle clear_edit si table precedente active */
init_edit()
{
	register struct image *nf;
	register n, i;
	if(!flg_edit) return 1 /* makes c99 happy */; 
	if(edit.active) clear_edit();
	if(flg_ednull) {
		edit.nlblock = 1;
		edit.active = 1;
		edit.modified = 0;
		imedvals.valdata[0] = 0;
#if 0
		imedvals.valdata[1] = -1;
#else
		imedvals.valdata[1] = (int)ed_curcolor;
#endif
		return 1 /* makes c99 happy */; 
	}
/*!!	malloc_debug(2); */
	nf = image_(tabim[nbim -1],"e","",(struct nf_fmt *)lfmtw);
	if(lfmtw[I_NDIMX] != NDIMX || lfmtw[I_NDIMY] != NDIMY)
		imerror(7,"dimensions in et out incompatibles\n");
	if(truecol_type != I_ZCOL) {
		if(lfmtw[I_NDIMZ] != NDIMZ)
			imerror(7,"dimensions (Z) in et out incompatibles\n");
	}
	if(truecol_type != I_VCOL) {
		if(lfmtw[I_NDIMV] != NDIMV)
			imerror(7,"dimensions (V) in et out incompatibles\n");
	}

	if(lfmtw[2] == -1 && lfmtw[3] == -1)
		n = 1;
	else if(lfmtw[2] == 1 && lfmtw[3] == 0)
		n = 8;
	else imerror(9,"on n'accepte que 1 ou 8 bits en sortie!\n");
	edit.wnf = nf;
	init_imedit(&edit,lfmtw,1,0);
	if(n == 1)
		edit.dimx = 8 * edit.buf_bytes_per_line;
	edit.lastbutton = 0;
	/* alloc and set to 0 */
	edit.pmodif = (unsigned char *) xvcalloc(edit.nlblock,1);
	/* init table imedvals */
	imedvals.psize = pas;
	imedvals.pxbits = lfmtw[I_TYPE] == PACKEE ? 1 : 8;
	i_Free((char **)&imedvals.pixdata[0]);
	i_Free((char **)&imedvals.pixdata[1]);
	n = imedvals.psize * imedvals.psize * imedvals.pxbits;
	n = (n + 7) / 8;
	imedvals.pixdata[0] = (char *)xvmalloc(n);
	imedvals.pixdata[1] = (char *)xvmalloc(n);
	imedvals.valdata[0] = 0;
#if 0
	imedvals.valdata[1] = -1;
#else
	imedvals.valdata[1] = (int)ed_curcolor;
#endif
	for(i=0;i<n;i++) {
		*(imedvals.pixdata[0] +i) =  imedvals.valdata[0];
		*(imedvals.pixdata[1] +i) =  imedvals.valdata[1];
	}
}

/* initialise struct imedit
   nbbuf = nb buffers (1 ou 3)
 */
init_imedit(edp,fmtw,nbbuf,flg_unpack)
register struct imedit *edp;
Fort_int fmtw[];
register nbbuf;
int flg_unpack;
{
	register n;
	edp->dimx = fmtw[I_DIMX];
	edp->dimy = nbbuf > 1 ? fmtw[I_NDIMY] : fmtw[I_DIMY];
	n = fmtw[I_BSIZE] < 0 ? -fmtw[I_BSIZE] : 8 * fmtw[I_BSIZE];
	if(flg_unpack) {
		edp->buf_bytes_per_line = (edp->dimx * ((n + 7) / 8));
		edp->bytes_per_line = fmtw[I_DIMX];
	} else {
		edp->buf_bytes_per_line = ((edp->dimx * n) + 7) / 8;
		edp->bytes_per_line = edp->buf_bytes_per_line;
	}
	n = koctet_ * 1024;
	edp->nlblock = n / (edp->buf_bytes_per_line * nbbuf);
	if(edp->nlblock > fmtw[I_NDIMY]) edp->nlblock = fmtw[I_NDIMY];
	/* alloc and set to 0 */
	edp->data = (unsigned char *) xvmalloc(edp->buf_bytes_per_line * edp->nlblock * nbbuf);
	edp->ymin = edp->ymax = -1;
	edp->active = 1;
	edp->modified = 0;
}

/* forcer ecriture si edition en cours */
flush_edit()
{
	register unsigned char *pc, *buf;
	register i, y, nbm;
	if(!edit.active || !edit.modified) return 1 /* makes c99 happy */; 
	edit.modified = 0;
	if(flg_ednull) return 1 /* makes c99 happy */; 
	pc = edit.pmodif;
	buf = (unsigned char *)edit.data;
	y = edit.ymin+1;
	nbm = 0;
	for(i=0;i<edit.nlblock;i++) {
		if(*pc) {
			*pc = 0;
			nbm++;
		} else {
			if(nbm) {
				c_lptset(edit.wnf,y);
				c_xecr(edit.wnf,nbm,buf,1);
				y += nbm;
				buf += nbm * edit.bytes_per_line;
				nbm = 0;
			}
			y++;
			buf += edit.bytes_per_line;
		}
		pc++;
	}
	if(nbm) {
		c_lptset(edit.wnf,y);
		c_xecr(edit.wnf,nbm,buf,1);
	}
}

/* initialise la table edvals  pour l'edition des pixels 
appele avant chaque chargement d'image (par trt_image, apres clear_edit))*/
init_edvals()
{
	register n;
	register i;
	register unsigned char *pc;
	n = zoom * g_size;
	if(scrdepth > 1)
		n *= (8 * byte_pixel);
	if(n < 32) {
		edvals.pixnx = (zoom * g_size) * ((n + 31) / n);
	} else {
		edvals.pixnx = zoom * g_size;
	}
	edvals.ny = zoom * g_size;
	edvals.nx = zoom * g_size;
	n = edvals.pixnx;
	if(scrdepth > 1)
		n *= (8 * byte_pixel);
	n = (n + 15) / 16;
	edvals.nbytes = 2 * n * edvals.ny;

	n = edvals.nbytes;
	pc = (unsigned char *)xvmalloc(n);
	ximage->width = edvals.pixnx;
	ximage->height = edvals.ny;
	ximage->bytes_per_line = n / edvals.ny;
	ximage->data = (char *)pc;
#if 0
	setedval(pc,blackpixel);
	setedval(pc,whitepixel);
#else
	setedval(pc,0);
	setedval(pc,ed_curcolor);
#endif
	free(pc);
	ximage->data = NULL;
}

zbuff(buf,n)
register char *buf;
register n;
{
	while(n-- > 0)
		*buf++ = 0;
}

pr_edit_action(flg,but,pi1,pi2)
register flg, but;
register struct imagept *pi1, *pi2;
{
	register i, j;
	if(flg == 0) {
		i = but == 1 ? 0 : 1;
		if(last_ed_z != pi1->z) {
			last_ed_z = pi1->z;
			printf("z %d\n",pi1->z + 1);
		}
		j = imedvals.valdata[i] & 0xff;
		if(last_ed_col != j) {
			printf("C %d\n",j);
			last_ed_col = j;
		}
		printf("p %d %d\n",pi1->x +1,pi1->zy +1);
	} else if(flg == 1)
		printf("l %d %d\n",pi1->x +1,pi1->zy +1);
	else
		printf("r %d %d\n",pi1->x +1,pi1->zy +1);
}
int DB_draw= 0;
/* trace une ligne entre le point definit dans edit.oldima et ima */
set_line(oldima,ima)
register struct imagept *ima, *oldima;
{
	struct imagept im1, im0;
	struct screenpt scr;
	int dx, dy;
	register ax, ay;
	register x0, y0, aux;
	register float r, delta;
	if(DB_draw) {
		draw_xline(oldima,ima);
		return 1 /* makes c99 happy */; 
	}

	memcpy(&im0,ima,sizeof (struct imagept));
	memcpy(&im1,ima,sizeof (struct imagept));
	
	x0 = oldima->vx;
	y0 = oldima->y;
	dx = ima->vx - x0;
	dy = ima->y - y0;
	ax = ABS(dx);
	ay = ABS(dy);
	if(debug_)
		fprintf(stderr,"ligne (%d,%d)->(%d,%d)\n",x0,y0,ima->x,ima->y);
	if(ax == 0 || ay == 0) {
		set_rect(oldima,ima);
		return 1 /* makes c99 happy */; 
	}
	if(ay > ax) {
		r = (float)dx / (float)dy;
		delta = r  < 0. ? -.5 : .5;
		if(dy < 0) {
			ax = dy;
			im0.vx = x0 + dx;
			im0.y = y0 + dy;
			delta = -delta;
		} else {
			ax = 0;
			im0.vx = x0;
			im0.y = y0;
		}
		im1.vx = im0.vx;
		im1.y = im0.y;
		while(ay-- >= 0) {
			aux = x0 + (int) (r * (float)ax + delta);
			if(aux == im0.x) {
				im1.vx = aux;
				im1.y = y0 + ax;
			} else {
			  im1.zy = im1.y % NDIMY;
			  im0.zy = im0.y % NDIMY;
/*!!				if(im0.x < 0 || im0.y < 0 || im1.x < 0 || im1.y< 0)
					xvdebug(0,&im0,&im1); */
				set_rect(&im0,&im1);
				im0.vx = aux;
				im1.vx = aux;
				im1.y = im0.y = y0 + ax;
			}
			ax++;
		}
/*!!		if(im0.x < 0 || im0.y < 0 || im1.x < 0 || im1.y< 0)
			xvdebug(1,&im0,&im1); */
		im1.zy = im1.y % NDIMY;
		im0.zy = im0.y % NDIMY;
		set_rect(&im0,&im1);
	} else {
		r = (float)dy / (float)dx;
		delta = r < 0. ? -.5 : .5;
		if(dx < 0) {
			ay = dx;
			im0.vx = x0 + dx;
			im0.y = y0 + dy;
			delta = -delta;
		} else {
			ay = 0;
			im0.vx = x0;
			im0.y = y0;
		}
		im1.vx = im0.vx;
		im1.y = im0.y;
		while(ax-- >= 0) {
			aux = y0 + (int) (r * (float)ay + delta);
			if(aux == im0.y) {
				im1.y = aux;
				im1.vx = x0 + ay;
			} else {
			  im1.zy = im1.y % NDIMY;
			  im0.zy = im0.y % NDIMY;
				
/*!!				if(im0.x < 0 || im0.y < 0 || im1.x < 0 || im1.y< 0)
					xvdebug(2,&im0,&im1); */
				set_rect(&im0,&im1);
				im0.y = aux;
				im1.y = aux;
				im1.vx = im0.vx = x0 + ay;
			}
			ay++;
				
		}
/*!!		if(im0.x < 0 || im0.y < 0 || im1.x < 0 || im1.y< 0)
			xvdebug(3,&im0,&im1); */
		im1.zy = im1.y % NDIMY;
		im0.zy = im0.y % NDIMY;
		set_rect(&im0,&im1);
	}
}
xvdebug(n,im0,im1)
{
}

/* trace un rectangle entre les points defini dans oldima et ima 
appele par cmn_edit_pt
*/
set_ed_rect(oldima,ima)
register struct imagept *ima, *oldima;
{
	set_rect(oldima,ima);
}

/* trace un rectangle entre les points defini dans oldima et ima */
set_rect(oldima,ima)
register struct imagept *ima, *oldima;
{
	struct imagept im1;
	struct screenpt scr1, scr2;
	register x0, y0, x, y, i, n;
	im2sc_coord(oldima,&scr1);
	im2sc_coord(ima,&scr2);
	x0 = scr1.x;
	y0 = scr1.y;
	x = scr2.x;
	y = scr2.y;
	if (debug_)
		fprintf(stderr,"box (%d,%d)->(%d,%d)\n",x0,y0,x,y);
	if(y0 > y) {
		i = y;
		y = y0;
		y0 = i;
	}
	if(x0 > x) {
		i = x;
		x = x0;
		x0 = i;
	}
	i = g_size * zoom;
	n = edit.lastbutton;
	if(n != 1)
		n = 3;
	xvfillrect(x0,y0,x-x0+i,y-y0+i,edvals.pmap[n-1]);
	set_im_rect(oldima,ima);
}
static 	Fort_int un= 1;
/* marque 1 point image
but : numero de bouton 1 ou 3 */
set_ed_pt(ima,but)
register struct imagept *ima;
register but;
{
	struct screenpt scr;
	register unsigned char *pl;
	register i, j;
	int x;
	i = but == 1 ? 0 : 1;
	im2sc_coord(ima,&scr);
	set_scr_pt(&scr,but);
	if(flg_ednull) return 1 /* makes c99 happy */; 
	if(debug_)
		fprintf(stderr,"set image point (%d,%d,%d)\n",ima->x,ima->zy,ima->z);
	pl = (unsigned char *) get_im_line(ima->y);
	x = ima->x +1;
	c_trtblb(imedvals.pixdata[i],imedvals.psize,1,pl,edit.dimx,
		x,imedvals.psize,imedvals.psize,imedvals.pxbits);
	j = ima->y - edit.ymin;
	for(i=0;i<imedvals.psize;i++)
		*(edit.pmodif + j++) = 1;
	edit.modified = 1;
}

unsigned char *get_im_line(y)
register y;
{
	register unsigned char *pl;
	register n;
	n = get_file_line(&edit,y,&edit.wnf,lfmtw,1,1,flush_edit,0);
	pl = (unsigned char *)(edit.data + n);
	return pl;
}

/* return offset of line in buffer
(read buffer if necessary)
conversion en 8 bits si flg_cnv > 0
 */
get_file_line(edp,y,nftab,fmtw,nbfiles,nbz,flush_func,flg_cnv)
register struct imedit *edp;
register y;
struct image **nftab;
int nbfiles, nbz, flg_cnv;
Fort_int *fmtw;
int (*flush_func)();
{
	register yp, z;
	register i, off;
	register unsigned char *pl;
	if(edp->ymin >= 0) {
		if(y >= edp->ymin && y < edp->ymax) {
			return ((y - edp->ymin) * ( flg_cnv ? edp->bytes_per_line : edp->buf_bytes_per_line));
		}
		flush_func();
	}
	/* on lit des lignes d'un meme plan, centrees en y */
	yp = y % fmtw[I_NDIMY];
	z = y / fmtw[I_NDIMY];
	if(yp - (edp->nlblock / 2) < 0)
		yp = 0;
	yp = pas * (yp / pas);
	edp->ymin = yp;
	edp->ymax = yp + edp->nlblock;
	if(edp->ymax > fmtw[I_NDIMY]) {
		edp->ymax = fmtw[I_NDIMY];
		edp->ymin = edp->ymax - edp->nlblock;
	}
	yp = z * fmtw[I_NDIMY];
	edp->ymin += yp;
	edp->ymax += yp;
	pl = edp->data;
	off = ed_rdpix.nlblock * ed_rdpix.buf_bytes_per_line;
	for(i=0;i<nbfiles;i++) {
		c_lptset(*(nftab+i),edp->ymin+1);
		c_xlect(*(nftab+i),edp->nlblock,pl,1);
		if(flg_cnv) {
		  c_cnvvis(pl,pl,edp->nlblock,fmtw,vis_exp,0,0,1);
		}
		pl += off;
	}
	if(nbz > 1) {
		yp = edp->ymin+1;
		for(i=1;i<nbz;i++) {
			yp += fmtw[I_NDIMY];
			c_lptset(*nftab,yp);
			c_xlect(*nftab,edp->nlblock,pl,1);
			pl += off;
		}
	}
	return ((y - edp->ymin) * ( flg_cnv ? edp->bytes_per_line : edp->buf_bytes_per_line));
}

set_im_rect(im1,im2)
register struct imagept *im1, *im2;
{
	register char *pl;
	register x0, y0, x, y, i;
	int xi, nl, nlig;
	if(flg_ednull) return 1 /* makes c99 happy */; 
	x0 = im1->vx;
	y0 = im1->y;
	x = im2->vx;
	y = im2->y;
	if(debug_)
		fprintf(stderr,"image box (%d,%d)->(%d,%d)\n",x0,y0,x,y);
	if(y0 > y) {
		i = y;
		y = y0;
		y0 = i;
	}
	if(x0 > x) {
		i = x;
		x = x0;
		x0 = i;
	}
	y += imedvals.psize -1;
	x += imedvals.psize -1;
	nlig = y - y0 + 1;
	while(nlig > 0) {
		pl = (char *)get_im_line(y0);
		nl = nlig;
		if(y >= edit.ymax)
			nl = edit.ymax - y0 +1;
		imedvals.nx = x - x0 + 1;
		imedvals.ny = nl;
		set_im_rect1(pl,x0,y0);
		y0 += nl;
		nlig -= nl;
	}
}
set_im_rect1(pl,x0,y0)
register char *pl;
register x0,y0;
{
	register char *pc;
	register i, j, nl;
	int xi;
	nl = imedvals.ny;
	i = edit.lastbutton == 1 ? 0 : 1;
	xi = (nl * imedvals.nx * imedvals.pxbits + 7) /8;
	if(imedvals.bufsize < xi) {
		i_Free((char **)&imedvals.curdata);
		imedvals.curdata = (char *)xvcalloc(xi,1);
		imedvals.bufsize = xi;
		imedvals.curbytes = xi;
		imedvals.curval = 0;
	}
	if(imedvals.valdata[i] != imedvals.curval) {
		j = 0;
		imedvals.curbytes = xi;
		imedvals.curval = imedvals.valdata[i];
	} else {
		j = imedvals.curbytes;
		if(imedvals.curbytes < xi)
			imedvals.curbytes = xi;
	}
	pc = imedvals.curdata + j;
	for(;j<xi;j++) 
		*pc++ = imedvals.curval;
	xi = x0 + 1;
	c_trtblb(imedvals.curdata,imedvals.nx,1,pl,edit.dimx,xi,imedvals.nx,imedvals.ny,imedvals.pxbits);
	j = y0 - edit.ymin;
	for(i=0;i<imedvals.ny;i++)
		*(edit.pmodif + j++) = 1;
	edit.modified = 1;
}
static int setedval(pc,v)
register char *pc;
register v;
{
	register i, num;
	register Pixmap px;
#if 0
	num = v == blackpixel ? 0 : 2;
#else
	if(v == 0) {
		v = blackpixel;
		num = 0;
	} else {
		num = 2;
		if(scrdepth == 1)
			v = whitepixel;
	}
	v &= 0xff;
#endif
	if(scrdepth == 1) {
		if(v != 0)
			v = 255;
	}
#if 0
	else if(num != 0) 
#else
	else if((num != 0) && (v == 255)) 
#endif
	  v = EDCOLOR;
	for(i=0;i<edvals.nbytes;i++)
	  *pc++ = v;
	if((px = edvals.pmap[num]) != 0)
		XFreePixmap(dpy,px);
	px = XCreatePixmap(dpy,W_image,edvals.pixnx,edvals.ny,scrdepth);
	XPutImage(dpy,px,defgc,ximage,0,0,0,0,edvals.pixnx,edvals.ny);
	edvals.pmap[num] = (long)px;
}

/* lit pixel a x.y dans fichier, valeurs converties en 8 bits */
xv_rdpix(x,y)
register x, y;
{
	register unsigned char *pc;
	register n, i, off, nbf;
	if(!ed_rdpix.active)
		if(init_rdpix() < 0) return -1;
	nbf = ed_rdpix.active;  /* nb de fichiers */
	n = nbf == 1 ? ed_rdpix.modified : 1;  /* nb de plans */
	i = get_file_line(&ed_rdpix,y,rd_nf,lfmtrdp,nbf,n,flush_rdpix,1);
	pc = ed_rdpix.data + i + x;
	if(truecol_type == I_MONO)
		return *pc;
	else if(truecol_type == I_VCOL) {
		pc += 2 * x;
		return ((*(pc + col_order[C_ROUGE]) << 16) |
			(*(pc+col_order[C_VERT]) << 8) |
			*(pc + col_order[C_BLEU]));
	} else {
		off = off_rdpix;
		return ((*pc << 16) | (*(pc + off) << 8) | (*(pc + 2*off)));
	}
}

/* lit pixel a x.y dans fichier, valeur en flottant si > 8 bits :
impt->val = -2 si float (dans impt->fval[])
*/
xv_rdpixv(x,y,fval)
register x, y;
float *fval;
{
	register unsigned char *pc;
	register n, i, off, nbf;
	Fort_int icodo[2];
	float tmp[3];
	if(!ed_rdpix.active)
		if(init_rdpix() < 0) return -1;
	nbf = ed_rdpix.active;  /* nb de fichiers */
	n = nbf == 1 ? ed_rdpix.modified : 1;  /* nb de plans */
	i = get_file_line(&ed_rdpix,y,rd_nf,lfmtrdp,nbf,n,flush_rdpix,0);
	pc = ed_rdpix.data + i + x* sizeof(float);
	icodo[0] = sizeof(float);
	icodo[1] = REELLE;
	if(truecol_type == I_MONO)
	  c_cnvtbg(pc,fval,1,&lfmtrdp[I_BSIZE],icodo,lfmtrdp[I_EXP],0);
	else if(truecol_type == I_VCOL) {
		pc += 2 * x * sizeof(float);
		c_cnvtbg(pc,tmp,3,&lfmtrdp[I_BSIZE],icodo,lfmtrdp[I_EXP],0);
		*fval++ = tmp[col_order[C_ROUGE]];
		*fval++ = tmp[col_order[C_VERT]];
		*fval++ = tmp[col_order[C_BLEU]];
	} else {
	  off = off_rdpix;
	  c_cnvtbg(pc,fval,1,&lfmtrdp[I_BSIZE],icodo,lfmtrdp[I_EXP],0);
	  c_cnvtbg(pc+off,fval+1,1,&lfmtrdp[I_BSIZE],icodo,lfmtrdp[I_EXP],0);
	  c_cnvtbg(pc+ 2*off,fval+2,1,&lfmtrdp[I_BSIZE],icodo,lfmtrdp[I_EXP],0);
	}
	return -2;
}

/* accepte n'importe quel format */
init_rdpix()
{
	register i, nbf, n;
	if(ed_rdpix.active) return 1 /* makes c99 happy */; 
	nbf = truecol_type == I_3COL ? 3 : 1;
	if(flg_fix || file_type == PIPE) {
		xvbell();
		return -1;
	}
#if 0
	lfmtrdp[I_EXP] = 200;
	lfmtrdp[I_BSIZE] = 1;
	lfmtrdp[I_TYPE] = FIXE;
	g_open(rd_nf,ptim,"e","t",lfmtrdp,0);
#else
	g_open(rd_nf,ptim,"e","",lfmtrdp,0);
#endif
	n = (truecol_type == I_3COL || truecol_type == I_ZCOL) ? 3 : 1;
	init_imedit(&ed_rdpix,lfmtrdp,n,1);
	ed_rdpix.active = nbf;
	off_rdpix = ed_rdpix.nlblock * ed_rdpix.buf_bytes_per_line;
	ed_rdpix.modified = n;  /* nb plans */
	return 0;
}

change_edcolor()
{
	register i, n;
	if(ed_curcolor == (unsigned long)imedvals.valdata[1])
		return 1 /* makes c99 happy */; 
	init_edvals();
	if(!edit.active)
		return 1 /* makes c99 happy */; 
	imedvals.valdata[1] = (int)ed_curcolor;
	n = (imedvals.psize * imedvals.psize * imedvals.pxbits + 7) / 8;
	for(i=0;i<n;i++) {
		*(imedvals.pixdata[1] +i) =  (int)ed_curcolor;
	}
}
