/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/
#include <stdio.h>
#include <inrimage/image.h>
#include "xvis.h"

/* les parametres du programme */
int fl_peano;  /* mode Peano */
int g_size;  /* taille pave sur ecrans 1 bits, 1 pour les autres */
int byte_pixel= 1;  /* nb byte / pixel  pour depth > 1 : depend de scrdepth */
int pas= 1;  /* pas d'echantillonage */
int deb_plan= 1, nb_plan= 0;  /* 0 = tous */
int deb_vcomp= 1, nb_vcomp= 0;  /* 0 = tous */
int zpas= 1;  /* pas en z */
int zoom= 1;  /* zoom. On a tjs zoom ou pas == 1 */
int opt_pas= 1;  /* == pas ou -zoom */
int vis_exp= 0;  /* exposant pour la visualisation, (de type 2**n) -128 a + 128 */
int flg_nu= 0;  /* fenetre image seule si -1, avec label si 1 */
int opt_z_horiz= 0, flg_z_horiz;  /* affichage plans horizontalement */
int opt_nb_hz= 0, nb_hz= 0;  /* nb plans par ligne (0=tous) */
int flg_rv_zloop= 0;  /* zloop auto reverse */
int flg_rv_loop= 0;  /* image loop auto reverse */
int sens_zloop= 0, sens_loop= 0;  /* <0 => reculer */
int flg_mmx= 1;  /* calculer min et max */
int flg_print= 1;  /* print points on stdout */
int flg_pix_fromfile= 0;  /* si 1 + read pix value in file */
int flg_txt_fond= 1;  /* si 1 : texte avec fond */
int gflg_nopix= 0;  /* ne jamais utiliser de Pixmap si 1 (utiliser Ximage */
int fflg_nopix= 0;  /* forcer flg_nopix pour image courante */
int flg_nopix= 0;  /* ne pas utiliser de Pixmap pour image courante si 1 (utiliser Ximage */
int opt_c254= 0, flg_c254;  /* use only 254 colors */
int flg_Xtc;  /* use current X col table */
int flg_initw;  /* 1 if window creation needed */
int flg_xsh= 0;  /* -1= load and exec shell file required, 1= do laod and exec*/
int shflg_shell= SH_SH;  /* 0 = sh, 1 = csh, 2= perl */
int flg_Wins= 0;  /* +0x7 pour ouvrir les fenetres shell, colors, help */
int flg_zloop= 0;  /* 1 => start zloop on 1st image */
int flg_geom= 0;   /* 1 si opt -geometry  (pour taille avec -nu */

int Req_depth = 0;

int iz0, nbz;  /* pour chaque affichage (iz0 >= 0)*/
int iv0, nbv;  /* pour chaque affichage (iv0 >= 0)*/
int flg_sep_comp; /* 1 => il faut separer les comp vect de l'image */
int flg_edit= 0;  /* edition de fichier demandee si >0; superposer images si 2 */
int flg_ednull= 0;  /* 1 si edit sur /dev/null */
int flg_pr_edit= 0;  /* print des operations d'edition sur stdout si >0 */
int imag_modif= 0;   /* l'image a ete modifiee */
int new_params= 0;  /* parametres modifies */

/* les nouvelles valeurs demandees */
int new_g_size, new_opt_pas, new_zpas, new_fl_peano, new_zloop_int;
int new_deb_plan, new_nb_plan, new_deb_vcomp, new_nb_vcomp, new_vis_exp, new_nb_hz;

int imin_tc, imax_tc;  /* pour correction table couleur indice de couleurs min et max */
struct screenpt cur_scr_top, cur_scr;
struct imagept cur_ima_top, cur_ima; /* coord pour zloop */
struct imagept cur_ima_pt;  /* coord dernier point clique */
int flg_follow_mouse= 0;  /* deplacer image en suivant la souris */

unsigned char *pglyph[NCOLOR];   /* ptrs vers glyph pour chaque niveau */
int pixmin=0, pixmax= 255;
unsigned char *ptabgly= NULL;

Fort_int lfmt[9], lfmto[9], lfmt1[9], lfmtw[9];

unsigned char *aout_buffer= 0, *ain_buffer= 0; /* pour alloc/free */
unsigned char *out_buffer= 0, *in_buffer= 0;  /* pour transferts */
int nblig_in, nblig_out, flg_out_all;  /* 1 si out_buffer doit contenir 1 plan complet */
int in_bufsize= 0;

int nbim, numim, numim1;
int file_type;
char **tabim = NULL;
int tabim_size = 0;
char **ptim, **ptim1;

/* pour les tables couleur */
unsigned char color_tables[NBCTBUFS * NCOLOR];
unsigned char *p_cts[NBCTBUFS];
unsigned char **pp_cur_ct, **pp_X_ct, **pp_prev_ct, **pp_mask_ct;
unsigned char **pp_prev_sc, **pp_sc_ct, **pp_cur_sc;

unsigned char tabc24_8[3*NCOLOR];  /* table de conversion data 24 bits en 8 bits couleur */
unsigned short tabc24_16[3*NCOLOR];  /* table de conversion data 24 bits en 8 bits couleur */

int ncolor= 0;
char tcfile[80], tcordre[32];

int num_g_open= 0;  /* nb appel a g_open1 */

int nbim_group= 0;  /* nb images par groupe , 0 si pas de groupage */

int cmap_type= CMAP_LIN;  /* type of initial cmap */
int im_nbfiles= 0;   /* nb -1 de fichiers pour 1 affichage
		       0  si mono ou vraie couleur 3 plans ou vect.
		       2 si vraie couleur
		       idem en mode edit
		     */
int im_openfiles=0;  /* nb of file to open, without edit output */
int im_opfiles=0;  /* nb of file to read, without edit output */

int fill_value= 0;  /* current fill value */

int truecol_type= I_MONO;  /* 0 = MONO, + 1 vraie couleur sur 1 image (3=3 plans, 5=vect 3), 
			 8= 3 images  : s'applique a image courante */

short shft_val[4];

unsigned char *ptabc24_8[3]= {tabc24_8, &tabc24_8[NCOLOR], &tabc24_8[2*NCOLOR]};
unsigned short *ptabc24_16[3]= {tabc24_16, &tabc24_16[NCOLOR], &tabc24_16[2*NCOLOR]};
unsigned char col_order[]= {C_ROUGE,C_VERT,C_BLEU};
unsigned char Xcol_order[3];  /* ordre des couleurs pour disp 24 bits
			       = num byte dans mot pour R V B , depend de byte_order */
unsigned char Xbyte_order;  /* X dspy byte order (24 bits) : MSBFirst or LSBFirst) */
unsigned char rvb_shft[]= { 0, 3, 6 };
unsigned char rvb_msk[]= {0xe0,0xe0,0xc0};
unsigned char rvb_rshft[]= {5,2,0};
unsigned char rvb_tc3b[]= {0,0x24,0x49,0x6d,0x92,0xb6,0xdb,0xff};
unsigned char rvb_tc2b[]= {0,0x49,0x92,0xff}; /* {0,0x55,0xaa,0xff}; */
unsigned char rvb_lg3b[]= {16,16,16,16,16,16,16,32};
unsigned char rvb_lg2b[]= {48,48,48,64}; /* {32,32,32,64}; */
int ncol_2bits= 2;  /* indice couleur codeee sur 2 bits */

Fort_int lfmtcol[9];
struct image *nfcolor= NULL;
int loop_int;	/* intervalle d'attente en sec. avant de reboucler */
int zloop_int;	/* nb d'affichage de chaque plan */
int cpt_zloop;  /* compteur courant pour z loop */
int sig_lock= 0;  /* ignore signal */
int flg_fix;	/* 0= images normales, 1= im. sans header, -1= image nulle */
int fdimx, fdimy;
int fdimz= 1;
int fdimv= 1;
struct image fixnf= {0};
struct image *xvnftab[MAX_NF];

int scrdepth;
unsigned long blackpixel, whitepixel;

unsigned char xtrans[NCOLOR];   /* table de transf. des valeurs sur ecran 8 bits */
unsigned char xtransi[NCOLOR]= {0};  /* table inverse */
struct trans_pix trans_pix[MAXTRANS];
int nb_trans_pix;
struct button *b_list[NBOUTONS]= {0};

int inverse= 0;
int cod_exit;
int loop_mode = 0;
char boxlabel[80];

/* pour definition de zones */
struct imagept zonept0= {0}, zonept1= {0};  /* zonept?.y = -1 si non defini */

/* edit */
struct imedit edit= {0};
struct imedit ed_rdpix= {0};
struct image *rd_nf[MAX_NF];
int off_rdpix;

struct edval edvals= {0};
struct imedval imedvals= {0};
int ed_lastbutton2=0;
struct imagept ed_oldima2;
unsigned long  ed_curcolor= 0xffffffff;  /* 4 octets identiques */

/* cursors */
int curs_new_type= 0, curs_type= 0, curs_prev_type= -1;
int curs_options= 0;
int curs_prev_size= -1, curs_size= 0;
struct screenpt curs_offset;

extern int xvopt_menu();
struct menu_item OPT_menulist[]= {
	{"256 colors",(OM_NBCOL) << 16 },
	{"254 colors",(OM_NBCOL << 16) | 1},
	{NULL,0},
	{"calcul min max",(OM_MMX << 16)},
	{NULL,0},
	{"move image with mouse-1",(OM_FOLLOW_M1 << 16)},
	{NULL,0},
	{"print points",(OM_PRINT << 16)},
	{"print pixel value",(OM_PRINT << 16) | 1},
	{NULL,0},
	{"print edit actions",(OM_EDP << 16)},
	{NULL,0},
	{"get pixel from file",(OM_PIXF << 16)},
	{"get pixel from file (float)",(OM_PIXF << 16) | 1},
	{NULL,0},
	{"show/modif file list",(OM_FILES << 16)},
	{NULL,0},
	{"display z horizontally",(OM_HZ << 16)},
	{NULL,0},
	{"Z-loop auto-reverse",(OM_ZLREVERSE << 16)},
	{"loop auto-reverse",(OM_LREVERSE << 16)},
	{NULL,0},
	{"horiz double cursor",(OM_CURSOR << 16)},
	{"define double cursor",(OM_CURSOR << 16) | 1},
	{"use dble curs. in edit",(OM_CURSOR << 16) | 2},
	{NULL,0},
	{"text with background",(OM_TXTFOND << 16)},
	{NULL,0},
	{"debug mode",(OM_DEBUG << 16)},
};
#define NBOPTS (sizeof(OPT_menulist)/sizeof(struct menu_item))
long OPT_wlist[NBOPTS];
struct xvmenu OPT_menu= {
	"OPT","options","",xvopt_menu,NBOPTS,OPT_menulist,OPT_wlist};
struct opt_tab options[NBOPTS];
int nb_opts= NBOPTS;

extern int b_next(), b_files(), b_exit(), b_loop(), b_prev(), b_step(), b_help(), b_same(), b_cmap(), b_edit(), b_zloop(), b_shell(), b_nextz(), b_prevz(), b_nextv(), b_prevv(), b_upleft(), b_center();
extern char *m_next[], *m_files[], *m_exit[], *m_loop[], *m_prev[], *m_step[], *m_help[], *m_same[], *m_cmap[], *m_edit[], *m_zloop[], *m_shell[];
extern char *m_dump[], *m_nextz[], *m_prevz[], *m_nextv[], *m_prevv[], *m_upleft[], *m_center[];
extern int ev_noop();
extern int bd_dump();
extern int bd_fill(), bd_clear(), bd_set(), bd_inv(), bd_copy(), bd_paste(), bd_undo(), bd_ptext();
extern int close_help();

struct button buttons[NBOUTONS] = {
	{0,"Files *",NULL,m_files,B_NOM,0,0,0,(long *)1},
	{0,"EXIT",b_exit,m_exit,B_EXIT,0,0,0,0},
	{0,"Loop",b_loop,m_loop,B_LOOP,0,0,0,(long *)-1},
/*	{0,"stop",b_step,m_step,B_STEP,0,0,0,0}, */
	{0,"Next",b_next,m_next,B_NEXT,0,0,0,0},
	{0,"HELP",b_help,(char **)-1,B_HELP,0,0,0,0},
	{0,"Prev",b_prev,m_prev,B_PREV,0,0,0,0},
	{0,"re-Read",b_same,m_same,B_SAME,0,0,0,0},
	{0,"COLORS",b_cmap,m_cmap,B_CMAP,0,0,0,(long *)-1},  /* toggle */
	{0,"Edit",b_edit,m_edit,B_EDIT,0,0,0,0},
	{0,"Z-Loop",b_zloop,m_zloop,B_ZLOOP,0,0,0,(long *)-1},  /* toggle button */
	{0,"Nextz",b_nextz,m_nextz,B_NEXTZ,0,0,0,0}, 
	{0,"Prevz",b_prevz,m_prevz,B_PREVZ,0,0,0,0}, 
	{0,"Nextv",b_nextv,m_nextv,B_NEXTV,0,0,0,0}, 
	{0,"Prevv",b_prevv,m_prevv,B_PREVV,0,0,0,0}, 
	{0,"Upleft",b_upleft,m_upleft,B_UPLEFT,0,0,0,0}, 
	{0,"Center",b_center,m_center,B_CENTER,0,0,0,0}, 
	{0,"SHELL",b_shell,m_shell,B_SHELL,0,0,0,0},
	{0,"Options ->",NULL,NULL,B_OPTS,0,0,-1,(long *)&OPT_menu},
	};
struct button labels[LBOUTONS]= {
	{0,"vmin=    , vmax=    ",ev_noop,NULL,L_MMX,0,0,0,0},
	{0,"X      Y            ",ev_noop,NULL,L_XY,0,0,0,0},
	{0,"                ",ev_noop,NULL,L_PARAM,0,0,0,0},
	{0,"                                         ",ev_noop,NULL,L_NOM,0,0,0,0},
	{0,boxlabel,ev_noop,NULL,L_BOX,0,0,0,0},
};
struct button *l_list[LBOUTONS] = {labels, &labels[1], &labels[2], &labels[3], &labels[4]};

struct button dumps[]= {
	{0,"dump",bd_dump,m_dump,0,0,0,0,0},
};
struct button *l_dump[]= {dumps};

struct button btn_help[]= {
	{0,"close",close_help,NULL,0,0,0,0,0},
};
struct button *lbtn_help[]= {btn_help};


extern char *m_clear[], *m_set[], *m_inv[], *m_copy[], *m_paste[], *m_pmode[], *m_undo[], *m_umode[];
extern struct xvmenu GX_menu, undo_menu;

/* I_PTEXT doit etre l'indice du bouton "paste text" */
struct button bcutp[]= {
	{0,"clear",bd_clear,m_clear,0,0,0,0,0},
	{0,"set",bd_set,m_set,0,0,0,0,0},
	{0,"invert",bd_inv,m_inv,0,0,0,0,0},
	{0,"fill",bd_fill,m_inv,0,0,0,0},
	{0,"copy",bd_copy,m_copy,0,0,0,0,0},
	{0,"paste",bd_paste,m_paste,0,0,0,0,0},
	{0,"paste text",bd_ptext,NULL,0,0,0,0,0},
	{0,NULL,NULL,m_pmode,0,0,0,0,(long *)&GX_menu},
	{0,NULL,NULL,m_umode,0,0,0,0,(long *)&undo_menu},
	{0,"undo",bd_undo,m_undo,0,0,0,0,0},
};
struct button *l_bcutp[]= {&bcutp[0],&bcutp[1],&bcutp[2],&bcutp[3],&bcutp[4],&bcutp[5],&bcutp[6],&bcutp[7],&bcutp[8],&bcutp[9]};
int nbt_cutp= sizeof(bcutp) / sizeof(struct button);
struct button *pbt_undo= &bcutp[9];


char imagelabel[80], paramslabel[80], coordlabel[80], mmxlabel[40];
int Nboutons= NBOUTONS;
int im_w, im_h;	/* taille image en pixels*/
int im_w1;  /* largeur ligne pour 1 plan (= im_w si display vertical) */
int im_w1v;  /* largeur ligne pour 1 composante vect (NDIMX) */
int im_wb, im_w1b;  /* taille en bytes pour ligne affichee et pour lire 1 ligne de plan */
int im_nbv;  /* nb de composantes par vect : on les separes horizontalement a l'affichage */
int old_im_w= 0, old_im_h= 0;
int  im_size;  /* taille buffer pour 1 plan d'image */
int im_h1, im_nz;  /* nb of effective lines /z, nb of z : tires de lfmto */
int im_nrowz, im_ncolz;  /* nb lignes et de colonnes de plans */
int im_last_ncolz;  /* nb de colonnes z dans derniere ligne de plans */
int im_lastw, im_lasth;  /* limites en x et y de la derniere ligne de plans */
