/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#ifndef X11R2
#ifndef X11R3
#define X11R4
#endif
#endif
#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <sys/time.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
/*#include <X11/ResourceI.h> */
#if defined X11R3 || defined X11R4
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/X.h>
#include <X11/Xproto.h>
#else
#include <X11/Atoms.h>
#endif
#ifdef X11R4
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Viewport.h>
#else
#include <X11/VPaned.h>
#include <X11/Label.h>
#include <X11/Command.h>
#include <X11/Box.h>
#include <X11/Dialog.h>
#include <X11/AsciiText.h>
#include <X11/Viewport.h>
#endif
#if defined X11R3 
#include <X11/MenuBox.h>
#include <X11/MenuShell.h>
#include <X11/Menu.h>
#endif
#ifdef X11R4
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#endif
#include <inrimage/image.h>
#include <inrimage/error.h>
#include "xvis.h"
#include "xvglobl.h"
#include "xvxglobl.h"

extern void xvimage_menu();
void xvimage_menu1();

static char menu_name[]= "Images";
static Widget my_imenu= NULL;

static int nbmenus, nbrest, lgmenu;
/* initialise les menu de noms d'images */
init_im_menu() 
{
	register long i, n;
	if(!im_opfiles) return 1 /* makes c99 happy */;
	if(flg_nu || flg_edit || (n = nbim / (im_opfiles)) <= 0) return 1 /* makes c99 happy */;
	if(n <= MAX_IMENU_SIZE) {
		init_im0_menu();
		return 0;
	}
	nbmenus = (n + MAX_IMENU_SIZE -1) / MAX_IMENU_SIZE;
	lgmenu = n / nbmenus;
	nbrest = n % nbmenus;
	if(nbmenus > MAX_SUBMENUS)
		nbmenus = MAX_SUBMENUS;
	init_im1_menu();
}

init_im0_menu() 
{
#if defined X11R3 || defined X11R4
	Widget w;
	Arg args[3];
	XtTranslations buttontrans;
	register long i;
	w = (Widget)b_list[B_NOM]->b_win;
	XtSetArg(args[0],XtNmenuName,menu_name);
	XtSetValues(w,args,1);
	XtSetArg(args[0],XtNlabel,menu_name);
	XtSetArg(args[1], XtNvisual, mydefvisual);
	XtSetArg(args[2], XtNcolormap, defcmap);
	if(my_imenu)
		XtDestroyWidget(my_imenu);
	my_imenu = XtCreatePopupShell(menu_name, simpleMenuWidgetClass, w,args, 3);
	for(i=0;i<nbim;i += im_opfiles) {
		Widget entry;
		entry = XtCreateManagedWidget(inr_basename(tabim[i]),smeBSBObjectClass,my_imenu,NULL, 0);
		XtAddCallback(entry, XtNcallback,xvimage_menu, (XtPointer)(i+1));
	}
	XtRealizeWidget(my_imenu);
	XtSetArg(args[0],XtNtranslations,&buttontrans);
	XtGetValues(w,args,1);
	b_list[B_NOM]->b_im_norm = (long *)buttontrans;
#endif
}

static char imenuTrans[]=
"<EnterWindow>:highlight()\n\
<LeaveWindow> : notify()unhighlight()\n\
<BtnMotion>:  highlight()\n\
<BtnUp>:  MenuPopdown() unhighlight()\n";

static char i2menuTrans[]=
"<EnterWindow>:highlight()\n\
<LeaveWindow> : MenuPopdown() unhighlight()\n\
<BtnMotion>:  highlight()\n\
<BtnUp>:  MenuPopdown()notify() unhighlight()\n";

/* initialise les menus de menus de nom d'images */
init_im1_menu() 
{
#if defined X11R3 || defined X11R4
	char *p1;
	char tmp[16];
	Widget w;
	Arg args[3];
	XtTranslations buttontrans, parsed_trans;
	register i, j, lg, j2;
	parsed_trans = XtParseTranslationTable(imenuTrans);
	w = (Widget)b_list[B_NOM]->b_win;
	XtSetArg(args[0],XtNmenuName,menu_name);
	XtSetValues(w,args,1);
	XtSetArg(args[0],XtNlabel,menu_name);
	XtSetArg(args[1], XtNvisual, mydefvisual);
	XtSetArg(args[2], XtNcolormap, defcmap);
	if(my_imenu)
		XtDestroyWidget(my_imenu);
	my_imenu = XtCreatePopupShell(menu_name, simpleMenuWidgetClass, w,args, 3);
	j = 0;
	strcpy(&tmp[3],".. ");
	strcpy(&tmp[9],".. =>");
	tmp[14] = 0;
	for(i=0;i<nbmenus;i++) {
		Widget entry;
		lg = i < nbrest ? lgmenu+1 : lgmenu;
		j2 = j + im_opfiles * lg;
		p1 = inr_basename(tabim[j]);
		strncpy(tmp,p1,3);
		p1 = inr_basename(tabim[j2 -1]);
		strncpy(&tmp[6],p1,3);
		entry = XtCreateManagedWidget(tmp,smeBSBObjectClass,my_imenu,NULL, 0);
		XtAddCallback(entry, XtNcallback,xvimage_menu1, (XtPointer)(i+1));
		init_im2_menu(entry,i,j,lg);
		j = j2;
	}
	XtRealizeWidget(my_imenu);
	XtOverrideTranslations(my_imenu,parsed_trans);
	XtSetArg(args[0],XtNtranslations,&buttontrans);
	XtGetValues(w,args,1);
	b_list[B_NOM]->b_im_norm = (long *)buttontrans;
#endif
}


Widget im_submenus[MAX_SUBMENUS]= {0};
init_im2_menu(w0,ix,i0,nb)
Widget w0;
register ix, i0, nb;
{
	Widget w, mw;
	Arg args[3];
	XtTranslations parsed_trans;
	register i, j;
	parsed_trans = XtParseTranslationTable(i2menuTrans);
	w = (Widget)b_list[B_NOM]->b_win;
/*	w = w0; */
	XtSetArg(args[0],XtNlabel,"...");
	XtSetArg(args[1], XtNvisual, mydefvisual);
	XtSetArg(args[2], XtNcolormap, defcmap);
	if(mw = im_submenus[ix])
		XtDestroyWidget(mw);
	im_submenus[ix] = mw = XtCreatePopupShell("...", simpleMenuWidgetClass, w,args, 3);
	j = i0;
	for(i=0;i<nb;i++) {
		Widget entry;
		entry = XtCreateManagedWidget(inr_basename(tabim[j]),smeBSBObjectClass,mw,NULL, 0);
		XtAddCallback(entry, XtNcallback,xvimage_menu, (XtPointer)(j+1));
		j += im_opfiles;
	}
	XtRealizeWidget(mw);
	XtOverrideTranslations(mw,parsed_trans);
}

void xvimage_menu1(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register i;
	i = (long)cl_data -1;
	if(debug_)
		fprintf(stderr,"menu1 (%d) image %s\n",i,tabim[i]);
		
		pop_menu2(w,i);
}
void xvimage_menu2(w,cl_data,data)
Widget w;
caddr_t cl_data, data;
{
	register i;
	i = (long)cl_data -1;
/*	if(debug_) */
		fprintf(stderr,"menu2 (%d) image %s\n",i,tabim[i]);
		
}

pop_menu2(w,i)
Widget w;
register i;
{
	Arg args[3];
	Widget mw;
	Position button_x, button_y;
	Dimension m_w;
	int menu_x, menu_y;
	int num_args;
	XtSetArg(args[0],XtNwidth,(XtArgVal)&m_w);
	XtGetValues(w,args,1);
	XtTranslateCoords(w, 0, 0, &button_x, &button_y);
	menu_x = button_x + m_w;
	menu_y = button_y;

	if (menu_x < 0)
		menu_x = 0;
	if (menu_y < 0)
		menu_y = 0;

	num_args = 0;
	XtSetArg(args[num_args], XtNx, menu_x); num_args++;
	XtSetArg(args[num_args], XtNy, menu_y); num_args++;
	mw = im_submenus[i];
	XtSetValues(mw, args, num_args);

	XtPopupSpringLoaded(mw);

	XFlush(dpy);
}
