/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

/** affichage d'images sous X11
*/
#include <X11/Xlib.h>
#include "imPcodes.h"
#include <stdio.h>
#include <inrimage/image.h>
#include <ctype.h>
#include "xvis.h"
#include "xvglobl.h"

#include <stdlib.h>
#include <string.h>
#include <signal.h>

/* for KHOROS mode */
static char Ucmd0[]=
"-nu [-nopix] [-p pas] [-zp Zpas] [-iz n] [-nz n][-iv n] [-nv n] [-hz nbhz][-zloop [-zl rep]] [-e exp][-d depth] [-col | -col1] [-tcf | -tc colors-file | -tced | -tcedr][-c254][-sh script_file | -xsh exec_script_file][-shargs script-args][-Wsh][-Wcol][-Whelp] [file1 ... filen]\n";
static char Ucmd1[]=
"-ed [-nopix] [-p pas] [-zp Zpas] [-iz n] [-nz n][-iv n] [-nv n] [-hz nbhz] [-e exp] [-d depth] [-col | -col1] [-tcf | -tc colors-file | -tced | -tcedr][-c254][-sh script_file | -xsh exec_script_file][-shargs script-args][-Wsh][-Wcol][-Whelp] image-in image-out\n";
static char Ucmd2[]=
"-grey [-nopix] [-p pas] [-zp Zpas] [-iz n] [-nz n][-iv n] [-nv n] [-hz nbhz] [-e exp] [-d depth] [-tcf | -tc colors-file | -tced | -tcedr][-c254][-sh script_file | -xsh exec_script_file][-Wsh][-Wcol][-Whelp] [file1 ... filen]\n";
static char Ucmd3[]=
" -col [-nopix] [-p pas] [-zp Zpas] [-iz n] [-nz n][-iv n] [-nv n] [-hz nbhz] [-zloop] [-zl rep] [-e exp] [-d depth] [-l n][-tcf | -tc colors-file | -tced | -tcedr][-c254][-sh script_file | -xsh exec_script_file][-shargs script-args][-Wsh][-Wcol][-Whelp] image-R image-G image-B\n";
static char Ucmd4[]=
"-col1 [-nopix] [-p pas] [-zp Zpas] [-iz n] [-nz n][-iv n] [-nv n] [-zloop] [-zl rep] [-e exp] [-d depth] [-l n] [-tcf | -tc colors-file | -tced | -tcedr][-c254][-sh script_file | -xsh exec_script_file][-shargs script-args][-Wsh][-Wcol][-Whelp] [color-image ... color-image]\n";

static char Ucmd[]=
"[-D] [-k octets] [-nu | -nulab] [-nopix] [-P] [-s matrix_size] [-p pas][-grp nbim][-hz nbhz] [-zp Zpas] [-iz n] [-nz n] [-zloop] [-zl rep] [-e exp] [-d depth] [-l n] [-f[null] dimx dimy [-fz dimz][-fv dimz]] [-grey | -col[rvb] | -col1[rvb]] [-tcn | -tcf | -tc colors-file | -tced | -tcedr][-c254 | -Xtc][-[x]sh| -[x]csh|-[x]perl| -[x]bash script_file][-shargs script-args][-Wsh][-Wcol][-Whelp][-ed[p] image-in image-out | file1 ... filen]\n";
static char Udetail[]=
"\t-D:\t debug mode\n\
\t-k octets :\t taille en k octets du tableau de lecture des donnees (def 300)\n\
\t-s matrix_size :\t taille du pavage (3 par defaut)\n\
\t-p pas :\t pas d'echantillonnage (def 1); pas <0 = zoom\n\
\t-grp nbim : regroupe nbim images en 1 image multiplan\n\
\t-iv n, -nv n: numero 1er composante et nb composantes a voir\n\
\t-zp Zpas :\t pas d'echantillonnage en Z\n\
\t-iz n, -nz n: numero 1er plan et nb plans a voir\n\
\t-hz nbhz: horizontal-z : display planes horizontally (nbhz by row, 0 = all)\n\
\t-P:\t par courbe de Peano (-s = zoom)\n\
\t-e exp : diviser l'image par 2**exp\n\
\t-f[null] dimx dimy: images sans header (dimx * dimy, event. -fz dimz, -fv dimv)\n\
\t\t-fnull => pseudo image nulle (pas de fichier)\n\
\t-grey : images en niveaux de gris\n\
\t-col[rvb]: vraie couleur en 3 images\n\
\t-col1[rvb]:vraie couleur en 1 fichier (ndimv ou ndimz ==3. option par defaut)\n\
\t-ed[p] in out:  edition de 'in' avec resultat dans 'out', print stdout si -edp\n\
\t-zloop: z-loop sur 1e image\n\
\tfile1...filen:  liste de fichiers images (types et tailles quelconques)\n\
\t\t\t images lues sur stdin si liste de noms vide\n\
\t-tcn: tables couleurs normales (lineaires)\n\
\t-tced: tables couleur pour edit (edition en vert)\n\
\t-tcedr: tables couleur pour edit (edition en rouge)\n\
\t-tcf : tables couleur dans fichier image (option par defaut)\n\
\t-tc file: chargement tables couleur a partir de file (3 t.c. si 3 lignes)\n\
\t-c254 : utiliser 254 couleurs sur 256\n\
\t-Xtc : utiliser la tbale couleur X courante\n\
\t-sh|-csh|-perl|-bash script_file:  chargement d'un script et choix de l'interpreteur\n\
\t-xsh|-xcsh|-xperl|-xbash script_file: le script est execute\n\
\t-Wsh, -Wcol, -Whelp: ouverture des fenetres xvis-shell, xvis-cmap, xvis-help\n\
\t-shargs args: arguments passes au script\n\
\t-nu -nulab : affichage image seule (avec label si -nulab)\n\
\t-l n :\t temps d'attente entre 2 affichages (defaut 0 sec.)\n";

static struct multi_cmd cmds[] = {
	"-nu",Ucmd0,Udetail,	/*  1 */
	"-ed",Ucmd1,Udetail,	/*  2 */
	"-grey",Ucmd2,Udetail,	/*  3 */
	"-col",Ucmd3,Udetail,	/*  4 */
	"-col1",Ucmd4,Udetail,	/*  5 */
	"",Ucmd,Udetail,	/*  default */
	0,0,0,
};

extern char xv_version[];

int XV_simul= 0;  /* 1 pour simuler 8 bits sur bitmap */
#define NEWDIMX (echan(NDIMX) * nbv)

int win_argc;
char **win_argv;
#define DEFSIZE 3

static int sdepth;
extern int koctet_, debug_;


short bsize1, lgly, lgtab;

static int zero= 0, un= 1;

struct imagemap hdr;
int ngly;

unsigned char *ppdecal[8];
static unsigned char maskval[8], maskcomp[8];
unsigned char flg_debo[8];

extern int khoros_mode;

extern errno;


int simbit();
extern int cod_exit;

char nstdi[]= "<";


#define MAXW 512
#define MAXH 512
static int first;

static int optcol_type= I_ZCOL;  /* I_MONO;  /* color type demande */
#define SHARGS_LEN 2048
char opt_shargs[SHARGS_LEN]; /* les args du script shell */

void sig_next();

main(argc,argv)
int argc;
char **argv;
{
	register i, c;
	register unsigned char *ptb;
	g_size = 0;
	zloop_int = 1;
	loop_int = 0;
	cpt_zloop = 0;
	file_type = nbim= 0;
	koctet_ = 500;
	im_nbfiles = 0;
#if 0
	optcol_type = I_MONO;
#else
	optcol_type = I_ZCOL;
#endif
/*	inr_init(argc,argv,xv_version,Ucmd,Udetail); */
	inr_initm(argc,argv,xv_version,cmds);
	if(!khoros_mode)
		fprintf(stderr,"%s %s\n",xargv[0],xv_version);
	else 
		igetopt0("-grey");
	igetopt1("-d","%d",&Req_depth);
	igetopt1("-s","%d",&g_size);
	igetopt1("-p","%d",&opt_pas);
	igetopt1("-grp","%d",&nbim_group);
	igetopt1("-zp","%d",&zpas);
	igetopt1("-e","%d",&vis_exp);
	if(zpas <= 0) zpas = 1;
	igetopt1("-iz","%d",&deb_plan);
	if(deb_plan <= 0) deb_plan = 1;
	igetopt1("-nz","%d",&nb_plan);
	igetopt1("-iv","%d",&deb_vcomp);
	if(deb_vcomp <= 0) deb_vcomp = 1;
	igetopt1("-nv","%d",&nb_vcomp);
	if(!(flg_Xtc = igetopt0("-Xtc")))
		flg_c254 = opt_c254 = igetopt0("-c254");
	opt_z_horiz = igetopt1("-hz","%d",&opt_nb_hz);
	if(opt_z_horiz) {
		nb_hz = opt_nb_hz;
#if 0
		if(opt_nb_hz == 1)
			opt_z_horiz = 0;
		else {
			if(opt_nb_hz <= 0)
				nb_hz = 100000;
		}
#else
		if(opt_nb_hz <= 0)
			nb_hz = 100000;
#endif
	}
	flg_z_horiz = opt_z_horiz;
	fl_peano = igetopt0("-P");
	flg_Wins = 0;
	if(igetopt0("-Wsh"))
		flg_Wins |= FLG_WSH;
	if(igetopt("-Wcol","",0,"",0,"",0))
		flg_Wins |= FLG_WCOL;
	if(igetopt("-Whelp","",0,"",0,"",0))
		flg_Wins |= FLG_WHELP;
	flg_nu = 0;
	if(igetopt0("-nu"))
		flg_nu = -1;
	else if(igetopt0("-nulab"))
		flg_nu = 1;
	flg_fix = 0;
	if(igetopt2("-f","%d",&fdimx,"%d",&fdimy)) {
		flg_fix = 1;
	} else if(igetopt2("-fnull","%d",&fdimx,"%d",&fdimy)) {
		flg_fix = -1;
	}
	if(flg_fix) {
		igetopt1("-fz","%d",&fdimz);
		igetopt1("-fv","%d",&fdimv);
	}
	flg_nopix = gflg_nopix = igetopt0("-nopix");
	igetopt1("-l","%d",&loop_int);
	igetopt1("-zl","%d",&zloop_int);
	flg_zloop = igetopt0("-zloop");
	if(igetopt1("-sh","%s",sh_filename))
		shflg_shell = SH_SH;
	else if(igetopt1("-xsh","%s",sh_filename)) {
		shflg_shell = SH_SH;
		flg_xsh = -1;
	} else if(igetopt1("-csh","%s",sh_filename))
		shflg_shell = SH_CSH;
	else if(igetopt1("-xcsh","%s",sh_filename)) {
		shflg_shell = SH_CSH;
		flg_xsh = -1;
	} else if(igetopt1("-perl","%s",sh_filename))
		shflg_shell = SH_PERL;
	else if(igetopt1("-xperl","%s",sh_filename)) {
		shflg_shell = SH_PERL;
		flg_xsh = -1;
	} else if(igetopt1("-bash","%s",sh_filename))
		shflg_shell = SH_BASH;
	else if(igetopt1("-xbash","%s",sh_filename)) {
		shflg_shell = SH_BASH;
		flg_xsh = -1;
	}
	/* arg de script */
	if(igetopt1("-shargs","%[^\n]",opt_shargs)) {
	  if(strlen(opt_shargs) >= SHARGS_LEN)
	    imerror(9,"Argument trop long (>2048) pour -shargs");
	}
	if(zloop_int < 0) {
		flg_rv_zloop = 1;
		zloop_int = -zloop_int;
	} else if(zloop_int < 1) zloop_int = 1;
	if(igetopt0("-ed"))
		flg_edit = 1;
	else if(igetopt0("-edp")) {
		flg_edit = 1;
		flg_pr_edit = 1;
	}
#if 0
	cmap_type = CMAP_LIN;
#else
	cmap_type = CMAP_IMAGE;
#endif
	if(igetopt1("-tc","%s",tcfile)) {
		cmap_type = CMAP_FILE;
	} else {
		if(igetopt0("-tced")) {
			cmap_type |= CMAP_EDG;
		} else if(igetopt0("-tcedr")) {
			cmap_type |= (CMAP_ED | CMAP_EDR);
		} else if(igetopt0("-tcn")) {
			cmap_type = CMAP_LIN;
		} else if(igetopt0("-tcf"))
			cmap_type = CMAP_IMAGE;
	}
	tcordre[0] = 0;
	if(igetopt0("-grey"))
		optcol_type = I_MONO;
	else if(igetopt0("-col1") || igetopt0x("-col1","%s",tcordre)) {
		optcol_type = I_ZCOL;
	} else if(igetopt0("-col") || igetopt0x("-col","%s",tcordre)) {
		optcol_type = I_3COL;
	}
	init_ctabs();  /* init c.t. pointers */
	initwin_args();
	sdepth = xvinit(&win_argc,win_argv);
	rmwin_args();  /* reset normal args */
	if(nbim_group <= 1)
		nbim_group = 0;
#if 0
	else if(nbim_group > MAX_NF) {
		fprintf(stderr,"max group size is %d\n",MAX_NF);
		nbim_group = MAX_NF;
	}
#endif
	if(flg_nopix) {
		if(flg_edit || (sdepth == 1))
			imerror(9,"-nopix incompatible avec options choisies\n");
	}
	if(flg_z_horiz && ((sdepth == 1) || flg_nopix))
		imerror(9,"option -hz not allowed on 1 bit display or with -nopix");
	if(nbim_group) {
		if(sdepth == 1)
			imerror(9,"option -grp not allowed on 1 bit display");
		if(flg_edit)
			imerror(9,"option -grp not allowed in edit mode");
	}
	if(optcol_type > 0) {  /* images vraie couleur */
		if(flg_fix && (optcol_type & I_3COL)) {
			fprintf(stderr,"-col n'est autorise qu'avec des images inrimage\n");
			Usage();
		}
		if(optcol_type == I_3COL)
			im_nbfiles = 1;
		if((i = strlen(tcordre)) > 0) {
			if(optcol_type == I_3COL)
				im_nbfiles = 2;
			if(i != 3) Usage();
			col_order[0] = 0xff;
			col_order[1] = 0xff;
			col_order[2] = 0xff;
			for(i=0;i<3;i++) {
				c = tcordre[i] | 0x20;
				switch (c) {
				case 'r':
					col_order[i] = C_ROUGE;
					break;
				case 'v':
				case 'g':
					col_order[i] = C_VERT;
					break;
				case 'b':
					col_order[i] = C_BLEU;
					break;
				}
			}
			if(col_order[0] == 0xff || col_order[1] == 0xff || col_order[2] == 0xff)
				Usage();
		}
	}
	getfiles();
	if(tstopts())
		Usage();
	if((flg_fix < 0) && (nbim > 0)) {
		fprintf(stderr,"No filenames allowed with -fnull\n");
		Usage();
	}
	init_file_list();
	/* lecture tables couleur */
	if((sdepth > 1) && !flg_Xtc)
		initcmap();  /* init t.c. */ 
	first = 1;
	flg_initw = 1;
	initxwin(first,sdepth);
/*	trt_image(); */
	signal(SIGHUP,sig_next);
	if(flg_Wins & FLG_WSH)
		xvsh_create();
	if(flg_Wins & FLG_WCOL)
		pop_cmap();
	if(flg_Wins & FLG_WHELP)
		b_help();
	xvis_loop();
	xtermine();
}

/** lecture des tables couleur
3 tables couleur si DIMY du fichier >= 3
   (3 lignes du meme fichier : R V B) */
read_colors()
{
	int i0, nb;
	register n;
	if(!(cmap_type & CMAP_FILE)) return 1 /* makes c99 happy */; 
	if(nfcolor)
		fermnf_(&nfcolor);
	nfcolor = image_(tcfile,"e","",lfmtcol);
	n = ird_ctfile(nfcolor,&i0,&nb,(char *)*(pp_cur_ct + C_ROUGE),(char *)*(pp_cur_ct + C_VERT),(char *)*(pp_cur_ct + C_BLEU),NCOLOR);
	fermnf_(&nfcolor);
}

/**affichage de l'image courante */
trt_image()
{
	register i;
	register struct image *nf;
	int i0, nb;
	int vcomp0;
	register maxz;
/*!!	malloc_debug(2);  pour tests */
	g_open(xvnftab,ptim,"e","",lfmt,1);
	init_params();
	nf = xvnftab[0];
	if(sh_filename[0] && flg_xsh)
		auto_xsh();
	if(first) {
		if(nbim == 0 && ispipe_(xvnftab))
			file_type = PIPE;
	}
	if(!first && (file_type & PIPE)) {
		if(!flg_fix) {
			if(init_nf(nf,nf->f_type) <= 0) return QUIT;
		} else
			finitnf();
		for(i=0;i<9;i++)
			lfmt[i] = nf->lfmt[i];
	}
	if(sdepth > 1) {
		fl_peano = 0;
		g_size = 1;
	}
	if(fl_peano || (BSIZE == -1 && TYPE< 0)) {
		if(g_size == 0) g_size = 1;
	}
	if(g_size == 0) g_size = DEFSIZE;
	if(nbim_group) {
		deb_plan = 1;
		zpas = 1;
		maxz = nbim_group;
	} else
		maxz = NDIMZ;
	if(deb_plan <= 0)
		deb_plan = 1;
	if(deb_plan >= maxz) {
		iz0 = maxz -1;
		nbz = 1;
	} else {
		iz0 = deb_plan -1;
		if(nb_plan <= 0 || nb_plan > (maxz - iz0))
			nbz = maxz - iz0;
		else
			nbz = nb_plan;
	}
	if(NDIMV > 1) flg_sep_comp = 1;
	if(deb_vcomp <= 0) deb_vcomp = 1;
	vcomp0 = deb_vcomp;
	if(vcomp0 >= NDIMV) {
	  vcomp0 = NDIMV - 1;
	  nbv = 1;
	} else {
	  iv0 = vcomp0 - 1;
	  if(nb_vcomp <= 0 || nb_vcomp > (NDIMV - iv0))
	    nbv = NDIMV - iv0;
	  else
	    nbv = nb_vcomp;
	}
	if(fl_peano) {
		lfmt1[I_NDIMX] = lfmt1[I_DIMX] = echan(DIMX);
		lfmt1[I_NDIMY] = echan(NDIMY);
		lfmt1[I_NDIMV] = 1;
		lfmt1[I_NDIMZ] = zechan(nbz);
		lfmt1[I_DIMY] = lfmt1[I_NDIMY] * lfmt1[I_NDIMZ];
		lfmt1[I_BSIZE] = BSIZE;
		lfmt1[I_TYPE] = TYPE;
		lfmt1[I_EXP] = lfmt[EXP];
		init_peano(g_size,lfmt1,lfmto);
	} else {
		if(sdepth == 1) {
#ifndef USE_IMGLY
		  imerror(9,"ecrans 1 bit avec -P seulement\n");
#else
			get_imgly(g_size,&hdr);
			ngly = hdr.nb_gly;
			bsize1 = (g_size + 7) >> 3;
			lgly = bsize1 * g_size;
			lgtab = lgly * ngly;
#endif
		}
		lfmto[I_NDIMX] = echan(NDIMX) * g_size;
		lfmto[I_DIMX] = lfmto[I_NDIMX] * nbv;
		lfmto[I_NDIMY] = echan(NDIMY) * g_size;
		lfmto[I_NDIMZ] = zechan(nbz);
		lfmto[I_DIMY] = lfmto[I_NDIMY] * lfmto[I_NDIMZ];
		lfmto[I_BSIZE] = lfmto[I_TYPE] = -1;
		lfmto[I_NDIMV] = nbv;
		lfmto[I_EXP] = 0;
		truecol_type = optcol_type;
		if(truecol_type & I_1COL) {
			if(NDIMV == 3 && nbv == 3) {
				truecol_type = I_VCOL;
				flg_sep_comp = 0;
				lfmto[I_NDIMV] = 1;
				lfmto[I_NDIMX] = echan(NDIMX) * g_size;
				lfmto[I_DIMX] = lfmto[I_NDIMX];
			} else if((NDIMZ == 3) && !nbim_group) {
				truecol_type = I_ZCOL;
				lfmto[I_NDIMZ] = 1;
				lfmto[I_DIMY] = lfmto[I_NDIMY];
			} else
				truecol_type = I_MONO;
		}
	}
	if(fflg_nopix) {
		flg_nopix = 1;
		fflg_nopix = 0;
	} else
		flg_nopix = gflg_nopix;
	set_initial_ct(1);  /* set initial color map */
	initwin(lfmt,lfmto,first,sdepth);
	if(flg_nopix) {
		if(flg_edit || (sdepth == 1))
			imerror(9,"-nopix incompatible avec options choisies\n");
	}
	first = 0;
	cpt_zloop = zloop_int;
	allocbufs();
	clear_edit();
	clear_rdpix();
	if(flg_edit)
		init_edvals();
#ifdef USE_IMGLY
	if(!fl_peano) {
		if(sdepth == 1) prpgly();   /* mise en forme table des glyph */
	}
#endif
	do_image(xvnftab,lfmt);
	xvset_tc();
	g_close();
	return NOOP;
}

#ifdef USE_IMGLY
/*   remise en forme des glyphs :  cadrage a droite (pas d'inversion)
    construction table de pointeurs ( 1 ptr vers glyph pour chaque valeur de
    pixel entre 0 et 255)
   construction des tables de compactage sur 8 bits :
     pour chaque valeur possible d'une ligne de glyph (0-2**size),
     on calcule les 2*8 valeurs a mettre dans un char resultat
     pour les 8 positions possibles du 1e bit du pixel dans le char
     Tient compte de la table couleur definie dans tab_cou[].
 */
prpgly()
{
	register unsigned char *ptb, *pc;
	register nshft, mask, i, j, n, v;
	i_Free((char **)&ptabgly);
	ptb = bufmap;
	nshft = 8 - g_size;
	for(i=0;i<ngly;i++) {
		pc = ptb;
		for(j=0;j<lgly;j++) {
			*pc = *pc  >> nshft;
			pc++;
		}
		ptb += lgly;
	}
	pc = *pp_X_ct;
	for(i=0;i<NCOLOR;i++) {
		j = *(pc + i);
		pglyph[i] = bufmap + (hdr.g_memb[j] * lgly);
	}
	if(g_size >= 8) return;
	n = 1 << g_size;  /* 2**size */
	i = 8 * 2 * n;  /* nb de valeurs possibles (sur 16 bits)*/
	ptb = (unsigned char *) xvmalloc(i);
	ptabgly = ptb;
	pc = ptb;
	mask = (0xff00 >> g_size) & 0xff;
	for(i=0;i<8;i++) {
		maskval[i] = (unsigned char) mask;
		maskcomp[i] = ~maskval[i];
		mask >>= 1;
		if(i < (8 - g_size))
			flg_debo[i] = 0;
		else
			flg_debo[i] = 1;
		flg_debo[8 - g_size] = 2;

	}
	for(i=0;i<8;i++) {
		ppdecal[i] = (unsigned char *)pc;
		for(j=0;j<n;j++) {
			nshft = j << (8 - g_size);
			v = (nshft >> i) | (nshft << (8-i));
			*pc++ = v;
		}
	}
}

#endif


do_image(nf,lfmt)
struct image **nf;
Fort_int lfmt[9];
{
	register i, n;	 /*nx= nb octets/ligne apres unpack */
	int nlig, nxo, nyo, n1;
	register unsigned char *bufout;
	int ndim;
	ndim = in_bufsize;
	numim1 = numim;
	b_list[cod_exit]->b_inv = 0;
	wrbutton(cod_exit);
	if(flg_mmx) {
		pixmin = -1;
		pixmax = -1;
	} else {
		pixmin = 0;
		pixmax = 255;
	}
	if(flg_fix < 0) {
		pixmin = 255;
		pixmax = 0;
		xzer_pixim();
	} else if(fl_peano) {
		vis1_peano(in_buffer,nf,lfmt);
	} else {
		if(sdepth == 1)
			nxo = (lfmto[I_DIMX] + 7) / 8;  /* nb de bytes par ligne */
		else
			nxo = lfmto[I_DIMX];
#if 0
		if((nlig = calcnlig(ndim,lfmt,&n1)) <= 0)
			imerror(8,"pas assez de memoire, utilisez option -k\n");
#else
		nlig = nblig_in;
#endif
		nyo = echan(nlig);
		if(truecol_type == I_ZCOL)
			vis1_zcol(in_buffer,nf,lfmt,nlig,nxo,nyo);
		else if(truecol_type == I_VCOL)
			vis1_vcol(in_buffer,nf,lfmt,nlig,nxo,nyo);
		else
			vis1_norm(in_buffer,nf,lfmt,nlig,nxo,nyo);
	}
	termine_pixmap();  /* terminer le remplissage si display z horiz */
	i_Free((char **)&ain_buffer);
	prp_mmx();
	wrt_label(L_MMX,mmxlabel);
 	xvisim();
	return 1 /* makes c99 happy */; 
}

vis1_peano(buf,nf,lfmt)
unsigned char *buf;
struct image **nf;
Fort_int lfmt[9];
{
	register i, nx;	 /*nx= nb octets/ligne apres unpack */
	int nl0,  nxo, nyo, n1;
	int nlg, np, y;
	int ncoup, nrest;
	int nz;
	int n, nlig;
	register unsigned char *p1, *p2;
	nx = DIMX * (BSIZE < 0 ? (-BSIZE +7) >> 3 : BSIZE);
	nxo = NEWDIMX;
	nlig = echan(NDIMY);
	n = (nlig - 1) * nxo;
	n1 = ((pas * nx) <= nxo) ? nxo : (pas * nx);
	n += n1 + 4;  /* !! pour etre toujours aligne */
	y = 0;
	if(flg_fix < 0) {
		xzer_pixim();
		return 1 /* makes c99 happy */; 
	}
	for(nz=iz0;nz<iz0+nbz;nz += zpas) {
		c_lptset(*nf,nz*NDIMY+1);
		p1 = p2 = buf;
		nlg = nlig;
		np = n;
		while(nlg > 0) {
			ncoup = np / n1;
			if(ncoup <= 0) xerr("??? pb in speano");
			if(ncoup > nlg) ncoup = nlg;
			nl0 = ncoup * pas;
			c_lect(*nf,nl0,p1);
			c_cnvvis(p1,p2,nl0,lfmt,vis_exp,0,0,pas);
			p2 += ncoup * nxo;
			p1 = (unsigned char *) ((unsigned long)(p2 + 3) & ~3);
			nlg -= ncoup;
			np -= ncoup * nxo;
		}
		applic_tc(buf,nxo * nlig,*pp_X_ct);
		zb_peano(out_buffer);  /* initialiser le buffer de sortie de Peano */
		ipeano(buf);
		xput_im(out_buffer,y,im_h1);
		y += im_h1;
	}
}

/*image normale : monochrome ou vraie couleur en 3 images */
vis1_norm(bufin,nf,lfmt,nlig,nxo,nyo)
unsigned char *bufin;
struct image **nf;
Fort_int lfmt[9];
int nlig, nxo, nyo;
{
	register i, y;	 /*nx= nb octets/ligne apres unpack */
	register nlg, nlgo, ntot;
	register nz;
	register n;
	int ntrue;
	int maxz;
	register unsigned char *bufout;
	y = 0;
	ntrue = flg_edit > 1 ? im_nbfiles + 1 : im_nbfiles;
	maxz = iz0+nbz;
	for(nz=iz0;nz < maxz;nz += zpas) {
		if(!nbim_group) {
			for(i=0;i<=ntrue;i++)
				c_lptset(*(nf+i),nz*NDIMY +1);
		} else if(nz > iz0) {
			g_open1(xvnftab,ptim1,"e","",lfmt,1);
		}
		bufout = (unsigned char *)out_buffer;
		n = nxo * nyo * (sdepth == 1 ? g_size : byte_pixel);  /* output lines are multiple of 16 bits*/
		ntot = NDIMY;
		nlg = nlig;
		nlgo = nblig_out;
		while (ntot > 0) {
			if(nlg > ntot) {
				nlg = ntot;
				nlgo = g_size * echan(nlg);
			}
			for(i=0;i<=ntrue;i++)
				docod(bufin,bufout,*(nf+i),nlg,i,i);
			if(flg_out_all) {
				bufout += n;
			} else {
				xput_im(out_buffer,y,nlgo);
				y += nlgo;
			}
			ntot -= nlg;
		}
		if(flg_out_all) {
			xput_im(out_buffer,y,im_h1);
			y += im_h1;
		}
		if(nbim_group) {
			if(nbim)
				ptim1 += ntrue + 1;
			g_close1();
		}
	}
}

/* image couleur avec composantes sur 3 plans meme fichier */
vis1_zcol(bufin,nf,lfmt,nlig0,nxo,nyo)
unsigned char *bufin;
struct image **nf;
Fort_int lfmt[9];
int nlig0, nxo, nyo;
{
	register i;
	register y, yz, iyo;
	register ntot, nlgo;
	register unsigned char *bufout;
	register n;
	register nlig;
	bufout = (unsigned char *)out_buffer;
	nlgo = nblig_out;
	if(flg_out_all) {
		n = nxo * nyo * (truecol_type == I_MONO ? g_size : byte_pixel);
		yz = flg_edit > 1 ? NDIMZ + 1 : NDIMZ;
		for(i=0;i<yz;i++) {
			ntot = NDIMY;
			nlig = nlig0;
			bufout = (unsigned char *)out_buffer;
			while (ntot > 0) {
				if(nlig > ntot)
					nlig = ntot;
				ntot -= nlig;
				if(i >= NDIMZ)
					docod(bufin,bufout,*(nf+1),nlig,3,i);
				else
					docod(bufin,bufout,*nf,nlig,col_order[i],i);
				bufout += n;
			}
		}
		xput_im(out_buffer,0,im_h1);
		return 1 /* makes c99 happy */; 
	}
	nlig = nlig0;
	yz = 1;
	ntot = NDIMY;
	iyo = 0;
	while (ntot > 0) {
		if(nlig > ntot) {
			nlig = ntot;
			nlgo = g_size * echan(nlig);
		}
		ntot -= nlig;
		y = yz;
		for(i=0;i<NDIMZ;i++) {
			c_lptset(*nf,y);
			docod(bufin,bufout,*nf,nlig,col_order[i],i);
			y += NDIMY;
		}
		if(flg_edit > 1) {
			c_lptset(*(nf+1),yz);
			docod(bufin,bufout,*(nf+1),nlig,3,3);
		}
		xput_im(out_buffer,iyo,nlgo);
		iyo += nlgo;
		yz += nlig;
	}
}

/* image couleur avec 3 composantes en chaque pixel (NDIMV = 3) */
vis1_vcol(bufin,nf,lfmt,nlig0,nxo,nyo)
unsigned char *bufin;
struct image **nf;
Fort_int lfmt[9];
int nxo, nyo, nlig0;
{
	register i;
	register nz, y;
	register nlig;
	register ntot, nlgo;
	int n;
	int maxz;
	register unsigned char *bufout;
	y = 0;
#if 0
	maxz = nbim_group ? nbim_group : NDIMZ;
	for(nz=0;nz<maxz;nz += zpas) {
#else
	maxz = iz0 + nbz;
	for(nz=iz0;nz<maxz;nz += zpas) {
#endif
		if(nbim_group && (nz > 0))
			g_open1(xvnftab,ptim1,"e","",lfmt,1);
		bufout = (unsigned char *)out_buffer;
		ntot = NDIMY;
		n = nxo * nyo * (truecol_type == I_MONO ? g_size : byte_pixel);
		nlig = nlig0;
		nlgo = nblig_out;
		while(ntot > 0) {
			if(nlig > ntot) {
				nlig = ntot;
				nlgo = g_size * echan(nlig);
			}
			ntot -= nlig;
			docod(bufin,bufout,*nf,nlig,-1,0);
			if(flg_edit > 1)
				docod(bufin,bufout,*(nf+1),nlig,1,1);
			if(flg_out_all) {
				bufout += n;
			} else {
				xput_im(out_buffer,y,nlgo);
				y += nlgo;
			}
		}
		if(flg_out_all) {
			xput_im(out_buffer,y,im_h1);
			y += im_h1;
		}
		if(nbim_group) {
			if(nbim)
				ptim1++;
			g_close1();
		}
	}
}

/* calcule nb lignes possibles pour buffer lecture (sans depasser 1 plan) 
   on doit avoir la place pour lire et convertir en 8 bits (avec pas et zoom)
*/
calcnlig(n,lfmt,size)
register n;
Fort_int lfmt[9];
long *size;
{
	register nx, nlig, n2, lg2;
	int nxv;
	nx = NDIMX * (BSIZE < 0 ? (-BSIZE +7) >> 3 : BSIZE);
	nxv = nx * NDIMV;
#if 0
	z2 = zoom * zoom;
	if(sdepth == 1 || truecol_type > I_MONO || flg_edit > 1) {
		lgmin = nxv * pas * z2;
	} else {
		lgmin = nxv * pas;
	}
	nlig = pas * (n / lgmin);
	if(nlig > NDIMY) nlig = NDIMY;
	*size = (nlig / pas) * lgmin;
#else
	n2 = n / im_w1b;
	n2 = (((n2 / (zoom * g_size)) - 1) * pas) + 1;
	nlig = n / nxv;
	if(nlig > n2)
		nlig = n2;
	if(nlig > NDIMY)
		nlig = NDIMY;
	n2 = echan(nlig) * echan(nx) * nbv;
	lg2 = nlig * nxv;
	*size = lg2 > n2 ? lg2 : n2;
#endif
	return nlig;
}
	

/* codage image : lecture dans bufin , resultat dans bufout
ncol = num couleur; si <0 : 3 composantes par pixel (DIMV = 3)
indcol = numero d'appel (0 la 1e fois : utile pour shftcol)
*/
docod(bufin,bufout,nf,nlig,ncol,indcol)
unsigned char *bufin;
unsigned char *bufout;
struct image *nf;
int nlig;
int ncol, indcol;  /* num couleur */
{
	register nxo, nyo, i;
	int ncol_ed;
	int exp;
	Fort_int lfmt[9];
	c_getgfm(nf,(struct nf_fmt *)lfmt,0);
	nyo = echan(nlig);
	nxo = NDIMV > 1 ? NEWDIMX : echan(NDIMX);
	if((truecol_type == I_VCOL)  &&  (opt_pas > 1))
		nxo = echan(NDIMX) * NDIMV;
	if(flg_fix < 0) {
		pixmin = 0;
		pixmax = 0;
		xzer_pixim();
		return 1 /* makes c99 happy */; 
	}
	if(sdepth == 1) { /* ecrans 1 bit */
		if(BSIZE == -1 && TYPE == -1) {
			c_xlect(nf,nlig,bufin,1);
			bufcodX1b(bufin,bufout,DIMX,nlig,pas);
			pixmin = 0;
			pixmax = 1;
			return 1 /* makes c99 happy */; 
		}

		/* ecrans 1 bit , image != 1bit*/
		c_lect(nf,nlig,bufin);
		if(flg_edit > 1 && ncol <= im_nbfiles) return 1 /* makes c99 happy */; 
		c_cnvvis(bufin,bufin,nlig,lfmt,vis_exp,0,0,opt_pas);
		if(ncol <= im_nbfiles)  /* pas de mmx pour image resultat */
			xvismmx(bufin,nyo * nxo);
		bufcodX(bufin,bufout,nxo,nyo);
		return 1 /* makes c99 happy */; 
	}
	exp = vis_exp;
	if(flg_edit > 1) {
		ncol_ed = im_nbfiles + 1;
		if(truecol_type == I_ZCOL)
			ncol_ed = 3;
		else if(truecol_type == I_ZCOL)
			ncol_ed = 1;
		if(ncol >= ncol_ed)
			exp = 0;
	}
	/* ecrans 8 ou 24 bits */
	c_lect(nf,nlig,bufin);
	if((truecol_type > I_MONO) || (ncol > im_nbfiles)) {
	  if(flg_sep_comp)
	    c_cnvvisg(bufin,bufin,nlig,lfmt,iv0,nbv,exp,0,0,opt_pas);
	  else
	    c_cnvvis(bufin,bufin,nlig,lfmt,exp,0,0,opt_pas);
	} else {  /* affichage monochrome sur ecran couleur */
		c_cnvvisg(bufin,bufout,nlig,lfmt,iv0,nbv,exp,0,0,opt_pas);
	}
	if(flg_edit > 1) {
		if(ncol < ncol_ed) {/* pas de mmx pour image edit */
			i = nyo * nxo;
			if(truecol_type == I_MONO) {
				xvismmx(bufout,i);
				if(sdepth == 24)
					compmono24(bufout,i);
				else if(sdepth == 24)
					compmono16(bufout,i);
			} else if(truecol_type == I_VCOL) {
				xvismmx(bufin,i);
				compcol(bufin,bufout,i,col_order);
			} else {
				xvismmx(bufin,i);
				shftcol(bufin,bufout,i,ncol,indcol);
			}
		} else {
			comped(bufin,bufout,nyo*nxo,ncol);
		}
	} else if(truecol_type > I_MONO) {
		if(ncol <= im_nbfiles) /* pas de mmx pour image edit */
			xvismmx(bufin,nyo * nxo);
		if(ncol < 0)  /* couleur image vect. */
			compcol(bufin,bufout,nyo*nxo,col_order);
		else {
			shftcol(bufin,bufout,nyo*nxo,ncol,indcol);
		}
	} else {  /* affichage monochrome sur ecran couleur */
		i = nyo * nxo;
		xvismmx(bufout,i);
		if(sdepth == 24) { /* ecran 24 bits */
			compmono24(bufout,i);
		} else if(sdepth == 16) { /* ecran 24 bits */
			compmono16(bufout,i);
		}
	}
	return 1 /* makes c99 happy */; 
}

compmono16(buff,size)
register unsigned char *buff;
register size;
{
	register unsigned char *pi;
	register unsigned short *po;
	register v;
	pi = buff + size - 1;
	po = (unsigned short *) (buff + (byte_pixel * size));
	po--;
	if(flg_Xtc) { /* apply color table */
		register unsigned char *pr, *pg, *pb;
		pr = *pp_cur_ct;
		pg = *(pp_cur_ct + 1);
		pb = *(pp_cur_ct + 2);
		while(size-- > 0) {
		  v = *pi--;
		  *po-- = ((*(pr+v) >> rvb_rshft[0]) << rvb_shft[0])  |
		    ((*(pg+v) >> rvb_rshft[1]) << rvb_shft[1]) |
		    ((*(pb+v) >> rvb_rshft[2]) << rvb_shft[2]);
		}
	} else {
	  while(size-- > 0) {
	    v = *pi--;
	    *po-- = ((v >> rvb_rshft[0]) << rvb_shft[0])  |
	      ((v >> rvb_rshft[1]) << rvb_shft[1]) |
	      ((v >> rvb_rshft[2]) << rvb_shft[2]);
	  }
	}
}

compmono24(buff,size)
register unsigned char *buff;
register size;
{
	register unsigned char *p1, *p2;
	p1 = buff + size - 1;
	p2 = buff + (byte_pixel * size) -1;
	if(flg_Xtc) { /* apply color table */
	  unsigned char *ptc[3];
		ptc[Xcol_order[C_ROUGE]] = *pp_cur_ct;
		ptc[Xcol_order[C_VERT]]  = *(pp_cur_ct + 1);
		ptc[Xcol_order[C_BLEU]] = *(pp_cur_ct + 2);
		if(Xbyte_order == MSB_first) {
			while(size-- > 0) {
				*p2-- = *(ptc[2] + *p1);
				*p2-- = *(ptc[1] + *p1);
				*p2-- = *(ptc[0] + *p1--);
				*p2-- = 0;
			}
		} else {
			while(size-- > 0) {
#if 0
				*p2-- = 0;
				*p2-- = *(ptc[2] + *p1);
				*p2-- = *(ptc[1] + *p1);
				*p2-- = *(ptc[0] + *p1--);
#else
				*p2-- = 0;
				*p2-- = *(ptc[2] + *p1);
				*p2-- = *(ptc[1] + *p1);
				*p2-- = *(ptc[0] + *p1--);
#endif
			}
		}
	} else {
		if(Xbyte_order == MSB_first) {
			while(size-- > 0) {
				*p2-- = *p1;
				*p2-- = *p1;
				*p2-- = *p1--;
				*p2-- = 0;
			}
		} else {
			while(size-- > 0) {
#if 1
				*p2-- = 0;
				*p2-- = *p1;
				*p2-- = *p1;
				*p2-- = *p1--;
#else
				*p2-- = *p1;
				*p2-- = *p1;
				*p2-- = *p1--;
				*p2-- = 0;
#endif	
		}
		}
	}
}

/*  ajoute  la composante couleur numero ncol de bufi dans bufo (n pixels)
indcol = 0 si 1er appel (copier buffer)
 */
shftcol(bufi,bufo,n,ncol,indcol)
register unsigned char *bufi, *bufo;
register n, ncol;
int indcol;
{
	register s, msk;
	register unsigned char *pc;
	register unsigned short *po, *ps;
	if(!truecol_type) return 1 /* makes c99 happy */; 
	if(sdepth == 24) {
		bufo += Xcol_order[ncol];
		while(n-- > 0) {
			*bufo = *bufi++;
			bufo += byte_pixel;
		}
		return 1 /* makes c99 happy */; 
	}
	if(sdepth == 16) {
	  ps = ptabc24_16[ncol];
	  po = (unsigned short *)bufo;
	  if(indcol == 0) {
	    while(n-- > 0)
	      *po++ = *(ps + *bufi++);
	    return 1 /* makes c99 happy */; 
	  }
	  while(n-- > 0)
		*po++ |= *(ps + *bufi++);
	  return 1 /* makes c99 happy */; 
	}
	/*  8 bits */
	pc = ptabc24_8[ncol];
	if(indcol == 0) {
		while(n-- > 0)
			*bufo++ = *(pc + *bufi++);
		return 1 /* makes c99 happy */; 
	}
	while(n-- > 0)
		*bufo++ |= *(pc + *bufi++);

}

/* compose 1 image monochrome et image a editer pour edit */
comped(bufi,bufo,nb,ncol)
register unsigned char *bufi, *bufo;
register nb;
int ncol;
{
	register v;
	if(sdepth > 8) {
		comped24(bufi,bufo,nb,ncol);
		return 1 /* makes c99 happy */; 
	}
	if(ncol == 0) {
		fastcpy(bufi,bufo,nb * byte_pixel);
		return 1 /* makes c99 happy */; 
	}
	if(cmap_type & CMAP_ED && pixmax >= EDCOLOR) {  /* supprimer les points a 255 */
		while(nb-- > 0) {
			if((v = *bufi++) > 0)
				*bufo = v == 255 ? EDCOLOR : v;
			else if(*bufo == EDCOLOR)
				*bufo = EDCOLOR-1;
			bufo++;
		}
		return 1 /* makes c99 happy */; 
	}
	if(cmap_type & CMAP_ED) {
		while(nb-- > 0) {
			if((v = *bufi++) > 0)
				*bufo = v == 255 ? EDCOLOR : v;
			bufo++;
		}
		return 1 /* makes c99 happy */; 
	}
	while(nb-- > 0) {
		if((v = *bufi++) > 0)
			*bufo = v;
		bufo++;
	}
}

/* compose 1 image monochrome et image a editer pour edit ecran 24 bits */
comped24(bufi,bufo,nb,ncol)
register unsigned char *bufi, *bufo;
register nb;
int ncol;
{
	register v;
	register j, n;
	n = byte_pixel;
	if(ncol == 0) {
		fastcpy(bufi,bufo,nb * n);
		return 1 /* makes c99 happy */; 
	}
	if(cmap_type & CMAP_ED && pixmax >= EDCOLOR) {  /* supprimer les points a 255 */
		while(nb-- > 0) {
			j = n;
			if((v = *bufi++) > 0) {
				while(j--)
					*bufo++ = v == 255 ? EDCOLOR : v;
			} else {
				while(j--) {
					if(*bufo == EDCOLOR)
						*bufo = EDCOLOR-1;
					bufo++;
				}
			}
		}
		return 1 /* makes c99 happy */; 
	}
	if(cmap_type & CMAP_ED) {
		while(nb-- > 0) {
			if((v = *bufi++) > 0) {
				j = n;
				while(j--)
					*bufo++ = v == 255 ? EDCOLOR : v;
			} else
				bufo += n;
		}
		return 1 /* makes c99 happy */; 
	}
	while(nb-- > 0) {
		if((v = *bufi++) > 0) {
			j = n;
			while(j--)
				*bufo++ = v;
		} else
			bufo += n;
	}
}

/* compose les couleurs : 3 octets de bufi -> 1 octet de bufo
n = taille de bufi 
l'ordre des couleurs est donne par ordre
*/
compcol(bufi,bufo,nb,ordre)
register unsigned char *bufi, *bufo;
int nb;
unsigned char ordre[];
{
	register n;
	register i1, i2, i3;
	register unsigned char *p1, *p2, *p3;
	register unsigned short *ps1, *ps2, *ps3, *po;
	if(!truecol_type) return 1 /* makes c99 happy */; 
	n = nb / 3;
	if(sdepth == 24) {
		i1 = Xcol_order[ordre[0]];
		i2 = Xcol_order[ordre[1]];
		i3 = Xcol_order[ordre[2]];
		/* expansion : commencer par la fin */
		bufi += nb -1;
		bufo += (n -1) * byte_pixel;
		while(n-- > 0) {
			*(bufo + i3) = *bufi--;
			*(bufo + i2) = *bufi--;
			*(bufo + i1) = *bufi--;
			bufo -= byte_pixel;
		}
		return 1 /* makes c99 happy */; 
	}
	if(sdepth == 16) {
	  ps1 = ptabc24_16[ordre[0]];
	  ps2 = ptabc24_16[ordre[1]];
	  ps3 = ptabc24_16[ordre[2]];
	  po = (unsigned short *)bufo;
	  while(n-- > 0) {
	    i1 = *(ps1 + *bufi++);
	    i1 |= *(ps2 + *bufi++);
	    *po++ = i1 | *(ps3 + *bufi++);
	  }
	  return 1 /* makes c99 happy */; 
	}
	p1 = ptabc24_8[ordre[0]];
	p2 = ptabc24_8[ordre[1]];
	p3 = ptabc24_8[ordre[2]];
	while(n-- > 0) {
		i1 = *(p1 + *bufi++);
		i1 |= *(p2 + *bufi++);
		*bufo++ = i1 | *(p3 + *bufi++);
	}
}

/**remplace chaque pixel (code sur un octet de bufin) par une matrice de bits */
bufcodX(bufin,bufout,nx,ny)
unsigned char *bufin;
unsigned char *bufout;
int ny, nx;
{
	register unsigned char *p1;
	register unsigned char *p2, *pmskv, *pd;
	register size, ibit, i, k;
	register unsigned char v, j;
	register unsigned char *pgl;
	int flg_16;  /* 1 si ligne out doit etre completee par 1 octet pour rendre mult. de 16 */
	size = hdr.g_size;
	p2 = bufout;
	pmskv = maskval;
	if((size = g_size) >= 8) return 1 /* makes c99 happy */; 
	flg_16 = ((nx * g_size + 7) / 8) & 1;
	while(ny-- > 0) {
		for(k=0;k<size;k++) {
			ibit = 0;
			v = 0;
			p1 = bufin;
			for(i=0;i<nx;i++) {
				pgl = pglyph[*p1++];
				j = ibit & 0x7;
				pd = *(ppdecal + j) + *(pgl+k);
				v |= (*pd & *(pmskv + j)); 
				if(flg_debo[j]) {
					*p2++ = v;
					v = *pd & maskcomp[j];
				}
				ibit += size;
			}
			if(flg_debo[j] != 2) *p2++ = v;  /* on doit l'ecrire */
			if(flg_16)
				*p2++ = 0;
		}
		bufin += nx;
	}
}


errio()
{
	fprintf(stderr,"read err %d\n",errno);
	exit(1);
}

Usage()
{
	iusage_(Ucmd,Udetail);
}
extern int inr_xargc;
extern char **inr_xargv;		
/* cherche les noms de fichier dans la liste des options, range les adresses
 dans tabim, renvoie le nb trouve.
appelle Usage s'il reste des arg. commencant par - */
getfiles()
{
	register i, c;
	register char *p;
	if(tabim == NULL) {
	  tabim = i_malloc(TABIM_CHUNK * sizeof(char *));
	  tabim_size = TABIM_CHUNK;
	}
	for(i=1;i<inr_xargc;i++) {
		if((p = inr_xargv[i]) == (char *) 0) continue;
		c = *p;
		if(khoros_mode) {
			if((c != '-') && (*(p+1) != 'i')) 
				imerror(9,"-i* option required\n");
			i++;
			if(i >= inr_xargc)
				imerror(9,"bad options\n");
			if((p = inr_xargv[i]) == (char *) 0)
				imerror(9,"missing file name\n");
		} else if(c == '-') Usage();
		if(nbim >= tabim_size) {
		  tabim_size += TABIM_CHUNK;
		  tabim = i_realloc(tabim,sizeof(char *) * tabim_size);
		}
		tabim[nbim] = p;
		inr_xargv[i] = (char *) 0;
		if(khoros_mode)
			inr_xargv[i-1] = (char *) 0;
		nbim++;
	}
}

/* test nb de fichiers correct
im_nbfile = 1 si 3 fichiers coul, 2 si 3 fichiers avec ordre a tester
retourne le nb fichiers donnes en arg.
*/
tstfiles()
{
	register i, c, k;
	register char *pc;
	int ordre[3];
	if(im_nbfiles) {
		k = nbim % 3;
		if(k || !nbim) {  /* non multiple de 3 ou stdin */
			if((flg_edit && k != 1) || (!flg_edit)) {
				fprintf(stderr,"pour la vraie couleur le nb d'images doit etre multiple de 3\n");
				im_nbfiles = 0;
				return nbim;
			}
		}
		if(fl_peano) {
			im_nbfiles = 0;
			return nbim;
		}
		if(im_nbfiles == 1) {  /* essayer de determiner l'ordre rvb */
			im_nbfiles = 2;
			ordre[0] = ordre[1] = ordre[2] = -1;
			for(i=0;i<3;i++) {
				pc = tabim[i];
				k = strlen(pc);
				if(k < 3) break;
				if(!strcmp(pc + k -2,".Z")) {
					k -= 2;
				} else if(!strcmp(pc + k -3,".gz")) {
					k -= 3;
				}
				if(k < 3) break;
				if(*(pc + k -2) != '.') break;
				c = *(pc + k -1) | 0x20;
				switch (c) {
				case 'r':
					ordre[i] = C_ROUGE;
					break;
				case 'v':
				case 'g':
					ordre[i] = C_VERT;
					break;
				case 'b':
					ordre[i] = C_BLEU;
					break;
				}
			}
			if(ordre[0] < 0 || ordre[1] < 0 || ordre[2] < 0)
				return nbim;
			for(i=0;i<3;i++)
				col_order[i] = ordre[i];
		}
		k = 3;
	} else
		k = 1;
	im_openfiles = k;
	im_opfiles = k;
	/* tester si nbim_group > 0 */
	if(nbim_group > 1) {
		i = k * nbim_group;
		c = 0;
#if 0
		if(i > MAX_NF) {
			i = MAX_NF;
			c = 1;
		}
#endif
		if(nbim && (i > nbim)) {
			i = nbim;
			c = 1;
		}
		if(c) {
			nbim_group = i / k;
			i = k * nbim_group;
			fprintf(stderr,"reducing group size to %d\n",nbim_group);
		}
		im_opfiles = i;
		if(nbim % i) {
			fprintf(stderr,"Impossible de grouper les images par %d",nbim_group);
			nbim_group = 0;
		}
	}
	return nbim;
}

bufcodX1b(bufin,bufout,nx,ny,pas)
register unsigned char *bufin;
unsigned char *bufout;
int nx, ny, pas;
{
	register unsigned char *p2, *pmskv, *pd;
	register size, ibit, i, k;
	register unsigned char v, j;
	register unsigned char *pgl;
	int incr;
	int flg_16;  /* 1 si ligne out doit etre completee par 1 octet pour rendre mult. de 16 */
	size = hdr.g_size;
	p2 = bufout;
	incr = ((nx+7)/8) * pas;
	pmskv = maskval;
	if((size = g_size) >= 8) return 1 /* makes c99 happy */; 
	flg_16 = ((nx * g_size + 7) / 8) & 1;
	while(ny > 0) {
		ny -= pas;
		for(k=0;k<size;k++) {
			ibit = 0;
			v = 0;
			for(i=0;i<nx;i += pas) {
				j = ibit & 0x7;
				if(*(bufin + (i >> 3)) & (0x80 >> (i & 7)))
					pd = *(ppdecal + j) + *(pglyph[255] +k);
				else
					pd = *(ppdecal + j) + *(pglyph[0] +k);
				v |= (*pd & *(pmskv + j)); 
				if(flg_debo[j]) {
					*p2++ = v;
					v = *pd & maskcomp[j];
				}
				ibit += size;
			}
			if(flg_debo[j] != 2) *p2++ = v;  /* on doit l'ecrire */
			if(flg_16)
				*p2++ = 0;
		}
		bufin += incr;
	}
}

#define DESC 256
/* open generalise de fichier :image ou non, selon flg_fix */
g_open(nftab,nm,str1,str2,lfmt,with_ed)
register char **nm;
char *str1, *str2;
struct image *nftab[];
Fort_int lfmt[9];
int with_ed;
{
	num_g_open = 0;
	ptim1 = nm;
	g_open1(nftab,nm,str1,str2,lfmt,with_ed);
}
static Fort_int ver_lfm[9];
static char fix_name[128];

/* open generalise de fichier :image ou non, selon flg_fix */
g_open1(nftab,nm,str1,str2,lfmt,with_ed)
register char **nm;
char *str1, *str2;
struct image *nftab[];
Fort_int lfmt[9];
int with_ed;
{
	register i, j, k, ng;
	struct image *nf;

	if(flg_fix)  {/* images sans header */
		if(num_g_open++) return 1 /* makes c99 happy */;   /* already open */
		nftab[0] = nf = &fixnf;
		fixnf.nom = fix_name;
		if(**nm == '<') {   /* stdin */
			nf->fd = 0;
		} else if(i = inr_tstext(*nm)) {
			nf->f_type = FL_SUBPROC;
			nf->fd = inr_startsubproc(*nm,i);
		} else {
			if((nf->fd = open(*nm,0)) <= 0) {
				fprintf(stderr,"%s : open err %d\n",*nm,errno);
				exit(1);
			}
			nf->f_type = 0;
		}
		nf->no_ligne = 1;
		nf->byte_pnt = 0;
		nf->hors_tout = fdimx;
		nf->bits_lig = fdimx * 8;
		nf->f_type |= FL_READ;
		nf->i_version = IV_INR3;
		strncpy(nf->nom,*nm,127);
		nf->NDIMX = NDIMX = fdimx;
		nf->DIMX = DIMX = fdimx * fdimv;
		nf->NDIMY = NDIMY = fdimy;
		nf->DIMY = DIMY = fdimz * fdimy;
		nf->NDIMV = NDIMV = fdimv;
		nf->NDIMZ = NDIMZ = fdimz;
		nf->EXP = EXP = 200;
		nf->TYPE = TYPE = FIXE;
		nf->BSIZE = BSIZE = 1;
		if(flg_fix < 0)
			nf->fd = -1;
		return 1 /* makes c99 happy */; 
	}

	/* images normales (avec header ) */
	ng = nbim_group;
	if(ng == 0) ng = 1;
	k = 0;
	ng = 1;
	for(j=0;j<ng;j++) {
		for(i=0;i<= im_nbfiles;i++) {
			nf = image_(*nm++,str1,str2,(struct nf_fmt *)lfmt);
#if 0
			if(k == 0) {
#else
			if(num_g_open == 0) {
#endif
				xvcopybuf(lfmt,ver_lfm,sizeof(ver_lfm));
				if(nbim_group && (NDIMZ > 1))
					imerror(9,"only mono-plane images with -grp\n");
			} else if(xvcmpbuf(lfmt,ver_lfm,sizeof(ver_lfm)))
				imerror(2,"images de type incompatible\n");
			if(im_nbfiles > 0)
				nftab[k + col_order[i]] = nf;
			else
				nftab[k] = nf;
		}
		if(flg_edit > 1 && with_ed) {
			if(optcol_type & I_1COL) {
				nftab[im_nbfiles +1] = image_(*nm,"e","",(struct nf_fmt *)ver_lfm);
				if((ver_lfm[I_NDIMX] != NDIMX) || (ver_lfm[I_NDIMY] != NDIMY) ||
				   ((ver_lfm[I_NDIMV] != NDIMV) && (ver_lfm[I_NDIMZ] != NDIMZ)))
					imerror(9,"%s : dimensions non acceptables\n",*nm);
			} else
				nftab[im_nbfiles +1] = image_(*nm,"e","d",(struct nf_fmt *)ver_lfm);
		}
		k += im_nbfiles + 1;
	}
	num_g_open++;
	return 1 /* makes c99 happy */; 
}

finitnf()
{
	fixnf.no_ligne = 1;
	fixnf.byte_pnt = 0;
}

/* close all opened images */
g_close()
{
	g_close1();
	num_g_open = 0;
	ptim1 = ptim;
}

/* close opened images */
g_close1()
{
	register i;
	if(!(file_type & PIPE)) {
		for(i=0;i< im_openfiles;i++)
			fermnf_(&xvnftab[i]);
		if(flg_edit > 1)
			fermnf_(&xvnftab[im_nbfiles +1]);
	}
}

/* copie les arguments restant dans win_argv , pour X ou suntools */
initwin_args()
{
	register i, n;
	n = 0;
	for(i=0;i<inr_xargc;i++)
		if(inr_xargv[i] != NULL)
			n++;
	if((win_argv = (char **)malloc(n * sizeof(char *))) == NULL)
		imerror(8,"arglist alloc error %d\n",errno);
	win_argc = n;
	n = 0;
	for(i=0;i<inr_xargc;i++) {
		if(inr_xargv[i] != NULL) {
			win_argv[n++] = inr_xargv[i];
			if(flg_nu) {
				if(strcmp(inr_xargv[i],"-geometry") == 0)
					flg_geom = 1;
			}
		}
	}
}
rmwin_args()
{
	register i;
	for(i=0;i<win_argc;i++)
		inr_xargv[i] = win_argv[i];
	inr_xargc = win_argc;
}

/* called on signal 1 : calls b_next() */
void sig_next()
{
	if(!sig_lock) {
		chg_image(1);
	}
	signal(SIGHUP,sig_next);
}

/* change image : called on kill, or by par_valid or but_exit 
sens <0 0 ou >0 pour prev, next, same
*/
chg_image(sens)
{
	if(sens > 0) {
		if(b_list[B_NEXT] != NULL) {
			b_next();
			return 1 /* makes c99 happy */; 
		}
	} else if(sens < 0) {
		if(b_list[B_PREV] != NULL) {
			b_prev();
			return 1 /* makes c99 happy */; 
		}
	}
	b_same();
}

init_ctabs()
{
	register i, j;
	register unsigned char *pc;
	pc = color_tables;
	for(i=0;i<NBCTBUFS;i++) {
		p_cts[i] = pc;
		pc += NCOLOR;
	}
	pp_cur_ct = p_cts;
	pp_X_ct = p_cts;
	pp_prev_ct = &p_cts[4*NBCTS];
	pp_mask_ct = pp_prev_ct + 3;
	pp_sc_ct = pp_mask_ct + 3;
	pp_cur_sc = pp_sc_ct;
	pp_prev_sc = pp_cur_sc + 2;
}

init_file_list()
{
	register i;
	if(tstfiles() == 0) 
		tabim[0] = nstdi;
	else if(nbim > 1)
		file_type = MULTIP;
	if(flg_edit) {
		flg_ednull = 0;
		i = optcol_type == I_3COL ? 4 : 2;
		if(nbim != i) {
			imerror(9,"l'option -ed requiert %d fichiers\n",i);
		}
		if(strcmp(tabim[0],tabim[i-1]) != 0) {
			if(strcmp(tabim[i-1],"/dev/null") == 0)
				flg_ednull = 1;
			else
				flg_edit = 2;  /* images diff. => les superposer */
		}
	}
	ptim = tabim;
	numim = 1;
}
