/* return codes */
#define NOOP 0
#define QUIT -1
#define SAME 1
#define NEXT 2
#define PREV 4
/* input file type */
#define PIPE 1
#define MULTIP 2    /* plusieurs fichiers */
/*  loop modes */
#define LOOP 1
#define ZLOOP 2
#define CTLOOP 4  /* color loop */
#define SHLOOP 8

#define MAX(a, b) (a) > (b) ? (a) : (b)
#define MIN(a, b) (a) < (b) ? (a) : (b)
#define ABS(x) (x < 0 ? -x : x)

/* les boutons */
#define	B_EXIT 0
#define B_HELP 1
#define B_NOM 2
#define	B_LOOP 3
/*!!#define	B_STEP 4 */
#define B_SAME 4
#define	B_NEXT 5
#define B_PREV 6
#define B_NEXTZ (B_PREV + 1)
#define B_PREVZ (B_NEXTZ + 1)
#define B_ZLOOP (B_PREVZ +1)
#define B_NEXTV (B_ZLOOP +1)
#define B_PREVV (B_NEXTV +1)
#define B_OPTS (B_PREVV +1)
#define B_UPLEFT (B_OPTS +1)
#define B_CENTER (B_UPLEFT +1)
#define B_EDIT (B_CENTER +1)
#define B_CMAP (B_EDIT +1)
#define B_SHELL (B_CMAP +1)
#define NBOUTONS (B_SHELL+1)

/* les labels du titre */
#define L_MMX 0
#define L_XY 1
#define L_PARAM 2
#define L_NOM 3
#define L_BOX 4
#define LBOUTONS (L_BOX+1)

extern int opt_pas, zoom, pas, zpas, g_size;

#define echan(x) (opt_pas < 0 ? x * zoom : (x -1)/ pas + 1)
#define xechan(x) ( (x -1)/ pas + 1)
#define zechan(x) ( (x -1)/ zpas + 1)

/* les dimension min et max de creation de la fenetre image */
#define MIN_W 336
#define MIN_H 192
#define MAX_W 1200
#define MAX_H 1024
/* epaisseur SUPPOSEE d'un scrollbar */
#define SCROL_W 16


/* pour les tables couleur */
#define NBCTS 3
#define NBCTBUFS (NBCTS * 6 + 3)
/* les numeros des couleurs */
#define C_BW 0
#define C_ROUGE 0
#define C_VERT 1
#define C_BLEU 2
#define C_SCALE 3

/* colormap type */
#define CMAP_LIN 1
#define CMAP_CURR 2
#define CMAP_ED 4
#define CMAP_EDG 4
#define CMAP_EDR 0x8
#define CMAP_PREV 0x10
#define CMAP_TAB1 0x20
#define CMAP_TAB2 0x40
#define CMAP_RAND 0x80
#define CMAP_XRAND 0x400
#define CMAP_FILE 0x100  /* tc par fichier */
#define CMAP_IMAGE 0x200  /* tc dans fichier image */

#define EDCOLOR 254  /* value of edit pixel */

#define NCOLOR 256
/* le type d'affichage */
#define I_MONO 0
#define I_ZCOL 3
#define I_VCOL 5
#define I_1COL 1
#define I_3COL 8

#define MARK_H 8
#define MARK_W 8
struct menu_item {
	char *label;
	long val;
};
struct xvmenu {
	char *m_name;
	char *m_title;
	char *m_prefix;  /* prefix a mettre sur le bouton */
	int (*menu_evnt)();
	int nb_items;
	struct menu_item *items;
	long *wlist;  /* widget list or NULL */
};
struct opt_tab {
	int *var;
	char stat;
};

struct button {
	long *b_win;
	char *b_text;   
	int (*but_evnt)();
	char **hlpmsg;      /* -1 => pas de mode help */
	short b_cod;
	short b_inv;	/* 1 si en video inverse , 0 si normale, -1 si non actif*/
	long *b_im_norm;   /* X11R4 : memorise table translation du menu
			      ou Widget text pour boutons de cmap
			    */
	long menu_item;   /* current menu item num, or -1 or text for cmap tab */
	long *b_menu;   /* -1 => Toggle (initialise a False)
			   1 => menu
			   autre (et != 0) : c'est un ptr vers menu */
};

#define B_ROUGE 1
#define B_VERT 2
#define B_BLEU 4
#define B_SCALE 8
#define B_RGB 7
#define B_ALL 0xf

struct screenpt {
	int x, y;
};
struct imagept {
  int x, y, zy, z;  /* zy est dans le plan, y est relatif a toute l'image */
  int vx, v;   /* vx = indice du vecteur, v = indice composante */
	int val;    /* valeur pixel -1 si inconnue)  0-255 si 8 bits
		     0x00rrggbb si 24 bits */
  float fval[3];  /* valeurs float si val = -2 (r/g/b) */
};
struct imbox {  /* box to be drawn */
	int x, y;   /* origin (upper left) screen coord */
	int dx, dy, dz, dv;   /* taille en x , y z et v*/
	short ep;     /* epaisseur */
};
/* structure pour l'edition */
struct imedit {
  char active;  /* 1 si edit actif */
  char modified;  /* 1 si fichier modifie */
  char lastbutton;
  char res;
  int dimx, dimy;
  int nlblock;  /* nb de lignes / bloc */
  int buf_bytes_per_line; /* nb bytes / ligne buffer */
  int bytes_per_line;
  int ymin, ymax;  /* debut et fin de bloc */
  struct image *wnf;
  unsigned char *pmodif;  /* ptr vers table des flags des lignes modifiees */
  unsigned char *data;   /* ptr vers datas */
  struct imagept oldima;
};
	
/* infos pour editer le pixmap */
struct edval {
	long pmap[3];
	int pixnx;   /* nb pixels par ligne du tile */
	int nx, ny;  /* taille pixmap associee a 1 pixel image */
	int nbytes;  /* nb de bytes dans pixmap */
};

/* infos pour editer l'image */
struct imedval {
	int psize;  /* taille du cote du carre elementaire en nb de pixels */
	int pxbits;  /* nb bits / pixel image de sortie */
	char *pixdata[2];  /* ptr vers data d'un pixel noir et d'1 blanc pour image de sortie */
	int  valdata[2];  /* valeur de remplissage image pour noir et blanc */
	char *curdata;    /* buffer courant */
	int bufsize;   /* taille en octets du buffer courant */
	int curval;  /* 0 si buffer noir, 1 si blanc */
	int curbytes;  /* nb d'octets actuellement utilises dans buffer */
	int nx, ny;  /* taille courante en pixels du buffer */
};


#define MSB_first 1

#define I_XERR 255
#define I_XERRPIX 256

struct hlp_tab {
	char *label;
	char **msg;
};

struct trans_pix {
	unsigned char pix_in, pix_out;
};
#define MAXTRANS 16
/* pour calcul de luminosite :
   .33R + .5G + .17B      : coefs multiplies par 256 
*/
#define RLUM 84
#define GLUM 128
#define BLUM 44

#define OM_NBCOL 0
#define OM_MMX 1
#define OM_PRINT 2
#define OM_EDP 3
#define OM_PIXF 4
#define OM_DEBUG 5
#define OM_FILES 6
#define OM_TXTFOND 7
#define OM_CURSOR 8
#define OM_HZ 9
#define OM_FOLLOW_M1 10
#define OM_ZLREVERSE 11
#define OM_LREVERSE 12

/* max of simultaneously opened images */
#define MAX_NF 8

/* nb max de noms dans un menu de noms */
#define MAX_IMENU_SIZE 20
#define MAX_SUBMENUS 32

/* types d'interpretes (shell) */
#define SH_SH 0
#define SH_CSH 1
#define SH_PERL 2
#define SH_BASH 3

#define mkpix16(r,g,b) (((r & 0xf8) << 8) | ((g & 0xfc) << 3) || ((b & 0xf8) >> 3))
