/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/
#ifndef X11R2
#ifndef X11R3
#define X11R4
#endif
#endif

#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <inrimage/image.h>
#include "xvis.h"
#include "xvglobl.h"
#include "xvxglobl.h"

#define src_width 16
#define src_height 16
#define src_x_hot 0
#define src_y_hot 0
#if 0
static char src_bits[] = {
	0x0, 0x0, 0x40, 0x00, 0x30, 0x00, 0x3c, 0x00,
	0x1f, 0x00, 0x1f, 0xc0, 0xf, 0xe0, 0xf, 0x80,
	0x7, 0x80,  0x6, 0x40, 0, 0x20, 0, 0x10,
	0, 0x8, 0, 0x4, 0, 0x2, 0, 0x1};

static char msk_bits[] = {
	0xc0, 0, 0xf0, 0, 0x7c, 0, 0x7f, 0,
	0x3f, 0xc0, 0x3f, 0xf0, 0x1f, 0xe0, 0x1f, 0x80,
	0xf, 0xc0, 0xe, 0xe0, 0xc, 0x70, 0x4, 0x38,
	0, 0x1c, 0, 0xe, 0, 0x7, 0, 0x3};
#else
static unsigned char src_bits[] = {
0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0x18, 0x0, 
0x1e, 0x0, 0xf, 0x80, 0xf, 0xe0, 0x7, 0xf0, 
0x7, 0xc0, 0x3, 0xc0, 0x3, 0x20, 0x0, 0x10, 
0x0, 0x8, 0x0, 0x4, 0x0, 0x2, 0x0, 0x1, 
};
static unsigned char msk_bits[] = {
0x0, 0x0, 0x60, 0x0, 0x78, 0x0, 0x3e, 0x0, 
0x3f, 0x80, 0x1f, 0xe0, 0x1f, 0xf8, 0xf, 0xf0, 
0xf, 0xc0, 0x7, 0xe0, 0x7, 0x70, 0x6, 0x38, 
0x2, 0x1c, 0x0, 0xe, 0x0, 0x7, 0x0, 0x3 
};
#endif

static Widget xvc_shell= 0;
static Widget xvc_child;
static Widget xvc_box, xvc_dial, xvc_bbox;

int xvc_set(), xvc_unset(), xvc_cancel(), xvc_orient();
struct button xvcbtn[]= {
	{0,"set",xvc_set,0,0,0,0,0,0},
	{0,"unset",xvc_unset,0,0,0,0,0,0},
	{0,"cancel",xvc_cancel,0,0,0,0,0,0},
};
struct button *l_xvcbtn[]= {&xvcbtn[0],&xvcbtn[1],&xvcbtn[2]};

static Arg args[10];
static int curs_num;
static int asked_size= 0, asked_type= CURS_DBLE_H;

static XColor curscolors[2] = {
	{ 1, 0,0,0,DoRed | DoGreen | DoBlue},    /* cursor color */
	{ 0, -1,-1,-1,DoRed | DoGreen | DoBlue},  /* background */
};

Pixmap xvmk_bitmap(), xvmk_pixmap();
static Pixmap ptr_src= 0, ptr_msk, p_save1, p_save2;
static int oldx1= -1, oldx2= -1, oldy1= -1, oldy2= -1;

set_cursor()
{
	register flg;
	flg = curs_new_type & CURS_ORIENT;
	if(flg && !(curs_new_type & CURS_VAR)) {
		if(curs_new_type & CURS_DBLE_H) {
			curs_size = flg_z_horiz ? im_w1 : (im_w1 / 2);
		} else { /* vertical : entre 2 plans */
			curs_size = im_h1;
			if(flg_z_horiz && (im_nrowz == 1))
				curs_size = (im_h1 / 2);
		}

	}
	if(curs_new_type & CURS_VAR) {
		curs_size = echan(asked_size) * g_size;
	}
	make_cursor();
}

make_cursor()
{
	register isize;
	register char *buf;
	register n, i, sbytes, size, i2;
	Pixmap c_src, c_msk;
	Cursor pcur;
	int c_w, c_h, base_dim;
	curs_type = curs_new_type;
	isize = curs_size;  /* taille en pixels entre 2 curseurs */
	if(curs_type == CURS_NORMAL) {
		if(curs_type != curs_prev_type) {
			Cursim = Curstd;
			Cursed = Cursed0;
			if(!edit.active)
				XDefineCursor(dpy,W_image,Cursim);
			else if(curs_options & CURS_OP_ED)
				XDefineCursor(dpy,W_image,Cursed);
			if(Cursvar) {
				XFreeCursor(dpy,Cursvar);
				Cursvar = 0;
			}
			XFlush(dpy);
		}
		curs_prev_type = CURS_NORMAL;
		curs_prev_size = -1;
		return 1 /* makes c99 happy */;
	}
	if((curs_type == curs_prev_type) && (curs_prev_size == curs_size))
		return 1 /* makes c99 happy */;
	pcur = Cursvar;
	if((curs_type & CURS_ORIENT) == CURS_DBLE_H) {
		base_dim = src_width;
		c_h = src_height;
		curs_offset.y = 0;
		curs_offset.x = curs_size;
	} else {
		base_dim = src_height;
		c_w = src_width;
		curs_offset.x = 0;
		curs_offset.y = curs_size;
	}
	isize += base_dim;
	size = (isize + 15)  & ~15;
	if(size < (2 * base_dim))
		size = 2 * base_dim;
	if((curs_type & CURS_ORIENT) == CURS_DBLE_H) {
		c_w = size;
		i2 = 1 + curs_size;
	} else {
		c_h = size;
		i2 = curs_size * c_w + 1;
	}
#if 0
	sbytes = c_w/8;
	n = c_h * sbytes;
	buf = ( char *)i_malloc(n);
	for (i=0;i<n;i++)
		*(buf + i) = 0;
	c_trtblb(src_bits,src_width,1,buf,c_w,1,src_width,src_height,1);
	c_trtblb(src_bits,src_width,1,buf,c_w,i2,src_width,src_height,1);
	c_src = xvmk_bitmap(dpy,W_image,buf,c_w,c_h);
	c_trtblb(msk_bits,src_width,1,buf,c_w,1,src_width,src_height,1);
	c_trtblb(msk_bits,src_width,1,buf,c_w,i2,src_width,src_height,1);
	c_msk = xvmk_bitmap(dpy,W_image,buf,c_w,c_h);
	free(buf);
	Cursvar = XCreatePixmapCursor(dpy,c_src,c_msk,&curscolors[0],&curscolors[1],src_x_hot,src_y_hot);
	Cursim = Cursvar;
	if(curs_options & CURS_OP_ED) {
		Cursed = Cursvar;
		if(edit.active)
			XDefineCursor(dpy,W_image,Cursim);
	}
	if(!edit.active)
		XDefineCursor(dpy,W_image,Cursim);
	XFreePixmap(dpy,c_src);
	XFreePixmap(dpy,c_msk);
#else
	if(ptr_src == 0) {
		ptr_src = xvmk_pixmap(msk_bits,src_bits,src_width,src_height);
		ptr_msk = xvmk_pixmap(0,msk_bits,src_width,src_height);
		p_save1 = XCreatePixmap(dpy,W_image, src_width, src_height, scrdepth);
		p_save2 = XCreatePixmap(dpy,W_image, src_width, src_height, scrdepth);

	}
#endif
	if(pcur) {
		XFreeCursor(dpy,pcur);
	}
	XFlush(dpy);
	curs_prev_type = curs_type;
	curs_prev_size = curs_size;
}

def_curs_var(n)
register n;
{
	Widget wh, wv;
	register narg;
	char tmp[16];
	curs_num = n;
	asked_type = curs_type & CURS_ORIENT;
	if(xvc_shell)
		return 1 /* makes c99 happy */;
	XtSetArg(args[0], XtNvisual, mydefvisual);
	XtSetArg(args[1], XtNcolormap, defcmap);
	xvc_shell = XtCreatePopupShell("xvcshell",topLevelShellWidgetClass,toplevel,args,2);
	xvc_child = XtCreateManagedWidget("xvcc",panedWidgetClass,xvc_shell,args,2);
	xvc_box = XtCreateManagedWidget("xvfbox",boxWidgetClass,xvc_child,args,0);
	xvc_bbox = XtCreateManagedWidget("xvfbbox",boxWidgetClass,xvc_child,args,0);
	createbuttons(xvc_box,l_xvcbtn,3);
	xvmanagebuttons(l_xvcbtn,3);
	XtSetArg (args[0], XtNlabel,"horiz");
	if(asked_type & CURS_DBLE_H) {
		XtSetArg (args[1], XtNstate,True);
		narg = 2;
	} else
		narg = 1;
	wh = XtCreateManagedWidget ("horiz", toggleWidgetClass, xvc_bbox,args,narg);
	XtAddCallback(wh,XtNcallback,xvc_orient,(char *)0);
	XtSetArg (args[0], XtNlabel,"vert");
	XtSetArg (args[1], XtNradioGroup,wh);
	if(asked_type & CURS_DBLE_V) {
		XtSetArg (args[2], XtNstate,True);
		narg = 3;
	} else
		narg = 2;
	wv = XtCreateManagedWidget ("vert", toggleWidgetClass, xvc_bbox,args,narg);
	XtAddCallback(wv,XtNcallback,xvc_orient,(char *)1);

#if 0
	XtSetArg(args[0], XtNstate, True);
	if((curs_type & CURS_ORIENT) == CURS_DBLE_V)
		XtSetValues(wv,args,1);
	else
		XtSetValues(wh,args,1);
#endif
	XtSetArg(args[0],XtNlabel,(XtArgVal)"curs. interval (image pixels)");
	sprintf(tmp,"%-5d",asked_size);
	XtSetArg(args[1],XtNvalue,(XtArgVal)tmp);
	xvc_dial = XtCreateManagedWidget("xvcsize",dialogWidgetClass,
					xvc_child,args,2);
	XtRealizeWidget(xvc_shell);
	XtPopup(xvc_shell,XtGrabNone);
	XFlush(dpy);
}


int xvc_set()
{
	register unsigned char *s;
	s = (unsigned char *)XawDialogGetValueString(xvc_dial);
	sscanf((char *)s,"%d",&asked_size);
	curs_new_type = asked_type;
	if(asked_size > 0)
		curs_new_type |= CURS_VAR;
	else
		asked_size = 0;
	set_option(curs_num,1);
	set_option(curs_num-1,0);
	curs_options = (curs_options & ~CURS_OP_STD2) | CURS_OP_VAR;
	set_cursor();
	xvc_cancel();
}

int xvc_unset()
{
	set_option(curs_num,0);
	curs_options = (curs_options & ~CURS_OP_STD2);
	if(curs_type & CURS_ORIENT) {
		curs_new_type = CURS_NORMAL;
		set_cursor();
	}
	xvc_cancel();
}

int xvc_cancel()
{
	XtDestroyWidget(xvc_shell);
	xvc_shell = NULL;
}

int xvc_orient(w,cl_data,call_data)
Widget w;
XtPointer cl_data, call_data;
{
	register long v;
	/* call_data = 0 pour reset, 1 pour set */
	v = (long) call_data;
	asked_type = (long)cl_data == 0 ? CURS_DBLE_H : CURS_DBLE_V;
	if(v == 0)
		asked_type = CURS_DBLE_H;
}

#if 1 /*def __alpha */
static unsigned char hx_swap[] = {0,8,4,0xc,2,0xa,6,0xe,1,9,5,0xd,3,0xb,7,0xf};
#endif
/* == XCreateBitmapFromData mais avec bits et bytes MSBFirst */
Pixmap xvmk_bitmap(display, d, data, width, height)
Display *display;
Drawable d;
char *data;
unsigned int width, height;
{
/*#ifdef __alpha */
#if 1
#define TMPSZ 40
	extern Pixmap XCreateBitmapFromData();
	char tmp[TMPSZ];
	register i, n, v1, v2;;
	n = ((width + 7)/ 8) * height;
	if(n > TMPSZ) n = TMPSZ;
	/* swap bits */
	for(i=0;i<n;i++) {
		v1 = *data & 0xf;
		v2 = (*data++ >> 4) & 0xf;
		v1 = (int)hx_swap[v1];
		v2 = (int)hx_swap[v2];
		tmp[i] = (unsigned char)((v1 << 4) | v2);
	}
	return XCreateBitmapFromData(display, d, tmp, width, height);
	
#else
#if 0
	XImage ximage;
#else
	XImage *ximage;
#endif
	GC gc;
	Pixmap pix;

	pix = XCreatePixmap(display, d, width, height, 1);
	if (! (gc = XCreateGC(display, pix, (unsigned long) 0, (XGCValues *) 0)))
		return (Pixmap) 0;
#if 0
	ximage.height = height;
	ximage.width = width;
	ximage.depth = 1;
	ximage.xoffset = 0;
	ximage.format = ZPixmap;
	ximage.data = (char *)data;
	ximage.byte_order = MSBFirst;
	ximage.bitmap_unit = 8;
	ximage.bitmap_bit_order = MSBFirst;
	ximage.bitmap_pad = 8;
	ximage.bytes_per_line = (width+7)/8;
	ximage.bits_per_pixel = 1;
#else
	ximage = XCreateImage(dpy,NULL,1,ZPixmap,0,data,width,height,8,(width+7)/8);
	ximage->byte_order = MSBFirst;
	ximage->bitmap_unit = 8;
	ximage->bitmap_bit_order = MSBFirst;
	ximage->depth = 1;
#endif
	XPutImage(display, pix, gc, &ximage, 0, 0, 0, 0, width, height);
	XFreeGC(display, gc);
	return(pix);
#endif /* alpha */
}

/* == XCreateBitmapFromData mais avec bits et bytes MSBFirst */
Pixmap xvmk_pixmap(bmsk,bdata, width, height)
char *bdata, *bmsk;
unsigned int width, height;
{
	XImage ximage;
	GC gc;
	Pixmap pix;
	char *data;
	register nb1, n, i, j, k;
	register c, v;
	pix = XCreatePixmap(dpy,W_image, width, height, scrdepth);
	if (! (gc = XCreateGC(dpy, pix, (unsigned long) 0, (XGCValues *) 0)))
		return (Pixmap) 0;
	if(scrdepth == 1) {
		ximage.bytes_per_line = (width+7)/8;
		ximage.bits_per_pixel = scrdepth;
		data = bdata;
	} else {
		if(scrdepth != 8 && scrdepth != 24)
			return (Pixmap) 0;
		nb1 = scrdepth == 8 ? 1 : 4;
		ximage.bytes_per_line = width * nb1;
		ximage.bits_per_pixel = 8 * nb1;
		n = width * height;
		data = (char *)i_malloc(n * nb1);
		if(bmsk == (char *)0) {
			prp_data(bdata,data,n,nb1,1,0);
		} else {
			for(i=0;i<n*nb1;i++)
				*(data+i) = 0;
			prp_data(bmsk,data,n,nb1,0,whitepixel);
			prp_data(bdata,data,n,nb1,0,blackpixel);
		}
	}
	ximage.height = height;
	ximage.width = width;
	ximage.depth = scrdepth;
	ximage.xoffset = 0;
	ximage.format = ZPixmap;
	ximage.data = (char *)data;
	ximage.byte_order = MSBFirst;
	ximage.bitmap_unit = 8;
	ximage.bitmap_bit_order = MSBFirst;
	ximage.bitmap_pad = 8;
	
	XPutImage(dpy, pix, gc, &ximage, 0, 0, 0, 0, width, height);
	XFreeGC(dpy, gc);
	if(scrdepth != 1)
		i_Free(&data);
	return(pix);
}

prp_data(bdata,data,n,nb1,flg_msk,val)
char *bdata, *data;
register n, nb1, flg_msk;
register val;
{
	register char *pi, *po;
	register i, j, k, c;
	pi = bdata;
	po = data;
	for(i=0;i<n/8;i++) {
		c = *pi++;
		for(j=0;j<8;j++) {
			if(flg_msk) { /* def mask */
				if(c & 0x80)
					val = -1;
				else
					val = 0;
				for(k=0;k<nb1;k++)
					*po++ = val;
			} else 	if(c & 0x80) {
				for(k=0;k<nb1;k++)
					*po++ = val;
			} else {
				po += nb1;
			}
			c <<= 1;
		}
	}
}

mk_stdcursor()
{
	Pixmap c_src, c_msk;
	c_src = xvmk_bitmap(dpy,W_image,src_bits,src_width,src_height);
	c_msk = xvmk_bitmap(dpy,W_image,msk_bits,src_width,src_height);
	Curstd = XCreatePixmapCursor(dpy,c_src,c_msk,&curscolors[0],&curscolors[1],src_x_hot,src_y_hot);
	XFreePixmap(dpy,c_src);
	XFreePixmap(dpy,c_msk);
	Cursim = Curstd;
}

draw_ptr(x,y)
register x, y;
{
	register x2, y2;
	x2 = x + curs_offset.x;
	y2 = y + curs_offset.y;
	/* save in old */
	XSetFunction(dpy,defgc,GXcopy);
	XCopyArea(dpy,W_image,p_save1,defgc,x,y,src_width,src_height,0,0);
	XCopyArea(dpy,W_image,p_save2,defgc,x2,y2,src_width,src_height,0,0);
	oldx1 = x;
	oldy1 = y;
	oldx2 = x2;
	oldy2 = y2;

	XSetFunction(dpy,defgc,GXandInverted);
	XCopyArea(dpy,ptr_msk,W_image,defgc,0,0,src_width,src_height,x,y);
	XCopyArea(dpy,ptr_msk,W_image,defgc,0,0,src_width,src_height,x2,y2);
	XSetFunction(dpy,defgc,GXor);
	XCopyArea(dpy,ptr_src,W_image,defgc,0,0,src_width,src_height,x,y);
	XCopyArea(dpy,ptr_src,W_image,defgc,0,0,src_width,src_height,x2,y2);
}
reset_prev()
{
	XSetFunction(dpy,defgc,GXcopy);
	if(oldx1 >= 0 || oldy1 >= 0)
		XCopyArea(dpy,p_save1,W_image,defgc,0,0,src_width,src_height,oldx1,oldy1);
	if(oldx2 >= 0 || oldy2 >= 0)
		XCopyArea(dpy,p_save2,W_image,defgc,0,0,src_width,src_height,oldx2,oldy2);
}
