/***************************************************************************
Copyright (c) 1988,1989
Institut National de Recherche en Informatique et Automatique
	Domaine de Voluceau-Rocquencourt  B.P. 105  78153 LE CHESNAY cedex

Toute distribution de ce logiciel doit etre soumise a l'autorisation
de l'INRIA et comporter le present avis de copyright.

***************************************************************************/

#include <stdio.h>
#ifdef sun5
#include <string.h>
#else
#include <strings.h>
#endif
#include <ctype.h>
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Shell.h>

#include <inrimage/image.h>
#include "xvshell.h"
#include "xvis.h"
#include "xvglobl.h"

extern int debug_;

static Widget xvf_shell= 0;
static Widget xvf_child;
static Widget xvf_box, xvf_txt;


extern Widget toplevel;
extern Colormap defcmap;
extern Visual *mydefvisual;

extern Display *dpy;
extern XtAppContext xvapp_con;
extern GC fillgc, defgc;

static int flg_xvf_modif= 0;

static Arg args[10];

int xvf_set(), xvf_cancel(), xvf_select(), xvf_modif();
struct button xvfbtn[]= {
	{0,"select",xvf_select,0,0,0,0,0,(long *)-1},
	{0,"modif",xvf_modif,0,0,0,0,0,(long *)-1},
	{0,"set",xvf_set,0,0,-1,0,0,0},
	{0,"cancel",xvf_cancel,0,0,0,0,0,0},
};
struct button *l_xvfbtn[]= {&xvfbtn[0],&xvfbtn[1],&xvfbtn[2],&xvfbtn[3]};

struct exp_buf xvf_ibuf= {0};
char *xvf_txtbuf= 0;
extern int nbim, numim;
extern char imagelabel[];

init_xvf()
{
}

xvf_create()
{
	Widget w;
	if(xvf_shell)
		return 1 /* makes c99 happy */;
	flg_xvf_modif = 0;
	XtSetArg(args[0], XtNvisual, mydefvisual);
	XtSetArg(args[1], XtNcolormap, defcmap);
	xvf_shell = XtCreatePopupShell("xvfshell",topLevelShellWidgetClass,toplevel,args,2);
	xvf_child = XtCreateManagedWidget("xvff",panedWidgetClass,xvf_shell,args,2);
	xvf_box = XtCreateManagedWidget("xvfbox",boxWidgetClass,xvf_child,args,0);
	mkflist();
	XtSetArg(args[0],XtNstring,(XtArgVal)xvf_txtbuf);
	XtSetArg(args[1],XtNtype,XawAsciiString);
	/* XtSetArg (args[2], XtNscrollVertical,XawtextScrollWhenNeeded); */
	XtSetArg (args[2], XtNscrollVertical,XawtextScrollAlways);
	XtSetArg (args[3], XtNscrollHorizontal,XawtextScrollWhenNeeded);
	XtSetArg (args[4], XtNeditType,XawtextRead);
	xvf_txt = XtCreateManagedWidget ("xvftext", asciiTextWidgetClass, xvf_child,args,5);
	createbuttons(xvf_box,l_xvfbtn,4);
	xvmanagebuttons(l_xvfbtn,4);
	XtSetArg(args[0],XtNstate,True);
	w = (Widget)xvfbtn[0].b_win;
	XtSetValues(w,args,1);
	XtSetArg(args[0],XtNradioGroup,w);
	XtSetValues((Widget)xvfbtn[1].b_win,args,1);
	xvfbtn[2].b_inv = -1;
	modifbutton(&xvfbtn[2]);
	XtRealizeWidget(xvf_shell);
	XtPopup(xvf_shell,XtGrabNone);
	XFlush(dpy);
}

int xvf_set_imlist(pc,n)
char *pc;
register n;
{
  char oldim[512];
  register i;
  strncpy(oldim,*ptim,511);
  bufexe_reall(&xvf_ibuf,n);
  mknewlist(pc);
  init_file_list();
  if(!flg_nu) {
    configbuttons();
    init_im_menu();
  }
  for(i=0;i<nbim;i++) {
    if(strcmp(oldim,tabim[i]) == 0)
      break;
  }
  if(i < nbim) {
    numim = i + 1;
    ptim = &tabim[i];
    prp_imlabel(ptim,lfmt);
    wrt_imlabel();
  } else {
    b_same();  /* relire 1e image */
  }
}

int xvf_set()
{
	char *pc;
	register n;
	XtSetArg(args[0],XtNstring,(XtArgVal)&pc);
	XtGetValues(xvf_txt,args,1);
	n = strlen(pc);
	xvf_set_imlist(pc,n);
	xvf_cancel();
}

int xvf_cancel()
{
	XtDestroyWidget(xvf_shell);
	xvf_shell = NULL;
	i_Free(&xvf_txtbuf);
}

xvf_select()
{
	if(!flg_xvf_modif) return 1 /* makes c99 happy */;
	flg_xvf_modif = 0;
	/* turn sensitivity of "set" off */
	xvfbtn[2].b_inv = -1;
	modifbutton(&xvfbtn[2]);
	/* rebuild file list */
	mkflist();
	XtSetArg(args[0],XtNeditType,XawtextRead);
	XtSetArg(args[1],XtNstring,(XtArgVal)xvf_txtbuf);
	XtSetValues(xvf_txt,args,2);
}

xvf_modif()
{
	if(flg_xvf_modif) return 1 /* makes c99 happy */;
	flg_xvf_modif = 1;
	/* turn sensitivity of "set" on */
	xvfbtn[2].b_inv = 0;
	modifbutton(&xvfbtn[2]);

	XtSetArg(args[0],XtNeditType,XawtextEdit);
	XtSetValues(xvf_txt,args,1);
}

file_select()
{
	char tmp[80];
	XawTextPosition start, finish;
	register n, i;
	register char *pc;
	XawTextGetSelectionPos (xvf_txt, &start, &finish);
	if((n = finish -start) <= 0) return 1 /* makes c99 happy */;
	if(n >= 80) n = 79;
	pc = xvf_txtbuf + start;
	for(i=0;i<n;i++)
		tmp[i] = *pc++;
	tmp[i] = 0;
	shx_reread(0,tmp,n);
}


#define MAXLG 40
mkflist()
{
	register i, n, lg;
	register char *pc;
	n = 0;
	for(i=0;i<nbim;i++) {
		n += strlen(tabim[i]) + 1;
	}
	i_Free(&xvf_txtbuf);
	xvf_txtbuf = (char *)i_malloc(n +1);
	pc = xvf_txtbuf;
	lg = 0;
	for(i=0;i<nbim;i++) {
		n = str_add(tabim[i],pc);
		pc += n;
		lg += n + 1;
		if(lg >= MAXLG) {
			*pc++ = '\n';
			lg = 0;
		} else
			*pc++ = ' ';
	}
	*pc = 0;
}

int str_add(in,out)
register char *in, *out;
{
	register i, c;
	i = 0;
	while((c = *in++)) {
		*out++ = c;
		i++;
	}
	return i;
}

/* reconstruit tabim avec la liste donnee dans s */
mknewlist(s)
register char *s;
{
	register nb, c, flg;
	register char *out;
	out = xvf_ibuf.bufexe;
	nb = 0;
	flg = 0;
	while((c = *s++)) {
		if(isspace(c)) {
			c = 0;
			flg = 0;
		} else {
			if(!flg) {
			  if(nb >= tabim_size) {
			    tabim_size += TABIM_CHUNK;
			    tabim = i_realloc(tabim,sizeof(char *) * tabim_size);
			  }
			  tabim[nb++] = out;
			}
			flg = 1;
		}
		*out++ = c;
	}
	*out = 0;
	nbim = nb;
}
